#ifndef _CEGOMEDIATORCONNECTION_H_INCLUDED_
#define _CEGOMEDIATORCONNECTION_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// CegoMediatorConnection.h
// ------------------------
// Cego mediator connection class defintion
//      
// Design and Implementation by Bjoern Lemke
//
// (C)opyright 2000-2007 Bjoern Lemke
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: CegoMediatorConnection
// 
// Description:
//
// Status: CLEAN
//
///////////////////////////////////////////////////////////////////////////////

#include "Chain.h"
#include "Logger.h"
#include "NetHandler.h"

#include "CegoAdminHandler.h"


class CegoMediatorConnection {

 public:


    CegoMediatorConnection();

    CegoMediatorConnection(const Chain& hostName);
    CegoMediatorConnection(const Chain& hostName, int portNo, const Chain& user, const Chain& passwd);

    ~CegoMediatorConnection();

    void setHostName(const Chain& hostName);
    const Chain& getHostName() const;

    void setPortNo(int portNo);
    int getPortNo() const;

    const Chain& getUser() const;
    const Chain& getPasswd() const;

    void connect();
    void disconnect();
    void beat();

    void setLogger(Logger* pLog);

    CegoMediatorConnection& operator = ( const CegoMediatorConnection& mc);
    bool operator == ( const CegoMediatorConnection& mc);

    friend ostream& operator << (ostream& s, const CegoMediatorConnection& mc);
    
private:
    
    Chain _hostName;
    int _portNo;
    Chain _user;
    Chain _passwd;

    NetHandler* _pN;
    CegoAdminHandler* _pAdminHandle;
    Logger* _pLog;
};

#endif




