//
// File: Cego.cc
// This code was produced by the dragon parser generator
//
#include "Cego.h"
#include "Exception.h"
#include "StackT.h"

Cego::ScannerStateEntry::ScannerStateEntry()
{
}

Cego::ScannerStateEntry::ScannerStateEntry(int state, ScannerStateType type)
{
   _state = state;
   _type = type;
}

Cego::ScannerStateEntry& Cego::ScannerStateEntry::operator = (const Cego::ScannerStateEntry& s)
{
   _state = s._state;
   _type = s._type;
   return(*this);
}

bool Cego::ScannerStateEntry::operator == (const Cego::ScannerStateEntry& s)
{
   if ( _state == s._state )
      return true;
   return false;
}

Cego::ScannerStateType Cego::ScannerStateEntry::getType()
{
   return _type;
}
int Cego::ScannerStateEntry::getState()
{
   return _state;
}


Cego::ScannerTransEntry::ScannerTransEntry()
{
}

Cego::ScannerTransEntry::ScannerTransEntry(int state, char c)
{
   _state = state;
   _c = c;
}

Cego::ScannerTransEntry::ScannerTransEntry(int state, char c, int fstate)
{
   _state = state;
   _c = c;
   _fstate = fstate;
}

Cego::ScannerTransEntry& Cego::ScannerTransEntry::operator = (const Cego::ScannerTransEntry& s)
{
   _state = s._state;
   _c = s._c;
   _fstate = s._fstate;
   return(*this);
}

bool Cego::ScannerTransEntry::operator == (const Cego::ScannerTransEntry& s)
{
   if ( _state == s._state && _c == s._c)
      return true;
   return false;
}

int Cego::ScannerTransEntry::getFState()
{
   return _fstate;
}


Cego::Scanner::Scanner()
{
}


Cego::Scanner::Scanner(Token t)
{
   _token = t;
}

Cego::Token Cego::Scanner::getToken()
{
   return _token;
}

void Cego::Scanner::addState(ScannerStateEntry s)
{
   _stateList.Insert(s);
}

void Cego::Scanner::addTransition(ScannerTransEntry t)
{
   _transList.Insert(t);
}

bool Cego::Scanner::checkPattern(const Chain& p)
{
   unsigned long state = 0;
   ScannerStateEntry* pS = _stateList.First();
   while (pS)
   {
      if (pS->getType() == START || pS->getType() == ANY)
      {
         state = pS->getState();
         pS = 0;
      }
      else
      {
         pS = _stateList.Next();
      }
   }
   unsigned long i = 0;
   ScannerTransEntry* pT = 
   _transList.Find(ScannerTransEntry(state, p[i]));
   while (pT)
   {
      ScannerStateEntry* pS = _stateList.Find(ScannerStateEntry(pT->getFState())); 
      if (pS)
      {
         if ( ( i == p.length()-2 ) && ( pS->getType() == FINAL || pS->getType() == ANY))
         {
            return true;
         }
         else
         {
            state = pT->getFState();
         }
      }
      else
      {
         return false;
      }
      i++;
      pT = _transList.Find(ScannerTransEntry(state, p[i]));
   }
   return false;
}
Cego::StackEntry::StackEntry()
{
   _symbol = NONE;
}

Cego::StackEntry::StackEntry(Symbol symbol, int num, int state, Chain tval)
{
   _symbol=symbol;
   _num=num;
   _state=state;
   _tval=tval;
}

Cego::StackEntry& Cego::StackEntry::operator = (const Cego::StackEntry& se)
{
   _symbol=se._symbol;
   _num=se._num;
   _state=se._state;
   _tval=se._tval;
   return(*this);
}

int Cego::StackEntry::getState()
{
   return _state;
}
Cego::Symbol Cego::StackEntry::getSymbol()
{
   return _symbol;
}
Chain& Cego::StackEntry::getTval()
{
   return _tval;
}

Cego::ActionEntry::ActionEntry()
{
   _action=NULLACTION;
}

Cego::ActionEntry::ActionEntry(Action action , int num)
{
   _action=action;
   _num=num;
}

bool Cego::ActionEntry::operator == (const Cego::ActionEntry& ae)
{
   if (_action == ae._action && _num == ae._num)
      return true;
   return false;
}

Cego::ActionEntry& Cego::ActionEntry::operator = (const Cego::ActionEntry& ae)
{
   _action=ae._action;
   _num=ae._num;
   return(*this);
}

Cego::Action Cego::ActionEntry::getAction()
{
   return _action;
}

int Cego::ActionEntry::getNum()
{
   return _num;
}

Cego::ProdEntry::ProdEntry()
{
}

Cego::ProdEntry::ProdEntry(int id)
{
   _id = id;
}

Cego::ProdEntry::ProdEntry(int id, Production prod, int numSymbol)
{
   _id = id;
   _prod = prod;
   _numSymbol = numSymbol;
}

bool Cego::ProdEntry::operator == (const Cego::ProdEntry& pe)
{
   if (_id == pe._id)
      return true;
   return false;
}

Cego::ProdEntry& Cego::ProdEntry::operator = (const Cego::ProdEntry& pe)
{
   _id = pe._id;
   _prod = pe._prod;
   _numSymbol = pe._numSymbol;
   return(*this);
}


int Cego::ProdEntry::getId()
{
   return _id;
}

Cego::Production Cego::ProdEntry::getProd()
{
   return _prod;
}

int Cego::ProdEntry::getNumSymbol()
{
   return _numSymbol;
}
void Cego::loadScanner()
{
   Scanner s0(ADD);
   s0.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(2 ,START));
   s0.addState(ScannerStateEntry(3 ,FINAL));
   s0.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s0.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s0.addTransition(ScannerTransEntry(2 ,'a' ,0));
   _scannerList.Insert(s0);

   Scanner s1(AND);
   s1.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(2 ,START));
   s1.addState(ScannerStateEntry(3 ,FINAL));
   s1.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s1.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s1.addTransition(ScannerTransEntry(2 ,'a' ,0));
   _scannerList.Insert(s1);

   Scanner s2(ALL);
   s2.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(2 ,START));
   s2.addState(ScannerStateEntry(3 ,FINAL));
   s2.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s2.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s2.addTransition(ScannerTransEntry(2 ,'a' ,0));
   _scannerList.Insert(s2);

   Scanner s3(ALTER);
   s3.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(2 ,START));
   s3.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(5 ,FINAL));
   s3.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s3.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s3.addTransition(ScannerTransEntry(2 ,'a' ,0));
   s3.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s3.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s3);

   Scanner s4(APPEND);
   s4.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(2 ,START));
   s4.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(6 ,FINAL));
   s4.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s4.addTransition(ScannerTransEntry(1 ,'p' ,3));
   s4.addTransition(ScannerTransEntry(2 ,'a' ,0));
   s4.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s4.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s4.addTransition(ScannerTransEntry(5 ,'d' ,6));
   _scannerList.Insert(s4);

   Scanner s5(AS);
   s5.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(1 ,FINAL));
   s5.addState(ScannerStateEntry(2 ,START));
   s5.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s5.addTransition(ScannerTransEntry(2 ,'a' ,0));
   _scannerList.Insert(s5);

   Scanner s6(ASC);
   s6.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(2 ,START));
   s6.addState(ScannerStateEntry(3 ,FINAL));
   s6.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s6.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s6.addTransition(ScannerTransEntry(2 ,'a' ,0));
   _scannerList.Insert(s6);

   Scanner s7(AUTHORIZE);
   s7.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(2 ,START));
   s7.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(9 ,FINAL));
   s7.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s7.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s7.addTransition(ScannerTransEntry(2 ,'a' ,0));
   s7.addTransition(ScannerTransEntry(3 ,'h' ,4));
   s7.addTransition(ScannerTransEntry(4 ,'o' ,5));
   s7.addTransition(ScannerTransEntry(5 ,'r' ,6));
   s7.addTransition(ScannerTransEntry(6 ,'i' ,7));
   s7.addTransition(ScannerTransEntry(7 ,'z' ,8));
   s7.addTransition(ScannerTransEntry(8 ,'e' ,9));
   _scannerList.Insert(s7);

   Scanner s8(AUTOCOMMIT);
   s8.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(2 ,START));
   s8.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(10 ,FINAL));
   s8.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s8.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s8.addTransition(ScannerTransEntry(2 ,'a' ,0));
   s8.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s8.addTransition(ScannerTransEntry(4 ,'c' ,5));
   s8.addTransition(ScannerTransEntry(5 ,'o' ,6));
   s8.addTransition(ScannerTransEntry(6 ,'m' ,7));
   s8.addTransition(ScannerTransEntry(7 ,'m' ,8));
   s8.addTransition(ScannerTransEntry(8 ,'i' ,9));
   s8.addTransition(ScannerTransEntry(9 ,'t' ,10));
   _scannerList.Insert(s8);

   Scanner s9(AVG);
   s9.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(2 ,START));
   s9.addState(ScannerStateEntry(3 ,FINAL));
   s9.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s9.addTransition(ScannerTransEntry(1 ,'g' ,3));
   s9.addTransition(ScannerTransEntry(2 ,'a' ,0));
   _scannerList.Insert(s9);

   Scanner s10(BEGIN);
   s10.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(2 ,START));
   s10.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(5 ,FINAL));
   s10.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s10.addTransition(ScannerTransEntry(1 ,'g' ,3));
   s10.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s10.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s10.addTransition(ScannerTransEntry(4 ,'n' ,5));
   _scannerList.Insert(s10);

   Scanner s11(BETWEEN);
   s11.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(2 ,START));
   s11.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(7 ,FINAL));
   s11.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s11.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s11.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s11.addTransition(ScannerTransEntry(3 ,'w' ,4));
   s11.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s11.addTransition(ScannerTransEntry(5 ,'e' ,6));
   s11.addTransition(ScannerTransEntry(6 ,'n' ,7));
   _scannerList.Insert(s11);

   Scanner s12(BIGINT);
   s12.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(2 ,START));
   s12.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(6 ,FINAL));
   s12.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s12.addTransition(ScannerTransEntry(1 ,'g' ,3));
   s12.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s12.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s12.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s12.addTransition(ScannerTransEntry(5 ,'t' ,6));
   _scannerList.Insert(s12);

   Scanner s13(BITAND);
   s13.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(2 ,START));
   s13.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(6 ,FINAL));
   s13.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s13.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s13.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s13.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s13.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s13.addTransition(ScannerTransEntry(5 ,'d' ,6));
   _scannerList.Insert(s13);

   Scanner s14(BITOR);
   s14.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(2 ,START));
   s14.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(5 ,FINAL));
   s14.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s14.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s14.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s14.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s14.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s14);

   Scanner s15(BITXOR);
   s15.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(2 ,START));
   s15.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(6 ,FINAL));
   s15.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s15.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s15.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s15.addTransition(ScannerTransEntry(3 ,'x' ,4));
   s15.addTransition(ScannerTransEntry(4 ,'o' ,5));
   s15.addTransition(ScannerTransEntry(5 ,'r' ,6));
   _scannerList.Insert(s15);

   Scanner s16(BLOB);
   s16.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(2 ,START));
   s16.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(4 ,FINAL));
   s16.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s16.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s16.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s16.addTransition(ScannerTransEntry(3 ,'b' ,4));
   _scannerList.Insert(s16);

   Scanner s17(BOOL);
   s17.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(2 ,START));
   s17.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(4 ,FINAL));
   s17.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s17.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s17.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s17.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s17);

   Scanner s18(BY);
   s18.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(1 ,FINAL));
   s18.addState(ScannerStateEntry(2 ,START));
   s18.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s18.addTransition(ScannerTransEntry(2 ,'b' ,0));
   _scannerList.Insert(s18);

   Scanner s19(CALL);
   s19.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(2 ,START));
   s19.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(4 ,FINAL));
   s19.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s19.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s19.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s19.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s19);

   Scanner s20(CASE);
   s20.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(2 ,START));
   s20.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(4 ,FINAL));
   s20.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s20.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s20.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s20.addTransition(ScannerTransEntry(3 ,'e' ,4));
   _scannerList.Insert(s20);

   Scanner s21(CHECK);
   s21.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(2 ,START));
   s21.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(5 ,FINAL));
   s21.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s21.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s21.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s21.addTransition(ScannerTransEntry(3 ,'c' ,4));
   s21.addTransition(ScannerTransEntry(4 ,'k' ,5));
   _scannerList.Insert(s21);

   Scanner s22(CLOSE);
   s22.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(2 ,START));
   s22.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(5 ,FINAL));
   s22.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s22.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s22.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s22.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s22.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s22);

   Scanner s23(COMMIT);
   s23.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(2 ,START));
   s23.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(6 ,FINAL));
   s23.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s23.addTransition(ScannerTransEntry(1 ,'m' ,3));
   s23.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s23.addTransition(ScannerTransEntry(3 ,'m' ,4));
   s23.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s23.addTransition(ScannerTransEntry(5 ,'t' ,6));
   _scannerList.Insert(s23);

   Scanner s24(COLUMN);
   s24.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(2 ,START));
   s24.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(6 ,FINAL));
   s24.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s24.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s24.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s24.addTransition(ScannerTransEntry(3 ,'u' ,4));
   s24.addTransition(ScannerTransEntry(4 ,'m' ,5));
   s24.addTransition(ScannerTransEntry(5 ,'n' ,6));
   _scannerList.Insert(s24);

   Scanner s25(CONSTRAINT);
   s25.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(2 ,START));
   s25.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(10 ,FINAL));
   s25.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s25.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s25.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s25.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s25.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s25.addTransition(ScannerTransEntry(5 ,'r' ,6));
   s25.addTransition(ScannerTransEntry(6 ,'a' ,7));
   s25.addTransition(ScannerTransEntry(7 ,'i' ,8));
   s25.addTransition(ScannerTransEntry(8 ,'n' ,9));
   s25.addTransition(ScannerTransEntry(9 ,'t' ,10));
   _scannerList.Insert(s25);

   Scanner s26(COUNT);
   s26.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(2 ,START));
   s26.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(5 ,FINAL));
   s26.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s26.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s26.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s26.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s26.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s26);

   Scanner s27(COUNTER);
   s27.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(2 ,START));
   s27.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(7 ,FINAL));
   s27.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s27.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s27.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s27.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s27.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s27.addTransition(ScannerTransEntry(5 ,'e' ,6));
   s27.addTransition(ScannerTransEntry(6 ,'r' ,7));
   _scannerList.Insert(s27);

   Scanner s28(CREATE);
   s28.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(2 ,START));
   s28.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(6 ,FINAL));
   s28.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s28.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s28.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s28.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s28.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s28.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s28);

   Scanner s29(CURSOR);
   s29.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(2 ,START));
   s29.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(6 ,FINAL));
   s29.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s29.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s29.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s29.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s29.addTransition(ScannerTransEntry(4 ,'o' ,5));
   s29.addTransition(ScannerTransEntry(5 ,'r' ,6));
   _scannerList.Insert(s29);

   Scanner s30(DATE);
   s30.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(2 ,START));
   s30.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(4 ,FINAL));
   s30.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s30.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s30.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s30.addTransition(ScannerTransEntry(3 ,'e' ,4));
   _scannerList.Insert(s30);

   Scanner s31(DATE2STR);
   s31.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(2 ,START));
   s31.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(8 ,FINAL));
   s31.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s31.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s31.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s31.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s31.addTransition(ScannerTransEntry(4 ,'2' ,5));
   s31.addTransition(ScannerTransEntry(5 ,'s' ,6));
   s31.addTransition(ScannerTransEntry(6 ,'t' ,7));
   s31.addTransition(ScannerTransEntry(7 ,'r' ,8));
   _scannerList.Insert(s31);

   Scanner s32(DATE2INT);
   s32.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(2 ,START));
   s32.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(8 ,FINAL));
   s32.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s32.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s32.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s32.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s32.addTransition(ScannerTransEntry(4 ,'2' ,5));
   s32.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s32.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s32.addTransition(ScannerTransEntry(7 ,'t' ,8));
   _scannerList.Insert(s32);

   Scanner s33(DATETIME);
   s33.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(2 ,START));
   s33.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(8 ,FINAL));
   s33.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s33.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s33.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s33.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s33.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s33.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s33.addTransition(ScannerTransEntry(6 ,'m' ,7));
   s33.addTransition(ScannerTransEntry(7 ,'e' ,8));
   _scannerList.Insert(s33);

   Scanner s34(DECIMAL);
   s34.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(2 ,START));
   s34.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(7 ,FINAL));
   s34.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s34.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s34.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s34.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s34.addTransition(ScannerTransEntry(4 ,'m' ,5));
   s34.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s34.addTransition(ScannerTransEntry(6 ,'l' ,7));
   _scannerList.Insert(s34);

   Scanner s35(DEFAULT);
   s35.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(2 ,START));
   s35.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(7 ,FINAL));
   s35.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s35.addTransition(ScannerTransEntry(1 ,'f' ,3));
   s35.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s35.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s35.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s35.addTransition(ScannerTransEntry(5 ,'l' ,6));
   s35.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s35);

   Scanner s36(DELETETOK);
   s36.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(2 ,START));
   s36.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(6 ,FINAL));
   s36.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s36.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s36.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s36.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s36.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s36.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s36);

   Scanner s37(DESC);
   s37.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(2 ,START));
   s37.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(4 ,FINAL));
   s37.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s37.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s37.addTransition(ScannerTransEntry(3 ,'c' ,4));
   _scannerList.Insert(s37);

   Scanner s38(DISTINCT);
   s38.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(2 ,START));
   s38.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(8 ,FINAL));
   s38.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s38.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s38.addTransition(ScannerTransEntry(3 ,'t' ,4));
   s38.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s38.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s38.addTransition(ScannerTransEntry(6 ,'c' ,7));
   s38.addTransition(ScannerTransEntry(7 ,'t' ,8));
   _scannerList.Insert(s38);

   Scanner s39(DIV);
   s39.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s39.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s39.addState(ScannerStateEntry(2 ,START));
   s39.addState(ScannerStateEntry(3 ,FINAL));
   s39.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'v' ,3));
   s39.addTransition(ScannerTransEntry(2 ,'d' ,0));
   _scannerList.Insert(s39);

   Scanner s40(DOUBLE);
   s40.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(2 ,START));
   s40.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(6 ,FINAL));
   s40.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s40.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s40.addTransition(ScannerTransEntry(3 ,'b' ,4));
   s40.addTransition(ScannerTransEntry(4 ,'l' ,5));
   s40.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s40);

   Scanner s41(DROP);
   s41.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s41.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s41.addState(ScannerStateEntry(2 ,START));
   s41.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s41.addState(ScannerStateEntry(4 ,FINAL));
   s41.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s41.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s41.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s41.addTransition(ScannerTransEntry(3 ,'p' ,4));
   _scannerList.Insert(s41);

   Scanner s42(ELSE);
   s42.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s42.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s42.addState(ScannerStateEntry(2 ,START));
   s42.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s42.addState(ScannerStateEntry(4 ,FINAL));
   s42.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s42.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s42.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s42.addTransition(ScannerTransEntry(3 ,'e' ,4));
   _scannerList.Insert(s42);

   Scanner s43(ELSIF);
   s43.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s43.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s43.addState(ScannerStateEntry(2 ,START));
   s43.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s43.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s43.addState(ScannerStateEntry(5 ,FINAL));
   s43.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s43.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s43.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s43.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s43.addTransition(ScannerTransEntry(4 ,'f' ,5));
   _scannerList.Insert(s43);

   Scanner s44(END_TOKEN);
   s44.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s44.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s44.addState(ScannerStateEntry(2 ,START));
   s44.addState(ScannerStateEntry(3 ,FINAL));
   s44.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s44.addTransition(ScannerTransEntry(2 ,'e' ,0));
   _scannerList.Insert(s44);

   Scanner s45(EXCEPTION);
   s45.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s45.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s45.addState(ScannerStateEntry(2 ,START));
   s45.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s45.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s45.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s45.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s45.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s45.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s45.addState(ScannerStateEntry(9 ,FINAL));
   s45.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s45.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s45.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s45.addTransition(ScannerTransEntry(4 ,'p' ,5));
   s45.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s45.addTransition(ScannerTransEntry(6 ,'i' ,7));
   s45.addTransition(ScannerTransEntry(7 ,'o' ,8));
   s45.addTransition(ScannerTransEntry(8 ,'n' ,9));
   _scannerList.Insert(s45);

   Scanner s46(EXISTS);
   s46.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s46.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s46.addState(ScannerStateEntry(2 ,START));
   s46.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s46.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s46.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s46.addState(ScannerStateEntry(6 ,FINAL));
   s46.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s46.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s46.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s46.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s46.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s46.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s46);

   Scanner s47(FALSEVAL);
   s47.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(2 ,START));
   s47.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(5 ,FINAL));
   s47.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s47.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s47.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s47.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s47);

   Scanner s48(FETCH);
   s48.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s48.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s48.addState(ScannerStateEntry(2 ,START));
   s48.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s48.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s48.addState(ScannerStateEntry(5 ,FINAL));
   s48.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s48.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s48.addTransition(ScannerTransEntry(3 ,'c' ,4));
   s48.addTransition(ScannerTransEntry(4 ,'h' ,5));
   _scannerList.Insert(s48);

   Scanner s49(FIXED);
   s49.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s49.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s49.addState(ScannerStateEntry(2 ,START));
   s49.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s49.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s49.addState(ScannerStateEntry(5 ,FINAL));
   s49.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s49.addTransition(ScannerTransEntry(1 ,'x' ,3));
   s49.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s49.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s49.addTransition(ScannerTransEntry(4 ,'d' ,5));
   _scannerList.Insert(s49);

   Scanner s50(FLOAT);
   s50.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s50.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s50.addState(ScannerStateEntry(2 ,START));
   s50.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s50.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s50.addState(ScannerStateEntry(5 ,FINAL));
   s50.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s50.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s50.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s50.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s50);

   Scanner s51(FOR);
   s51.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s51.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s51.addState(ScannerStateEntry(2 ,START));
   s51.addState(ScannerStateEntry(3 ,FINAL));
   s51.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s51.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s51.addTransition(ScannerTransEntry(2 ,'f' ,0));
   _scannerList.Insert(s51);

   Scanner s52(FOREIGN);
   s52.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s52.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s52.addState(ScannerStateEntry(2 ,START));
   s52.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s52.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s52.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s52.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s52.addState(ScannerStateEntry(7 ,FINAL));
   s52.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s52.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s52.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s52.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s52.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s52.addTransition(ScannerTransEntry(5 ,'g' ,6));
   s52.addTransition(ScannerTransEntry(6 ,'n' ,7));
   _scannerList.Insert(s52);

   Scanner s53(FROM);
   s53.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s53.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s53.addState(ScannerStateEntry(2 ,START));
   s53.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s53.addState(ScannerStateEntry(4 ,FINAL));
   s53.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s53.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s53.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s53.addTransition(ScannerTransEntry(3 ,'m' ,4));
   _scannerList.Insert(s53);

   Scanner s54(GETPOS);
   s54.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s54.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s54.addState(ScannerStateEntry(2 ,START));
   s54.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s54.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s54.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s54.addState(ScannerStateEntry(6 ,FINAL));
   s54.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s54.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s54.addTransition(ScannerTransEntry(2 ,'g' ,0));
   s54.addTransition(ScannerTransEntry(3 ,'p' ,4));
   s54.addTransition(ScannerTransEntry(4 ,'o' ,5));
   s54.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s54);

   Scanner s55(GROUP);
   s55.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s55.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s55.addState(ScannerStateEntry(2 ,START));
   s55.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s55.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s55.addState(ScannerStateEntry(5 ,FINAL));
   s55.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s55.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s55.addTransition(ScannerTransEntry(2 ,'g' ,0));
   s55.addTransition(ScannerTransEntry(3 ,'u' ,4));
   s55.addTransition(ScannerTransEntry(4 ,'p' ,5));
   _scannerList.Insert(s55);

   Scanner s56(HAVING);
   s56.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s56.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s56.addState(ScannerStateEntry(2 ,START));
   s56.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s56.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s56.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s56.addState(ScannerStateEntry(6 ,FINAL));
   s56.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s56.addTransition(ScannerTransEntry(1 ,'v' ,3));
   s56.addTransition(ScannerTransEntry(2 ,'h' ,0));
   s56.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s56.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s56.addTransition(ScannerTransEntry(5 ,'g' ,6));
   _scannerList.Insert(s56);

   Scanner s57(IDENTIFIED);
   s57.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(2 ,START));
   s57.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(10 ,FINAL));
   s57.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s57.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s57.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s57.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s57.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s57.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s57.addTransition(ScannerTransEntry(6 ,'f' ,7));
   s57.addTransition(ScannerTransEntry(7 ,'i' ,8));
   s57.addTransition(ScannerTransEntry(8 ,'e' ,9));
   s57.addTransition(ScannerTransEntry(9 ,'d' ,10));
   _scannerList.Insert(s57);

   Scanner s58(IF);
   s58.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s58.addState(ScannerStateEntry(1 ,FINAL));
   s58.addState(ScannerStateEntry(2 ,START));
   s58.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s58.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s58);

   Scanner s59(INTOK);
   s59.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s59.addState(ScannerStateEntry(1 ,FINAL));
   s59.addState(ScannerStateEntry(2 ,START));
   s59.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s59.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s59);

   Scanner s60(INDEX);
   s60.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s60.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s60.addState(ScannerStateEntry(2 ,START));
   s60.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s60.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s60.addState(ScannerStateEntry(5 ,FINAL));
   s60.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s60.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s60.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s60.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s60.addTransition(ScannerTransEntry(4 ,'x' ,5));
   _scannerList.Insert(s60);

   Scanner s61(INNER);
   s61.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s61.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s61.addState(ScannerStateEntry(2 ,START));
   s61.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s61.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s61.addState(ScannerStateEntry(5 ,FINAL));
   s61.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s61.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s61.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s61.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s61.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s61);

   Scanner s62(INT);
   s62.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s62.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s62.addState(ScannerStateEntry(2 ,START));
   s62.addState(ScannerStateEntry(3 ,FINAL));
   s62.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s62.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s62.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s62);

   Scanner s63(INTO);
   s63.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s63.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s63.addState(ScannerStateEntry(2 ,START));
   s63.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s63.addState(ScannerStateEntry(4 ,FINAL));
   s63.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s63.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s63.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s63.addTransition(ScannerTransEntry(3 ,'o' ,4));
   _scannerList.Insert(s63);

   Scanner s64(INT2DATE);
   s64.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s64.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s64.addState(ScannerStateEntry(2 ,START));
   s64.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s64.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s64.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s64.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s64.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s64.addState(ScannerStateEntry(8 ,FINAL));
   s64.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s64.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s64.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s64.addTransition(ScannerTransEntry(3 ,'2' ,4));
   s64.addTransition(ScannerTransEntry(4 ,'d' ,5));
   s64.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s64.addTransition(ScannerTransEntry(6 ,'t' ,7));
   s64.addTransition(ScannerTransEntry(7 ,'e' ,8));
   _scannerList.Insert(s64);

   Scanner s65(INSERT);
   s65.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s65.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s65.addState(ScannerStateEntry(2 ,START));
   s65.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s65.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s65.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s65.addState(ScannerStateEntry(6 ,FINAL));
   s65.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s65.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s65.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s65.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s65.addTransition(ScannerTransEntry(4 ,'r' ,5));
   s65.addTransition(ScannerTransEntry(5 ,'t' ,6));
   _scannerList.Insert(s65);

   Scanner s66(IS);
   s66.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s66.addState(ScannerStateEntry(1 ,FINAL));
   s66.addState(ScannerStateEntry(2 ,START));
   s66.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s66.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s66);

   Scanner s67(ISOLATION);
   s67.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(2 ,START));
   s67.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(9 ,FINAL));
   s67.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s67.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s67.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s67.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s67.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s67.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s67.addTransition(ScannerTransEntry(6 ,'i' ,7));
   s67.addTransition(ScannerTransEntry(7 ,'o' ,8));
   s67.addTransition(ScannerTransEntry(8 ,'n' ,9));
   _scannerList.Insert(s67);

   Scanner s68(JDBC);
   s68.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s68.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s68.addState(ScannerStateEntry(2 ,START));
   s68.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s68.addState(ScannerStateEntry(4 ,FINAL));
   s68.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s68.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s68.addTransition(ScannerTransEntry(2 ,'j' ,0));
   s68.addTransition(ScannerTransEntry(3 ,'c' ,4));
   _scannerList.Insert(s68);

   Scanner s69(JOIN);
   s69.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s69.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s69.addState(ScannerStateEntry(2 ,START));
   s69.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s69.addState(ScannerStateEntry(4 ,FINAL));
   s69.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s69.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s69.addTransition(ScannerTransEntry(2 ,'j' ,0));
   s69.addTransition(ScannerTransEntry(3 ,'n' ,4));
   _scannerList.Insert(s69);

   Scanner s70(KEY);
   s70.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s70.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s70.addState(ScannerStateEntry(2 ,START));
   s70.addState(ScannerStateEntry(3 ,FINAL));
   s70.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s70.addTransition(ScannerTransEntry(1 ,'y' ,3));
   s70.addTransition(ScannerTransEntry(2 ,'k' ,0));
   _scannerList.Insert(s70);

   Scanner s71(LEFT);
   s71.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s71.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s71.addState(ScannerStateEntry(2 ,START));
   s71.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s71.addState(ScannerStateEntry(4 ,FINAL));
   s71.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s71.addTransition(ScannerTransEntry(1 ,'f' ,3));
   s71.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s71.addTransition(ScannerTransEntry(3 ,'t' ,4));
   _scannerList.Insert(s71);

   Scanner s72(LENGTH);
   s72.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s72.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s72.addState(ScannerStateEntry(2 ,START));
   s72.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s72.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s72.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s72.addState(ScannerStateEntry(6 ,FINAL));
   s72.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s72.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s72.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s72.addTransition(ScannerTransEntry(3 ,'g' ,4));
   s72.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s72.addTransition(ScannerTransEntry(5 ,'h' ,6));
   _scannerList.Insert(s72);

   Scanner s73(LIKE);
   s73.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s73.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s73.addState(ScannerStateEntry(2 ,START));
   s73.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s73.addState(ScannerStateEntry(4 ,FINAL));
   s73.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s73.addTransition(ScannerTransEntry(1 ,'k' ,3));
   s73.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s73.addTransition(ScannerTransEntry(3 ,'e' ,4));
   _scannerList.Insert(s73);

   Scanner s74(LIST);
   s74.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s74.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s74.addState(ScannerStateEntry(2 ,START));
   s74.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s74.addState(ScannerStateEntry(4 ,FINAL));
   s74.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s74.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s74.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s74.addTransition(ScannerTransEntry(3 ,'t' ,4));
   _scannerList.Insert(s74);

   Scanner s75(LOAD);
   s75.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s75.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s75.addState(ScannerStateEntry(2 ,START));
   s75.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s75.addState(ScannerStateEntry(4 ,FINAL));
   s75.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s75.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s75.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s75.addTransition(ScannerTransEntry(3 ,'d' ,4));
   _scannerList.Insert(s75);

   Scanner s76(LOCKS);
   s76.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s76.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s76.addState(ScannerStateEntry(2 ,START));
   s76.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s76.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s76.addState(ScannerStateEntry(5 ,FINAL));
   s76.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s76.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s76.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s76.addTransition(ScannerTransEntry(3 ,'k' ,4));
   s76.addTransition(ScannerTransEntry(4 ,'s' ,5));
   _scannerList.Insert(s76);

   Scanner s77(LONG);
   s77.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s77.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s77.addState(ScannerStateEntry(2 ,START));
   s77.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s77.addState(ScannerStateEntry(4 ,FINAL));
   s77.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s77.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s77.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s77.addTransition(ScannerTransEntry(3 ,'g' ,4));
   _scannerList.Insert(s77);

   Scanner s78(LOWER);
   s78.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s78.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s78.addState(ScannerStateEntry(2 ,START));
   s78.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s78.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s78.addState(ScannerStateEntry(5 ,FINAL));
   s78.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s78.addTransition(ScannerTransEntry(1 ,'w' ,3));
   s78.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s78.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s78.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s78);

   Scanner s79(LTRIM);
   s79.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s79.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s79.addState(ScannerStateEntry(2 ,START));
   s79.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s79.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s79.addState(ScannerStateEntry(5 ,FINAL));
   s79.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s79.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s79.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s79.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s79.addTransition(ScannerTransEntry(4 ,'m' ,5));
   _scannerList.Insert(s79);

   Scanner s80(MIN);
   s80.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s80.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s80.addState(ScannerStateEntry(2 ,START));
   s80.addState(ScannerStateEntry(3 ,FINAL));
   s80.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s80.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s80.addTransition(ScannerTransEntry(2 ,'m' ,0));
   _scannerList.Insert(s80);

   Scanner s81(MAX);
   s81.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s81.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s81.addState(ScannerStateEntry(2 ,START));
   s81.addState(ScannerStateEntry(3 ,FINAL));
   s81.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s81.addTransition(ScannerTransEntry(1 ,'x' ,3));
   s81.addTransition(ScannerTransEntry(2 ,'m' ,0));
   _scannerList.Insert(s81);

   Scanner s82(MOD);
   s82.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s82.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s82.addState(ScannerStateEntry(2 ,START));
   s82.addState(ScannerStateEntry(3 ,FINAL));
   s82.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s82.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s82.addTransition(ScannerTransEntry(2 ,'m' ,0));
   _scannerList.Insert(s82);

   Scanner s83(MODIFY);
   s83.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s83.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s83.addState(ScannerStateEntry(2 ,START));
   s83.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s83.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s83.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s83.addState(ScannerStateEntry(6 ,FINAL));
   s83.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s83.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s83.addTransition(ScannerTransEntry(2 ,'m' ,0));
   s83.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s83.addTransition(ScannerTransEntry(4 ,'f' ,5));
   s83.addTransition(ScannerTransEntry(5 ,'y' ,6));
   _scannerList.Insert(s83);

   Scanner s84(NEXTCOUNT);
   s84.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s84.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s84.addState(ScannerStateEntry(2 ,START));
   s84.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s84.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s84.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s84.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s84.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s84.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s84.addState(ScannerStateEntry(9 ,FINAL));
   s84.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s84.addTransition(ScannerTransEntry(1 ,'x' ,3));
   s84.addTransition(ScannerTransEntry(2 ,'n' ,0));
   s84.addTransition(ScannerTransEntry(3 ,'t' ,4));
   s84.addTransition(ScannerTransEntry(4 ,'c' ,5));
   s84.addTransition(ScannerTransEntry(5 ,'o' ,6));
   s84.addTransition(ScannerTransEntry(6 ,'u' ,7));
   s84.addTransition(ScannerTransEntry(7 ,'n' ,8));
   s84.addTransition(ScannerTransEntry(8 ,'t' ,9));
   _scannerList.Insert(s84);

   Scanner s85(NOOP);
   s85.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s85.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s85.addState(ScannerStateEntry(2 ,START));
   s85.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s85.addState(ScannerStateEntry(4 ,FINAL));
   s85.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s85.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s85.addTransition(ScannerTransEntry(2 ,'n' ,0));
   s85.addTransition(ScannerTransEntry(3 ,'p' ,4));
   _scannerList.Insert(s85);

   Scanner s86(NOT);
   s86.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s86.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s86.addState(ScannerStateEntry(2 ,START));
   s86.addState(ScannerStateEntry(3 ,FINAL));
   s86.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s86.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s86.addTransition(ScannerTransEntry(2 ,'n' ,0));
   _scannerList.Insert(s86);

   Scanner s87(NULLTOKEN);
   s87.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s87.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s87.addState(ScannerStateEntry(2 ,START));
   s87.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s87.addState(ScannerStateEntry(4 ,FINAL));
   s87.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s87.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s87.addTransition(ScannerTransEntry(2 ,'n' ,0));
   s87.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s87);

   Scanner s88(OFF);
   s88.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s88.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s88.addState(ScannerStateEntry(2 ,START));
   s88.addState(ScannerStateEntry(3 ,FINAL));
   s88.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s88.addTransition(ScannerTransEntry(1 ,'f' ,3));
   s88.addTransition(ScannerTransEntry(2 ,'o' ,0));
   _scannerList.Insert(s88);

   Scanner s89(ON);
   s89.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s89.addState(ScannerStateEntry(1 ,FINAL));
   s89.addState(ScannerStateEntry(2 ,START));
   s89.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s89.addTransition(ScannerTransEntry(2 ,'o' ,0));
   _scannerList.Insert(s89);

   Scanner s90(OUTTOK);
   s90.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s90.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s90.addState(ScannerStateEntry(2 ,START));
   s90.addState(ScannerStateEntry(3 ,FINAL));
   s90.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s90.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s90.addTransition(ScannerTransEntry(2 ,'o' ,0));
   _scannerList.Insert(s90);

   Scanner s91(OUTER);
   s91.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s91.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s91.addState(ScannerStateEntry(2 ,START));
   s91.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s91.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s91.addState(ScannerStateEntry(5 ,FINAL));
   s91.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s91.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s91.addTransition(ScannerTransEntry(2 ,'o' ,0));
   s91.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s91.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s91);

   Scanner s92(OR);
   s92.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s92.addState(ScannerStateEntry(1 ,FINAL));
   s92.addState(ScannerStateEntry(2 ,START));
   s92.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s92.addTransition(ScannerTransEntry(2 ,'o' ,0));
   _scannerList.Insert(s92);

   Scanner s93(ORDER);
   s93.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s93.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s93.addState(ScannerStateEntry(2 ,START));
   s93.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s93.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s93.addState(ScannerStateEntry(5 ,FINAL));
   s93.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s93.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s93.addTransition(ScannerTransEntry(2 ,'o' ,0));
   s93.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s93.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s93);

   Scanner s94(ORDERSPACE);
   s94.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s94.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s94.addState(ScannerStateEntry(2 ,START));
   s94.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s94.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s94.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s94.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s94.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s94.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s94.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s94.addState(ScannerStateEntry(10 ,FINAL));
   s94.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s94.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s94.addTransition(ScannerTransEntry(2 ,'o' ,0));
   s94.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s94.addTransition(ScannerTransEntry(4 ,'r' ,5));
   s94.addTransition(ScannerTransEntry(5 ,'s' ,6));
   s94.addTransition(ScannerTransEntry(6 ,'p' ,7));
   s94.addTransition(ScannerTransEntry(7 ,'a' ,8));
   s94.addTransition(ScannerTransEntry(8 ,'c' ,9));
   s94.addTransition(ScannerTransEntry(9 ,'e' ,10));
   _scannerList.Insert(s94);

   Scanner s95(PLAN);
   s95.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s95.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s95.addState(ScannerStateEntry(2 ,START));
   s95.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s95.addState(ScannerStateEntry(4 ,FINAL));
   s95.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s95.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s95.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s95.addTransition(ScannerTransEntry(3 ,'n' ,4));
   _scannerList.Insert(s95);

   Scanner s96(POOL);
   s96.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s96.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s96.addState(ScannerStateEntry(2 ,START));
   s96.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s96.addState(ScannerStateEntry(4 ,FINAL));
   s96.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s96.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s96.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s96.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s96);

   Scanner s97(POWER);
   s97.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s97.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s97.addState(ScannerStateEntry(2 ,START));
   s97.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s97.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s97.addState(ScannerStateEntry(5 ,FINAL));
   s97.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s97.addTransition(ScannerTransEntry(1 ,'w' ,3));
   s97.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s97.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s97.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s97);

   Scanner s98(PRIMARY);
   s98.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s98.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s98.addState(ScannerStateEntry(2 ,START));
   s98.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s98.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s98.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s98.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s98.addState(ScannerStateEntry(7 ,FINAL));
   s98.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s98.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s98.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s98.addTransition(ScannerTransEntry(3 ,'m' ,4));
   s98.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s98.addTransition(ScannerTransEntry(5 ,'r' ,6));
   s98.addTransition(ScannerTransEntry(6 ,'y' ,7));
   _scannerList.Insert(s98);

   Scanner s99(PRINT);
   s99.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s99.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s99.addState(ScannerStateEntry(2 ,START));
   s99.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s99.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s99.addState(ScannerStateEntry(5 ,FINAL));
   s99.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s99.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s99.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s99.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s99.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s99);

   Scanner s100(PROCEDURE);
   s100.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s100.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s100.addState(ScannerStateEntry(2 ,START));
   s100.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s100.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s100.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s100.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s100.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s100.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s100.addState(ScannerStateEntry(9 ,FINAL));
   s100.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s100.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s100.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s100.addTransition(ScannerTransEntry(3 ,'c' ,4));
   s100.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s100.addTransition(ScannerTransEntry(5 ,'d' ,6));
   s100.addTransition(ScannerTransEntry(6 ,'u' ,7));
   s100.addTransition(ScannerTransEntry(7 ,'r' ,8));
   s100.addTransition(ScannerTransEntry(8 ,'e' ,9));
   _scannerList.Insert(s100);

   Scanner s101(QUIT);
   s101.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s101.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s101.addState(ScannerStateEntry(2 ,START));
   s101.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s101.addState(ScannerStateEntry(4 ,FINAL));
   s101.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s101.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s101.addTransition(ScannerTransEntry(2 ,'q' ,0));
   s101.addTransition(ScannerTransEntry(3 ,'t' ,4));
   _scannerList.Insert(s101);

   Scanner s102(RANDSTR);
   s102.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s102.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s102.addState(ScannerStateEntry(2 ,START));
   s102.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s102.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s102.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s102.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s102.addState(ScannerStateEntry(7 ,FINAL));
   s102.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s102.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s102.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s102.addTransition(ScannerTransEntry(3 ,'d' ,4));
   s102.addTransition(ScannerTransEntry(4 ,'s' ,5));
   s102.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s102.addTransition(ScannerTransEntry(6 ,'r' ,7));
   _scannerList.Insert(s102);

   Scanner s103(RANDINT);
   s103.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s103.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s103.addState(ScannerStateEntry(2 ,START));
   s103.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s103.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s103.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s103.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s103.addState(ScannerStateEntry(7 ,FINAL));
   s103.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s103.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s103.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s103.addTransition(ScannerTransEntry(3 ,'d' ,4));
   s103.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s103.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s103.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s103);

   Scanner s104(RBSEG);
   s104.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s104.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s104.addState(ScannerStateEntry(2 ,START));
   s104.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s104.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s104.addState(ScannerStateEntry(5 ,FINAL));
   s104.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s104.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s104.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s104.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s104.addTransition(ScannerTransEntry(4 ,'g' ,5));
   _scannerList.Insert(s104);

   Scanner s105(REFERENCES);
   s105.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(2 ,START));
   s105.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(10 ,FINAL));
   s105.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s105.addTransition(ScannerTransEntry(1 ,'f' ,3));
   s105.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s105.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s105.addTransition(ScannerTransEntry(4 ,'r' ,5));
   s105.addTransition(ScannerTransEntry(5 ,'e' ,6));
   s105.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s105.addTransition(ScannerTransEntry(7 ,'c' ,8));
   s105.addTransition(ScannerTransEntry(8 ,'e' ,9));
   s105.addTransition(ScannerTransEntry(9 ,'s' ,10));
   _scannerList.Insert(s105);

   Scanner s106(RENAME);
   s106.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(2 ,START));
   s106.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(6 ,FINAL));
   s106.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s106.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s106.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s106.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s106.addTransition(ScannerTransEntry(4 ,'m' ,5));
   s106.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s106);

   Scanner s107(REORGANIZE);
   s107.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(2 ,START));
   s107.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(10 ,FINAL));
   s107.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s107.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s107.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s107.addTransition(ScannerTransEntry(3 ,'r' ,4));
   s107.addTransition(ScannerTransEntry(4 ,'g' ,5));
   s107.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s107.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s107.addTransition(ScannerTransEntry(7 ,'i' ,8));
   s107.addTransition(ScannerTransEntry(8 ,'z' ,9));
   s107.addTransition(ScannerTransEntry(9 ,'e' ,10));
   _scannerList.Insert(s107);

   Scanner s108(RETURNTOKEN);
   s108.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(2 ,START));
   s108.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(6 ,FINAL));
   s108.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s108.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s108.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s108.addTransition(ScannerTransEntry(3 ,'u' ,4));
   s108.addTransition(ScannerTransEntry(4 ,'r' ,5));
   s108.addTransition(ScannerTransEntry(5 ,'n' ,6));
   _scannerList.Insert(s108);

   Scanner s109(REMOVE);
   s109.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s109.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s109.addState(ScannerStateEntry(2 ,START));
   s109.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s109.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s109.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s109.addState(ScannerStateEntry(6 ,FINAL));
   s109.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s109.addTransition(ScannerTransEntry(1 ,'m' ,3));
   s109.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s109.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s109.addTransition(ScannerTransEntry(4 ,'v' ,5));
   s109.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s109);

   Scanner s110(REPLACE);
   s110.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s110.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s110.addState(ScannerStateEntry(2 ,START));
   s110.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s110.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s110.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s110.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s110.addState(ScannerStateEntry(7 ,FINAL));
   s110.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s110.addTransition(ScannerTransEntry(1 ,'p' ,3));
   s110.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s110.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s110.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s110.addTransition(ScannerTransEntry(5 ,'c' ,6));
   s110.addTransition(ScannerTransEntry(6 ,'e' ,7));
   _scannerList.Insert(s110);

   Scanner s111(RIGHT);
   s111.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s111.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s111.addState(ScannerStateEntry(2 ,START));
   s111.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s111.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s111.addState(ScannerStateEntry(5 ,FINAL));
   s111.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s111.addTransition(ScannerTransEntry(1 ,'g' ,3));
   s111.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s111.addTransition(ScannerTransEntry(3 ,'h' ,4));
   s111.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s111);

   Scanner s112(ROLLBACK);
   s112.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s112.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s112.addState(ScannerStateEntry(2 ,START));
   s112.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s112.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s112.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s112.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s112.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s112.addState(ScannerStateEntry(8 ,FINAL));
   s112.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s112.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s112.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s112.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s112.addTransition(ScannerTransEntry(4 ,'b' ,5));
   s112.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s112.addTransition(ScannerTransEntry(6 ,'c' ,7));
   s112.addTransition(ScannerTransEntry(7 ,'k' ,8));
   _scannerList.Insert(s112);

   Scanner s113(ROUND);
   s113.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s113.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s113.addState(ScannerStateEntry(2 ,START));
   s113.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s113.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s113.addState(ScannerStateEntry(5 ,FINAL));
   s113.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s113.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s113.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s113.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s113.addTransition(ScannerTransEntry(4 ,'d' ,5));
   _scannerList.Insert(s113);

   Scanner s114(ROWLIMIT);
   s114.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s114.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s114.addState(ScannerStateEntry(2 ,START));
   s114.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s114.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s114.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s114.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s114.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s114.addState(ScannerStateEntry(8 ,FINAL));
   s114.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s114.addTransition(ScannerTransEntry(1 ,'w' ,3));
   s114.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s114.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s114.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s114.addTransition(ScannerTransEntry(5 ,'m' ,6));
   s114.addTransition(ScannerTransEntry(6 ,'i' ,7));
   s114.addTransition(ScannerTransEntry(7 ,'t' ,8));
   _scannerList.Insert(s114);

   Scanner s115(RTRIM);
   s115.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s115.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s115.addState(ScannerStateEntry(2 ,START));
   s115.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s115.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s115.addState(ScannerStateEntry(5 ,FINAL));
   s115.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s115.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s115.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s115.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s115.addTransition(ScannerTransEntry(4 ,'m' ,5));
   _scannerList.Insert(s115);

   Scanner s116(SELECT);
   s116.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s116.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s116.addState(ScannerStateEntry(2 ,START));
   s116.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s116.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s116.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s116.addState(ScannerStateEntry(6 ,FINAL));
   s116.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s116.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s116.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s116.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s116.addTransition(ScannerTransEntry(4 ,'c' ,5));
   s116.addTransition(ScannerTransEntry(5 ,'t' ,6));
   _scannerList.Insert(s116);

   Scanner s117(SET);
   s117.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s117.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s117.addState(ScannerStateEntry(2 ,START));
   s117.addState(ScannerStateEntry(3 ,FINAL));
   s117.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s117.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s117.addTransition(ScannerTransEntry(2 ,'s' ,0));
   _scannerList.Insert(s117);

   Scanner s118(SHOW);
   s118.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s118.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s118.addState(ScannerStateEntry(2 ,START));
   s118.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s118.addState(ScannerStateEntry(4 ,FINAL));
   s118.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s118.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s118.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s118.addTransition(ScannerTransEntry(3 ,'w' ,4));
   _scannerList.Insert(s118);

   Scanner s119(SMALLINT);
   s119.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(2 ,START));
   s119.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(8 ,FINAL));
   s119.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s119.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s119.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s119.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s119.addTransition(ScannerTransEntry(4 ,'l' ,5));
   s119.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s119.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s119.addTransition(ScannerTransEntry(7 ,'t' ,8));
   _scannerList.Insert(s119);

   Scanner s120(START_TOKEN);
   s120.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s120.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s120.addState(ScannerStateEntry(2 ,START));
   s120.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s120.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s120.addState(ScannerStateEntry(5 ,FINAL));
   s120.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s120.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s120.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s120.addTransition(ScannerTransEntry(3 ,'r' ,4));
   s120.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s120);

   Scanner s121(STRING);
   s121.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s121.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s121.addState(ScannerStateEntry(2 ,START));
   s121.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s121.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s121.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s121.addState(ScannerStateEntry(6 ,FINAL));
   s121.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s121.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s121.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s121.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s121.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s121.addTransition(ScannerTransEntry(5 ,'g' ,6));
   _scannerList.Insert(s121);

   Scanner s122(SUBSTR);
   s122.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s122.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s122.addState(ScannerStateEntry(2 ,START));
   s122.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s122.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s122.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s122.addState(ScannerStateEntry(6 ,FINAL));
   s122.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s122.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s122.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s122.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s122.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s122.addTransition(ScannerTransEntry(5 ,'r' ,6));
   _scannerList.Insert(s122);

   Scanner s123(SUM);
   s123.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s123.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s123.addState(ScannerStateEntry(2 ,START));
   s123.addState(ScannerStateEntry(3 ,FINAL));
   s123.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s123.addTransition(ScannerTransEntry(1 ,'m' ,3));
   s123.addTransition(ScannerTransEntry(2 ,'s' ,0));
   _scannerList.Insert(s123);

   Scanner s124(SYNC);
   s124.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s124.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s124.addState(ScannerStateEntry(2 ,START));
   s124.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s124.addState(ScannerStateEntry(4 ,FINAL));
   s124.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s124.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s124.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s124.addTransition(ScannerTransEntry(3 ,'c' ,4));
   _scannerList.Insert(s124);

   Scanner s125(SYSDATE);
   s125.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s125.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s125.addState(ScannerStateEntry(2 ,START));
   s125.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s125.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s125.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s125.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s125.addState(ScannerStateEntry(7 ,FINAL));
   s125.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s125.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s125.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s125.addTransition(ScannerTransEntry(3 ,'d' ,4));
   s125.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s125.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s125.addTransition(ScannerTransEntry(6 ,'e' ,7));
   _scannerList.Insert(s125);

   Scanner s126(SYSTEMSPACE);
   s126.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(2 ,START));
   s126.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(10 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(11 ,FINAL));
   s126.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s126.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s126.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s126.addTransition(ScannerTransEntry(3 ,'t' ,4));
   s126.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s126.addTransition(ScannerTransEntry(5 ,'m' ,6));
   s126.addTransition(ScannerTransEntry(6 ,'s' ,7));
   s126.addTransition(ScannerTransEntry(7 ,'p' ,8));
   s126.addTransition(ScannerTransEntry(8 ,'a' ,9));
   s126.addTransition(ScannerTransEntry(9 ,'c' ,10));
   s126.addTransition(ScannerTransEntry(10 ,'e' ,11));
   _scannerList.Insert(s126);

   Scanner s127(SYSOBJ);
   s127.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s127.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s127.addState(ScannerStateEntry(2 ,START));
   s127.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s127.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s127.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s127.addState(ScannerStateEntry(6 ,FINAL));
   s127.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s127.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s127.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s127.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s127.addTransition(ScannerTransEntry(4 ,'b' ,5));
   s127.addTransition(ScannerTransEntry(5 ,'j' ,6));
   _scannerList.Insert(s127);

   Scanner s128(TABLEINFO);
   s128.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(2 ,START));
   s128.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(9 ,FINAL));
   s128.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s128.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s128.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s128.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s128.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s128.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s128.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s128.addTransition(ScannerTransEntry(7 ,'f' ,8));
   s128.addTransition(ScannerTransEntry(8 ,'o' ,9));
   _scannerList.Insert(s128);

   Scanner s129(TABLE);
   s129.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s129.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s129.addState(ScannerStateEntry(2 ,START));
   s129.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s129.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s129.addState(ScannerStateEntry(5 ,FINAL));
   s129.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s129.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s129.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s129.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s129.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s129);

   Scanner s130(TABLESET);
   s130.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(2 ,START));
   s130.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(8 ,FINAL));
   s130.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s130.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s130.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s130.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s130.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s130.addTransition(ScannerTransEntry(5 ,'s' ,6));
   s130.addTransition(ScannerTransEntry(6 ,'e' ,7));
   s130.addTransition(ScannerTransEntry(7 ,'t' ,8));
   _scannerList.Insert(s130);

   Scanner s131(THEN);
   s131.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s131.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s131.addState(ScannerStateEntry(2 ,START));
   s131.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s131.addState(ScannerStateEntry(4 ,FINAL));
   s131.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s131.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s131.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s131.addTransition(ScannerTransEntry(3 ,'n' ,4));
   _scannerList.Insert(s131);

   Scanner s132(TINYINT);
   s132.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(2 ,START));
   s132.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(7 ,FINAL));
   s132.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s132.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s132.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s132.addTransition(ScannerTransEntry(3 ,'y' ,4));
   s132.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s132.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s132.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s132);

   Scanner s133(TMPOBJ);
   s133.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s133.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s133.addState(ScannerStateEntry(2 ,START));
   s133.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s133.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s133.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s133.addState(ScannerStateEntry(6 ,FINAL));
   s133.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s133.addTransition(ScannerTransEntry(1 ,'p' ,3));
   s133.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s133.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s133.addTransition(ScannerTransEntry(4 ,'b' ,5));
   s133.addTransition(ScannerTransEntry(5 ,'j' ,6));
   _scannerList.Insert(s133);

   Scanner s134(TRANSACTION);
   s134.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(2 ,START));
   s134.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(10 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(11 ,FINAL));
   s134.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s134.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s134.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s134.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s134.addTransition(ScannerTransEntry(4 ,'s' ,5));
   s134.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s134.addTransition(ScannerTransEntry(6 ,'c' ,7));
   s134.addTransition(ScannerTransEntry(7 ,'t' ,8));
   s134.addTransition(ScannerTransEntry(8 ,'i' ,9));
   s134.addTransition(ScannerTransEntry(9 ,'o' ,10));
   s134.addTransition(ScannerTransEntry(10 ,'n' ,11));
   _scannerList.Insert(s134);

   Scanner s135(STR2INT);
   s135.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s135.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s135.addState(ScannerStateEntry(2 ,START));
   s135.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s135.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s135.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s135.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s135.addState(ScannerStateEntry(7 ,FINAL));
   s135.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s135.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s135.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s135.addTransition(ScannerTransEntry(3 ,'2' ,4));
   s135.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s135.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s135.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s135);

   Scanner s136(STR2LONG);
   s136.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s136.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s136.addState(ScannerStateEntry(2 ,START));
   s136.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s136.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s136.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s136.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s136.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s136.addState(ScannerStateEntry(8 ,FINAL));
   s136.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s136.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s136.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s136.addTransition(ScannerTransEntry(3 ,'2' ,4));
   s136.addTransition(ScannerTransEntry(4 ,'l' ,5));
   s136.addTransition(ScannerTransEntry(5 ,'o' ,6));
   s136.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s136.addTransition(ScannerTransEntry(7 ,'g' ,8));
   _scannerList.Insert(s136);

   Scanner s137(TO);
   s137.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s137.addState(ScannerStateEntry(1 ,FINAL));
   s137.addState(ScannerStateEntry(2 ,START));
   s137.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s137.addTransition(ScannerTransEntry(2 ,'t' ,0));
   _scannerList.Insert(s137);

   Scanner s138(TRIM);
   s138.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s138.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s138.addState(ScannerStateEntry(2 ,START));
   s138.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s138.addState(ScannerStateEntry(4 ,FINAL));
   s138.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s138.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s138.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s138.addTransition(ScannerTransEntry(3 ,'m' ,4));
   _scannerList.Insert(s138);

   Scanner s139(TRUEVAL);
   s139.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s139.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s139.addState(ScannerStateEntry(2 ,START));
   s139.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s139.addState(ScannerStateEntry(4 ,FINAL));
   s139.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s139.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s139.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s139.addTransition(ScannerTransEntry(3 ,'e' ,4));
   _scannerList.Insert(s139);

   Scanner s140(TRUNC);
   s140.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s140.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s140.addState(ScannerStateEntry(2 ,START));
   s140.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s140.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s140.addState(ScannerStateEntry(5 ,FINAL));
   s140.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s140.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s140.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s140.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s140.addTransition(ScannerTransEntry(4 ,'c' ,5));
   _scannerList.Insert(s140);

   Scanner s141(UNION);
   s141.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s141.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s141.addState(ScannerStateEntry(2 ,START));
   s141.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s141.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s141.addState(ScannerStateEntry(5 ,FINAL));
   s141.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s141.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s141.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s141.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s141.addTransition(ScannerTransEntry(4 ,'n' ,5));
   _scannerList.Insert(s141);

   Scanner s142(UNIQUE);
   s142.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s142.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s142.addState(ScannerStateEntry(2 ,START));
   s142.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s142.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s142.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s142.addState(ScannerStateEntry(6 ,FINAL));
   s142.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s142.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s142.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s142.addTransition(ScannerTransEntry(3 ,'q' ,4));
   s142.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s142.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s142);

   Scanner s143(UPDATE);
   s143.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s143.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s143.addState(ScannerStateEntry(2 ,START));
   s143.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s143.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s143.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s143.addState(ScannerStateEntry(6 ,FINAL));
   s143.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s143.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s143.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s143.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s143.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s143.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s143);

   Scanner s144(UPPER);
   s144.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s144.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s144.addState(ScannerStateEntry(2 ,START));
   s144.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s144.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s144.addState(ScannerStateEntry(5 ,FINAL));
   s144.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s144.addTransition(ScannerTransEntry(1 ,'p' ,3));
   s144.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s144.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s144.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s144);

   Scanner s145(VAR);
   s145.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s145.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s145.addState(ScannerStateEntry(2 ,START));
   s145.addState(ScannerStateEntry(3 ,FINAL));
   s145.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s145.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s145.addTransition(ScannerTransEntry(2 ,'v' ,0));
   _scannerList.Insert(s145);

   Scanner s146(VALUES);
   s146.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s146.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s146.addState(ScannerStateEntry(2 ,START));
   s146.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s146.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s146.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s146.addState(ScannerStateEntry(6 ,FINAL));
   s146.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s146.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s146.addTransition(ScannerTransEntry(2 ,'v' ,0));
   s146.addTransition(ScannerTransEntry(3 ,'u' ,4));
   s146.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s146.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s146);

   Scanner s147(VIEW);
   s147.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s147.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s147.addState(ScannerStateEntry(2 ,START));
   s147.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s147.addState(ScannerStateEntry(4 ,FINAL));
   s147.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s147.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s147.addTransition(ScannerTransEntry(2 ,'v' ,0));
   s147.addTransition(ScannerTransEntry(3 ,'w' ,4));
   _scannerList.Insert(s147);

   Scanner s148(WHEN);
   s148.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s148.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s148.addState(ScannerStateEntry(2 ,START));
   s148.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s148.addState(ScannerStateEntry(4 ,FINAL));
   s148.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s148.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s148.addTransition(ScannerTransEntry(2 ,'w' ,0));
   s148.addTransition(ScannerTransEntry(3 ,'n' ,4));
   _scannerList.Insert(s148);

   Scanner s149(WHERE);
   s149.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s149.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s149.addState(ScannerStateEntry(2 ,START));
   s149.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s149.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s149.addState(ScannerStateEntry(5 ,FINAL));
   s149.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s149.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s149.addTransition(ScannerTransEntry(2 ,'w' ,0));
   s149.addTransition(ScannerTransEntry(3 ,'r' ,4));
   s149.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s149);

   Scanner s150(WHILE);
   s150.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s150.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s150.addState(ScannerStateEntry(2 ,START));
   s150.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s150.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s150.addState(ScannerStateEntry(5 ,FINAL));
   s150.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s150.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s150.addTransition(ScannerTransEntry(2 ,'w' ,0));
   s150.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s150.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s150);

   Scanner s151(CONCAT);
   s151.addState(ScannerStateEntry(0 ,START));
   s151.addState(ScannerStateEntry(1 ,FINAL));
   s151.addTransition(ScannerTransEntry(0 ,'|' ,1));
   _scannerList.Insert(s151);

   Scanner s152(EQU);
   s152.addState(ScannerStateEntry(0 ,START));
   s152.addState(ScannerStateEntry(1 ,FINAL));
   s152.addTransition(ScannerTransEntry(0 ,'=' ,1));
   _scannerList.Insert(s152);

   Scanner s153(KSEP);
   s153.addState(ScannerStateEntry(0 ,START));
   s153.addState(ScannerStateEntry(1 ,FINAL));
   s153.addTransition(ScannerTransEntry(0 ,',' ,1));
   _scannerList.Insert(s153);

   Scanner s154(LB);
   s154.addState(ScannerStateEntry(0 ,START));
   s154.addState(ScannerStateEntry(1 ,FINAL));
   s154.addTransition(ScannerTransEntry(0 ,'(' ,1));
   _scannerList.Insert(s154);

   Scanner s155(LT);
   s155.addState(ScannerStateEntry(0 ,START));
   s155.addState(ScannerStateEntry(1 ,FINAL));
   s155.addTransition(ScannerTransEntry(0 ,'<' ,1));
   _scannerList.Insert(s155);

   Scanner s156(MT);
   s156.addState(ScannerStateEntry(0 ,START));
   s156.addState(ScannerStateEntry(1 ,FINAL));
   s156.addTransition(ScannerTransEntry(0 ,'>' ,1));
   _scannerList.Insert(s156);

   Scanner s157(NEGATION);
   s157.addState(ScannerStateEntry(0 ,START));
   s157.addState(ScannerStateEntry(1 ,FINAL));
   s157.addTransition(ScannerTransEntry(0 ,'!' ,1));
   _scannerList.Insert(s157);

   Scanner s158(RB);
   s158.addState(ScannerStateEntry(0 ,START));
   s158.addState(ScannerStateEntry(1 ,FINAL));
   s158.addTransition(ScannerTransEntry(0 ,')' ,1));
   _scannerList.Insert(s158);

   Scanner s159(LAB);
   s159.addState(ScannerStateEntry(0 ,START));
   s159.addState(ScannerStateEntry(1 ,FINAL));
   s159.addTransition(ScannerTransEntry(0 ,'[' ,1));
   _scannerList.Insert(s159);

   Scanner s160(RAB);
   s160.addState(ScannerStateEntry(0 ,START));
   s160.addState(ScannerStateEntry(1 ,FINAL));
   s160.addTransition(ScannerTransEntry(0 ,']' ,1));
   _scannerList.Insert(s160);

   Scanner s161(SEMICOLON);
   s161.addState(ScannerStateEntry(0 ,START));
   s161.addState(ScannerStateEntry(1 ,FINAL));
   s161.addTransition(ScannerTransEntry(0 ,';' ,1));
   _scannerList.Insert(s161);

   Scanner s162(STAR);
   s162.addState(ScannerStateEntry(0 ,START));
   s162.addState(ScannerStateEntry(1 ,FINAL));
   s162.addTransition(ScannerTransEntry(0 ,'*' ,1));
   _scannerList.Insert(s162);

   Scanner s163(DIVISION);
   s163.addState(ScannerStateEntry(0 ,START));
   s163.addState(ScannerStateEntry(1 ,FINAL));
   s163.addTransition(ScannerTransEntry(0 ,'/' ,1));
   _scannerList.Insert(s163);

   Scanner s164(MINUS);
   s164.addState(ScannerStateEntry(0 ,START));
   s164.addState(ScannerStateEntry(1 ,FINAL));
   s164.addTransition(ScannerTransEntry(0 ,'-' ,1));
   _scannerList.Insert(s164);

   Scanner s165(PLUS);
   s165.addState(ScannerStateEntry(0 ,START));
   s165.addState(ScannerStateEntry(1 ,FINAL));
   s165.addTransition(ScannerTransEntry(0 ,'+' ,1));
   _scannerList.Insert(s165);

   Scanner s166(INTVAL);
   s166.addState(ScannerStateEntry(0 ,START));
   s166.addState(ScannerStateEntry(1 ,FINAL));
   s166.addState(ScannerStateEntry(2 ,FINAL));
   s166.addTransition(ScannerTransEntry(0 ,'1' ,1));
   s166.addTransition(ScannerTransEntry(0 ,'2' ,1));
   s166.addTransition(ScannerTransEntry(0 ,'3' ,1));
   s166.addTransition(ScannerTransEntry(0 ,'4' ,1));
   s166.addTransition(ScannerTransEntry(0 ,'5' ,1));
   s166.addTransition(ScannerTransEntry(0 ,'6' ,1));
   s166.addTransition(ScannerTransEntry(0 ,'7' ,1));
   s166.addTransition(ScannerTransEntry(0 ,'8' ,1));
   s166.addTransition(ScannerTransEntry(0 ,'9' ,1));
   s166.addTransition(ScannerTransEntry(0 ,'0' ,2));
   s166.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s166.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s166.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s166.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s166.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s166.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s166.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s166.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s166.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s166.addTransition(ScannerTransEntry(1 ,'9' ,1));
   _scannerList.Insert(s166);

   Scanner s167(FLOATVAL);
   s167.addState(ScannerStateEntry(0 ,START));
   s167.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s167.addState(ScannerStateEntry(2 ,INTERMEDIATE));
   s167.addState(ScannerStateEntry(3 ,FINAL));
   s167.addTransition(ScannerTransEntry(0 ,'1' ,1));
   s167.addTransition(ScannerTransEntry(0 ,'2' ,1));
   s167.addTransition(ScannerTransEntry(0 ,'3' ,1));
   s167.addTransition(ScannerTransEntry(0 ,'4' ,1));
   s167.addTransition(ScannerTransEntry(0 ,'5' ,1));
   s167.addTransition(ScannerTransEntry(0 ,'6' ,1));
   s167.addTransition(ScannerTransEntry(0 ,'7' ,1));
   s167.addTransition(ScannerTransEntry(0 ,'8' ,1));
   s167.addTransition(ScannerTransEntry(0 ,'9' ,1));
   s167.addTransition(ScannerTransEntry(0 ,'0' ,2));
   s167.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s167.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s167.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s167.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s167.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s167.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s167.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s167.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s167.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s167.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s167.addTransition(ScannerTransEntry(1 ,'.' ,3));
   s167.addTransition(ScannerTransEntry(2 ,'.' ,3));
   s167.addTransition(ScannerTransEntry(3 ,'0' ,3));
   s167.addTransition(ScannerTransEntry(3 ,'1' ,3));
   s167.addTransition(ScannerTransEntry(3 ,'2' ,3));
   s167.addTransition(ScannerTransEntry(3 ,'3' ,3));
   s167.addTransition(ScannerTransEntry(3 ,'4' ,3));
   s167.addTransition(ScannerTransEntry(3 ,'5' ,3));
   s167.addTransition(ScannerTransEntry(3 ,'6' ,3));
   s167.addTransition(ScannerTransEntry(3 ,'7' ,3));
   s167.addTransition(ScannerTransEntry(3 ,'8' ,3));
   s167.addTransition(ScannerTransEntry(3 ,'9' ,3));
   _scannerList.Insert(s167);

   Scanner s168(IDENTIFIER);
   s168.addState(ScannerStateEntry(0 ,START));
   s168.addState(ScannerStateEntry(1 ,FINAL));
   s168.addTransition(ScannerTransEntry(0 ,'$' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s168.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s168.addTransition(ScannerTransEntry(1 ,'z' ,1));
   _scannerList.Insert(s168);

   Scanner s169(VARREF);
   s169.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s169.addState(ScannerStateEntry(1 ,FINAL));
   s169.addState(ScannerStateEntry(2 ,START));
   s169.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s169.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s169.addTransition(ScannerTransEntry(1 ,'z' ,1));
   s169.addTransition(ScannerTransEntry(2 ,':' ,0));
   _scannerList.Insert(s169);

   Scanner s170(QUALIFIEDOBJ);
   s170.addState(ScannerStateEntry(0 ,START));
   s170.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s170.addState(ScannerStateEntry(2 ,INTERMEDIATE));
   s170.addState(ScannerStateEntry(3 ,FINAL));
   s170.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s170.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'z' ,1));
   s170.addTransition(ScannerTransEntry(1 ,'.' ,2));
   s170.addTransition(ScannerTransEntry(2 ,'$' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'A' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'B' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'C' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'D' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'E' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'F' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'G' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'H' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'I' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'J' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'K' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'L' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'M' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'N' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'O' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'P' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'Q' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'R' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'S' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'T' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'U' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'V' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'W' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'X' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'Y' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'Z' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'a' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'b' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'c' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'d' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'e' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'f' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'g' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'h' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'i' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'j' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'k' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'l' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'m' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'n' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'o' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'p' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'q' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'r' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'s' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'t' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'u' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'v' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'w' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'x' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'y' ,3));
   s170.addTransition(ScannerTransEntry(2 ,'z' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'0' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'1' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'2' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'3' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'4' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'5' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'6' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'7' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'8' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'9' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'A' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'B' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'C' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'D' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'E' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'F' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'G' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'H' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'I' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'J' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'K' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'L' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'M' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'N' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'O' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'P' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'Q' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'R' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'S' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'T' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'U' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'V' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'W' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'X' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'Y' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'Z' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'_' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'a' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'b' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'c' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'d' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'e' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'f' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'g' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'h' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'i' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'j' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'k' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'l' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'m' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'n' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'o' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'p' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'q' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'r' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'s' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'t' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'u' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'v' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'w' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'x' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'y' ,3));
   s170.addTransition(ScannerTransEntry(3 ,'z' ,3));
   _scannerList.Insert(s170);

   Scanner s171(QUALIFIEDPRE);
   s171.addState(ScannerStateEntry(0 ,START));
   s171.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s171.addState(ScannerStateEntry(2 ,FINAL));
   s171.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'z' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'.' ,2));
   _scannerList.Insert(s171);

   Scanner s172(QUALIFIEDTS);
   s172.addState(ScannerStateEntry(0 ,START));
   s172.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s172.addState(ScannerStateEntry(2 ,INTERMEDIATE));
   s172.addState(ScannerStateEntry(3 ,FINAL));
   s172.addTransition(ScannerTransEntry(0 ,'$' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'z' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'@' ,2));
   s172.addTransition(ScannerTransEntry(2 ,'A' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'B' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'C' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'D' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'E' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'F' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'G' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'H' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'I' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'J' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'K' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'L' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'M' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'N' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'O' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'P' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'Q' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'R' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'S' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'T' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'U' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'V' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'W' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'X' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'Y' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'Z' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'a' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'b' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'c' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'d' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'e' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'f' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'g' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'h' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'i' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'j' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'k' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'l' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'m' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'n' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'o' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'p' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'q' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'r' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'s' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'t' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'u' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'v' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'w' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'x' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'y' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'z' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'0' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'1' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'2' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'3' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'4' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'5' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'6' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'7' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'8' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'9' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'A' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'B' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'C' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'D' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'E' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'F' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'G' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'H' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'I' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'J' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'K' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'L' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'M' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'N' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'O' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'P' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'Q' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'R' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'S' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'T' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'U' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'V' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'W' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'X' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'Y' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'Z' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'_' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'a' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'b' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'c' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'d' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'e' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'f' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'g' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'h' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'i' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'j' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'k' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'l' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'m' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'n' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'o' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'p' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'q' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'r' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'s' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'t' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'u' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'v' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'w' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'x' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'y' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'z' ,3));
   _scannerList.Insert(s172);

   Scanner s173(COUNTERID);
   s173.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s173.addState(ScannerStateEntry(1 ,FINAL));
   s173.addState(ScannerStateEntry(2 ,START));
   s173.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'z' ,1));
   s173.addTransition(ScannerTransEntry(2 ,'#' ,0));
   _scannerList.Insert(s173);

}
void Cego::loadParser0()
{
   _actionMap[791][SEMICOLON] = ActionEntry(REDUCE, 60);
   _actionMap[790][RB] = ActionEntry(SHIFT, 791);
   _actionMap[789][IDENTIFIER] = ActionEntry(SHIFT, 675);
   _jumpMap[789][SimpleAttr] = 674;
   _jumpMap[789][SimpleAttrList] = 790;
   _actionMap[786][LB] = ActionEntry(SHIFT, 789);
   _actionMap[787][ROWLIMIT] = ActionEntry(REDUCE, 221);
   _actionMap[787][UNION] = ActionEntry(REDUCE, 221);
   _actionMap[787][ENDTOKEN] = ActionEntry(REDUCE, 221);
   _actionMap[787][RB] = ActionEntry(REDUCE, 221);
   _actionMap[787][SEMICOLON] = ActionEntry(REDUCE, 221);
   _actionMap[787][KSEP] = ActionEntry(REDUCE, 221);
   _actionMap[788][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[788][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[788][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[788][ORDER] = ActionEntry(REDUCE, 215);
   _actionMap[788][ROWLIMIT] = ActionEntry(REDUCE, 215);
   _actionMap[788][UNION] = ActionEntry(REDUCE, 215);
   _actionMap[788][ENDTOKEN] = ActionEntry(REDUCE, 215);
   _actionMap[788][RB] = ActionEntry(REDUCE, 215);
   _actionMap[788][SEMICOLON] = ActionEntry(REDUCE, 215);
   _actionMap[782][IDENTIFIER] = ActionEntry(SHIFT, 786);
   _actionMap[783][SEMICOLON] = ActionEntry(REDUCE, 70);
   _actionMap[783][RB] = ActionEntry(REDUCE, 70);
   _actionMap[784][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[784][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[784][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[784][ASC] = ActionEntry(SHIFT, 775);
   _actionMap[784][ROWLIMIT] = ActionEntry(REDUCE, 226);
   _actionMap[784][DESC] = ActionEntry(SHIFT, 776);
   _actionMap[784][UNION] = ActionEntry(REDUCE, 226);
   _actionMap[784][ENDTOKEN] = ActionEntry(REDUCE, 226);
   _actionMap[784][RB] = ActionEntry(REDUCE, 226);
   _actionMap[784][SEMICOLON] = ActionEntry(REDUCE, 226);
   _actionMap[784][KSEP] = ActionEntry(REDUCE, 226);
   _jumpMap[784][DefaultOrderOpt] = 774;
   _jumpMap[784][OrderingOpt] = 787;
   _actionMap[785][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[785][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[785][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[785][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[785][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[785][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[785][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[785][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[785][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[785][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[785][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[785][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[785][LEFT] = ActionEntry(SHIFT, 110);
}
void Cego::loadParser1()
{
   _actionMap[785][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[785][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[785][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[785][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[785][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[785][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[785][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[785][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[785][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[785][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[785][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[785][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[785][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[785][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[785][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[785][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[785][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[785][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[785][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[785][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[785][LB] = ActionEntry(SHIFT, 135);
   _actionMap[785][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[785][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[785][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[785][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[785][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[785][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[785][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[785][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[785][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[785][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[785][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[785][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[785][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[785][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[785][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[785][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[785][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[785][ObjSpec] = 94;
   _jumpMap[785][Constant] = 93;
   _jumpMap[785][SignedFloat] = 92;
   _jumpMap[785][SignedInt] = 91;
   _jumpMap[785][Attribute] = 90;
   _jumpMap[785][Function] = 89;
   _jumpMap[785][CasePrepare] = 88;
   _jumpMap[785][CaseClause] = 87;
   _jumpMap[785][Factor] = 86;
   _jumpMap[785][Term] = 85;
   _jumpMap[785][Expr] = 788;
   _actionMap[770][REFERENCES] = ActionEntry(SHIFT, 782);
}
void Cego::loadParser2()
{
   _actionMap[771][ELSE] = ActionEntry(REDUCE, 106);
   _actionMap[771][ELSIF] = ActionEntry(REDUCE, 106);
   _actionMap[771][EXCEPTION] = ActionEntry(REDUCE, 106);
   _actionMap[771][END_TOKEN] = ActionEntry(REDUCE, 106);
   _actionMap[771][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[771][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[771][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[771][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[771][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[771][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[771][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[771][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[771][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[771][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[771][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[771][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[771][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[771][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[771][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[771][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[771][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[771][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[771][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[771][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[771][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[771][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[771][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[771][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[771][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[771][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[771][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[771][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[771][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[771][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[771][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[771][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[771][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[771][LB] = ActionEntry(SHIFT, 135);
   _actionMap[771][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[771][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[771][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[771][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[771][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[771][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[771][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[771][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[771][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[771][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[771][VARREF] = ActionEntry(SHIFT, 320);
   _actionMap[771][FETCH] = ActionEntry(SHIFT, 107);
}
void Cego::loadParser3()
{
   _actionMap[771][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[771][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[771][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[771][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[771][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[771][IF] = ActionEntry(SHIFT, 315);
   _actionMap[771][BEGIN] = ActionEntry(SHIFT, 312);
   _actionMap[771][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[771][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[771][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[771][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[771][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[771][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[771][VAR] = ActionEntry(SHIFT, 318);
   _actionMap[771][CURSOR] = ActionEntry(SHIFT, 314);
   _actionMap[771][CLOSE] = ActionEntry(SHIFT, 313);
   _actionMap[771][NOOP] = ActionEntry(SHIFT, 316);
   _actionMap[771][RETURNTOKEN] = ActionEntry(SHIFT, 317);
   _actionMap[771][WHILE] = ActionEntry(SHIFT, 319);
   _jumpMap[771][ObjSpec] = 94;
   _jumpMap[771][Constant] = 93;
   _jumpMap[771][SignedFloat] = 92;
   _jumpMap[771][SignedInt] = 91;
   _jumpMap[771][Attribute] = 90;
   _jumpMap[771][Function] = 89;
   _jumpMap[771][DeleteStatement] = 311;
   _jumpMap[771][UpdateStatement] = 310;
   _jumpMap[771][InsertStatement] = 309;
   _jumpMap[771][RollbackStatement] = 308;
   _jumpMap[771][CommitStatement] = 307;
   _jumpMap[771][StartStatement] = 306;
   _jumpMap[771][CasePrepare] = 88;
   _jumpMap[771][CaseClause] = 87;
   _jumpMap[771][Factor] = 86;
   _jumpMap[771][Term] = 85;
   _jumpMap[771][Expr] = 305;
   _jumpMap[771][ProcStatement] = 427;
   _jumpMap[771][ProcIfPart] = 303;
   _jumpMap[771][ProcBlockStart] = 302;
   _actionMap[772][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[772][SelectStatement] = 783;
   _actionMap[773][ROWLIMIT] = ActionEntry(REDUCE, 222);
   _actionMap[773][UNION] = ActionEntry(REDUCE, 222);
   _actionMap[773][ENDTOKEN] = ActionEntry(REDUCE, 222);
   _actionMap[773][RB] = ActionEntry(REDUCE, 222);
   _actionMap[773][SEMICOLON] = ActionEntry(REDUCE, 222);
   _actionMap[773][KSEP] = ActionEntry(REDUCE, 222);
   _actionMap[774][ROWLIMIT] = ActionEntry(REDUCE, 223);
   _actionMap[774][UNION] = ActionEntry(REDUCE, 223);
   _actionMap[774][ENDTOKEN] = ActionEntry(REDUCE, 223);
}
void Cego::loadParser4()
{
   _actionMap[774][RB] = ActionEntry(REDUCE, 223);
   _actionMap[774][SEMICOLON] = ActionEntry(REDUCE, 223);
   _actionMap[774][KSEP] = ActionEntry(REDUCE, 223);
   _actionMap[775][ROWLIMIT] = ActionEntry(REDUCE, 225);
   _actionMap[775][UNION] = ActionEntry(REDUCE, 225);
   _actionMap[775][ENDTOKEN] = ActionEntry(REDUCE, 225);
   _actionMap[775][RB] = ActionEntry(REDUCE, 225);
   _actionMap[775][SEMICOLON] = ActionEntry(REDUCE, 225);
   _actionMap[775][KSEP] = ActionEntry(REDUCE, 225);
   _actionMap[776][ROWLIMIT] = ActionEntry(REDUCE, 224);
   _actionMap[776][UNION] = ActionEntry(REDUCE, 224);
   _actionMap[776][ENDTOKEN] = ActionEntry(REDUCE, 224);
   _actionMap[776][RB] = ActionEntry(REDUCE, 224);
   _actionMap[776][SEMICOLON] = ActionEntry(REDUCE, 224);
   _actionMap[776][KSEP] = ActionEntry(REDUCE, 224);
   _actionMap[777][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[777][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[777][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[777][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[777][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[777][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[777][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[777][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[777][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[777][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[777][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[777][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[777][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[777][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[777][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[777][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[777][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[777][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[777][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[777][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[777][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[777][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[777][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[777][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[777][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[777][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[777][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[777][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[777][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[777][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[777][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[777][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[777][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[777][LB] = ActionEntry(SHIFT, 135);
   _actionMap[777][STRINGVAL] = ActionEntry(SHIFT, 95);
}
void Cego::loadParser5()
{
   _actionMap[777][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[777][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[777][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[777][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[777][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[777][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[777][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[777][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[777][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[777][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[777][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[777][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[777][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[777][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[777][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[777][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[777][ObjSpec] = 94;
   _jumpMap[777][Constant] = 93;
   _jumpMap[777][SignedFloat] = 92;
   _jumpMap[777][SignedInt] = 91;
   _jumpMap[777][Attribute] = 90;
   _jumpMap[777][Function] = 89;
   _jumpMap[777][CasePrepare] = 88;
   _jumpMap[777][CaseClause] = 87;
   _jumpMap[777][Factor] = 86;
   _jumpMap[777][Term] = 85;
   _jumpMap[777][Expr] = 784;
   _actionMap[778][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[778][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[778][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[778][EQU] = ActionEntry(SHIFT, 471);
   _actionMap[778][NEGATION] = ActionEntry(SHIFT, 474);
   _actionMap[778][LT] = ActionEntry(SHIFT, 472);
   _actionMap[778][MT] = ActionEntry(SHIFT, 473);
   _jumpMap[778][Comparison] = 785;
   _actionMap[779][KSEP] = ActionEntry(REDUCE, 213);
   _actionMap[779][HAVING] = ActionEntry(REDUCE, 213);
   _actionMap[779][ORDER] = ActionEntry(REDUCE, 213);
   _actionMap[779][ROWLIMIT] = ActionEntry(REDUCE, 213);
   _actionMap[779][UNION] = ActionEntry(REDUCE, 213);
   _actionMap[779][ENDTOKEN] = ActionEntry(REDUCE, 213);
   _actionMap[779][RB] = ActionEntry(REDUCE, 213);
   _actionMap[779][SEMICOLON] = ActionEntry(REDUCE, 213);
   _actionMap[780][AND] = ActionEntry(SHIFT, 475);
   _actionMap[780][OR] = ActionEntry(SHIFT, 476);
   _actionMap[780][LEFT] = ActionEntry(REDUCE, 199);
   _actionMap[780][RIGHT] = ActionEntry(REDUCE, 199);
   _actionMap[780][INNER] = ActionEntry(REDUCE, 199);
   _actionMap[780][JOIN] = ActionEntry(REDUCE, 199);
   _actionMap[780][RETURNTOKEN] = ActionEntry(REDUCE, 199);
}
void Cego::loadParser6()
{
   _actionMap[780][SEMICOLON] = ActionEntry(REDUCE, 199);
   _actionMap[780][RB] = ActionEntry(REDUCE, 199);
   _actionMap[780][ENDTOKEN] = ActionEntry(REDUCE, 199);
   _actionMap[780][UNION] = ActionEntry(REDUCE, 199);
   _actionMap[780][ROWLIMIT] = ActionEntry(REDUCE, 199);
   _actionMap[780][ORDER] = ActionEntry(REDUCE, 199);
   _actionMap[780][GROUP] = ActionEntry(REDUCE, 199);
   _actionMap[780][WHERE] = ActionEntry(REDUCE, 199);
   _actionMap[781][AND] = ActionEntry(SHIFT, 475);
   _actionMap[781][OR] = ActionEntry(SHIFT, 476);
   _actionMap[781][LEFT] = ActionEntry(REDUCE, 200);
   _actionMap[781][RIGHT] = ActionEntry(REDUCE, 200);
   _actionMap[781][INNER] = ActionEntry(REDUCE, 200);
   _actionMap[781][JOIN] = ActionEntry(REDUCE, 200);
   _actionMap[781][RETURNTOKEN] = ActionEntry(REDUCE, 200);
   _actionMap[781][SEMICOLON] = ActionEntry(REDUCE, 200);
   _actionMap[781][RB] = ActionEntry(REDUCE, 200);
   _actionMap[781][ENDTOKEN] = ActionEntry(REDUCE, 200);
   _actionMap[781][UNION] = ActionEntry(REDUCE, 200);
   _actionMap[781][ROWLIMIT] = ActionEntry(REDUCE, 200);
   _actionMap[781][ORDER] = ActionEntry(REDUCE, 200);
   _actionMap[781][GROUP] = ActionEntry(REDUCE, 200);
   _actionMap[781][WHERE] = ActionEntry(REDUCE, 200);
   _actionMap[747][RB] = ActionEntry(SHIFT, 770);
   _actionMap[748][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[748][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[748][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[748][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[748][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[748][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[748][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[748][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[748][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[748][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[748][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[748][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[748][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[748][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[748][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[748][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[748][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[748][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[748][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[748][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[748][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[748][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[748][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[748][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[748][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[748][POWER] = ActionEntry(SHIFT, 119);
}
void Cego::loadParser7()
{
   _actionMap[748][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[748][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[748][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[748][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[748][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[748][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[748][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[748][LB] = ActionEntry(SHIFT, 135);
   _actionMap[748][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[748][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[748][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[748][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[748][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[748][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[748][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[748][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[748][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[748][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[748][VARREF] = ActionEntry(SHIFT, 320);
   _actionMap[748][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[748][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[748][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[748][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[748][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[748][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[748][IF] = ActionEntry(SHIFT, 315);
   _actionMap[748][BEGIN] = ActionEntry(SHIFT, 312);
   _actionMap[748][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[748][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[748][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[748][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[748][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[748][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[748][VAR] = ActionEntry(SHIFT, 318);
   _actionMap[748][CURSOR] = ActionEntry(SHIFT, 314);
   _actionMap[748][CLOSE] = ActionEntry(SHIFT, 313);
   _actionMap[748][NOOP] = ActionEntry(SHIFT, 316);
   _actionMap[748][RETURNTOKEN] = ActionEntry(SHIFT, 317);
   _actionMap[748][WHILE] = ActionEntry(SHIFT, 319);
   _jumpMap[748][ObjSpec] = 94;
   _jumpMap[748][Constant] = 93;
   _jumpMap[748][SignedFloat] = 92;
   _jumpMap[748][SignedInt] = 91;
   _jumpMap[748][Attribute] = 90;
   _jumpMap[748][Function] = 89;
   _jumpMap[748][DeleteStatement] = 311;
   _jumpMap[748][UpdateStatement] = 310;
   _jumpMap[748][InsertStatement] = 309;
   _jumpMap[748][RollbackStatement] = 308;
   _jumpMap[748][CommitStatement] = 307;
}
void Cego::loadParser8()
{
   _jumpMap[748][StartStatement] = 306;
   _jumpMap[748][CasePrepare] = 88;
   _jumpMap[748][CaseClause] = 87;
   _jumpMap[748][Factor] = 86;
   _jumpMap[748][Term] = 85;
   _jumpMap[748][Expr] = 305;
   _jumpMap[748][ProcStatement] = 304;
   _jumpMap[748][ProcIfPart] = 303;
   _jumpMap[748][ProcBlockStart] = 302;
   _jumpMap[748][ProcStatementList] = 771;
   _actionMap[749][BEGIN] = ActionEntry(REDUCE, 308);
   _actionMap[749][DEFAULT] = ActionEntry(REDUCE, 308);
   _actionMap[749][NULLTOKEN] = ActionEntry(REDUCE, 308);
   _actionMap[749][NOT] = ActionEntry(REDUCE, 308);
   _actionMap[749][KSEP] = ActionEntry(REDUCE, 308);
   _actionMap[749][RB] = ActionEntry(REDUCE, 308);
   _actionMap[749][EQU] = ActionEntry(REDUCE, 308);
   _actionMap[749][SEMICOLON] = ActionEntry(REDUCE, 308);
   _actionMap[750][BEGIN] = ActionEntry(REDUCE, 313);
   _actionMap[750][DEFAULT] = ActionEntry(REDUCE, 313);
   _actionMap[750][NULLTOKEN] = ActionEntry(REDUCE, 313);
   _actionMap[750][NOT] = ActionEntry(REDUCE, 313);
   _actionMap[750][KSEP] = ActionEntry(REDUCE, 313);
   _actionMap[750][RB] = ActionEntry(REDUCE, 313);
   _actionMap[750][EQU] = ActionEntry(REDUCE, 313);
   _actionMap[750][SEMICOLON] = ActionEntry(REDUCE, 313);
   _actionMap[751][BEGIN] = ActionEntry(REDUCE, 314);
   _actionMap[751][DEFAULT] = ActionEntry(REDUCE, 314);
   _actionMap[751][NULLTOKEN] = ActionEntry(REDUCE, 314);
   _actionMap[751][NOT] = ActionEntry(REDUCE, 314);
   _actionMap[751][KSEP] = ActionEntry(REDUCE, 314);
   _actionMap[751][RB] = ActionEntry(REDUCE, 314);
   _actionMap[751][EQU] = ActionEntry(REDUCE, 314);
   _actionMap[751][SEMICOLON] = ActionEntry(REDUCE, 314);
   _actionMap[752][BEGIN] = ActionEntry(REDUCE, 305);
   _actionMap[752][DEFAULT] = ActionEntry(REDUCE, 305);
   _actionMap[752][NULLTOKEN] = ActionEntry(REDUCE, 305);
   _actionMap[752][NOT] = ActionEntry(REDUCE, 305);
   _actionMap[752][KSEP] = ActionEntry(REDUCE, 305);
   _actionMap[752][RB] = ActionEntry(REDUCE, 305);
   _actionMap[752][EQU] = ActionEntry(REDUCE, 305);
   _actionMap[752][SEMICOLON] = ActionEntry(REDUCE, 305);
   _actionMap[753][SEMICOLON] = ActionEntry(REDUCE, 51);
   _actionMap[754][RB] = ActionEntry(REDUCE, 171);
   _actionMap[755][SEMICOLON] = ActionEntry(REDUCE, 165);
   _actionMap[755][KSEP] = ActionEntry(REDUCE, 165);
   _actionMap[755][RB] = ActionEntry(REDUCE, 165);
   _actionMap[756][LEFT] = ActionEntry(REDUCE, 294);
   _actionMap[756][RIGHT] = ActionEntry(REDUCE, 294);
   _actionMap[756][INNER] = ActionEntry(REDUCE, 294);
}
void Cego::loadParser9()
{
   _actionMap[756][JOIN] = ActionEntry(REDUCE, 294);
   _actionMap[756][RETURNTOKEN] = ActionEntry(REDUCE, 294);
   _actionMap[756][SEMICOLON] = ActionEntry(REDUCE, 294);
   _actionMap[756][ENDTOKEN] = ActionEntry(REDUCE, 294);
   _actionMap[756][UNION] = ActionEntry(REDUCE, 294);
   _actionMap[756][ROWLIMIT] = ActionEntry(REDUCE, 294);
   _actionMap[756][ORDER] = ActionEntry(REDUCE, 294);
   _actionMap[756][GROUP] = ActionEntry(REDUCE, 294);
   _actionMap[756][WHERE] = ActionEntry(REDUCE, 294);
   _actionMap[756][THEN] = ActionEntry(REDUCE, 294);
   _actionMap[756][AND] = ActionEntry(REDUCE, 294);
   _actionMap[756][OR] = ActionEntry(REDUCE, 294);
   _actionMap[756][RB] = ActionEntry(REDUCE, 294);
   _actionMap[757][SEMICOLON] = ActionEntry(REDUCE, 188);
   _actionMap[757][RB] = ActionEntry(REDUCE, 188);
   _actionMap[758][ALL] = ActionEntry(SHIFT, 772);
   _actionMap[759][UNION] = ActionEntry(REDUCE, 229);
   _actionMap[759][ENDTOKEN] = ActionEntry(REDUCE, 229);
   _actionMap[759][RB] = ActionEntry(REDUCE, 229);
   _actionMap[759][SEMICOLON] = ActionEntry(REDUCE, 229);
   _actionMap[760][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[760][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[760][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[760][ASC] = ActionEntry(SHIFT, 775);
   _actionMap[760][ROWLIMIT] = ActionEntry(REDUCE, 226);
   _actionMap[760][DESC] = ActionEntry(SHIFT, 776);
   _actionMap[760][UNION] = ActionEntry(REDUCE, 226);
   _actionMap[760][ENDTOKEN] = ActionEntry(REDUCE, 226);
   _actionMap[760][RB] = ActionEntry(REDUCE, 226);
   _actionMap[760][SEMICOLON] = ActionEntry(REDUCE, 226);
   _actionMap[760][KSEP] = ActionEntry(REDUCE, 226);
   _jumpMap[760][DefaultOrderOpt] = 774;
   _jumpMap[760][OrderingOpt] = 773;
   _actionMap[761][KSEP] = ActionEntry(SHIFT, 777);
   _actionMap[761][ROWLIMIT] = ActionEntry(REDUCE, 218);
   _actionMap[761][UNION] = ActionEntry(REDUCE, 218);
   _actionMap[761][ENDTOKEN] = ActionEntry(REDUCE, 218);
   _actionMap[761][RB] = ActionEntry(REDUCE, 218);
   _actionMap[761][SEMICOLON] = ActionEntry(REDUCE, 218);
   _actionMap[762][ORDER] = ActionEntry(REDUCE, 210);
   _actionMap[762][ROWLIMIT] = ActionEntry(REDUCE, 210);
   _actionMap[762][UNION] = ActionEntry(REDUCE, 210);
   _actionMap[762][ENDTOKEN] = ActionEntry(REDUCE, 210);
   _actionMap[762][RB] = ActionEntry(REDUCE, 210);
   _actionMap[762][SEMICOLON] = ActionEntry(REDUCE, 210);
   _actionMap[763][ORDER] = ActionEntry(REDUCE, 216);
   _actionMap[763][ROWLIMIT] = ActionEntry(REDUCE, 216);
   _actionMap[763][UNION] = ActionEntry(REDUCE, 216);
   _actionMap[763][ENDTOKEN] = ActionEntry(REDUCE, 216);
   _actionMap[763][RB] = ActionEntry(REDUCE, 216);
}
void Cego::loadParser10()
{
   _actionMap[763][SEMICOLON] = ActionEntry(REDUCE, 216);
   _actionMap[764][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[764][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[764][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[764][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[764][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[764][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[764][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[764][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[764][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[764][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[764][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[764][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[764][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[764][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[764][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[764][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[764][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[764][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[764][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[764][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[764][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[764][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[764][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[764][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[764][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[764][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[764][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[764][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[764][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[764][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[764][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[764][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[764][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[764][LB] = ActionEntry(SHIFT, 135);
   _actionMap[764][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[764][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[764][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[764][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[764][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[764][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[764][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[764][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[764][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[764][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[764][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[764][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[764][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[764][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[764][AVG] = ActionEntry(SHIFT, 96);
}
void Cego::loadParser11()
{
   _actionMap[764][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[764][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[764][ObjSpec] = 94;
   _jumpMap[764][Constant] = 93;
   _jumpMap[764][SignedFloat] = 92;
   _jumpMap[764][SignedInt] = 91;
   _jumpMap[764][Attribute] = 90;
   _jumpMap[764][Function] = 89;
   _jumpMap[764][CasePrepare] = 88;
   _jumpMap[764][CaseClause] = 87;
   _jumpMap[764][Factor] = 86;
   _jumpMap[764][Term] = 85;
   _jumpMap[764][Expr] = 778;
   _actionMap[765][IDENTIFIER] = ActionEntry(SHIFT, 740);
   _actionMap[765][QUALIFIEDOBJ] = ActionEntry(SHIFT, 741);
   _actionMap[765][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _jumpMap[765][Attribute] = 779;
   _actionMap[766][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[766][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[766][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[766][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[766][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[766][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[766][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[766][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[766][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[766][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[766][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[766][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[766][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[766][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[766][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[766][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[766][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[766][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[766][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[766][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[766][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[766][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[766][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[766][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[766][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[766][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[766][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[766][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[766][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[766][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[766][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[766][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[766][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
}
void Cego::loadParser12()
{
   _actionMap[766][LB] = ActionEntry(SHIFT, 347);
   _actionMap[766][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[766][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[766][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[766][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[766][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[766][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[766][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[766][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[766][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[766][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[766][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[766][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[766][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[766][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[766][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[766][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[766][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[766][EXISTS] = ActionEntry(SHIFT, 345);
   _actionMap[766][NOT] = ActionEntry(SHIFT, 346);
   _jumpMap[766][ObjSpec] = 94;
   _jumpMap[766][Constant] = 93;
   _jumpMap[766][SignedFloat] = 92;
   _jumpMap[766][SignedInt] = 91;
   _jumpMap[766][Attribute] = 90;
   _jumpMap[766][QueryPredicate] = 344;
   _jumpMap[766][QueryCondition] = 780;
   _jumpMap[766][Function] = 89;
   _jumpMap[766][CasePrepare] = 88;
   _jumpMap[766][CaseClause] = 87;
   _jumpMap[766][Factor] = 86;
   _jumpMap[766][Term] = 85;
   _jumpMap[766][Expr] = 342;
   _actionMap[767][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[767][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[767][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[767][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[767][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[767][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[767][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[767][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[767][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[767][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[767][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[767][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[767][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[767][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[767][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[767][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[767][REPLACE] = ActionEntry(SHIFT, 122);
}
void Cego::loadParser13()
{
   _actionMap[767][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[767][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[767][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[767][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[767][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[767][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[767][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[767][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[767][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[767][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[767][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[767][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[767][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[767][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[767][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[767][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[767][LB] = ActionEntry(SHIFT, 347);
   _actionMap[767][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[767][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[767][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[767][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[767][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[767][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[767][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[767][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[767][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[767][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[767][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[767][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[767][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[767][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[767][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[767][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[767][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[767][EXISTS] = ActionEntry(SHIFT, 345);
   _actionMap[767][NOT] = ActionEntry(SHIFT, 346);
   _jumpMap[767][ObjSpec] = 94;
   _jumpMap[767][Constant] = 93;
   _jumpMap[767][SignedFloat] = 92;
   _jumpMap[767][SignedInt] = 91;
   _jumpMap[767][Attribute] = 90;
   _jumpMap[767][QueryPredicate] = 344;
   _jumpMap[767][QueryCondition] = 781;
   _jumpMap[767][Function] = 89;
   _jumpMap[767][CasePrepare] = 88;
   _jumpMap[767][CaseClause] = 87;
   _jumpMap[767][Factor] = 86;
   _jumpMap[767][Term] = 85;
   _jumpMap[767][Expr] = 342;
   _actionMap[768][SEMICOLON] = ActionEntry(REDUCE, 238);
}
void Cego::loadParser14()
{
   _actionMap[768][KSEP] = ActionEntry(REDUCE, 238);
   _actionMap[769][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[769][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[769][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[769][SEMICOLON] = ActionEntry(REDUCE, 240);
   _actionMap[769][KSEP] = ActionEntry(REDUCE, 240);
   _actionMap[707][AND] = ActionEntry(SHIFT, 475);
   _actionMap[707][OR] = ActionEntry(SHIFT, 476);
   _actionMap[707][SEMICOLON] = ActionEntry(REDUCE, 61);
   _actionMap[708][IDENTIFIER] = ActionEntry(SHIFT, 675);
   _jumpMap[708][SimpleAttr] = 674;
   _jumpMap[708][SimpleAttrList] = 747;
   _actionMap[709][SEMICOLON] = ActionEntry(REDUCE, 248);
   _actionMap[709][KSEP] = ActionEntry(REDUCE, 248);
   _actionMap[710][THEN] = ActionEntry(SHIFT, 748);
   _actionMap[711][THEN] = ActionEntry(REDUCE, 111);
   _actionMap[712][END_TOKEN] = ActionEntry(REDUCE, 116);
   _actionMap[712][ELSE] = ActionEntry(REDUCE, 116);
   _actionMap[712][ELSIF] = ActionEntry(REDUCE, 116);
   _actionMap[713][BEGIN] = ActionEntry(REDUCE, 130);
   _actionMap[713][THEN] = ActionEntry(REDUCE, 130);
   _actionMap[713][OR] = ActionEntry(REDUCE, 130);
   _actionMap[713][AND] = ActionEntry(REDUCE, 130);
   _actionMap[713][RB] = ActionEntry(REDUCE, 130);
   _actionMap[714][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[714][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[714][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[714][SEMICOLON] = ActionEntry(REDUCE, 91);
   _actionMap[715][RB] = ActionEntry(SHIFT, 749);
   _actionMap[716][RB] = ActionEntry(SHIFT, 750);
   _actionMap[717][RB] = ActionEntry(SHIFT, 751);
   _actionMap[718][RB] = ActionEntry(SHIFT, 752);
   _actionMap[719][SEMICOLON] = ActionEntry(REDUCE, 122);
   _actionMap[720][RB] = ActionEntry(SHIFT, 753);
   _actionMap[721][SEMICOLON] = ActionEntry(REDUCE, 50);
   _actionMap[722][IDENTIFIER] = ActionEntry(SHIFT, 675);
   _jumpMap[722][SimpleAttr] = 674;
   _jumpMap[722][SimpleAttrList] = 754;
   _actionMap[723][SEMICOLON] = ActionEntry(REDUCE, 163);
   _actionMap[723][KSEP] = ActionEntry(REDUCE, 163);
   _actionMap[723][RB] = ActionEntry(REDUCE, 163);
   _actionMap[724][SEMICOLON] = ActionEntry(REDUCE, 166);
   _actionMap[724][KSEP] = ActionEntry(REDUCE, 166);
   _actionMap[724][RB] = ActionEntry(REDUCE, 166);
   _actionMap[725][NULLTOKEN] = ActionEntry(SHIFT, 755);
   _actionMap[726][SEMICOLON] = ActionEntry(REDUCE, 164);
   _actionMap[726][KSEP] = ActionEntry(REDUCE, 164);
   _actionMap[726][RB] = ActionEntry(REDUCE, 164);
   _actionMap[727][NULLTOKEN] = ActionEntry(REDUCE, 168);
   _actionMap[727][NOT] = ActionEntry(REDUCE, 168);
}
void Cego::loadParser15()
{
   _actionMap[727][KSEP] = ActionEntry(REDUCE, 168);
   _actionMap[727][SEMICOLON] = ActionEntry(REDUCE, 168);
   _actionMap[727][RB] = ActionEntry(REDUCE, 168);
   _actionMap[728][LONG] = ActionEntry(SHIFT, 257);
   _actionMap[728][BIGINT] = ActionEntry(SHIFT, 253);
   _actionMap[728][SMALLINT] = ActionEntry(SHIFT, 258);
   _actionMap[728][TINYINT] = ActionEntry(SHIFT, 259);
   _actionMap[728][DOUBLE] = ActionEntry(SHIFT, 255);
   _actionMap[728][DECIMAL] = ActionEntry(SHIFT, 254);
   _actionMap[728][FIXED] = ActionEntry(SHIFT, 256);
   _actionMap[729][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[729][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[729][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[729][KSEP] = ActionEntry(REDUCE, 186);
   _actionMap[729][RB] = ActionEntry(REDUCE, 186);
   _actionMap[730][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[730][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[730][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[730][LEFT] = ActionEntry(REDUCE, 296);
   _actionMap[730][RIGHT] = ActionEntry(REDUCE, 296);
   _actionMap[730][INNER] = ActionEntry(REDUCE, 296);
   _actionMap[730][JOIN] = ActionEntry(REDUCE, 296);
   _actionMap[730][RETURNTOKEN] = ActionEntry(REDUCE, 296);
   _actionMap[730][SEMICOLON] = ActionEntry(REDUCE, 296);
   _actionMap[730][ENDTOKEN] = ActionEntry(REDUCE, 296);
   _actionMap[730][UNION] = ActionEntry(REDUCE, 296);
   _actionMap[730][ROWLIMIT] = ActionEntry(REDUCE, 296);
   _actionMap[730][ORDER] = ActionEntry(REDUCE, 296);
   _actionMap[730][GROUP] = ActionEntry(REDUCE, 296);
   _actionMap[730][WHERE] = ActionEntry(REDUCE, 296);
   _actionMap[730][THEN] = ActionEntry(REDUCE, 296);
   _actionMap[730][AND] = ActionEntry(REDUCE, 296);
   _actionMap[730][OR] = ActionEntry(REDUCE, 296);
   _actionMap[730][RB] = ActionEntry(REDUCE, 296);
   _actionMap[731][LEFT] = ActionEntry(REDUCE, 293);
   _actionMap[731][RIGHT] = ActionEntry(REDUCE, 293);
   _actionMap[731][INNER] = ActionEntry(REDUCE, 293);
   _actionMap[731][JOIN] = ActionEntry(REDUCE, 293);
   _actionMap[731][RETURNTOKEN] = ActionEntry(REDUCE, 293);
   _actionMap[731][SEMICOLON] = ActionEntry(REDUCE, 293);
   _actionMap[731][ENDTOKEN] = ActionEntry(REDUCE, 293);
   _actionMap[731][UNION] = ActionEntry(REDUCE, 293);
   _actionMap[731][ROWLIMIT] = ActionEntry(REDUCE, 293);
   _actionMap[731][ORDER] = ActionEntry(REDUCE, 293);
   _actionMap[731][GROUP] = ActionEntry(REDUCE, 293);
   _actionMap[731][WHERE] = ActionEntry(REDUCE, 293);
   _actionMap[731][THEN] = ActionEntry(REDUCE, 293);
   _actionMap[731][AND] = ActionEntry(REDUCE, 293);
   _actionMap[731][OR] = ActionEntry(REDUCE, 293);
   _actionMap[731][RB] = ActionEntry(REDUCE, 293);
}
void Cego::loadParser16()
{
   _actionMap[732][RB] = ActionEntry(SHIFT, 756);
   _actionMap[733][KSEP] = ActionEntry(REDUCE, 157);
   _actionMap[733][RB] = ActionEntry(REDUCE, 157);
   _actionMap[734][UNION] = ActionEntry(SHIFT, 758);
   _actionMap[734][SEMICOLON] = ActionEntry(REDUCE, 71);
   _actionMap[734][RB] = ActionEntry(REDUCE, 71);
   _jumpMap[734][UnionAllOpt] = 757;
   _actionMap[735][UNION] = ActionEntry(REDUCE, 230);
   _actionMap[735][ENDTOKEN] = ActionEntry(REDUCE, 230);
   _actionMap[735][RB] = ActionEntry(REDUCE, 230);
   _actionMap[735][SEMICOLON] = ActionEntry(REDUCE, 230);
   _actionMap[736][INTVAL] = ActionEntry(SHIFT, 759);
   _actionMap[737][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[737][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[737][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[737][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[737][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[737][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[737][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[737][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[737][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[737][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[737][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[737][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[737][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[737][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[737][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[737][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[737][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[737][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[737][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[737][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[737][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[737][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[737][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[737][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[737][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[737][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[737][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[737][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[737][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[737][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[737][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[737][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[737][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[737][LB] = ActionEntry(SHIFT, 135);
   _actionMap[737][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[737][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[737][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[737][NULLTOKEN] = ActionEntry(SHIFT, 118);
}
void Cego::loadParser17()
{
   _actionMap[737][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[737][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[737][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[737][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[737][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[737][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[737][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[737][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[737][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[737][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[737][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[737][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[737][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[737][ObjSpec] = 94;
   _jumpMap[737][Constant] = 93;
   _jumpMap[737][SignedFloat] = 92;
   _jumpMap[737][SignedInt] = 91;
   _jumpMap[737][Attribute] = 90;
   _jumpMap[737][Function] = 89;
   _jumpMap[737][OrderingList] = 761;
   _jumpMap[737][CasePrepare] = 88;
   _jumpMap[737][CaseClause] = 87;
   _jumpMap[737][Factor] = 86;
   _jumpMap[737][Term] = 85;
   _jumpMap[737][Expr] = 760;
   _actionMap[738][KSEP] = ActionEntry(SHIFT, 765);
   _actionMap[738][ORDER] = ActionEntry(REDUCE, 217);
   _actionMap[738][HAVING] = ActionEntry(SHIFT, 764);
   _actionMap[738][ROWLIMIT] = ActionEntry(REDUCE, 217);
   _actionMap[738][UNION] = ActionEntry(REDUCE, 217);
   _actionMap[738][ENDTOKEN] = ActionEntry(REDUCE, 217);
   _actionMap[738][RB] = ActionEntry(REDUCE, 217);
   _actionMap[738][SEMICOLON] = ActionEntry(REDUCE, 217);
   _jumpMap[738][NoHaving] = 763;
   _jumpMap[738][HavingClause] = 762;
   _actionMap[739][KSEP] = ActionEntry(REDUCE, 214);
   _actionMap[739][HAVING] = ActionEntry(REDUCE, 214);
   _actionMap[739][ORDER] = ActionEntry(REDUCE, 214);
   _actionMap[739][ROWLIMIT] = ActionEntry(REDUCE, 214);
   _actionMap[739][UNION] = ActionEntry(REDUCE, 214);
   _actionMap[739][ENDTOKEN] = ActionEntry(REDUCE, 214);
   _actionMap[739][RB] = ActionEntry(REDUCE, 214);
   _actionMap[739][SEMICOLON] = ActionEntry(REDUCE, 214);
   _actionMap[740][KSEP] = ActionEntry(REDUCE, 322);
   _actionMap[740][HAVING] = ActionEntry(REDUCE, 322);
   _actionMap[740][ORDER] = ActionEntry(REDUCE, 322);
   _actionMap[740][ROWLIMIT] = ActionEntry(REDUCE, 322);
   _actionMap[740][UNION] = ActionEntry(REDUCE, 322);
   _actionMap[740][ENDTOKEN] = ActionEntry(REDUCE, 322);
   _actionMap[740][RB] = ActionEntry(REDUCE, 322);
}
void Cego::loadParser18()
{
   _actionMap[740][SEMICOLON] = ActionEntry(REDUCE, 322);
   _actionMap[741][KSEP] = ActionEntry(REDUCE, 323);
   _actionMap[741][HAVING] = ActionEntry(REDUCE, 323);
   _actionMap[741][ORDER] = ActionEntry(REDUCE, 323);
   _actionMap[741][ROWLIMIT] = ActionEntry(REDUCE, 323);
   _actionMap[741][UNION] = ActionEntry(REDUCE, 323);
   _actionMap[741][ENDTOKEN] = ActionEntry(REDUCE, 323);
   _actionMap[741][RB] = ActionEntry(REDUCE, 323);
   _actionMap[741][SEMICOLON] = ActionEntry(REDUCE, 323);
   _actionMap[742][AND] = ActionEntry(SHIFT, 475);
   _actionMap[742][OR] = ActionEntry(SHIFT, 476);
   _actionMap[742][LEFT] = ActionEntry(REDUCE, 198);
   _actionMap[742][RIGHT] = ActionEntry(REDUCE, 198);
   _actionMap[742][INNER] = ActionEntry(REDUCE, 198);
   _actionMap[742][JOIN] = ActionEntry(REDUCE, 198);
   _actionMap[742][RETURNTOKEN] = ActionEntry(REDUCE, 198);
   _actionMap[742][SEMICOLON] = ActionEntry(REDUCE, 198);
   _actionMap[742][RB] = ActionEntry(REDUCE, 198);
   _actionMap[742][ENDTOKEN] = ActionEntry(REDUCE, 198);
   _actionMap[742][UNION] = ActionEntry(REDUCE, 198);
   _actionMap[742][ROWLIMIT] = ActionEntry(REDUCE, 198);
   _actionMap[742][ORDER] = ActionEntry(REDUCE, 198);
   _actionMap[742][GROUP] = ActionEntry(REDUCE, 198);
   _actionMap[742][WHERE] = ActionEntry(REDUCE, 198);
   _actionMap[743][ON] = ActionEntry(SHIFT, 701);
   _jumpMap[743][JoinTableOn] = 766;
   _actionMap[744][ON] = ActionEntry(SHIFT, 701);
   _jumpMap[744][JoinTableOn] = 767;
   _actionMap[745][VARREF] = ActionEntry(SHIFT, 706);
   _jumpMap[745][ReturnVar] = 768;
   _actionMap[746][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[746][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[746][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[746][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[746][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[746][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[746][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[746][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[746][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[746][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[746][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[746][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[746][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[746][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[746][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[746][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[746][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[746][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[746][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[746][STR2INT] = ActionEntry(SHIFT, 129);
}
void Cego::loadParser19()
{
   _actionMap[746][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[746][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[746][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[746][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[746][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[746][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[746][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[746][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[746][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[746][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[746][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[746][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[746][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[746][LB] = ActionEntry(SHIFT, 135);
   _actionMap[746][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[746][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[746][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[746][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[746][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[746][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[746][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[746][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[746][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[746][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[746][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[746][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[746][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[746][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[746][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[746][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[746][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[746][ObjSpec] = 94;
   _jumpMap[746][Constant] = 93;
   _jumpMap[746][SignedFloat] = 92;
   _jumpMap[746][SignedInt] = 91;
   _jumpMap[746][Attribute] = 90;
   _jumpMap[746][Function] = 89;
   _jumpMap[746][CasePrepare] = 88;
   _jumpMap[746][CaseClause] = 87;
   _jumpMap[746][Factor] = 86;
   _jumpMap[746][Term] = 85;
   _jumpMap[746][Expr] = 769;
   _actionMap[649][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[649][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[649][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[649][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[649][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[649][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[649][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[649][DATE2STR] = ActionEntry(SHIFT, 103);
}
void Cego::loadParser20()
{
   _actionMap[649][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[649][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[649][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[649][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[649][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[649][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[649][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[649][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[649][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[649][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[649][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[649][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[649][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[649][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[649][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[649][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[649][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[649][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[649][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[649][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[649][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[649][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[649][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[649][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[649][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[649][LB] = ActionEntry(SHIFT, 347);
   _actionMap[649][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[649][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[649][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[649][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[649][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[649][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[649][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[649][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[649][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[649][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[649][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[649][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[649][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[649][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[649][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[649][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[649][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[649][EXISTS] = ActionEntry(SHIFT, 345);
   _actionMap[649][NOT] = ActionEntry(SHIFT, 346);
   _jumpMap[649][ObjSpec] = 94;
   _jumpMap[649][Constant] = 93;
   _jumpMap[649][SignedFloat] = 92;
   _jumpMap[649][SignedInt] = 91;
   _jumpMap[649][Attribute] = 90;
}
void Cego::loadParser21()
{
   _jumpMap[649][QueryPredicate] = 344;
   _jumpMap[649][QueryCondition] = 707;
   _jumpMap[649][Function] = 89;
   _jumpMap[649][CasePrepare] = 88;
   _jumpMap[649][CaseClause] = 87;
   _jumpMap[649][Factor] = 86;
   _jumpMap[649][Term] = 85;
   _jumpMap[649][Expr] = 342;
   _actionMap[650][LB] = ActionEntry(SHIFT, 708);
   _actionMap[651][IDENTIFIER] = ActionEntry(SHIFT, 709);
   _actionMap[652][SEMICOLON] = ActionEntry(REDUCE, 25);
   _actionMap[653][IDENTIFIER] = ActionEntry(SHIFT, 711);
   _jumpMap[653][ProcExceptionType] = 710;
   _actionMap[654][END_TOKEN] = ActionEntry(REDUCE, 117);
   _actionMap[655][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[655][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[655][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[655][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[655][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[655][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[655][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[655][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[655][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[655][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[655][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[655][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[655][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[655][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[655][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[655][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[655][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[655][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[655][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[655][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[655][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[655][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[655][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[655][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[655][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[655][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[655][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[655][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[655][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[655][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[655][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[655][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[655][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[655][LB] = ActionEntry(SHIFT, 135);
   _actionMap[655][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[655][DATE] = ActionEntry(SHIFT, 102);
}
void Cego::loadParser22()
{
   _actionMap[655][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[655][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[655][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[655][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[655][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[655][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[655][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[655][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[655][VARREF] = ActionEntry(SHIFT, 320);
   _actionMap[655][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[655][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[655][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[655][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[655][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[655][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[655][IF] = ActionEntry(SHIFT, 315);
   _actionMap[655][BEGIN] = ActionEntry(SHIFT, 312);
   _actionMap[655][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[655][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[655][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[655][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[655][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[655][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[655][VAR] = ActionEntry(SHIFT, 318);
   _actionMap[655][CURSOR] = ActionEntry(SHIFT, 314);
   _actionMap[655][CLOSE] = ActionEntry(SHIFT, 313);
   _actionMap[655][NOOP] = ActionEntry(SHIFT, 316);
   _actionMap[655][RETURNTOKEN] = ActionEntry(SHIFT, 317);
   _actionMap[655][WHILE] = ActionEntry(SHIFT, 319);
   _jumpMap[655][ObjSpec] = 94;
   _jumpMap[655][Constant] = 93;
   _jumpMap[655][SignedFloat] = 92;
   _jumpMap[655][SignedInt] = 91;
   _jumpMap[655][Attribute] = 90;
   _jumpMap[655][Function] = 89;
   _jumpMap[655][DeleteStatement] = 311;
   _jumpMap[655][UpdateStatement] = 310;
   _jumpMap[655][InsertStatement] = 309;
   _jumpMap[655][RollbackStatement] = 308;
   _jumpMap[655][CommitStatement] = 307;
   _jumpMap[655][StartStatement] = 306;
   _jumpMap[655][CasePrepare] = 88;
   _jumpMap[655][CaseClause] = 87;
   _jumpMap[655][Factor] = 86;
   _jumpMap[655][Term] = 85;
   _jumpMap[655][Expr] = 305;
   _jumpMap[655][ProcStatement] = 304;
   _jumpMap[655][ProcIfPart] = 303;
   _jumpMap[655][ProcBlockStart] = 302;
   _jumpMap[655][ProcStatementList] = 301;
}
void Cego::loadParser23()
{
   _jumpMap[655][ProcStmtBlock] = 712;
   _actionMap[656][SEMICOLON] = ActionEntry(REDUCE, 86);
   _actionMap[657][END_TOKEN] = ActionEntry(REDUCE, 113);
   _actionMap[657][ELSE] = ActionEntry(REDUCE, 113);
   _actionMap[657][ELSIF] = ActionEntry(REDUCE, 113);
   _actionMap[658][BEGIN] = ActionEntry(REDUCE, 125);
   _actionMap[658][RB] = ActionEntry(REDUCE, 125);
   _actionMap[658][AND] = ActionEntry(REDUCE, 125);
   _actionMap[658][OR] = ActionEntry(REDUCE, 125);
   _actionMap[658][THEN] = ActionEntry(REDUCE, 125);
   _actionMap[659][BEGIN] = ActionEntry(REDUCE, 124);
   _actionMap[659][RB] = ActionEntry(REDUCE, 124);
   _actionMap[659][AND] = ActionEntry(REDUCE, 124);
   _actionMap[659][OR] = ActionEntry(REDUCE, 124);
   _actionMap[659][THEN] = ActionEntry(REDUCE, 124);
   _actionMap[660][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[660][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[660][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[660][BEGIN] = ActionEntry(REDUCE, 128);
   _actionMap[660][THEN] = ActionEntry(REDUCE, 128);
   _actionMap[660][OR] = ActionEntry(REDUCE, 128);
   _actionMap[660][AND] = ActionEntry(REDUCE, 128);
   _actionMap[660][RB] = ActionEntry(REDUCE, 128);
   _actionMap[661][NULLTOKEN] = ActionEntry(SHIFT, 713);
   _actionMap[662][BEGIN] = ActionEntry(REDUCE, 129);
   _actionMap[662][THEN] = ActionEntry(REDUCE, 129);
   _actionMap[662][OR] = ActionEntry(REDUCE, 129);
   _actionMap[662][AND] = ActionEntry(REDUCE, 129);
   _actionMap[662][RB] = ActionEntry(REDUCE, 129);
   _actionMap[663][BEGIN] = ActionEntry(REDUCE, 127);
   _actionMap[663][RB] = ActionEntry(REDUCE, 127);
   _actionMap[663][AND] = ActionEntry(REDUCE, 127);
   _actionMap[663][OR] = ActionEntry(REDUCE, 127);
   _actionMap[663][THEN] = ActionEntry(REDUCE, 127);
   _actionMap[664][SEMICOLON] = ActionEntry(REDUCE, 85);
   _actionMap[665][SEMICOLON] = ActionEntry(REDUCE, 92);
   _actionMap[666][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[666][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[666][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[666][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[666][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[666][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[666][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[666][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[666][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[666][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[666][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[666][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[666][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[666][RIGHT] = ActionEntry(SHIFT, 123);
}
void Cego::loadParser24()
{
   _actionMap[666][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[666][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[666][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[666][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[666][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[666][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[666][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[666][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[666][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[666][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[666][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[666][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[666][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[666][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[666][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[666][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[666][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[666][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[666][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[666][LB] = ActionEntry(SHIFT, 135);
   _actionMap[666][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[666][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[666][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[666][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[666][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[666][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[666][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[666][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[666][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[666][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[666][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[666][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[666][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[666][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[666][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[666][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[666][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[666][ObjSpec] = 94;
   _jumpMap[666][Constant] = 93;
   _jumpMap[666][SignedFloat] = 92;
   _jumpMap[666][SignedInt] = 91;
   _jumpMap[666][Attribute] = 90;
   _jumpMap[666][Function] = 89;
   _jumpMap[666][CasePrepare] = 88;
   _jumpMap[666][CaseClause] = 87;
   _jumpMap[666][Factor] = 86;
   _jumpMap[666][Term] = 85;
   _jumpMap[666][Expr] = 714;
   _actionMap[667][INTVAL] = ActionEntry(SHIFT, 715);
   _actionMap[668][INTVAL] = ActionEntry(SHIFT, 716);
}
void Cego::loadParser25()
{
   _actionMap[669][INTVAL] = ActionEntry(SHIFT, 717);
   _actionMap[670][INTVAL] = ActionEntry(SHIFT, 718);
   _actionMap[671][END_TOKEN] = ActionEntry(SHIFT, 719);
   _actionMap[672][IDENTIFIER] = ActionEntry(SHIFT, 675);
   _jumpMap[672][SimpleAttr] = 674;
   _jumpMap[672][SimpleAttrList] = 720;
   _actionMap[673][RB] = ActionEntry(SHIFT, 721);
   _actionMap[674][KSEP] = ActionEntry(SHIFT, 722);
   _actionMap[674][RB] = ActionEntry(REDUCE, 172);
   _actionMap[675][RB] = ActionEntry(REDUCE, 173);
   _actionMap[675][KSEP] = ActionEntry(REDUCE, 173);
   _actionMap[676][KSEP] = ActionEntry(REDUCE, 78);
   _actionMap[676][RB] = ActionEntry(REDUCE, 78);
   _actionMap[677][BEGIN] = ActionEntry(REDUCE, 74);
   _actionMap[678][KSEP] = ActionEntry(REDUCE, 80);
   _actionMap[678][RB] = ActionEntry(REDUCE, 80);
   _actionMap[679][KSEP] = ActionEntry(REDUCE, 81);
   _actionMap[679][RB] = ActionEntry(REDUCE, 81);
   _actionMap[680][KSEP] = ActionEntry(REDUCE, 159);
   _actionMap[680][RB] = ActionEntry(REDUCE, 159);
   _actionMap[681][SEMICOLON] = ActionEntry(REDUCE, 167);
   _actionMap[681][NULLTOKEN] = ActionEntry(SHIFT, 726);
   _actionMap[681][NOT] = ActionEntry(SHIFT, 725);
   _actionMap[681][KSEP] = ActionEntry(REDUCE, 167);
   _actionMap[681][RB] = ActionEntry(REDUCE, 167);
   _jumpMap[681][DefaultNullOpt] = 724;
   _jumpMap[681][NullOpt] = 723;
   _actionMap[682][NULLTOKEN] = ActionEntry(REDUCE, 169);
   _actionMap[682][NOT] = ActionEntry(REDUCE, 169);
   _actionMap[682][KSEP] = ActionEntry(REDUCE, 169);
   _actionMap[682][SEMICOLON] = ActionEntry(REDUCE, 169);
   _actionMap[682][RB] = ActionEntry(REDUCE, 169);
   _actionMap[683][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[683][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[683][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[683][LB] = ActionEntry(SHIFT, 728);
   _actionMap[683][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[683][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[683][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[683][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[683][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[683][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[683][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[683][COUNTERID] = ActionEntry(SHIFT, 144);
   _jumpMap[683][Constant] = 727;
   _jumpMap[683][SignedFloat] = 92;
   _jumpMap[683][SignedInt] = 91;
   _actionMap[684][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[684][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[684][INTVAL] = ActionEntry(SHIFT, 138);
}
void Cego::loadParser26()
{
   _actionMap[684][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[684][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[684][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[684][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[684][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[684][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[684][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[684][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[684][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[684][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[684][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[684][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[684][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[684][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[684][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[684][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[684][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[684][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[684][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[684][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[684][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[684][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[684][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[684][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[684][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[684][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[684][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[684][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[684][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[684][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[684][LB] = ActionEntry(SHIFT, 135);
   _actionMap[684][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[684][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[684][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[684][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[684][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[684][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[684][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[684][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[684][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[684][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[684][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[684][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[684][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[684][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[684][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[684][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[684][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[684][ObjSpec] = 94;
   _jumpMap[684][Constant] = 93;
}
void Cego::loadParser27()
{
   _jumpMap[684][SignedFloat] = 92;
   _jumpMap[684][SignedInt] = 91;
   _jumpMap[684][Attribute] = 90;
   _jumpMap[684][Function] = 89;
   _jumpMap[684][CasePrepare] = 88;
   _jumpMap[684][CaseClause] = 87;
   _jumpMap[684][Factor] = 86;
   _jumpMap[684][Term] = 85;
   _jumpMap[684][Expr] = 729;
   _actionMap[685][SEMICOLON] = ActionEntry(REDUCE, 183);
   _actionMap[686][KSEP] = ActionEntry(REDUCE, 184);
   _actionMap[686][RB] = ActionEntry(REDUCE, 184);
   _actionMap[687][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[687][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[687][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[687][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[687][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[687][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[687][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[687][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[687][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[687][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[687][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[687][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[687][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[687][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[687][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[687][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[687][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[687][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[687][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[687][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[687][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[687][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[687][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[687][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[687][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[687][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[687][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[687][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[687][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[687][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[687][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[687][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[687][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[687][LB] = ActionEntry(SHIFT, 135);
   _actionMap[687][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[687][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[687][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[687][NULLTOKEN] = ActionEntry(SHIFT, 118);
}
void Cego::loadParser28()
{
   _actionMap[687][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[687][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[687][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[687][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[687][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[687][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[687][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[687][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[687][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[687][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[687][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[687][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[687][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[687][ObjSpec] = 94;
   _jumpMap[687][Constant] = 93;
   _jumpMap[687][SignedFloat] = 92;
   _jumpMap[687][SignedInt] = 91;
   _jumpMap[687][Attribute] = 90;
   _jumpMap[687][Function] = 89;
   _jumpMap[687][CasePrepare] = 88;
   _jumpMap[687][CaseClause] = 87;
   _jumpMap[687][Factor] = 86;
   _jumpMap[687][Term] = 85;
   _jumpMap[687][Expr] = 730;
   _actionMap[688][RB] = ActionEntry(SHIFT, 731);
   _actionMap[689][LEFT] = ActionEntry(REDUCE, 298);
   _actionMap[689][RIGHT] = ActionEntry(REDUCE, 298);
   _actionMap[689][INNER] = ActionEntry(REDUCE, 298);
   _actionMap[689][JOIN] = ActionEntry(REDUCE, 298);
   _actionMap[689][RETURNTOKEN] = ActionEntry(REDUCE, 298);
   _actionMap[689][SEMICOLON] = ActionEntry(REDUCE, 298);
   _actionMap[689][ENDTOKEN] = ActionEntry(REDUCE, 298);
   _actionMap[689][UNION] = ActionEntry(REDUCE, 298);
   _actionMap[689][ROWLIMIT] = ActionEntry(REDUCE, 298);
   _actionMap[689][ORDER] = ActionEntry(REDUCE, 298);
   _actionMap[689][GROUP] = ActionEntry(REDUCE, 298);
   _actionMap[689][WHERE] = ActionEntry(REDUCE, 298);
   _actionMap[689][THEN] = ActionEntry(REDUCE, 298);
   _actionMap[689][AND] = ActionEntry(REDUCE, 298);
   _actionMap[689][OR] = ActionEntry(REDUCE, 298);
   _actionMap[689][RB] = ActionEntry(REDUCE, 298);
   _actionMap[690][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[690][SelectStatement] = 732;
   _actionMap[691][LEFT] = ActionEntry(REDUCE, 300);
   _actionMap[691][RIGHT] = ActionEntry(REDUCE, 300);
   _actionMap[691][INNER] = ActionEntry(REDUCE, 300);
   _actionMap[691][JOIN] = ActionEntry(REDUCE, 300);
   _actionMap[691][RETURNTOKEN] = ActionEntry(REDUCE, 300);
   _actionMap[691][SEMICOLON] = ActionEntry(REDUCE, 300);
   _actionMap[691][ENDTOKEN] = ActionEntry(REDUCE, 300);
}
void Cego::loadParser29()
{
   _actionMap[691][UNION] = ActionEntry(REDUCE, 300);
   _actionMap[691][ROWLIMIT] = ActionEntry(REDUCE, 300);
   _actionMap[691][ORDER] = ActionEntry(REDUCE, 300);
   _actionMap[691][GROUP] = ActionEntry(REDUCE, 300);
   _actionMap[691][WHERE] = ActionEntry(REDUCE, 300);
   _actionMap[691][THEN] = ActionEntry(REDUCE, 300);
   _actionMap[691][AND] = ActionEntry(REDUCE, 300);
   _actionMap[691][OR] = ActionEntry(REDUCE, 300);
   _actionMap[691][RB] = ActionEntry(REDUCE, 300);
   _actionMap[692][THEN] = ActionEntry(REDUCE, 292);
   _actionMap[692][LEFT] = ActionEntry(REDUCE, 292);
   _actionMap[692][RIGHT] = ActionEntry(REDUCE, 292);
   _actionMap[692][INNER] = ActionEntry(REDUCE, 292);
   _actionMap[692][JOIN] = ActionEntry(REDUCE, 292);
   _actionMap[692][RETURNTOKEN] = ActionEntry(REDUCE, 292);
   _actionMap[692][SEMICOLON] = ActionEntry(REDUCE, 292);
   _actionMap[692][RB] = ActionEntry(REDUCE, 292);
   _actionMap[692][ENDTOKEN] = ActionEntry(REDUCE, 292);
   _actionMap[692][UNION] = ActionEntry(REDUCE, 292);
   _actionMap[692][ROWLIMIT] = ActionEntry(REDUCE, 292);
   _actionMap[692][ORDER] = ActionEntry(REDUCE, 292);
   _actionMap[692][GROUP] = ActionEntry(REDUCE, 292);
   _actionMap[692][WHERE] = ActionEntry(REDUCE, 292);
   _actionMap[692][AND] = ActionEntry(REDUCE, 292);
   _actionMap[692][OR] = ActionEntry(REDUCE, 292);
   _actionMap[693][WHEN] = ActionEntry(REDUCE, 339);
   _actionMap[693][ELSE] = ActionEntry(REDUCE, 339);
   _actionMap[693][LEFT] = ActionEntry(REDUCE, 339);
   _actionMap[693][RIGHT] = ActionEntry(REDUCE, 339);
   _actionMap[693][INNER] = ActionEntry(REDUCE, 339);
   _actionMap[693][JOIN] = ActionEntry(REDUCE, 339);
   _actionMap[693][RETURNTOKEN] = ActionEntry(REDUCE, 339);
   _actionMap[693][ORDER] = ActionEntry(REDUCE, 339);
   _actionMap[693][GROUP] = ActionEntry(REDUCE, 339);
   _actionMap[693][WHERE] = ActionEntry(REDUCE, 339);
   _actionMap[693][NULLTOKEN] = ActionEntry(REDUCE, 339);
   _actionMap[693][FROM] = ActionEntry(REDUCE, 339);
   _actionMap[693][AS] = ActionEntry(REDUCE, 339);
   _actionMap[693][END_TOKEN] = ActionEntry(REDUCE, 339);
   _actionMap[693][BEGIN] = ActionEntry(REDUCE, 339);
   _actionMap[693][THEN] = ActionEntry(REDUCE, 339);
   _actionMap[693][OR] = ActionEntry(REDUCE, 339);
   _actionMap[693][AND] = ActionEntry(REDUCE, 339);
   _actionMap[693][INTOK] = ActionEntry(REDUCE, 339);
   _actionMap[693][NOT] = ActionEntry(REDUCE, 339);
   _actionMap[693][BETWEEN] = ActionEntry(REDUCE, 339);
   _actionMap[693][IS] = ActionEntry(REDUCE, 339);
   _actionMap[693][LIKE] = ActionEntry(REDUCE, 339);
   _actionMap[693][MT] = ActionEntry(REDUCE, 339);
   _actionMap[693][LT] = ActionEntry(REDUCE, 339);
}
void Cego::loadParser30()
{
   _actionMap[693][NEGATION] = ActionEntry(REDUCE, 339);
   _actionMap[693][EQU] = ActionEntry(REDUCE, 339);
   _actionMap[693][RB] = ActionEntry(REDUCE, 339);
   _actionMap[693][ENDTOKEN] = ActionEntry(REDUCE, 339);
   _actionMap[693][UNION] = ActionEntry(REDUCE, 339);
   _actionMap[693][ROWLIMIT] = ActionEntry(REDUCE, 339);
   _actionMap[693][KSEP] = ActionEntry(REDUCE, 339);
   _actionMap[693][ASC] = ActionEntry(REDUCE, 339);
   _actionMap[693][DESC] = ActionEntry(REDUCE, 339);
   _actionMap[693][SEMICOLON] = ActionEntry(REDUCE, 339);
   _actionMap[693][PLUS] = ActionEntry(REDUCE, 339);
   _actionMap[693][MINUS] = ActionEntry(REDUCE, 339);
   _actionMap[693][DIVISION] = ActionEntry(REDUCE, 339);
   _actionMap[693][STAR] = ActionEntry(REDUCE, 339);
   _actionMap[693][CONCAT] = ActionEntry(REDUCE, 339);
   _actionMap[694][VARREF] = ActionEntry(SHIFT, 733);
   _actionMap[695][WHEN] = ActionEntry(REDUCE, 140);
   _actionMap[695][ELSE] = ActionEntry(REDUCE, 140);
   _actionMap[695][LEFT] = ActionEntry(REDUCE, 140);
   _actionMap[695][RIGHT] = ActionEntry(REDUCE, 140);
   _actionMap[695][INNER] = ActionEntry(REDUCE, 140);
   _actionMap[695][JOIN] = ActionEntry(REDUCE, 140);
   _actionMap[695][RETURNTOKEN] = ActionEntry(REDUCE, 140);
   _actionMap[695][ORDER] = ActionEntry(REDUCE, 140);
   _actionMap[695][GROUP] = ActionEntry(REDUCE, 140);
   _actionMap[695][WHERE] = ActionEntry(REDUCE, 140);
   _actionMap[695][AS] = ActionEntry(REDUCE, 140);
   _actionMap[695][FROM] = ActionEntry(REDUCE, 140);
   _actionMap[695][END_TOKEN] = ActionEntry(REDUCE, 140);
   _actionMap[695][BEGIN] = ActionEntry(REDUCE, 140);
   _actionMap[695][THEN] = ActionEntry(REDUCE, 140);
   _actionMap[695][OR] = ActionEntry(REDUCE, 140);
   _actionMap[695][AND] = ActionEntry(REDUCE, 140);
   _actionMap[695][LIKE] = ActionEntry(REDUCE, 140);
   _actionMap[695][IS] = ActionEntry(REDUCE, 140);
   _actionMap[695][BETWEEN] = ActionEntry(REDUCE, 140);
   _actionMap[695][NOT] = ActionEntry(REDUCE, 140);
   _actionMap[695][INTOK] = ActionEntry(REDUCE, 140);
   _actionMap[695][EQU] = ActionEntry(REDUCE, 140);
   _actionMap[695][NEGATION] = ActionEntry(REDUCE, 140);
   _actionMap[695][LT] = ActionEntry(REDUCE, 140);
   _actionMap[695][MT] = ActionEntry(REDUCE, 140);
   _actionMap[695][DESC] = ActionEntry(REDUCE, 140);
   _actionMap[695][ASC] = ActionEntry(REDUCE, 140);
   _actionMap[695][KSEP] = ActionEntry(REDUCE, 140);
   _actionMap[695][ROWLIMIT] = ActionEntry(REDUCE, 140);
   _actionMap[695][UNION] = ActionEntry(REDUCE, 140);
   _actionMap[695][ENDTOKEN] = ActionEntry(REDUCE, 140);
   _actionMap[695][RB] = ActionEntry(REDUCE, 140);
   _actionMap[695][SEMICOLON] = ActionEntry(REDUCE, 140);
}
void Cego::loadParser31()
{
   _actionMap[695][CONCAT] = ActionEntry(REDUCE, 140);
   _actionMap[695][STAR] = ActionEntry(REDUCE, 140);
   _actionMap[695][DIVISION] = ActionEntry(REDUCE, 140);
   _actionMap[695][MINUS] = ActionEntry(REDUCE, 140);
   _actionMap[695][PLUS] = ActionEntry(REDUCE, 140);
   _actionMap[696][SEMICOLON] = ActionEntry(REDUCE, 231);
   _actionMap[696][RB] = ActionEntry(REDUCE, 231);
   _actionMap[696][ENDTOKEN] = ActionEntry(REDUCE, 231);
   _actionMap[696][UNION] = ActionEntry(REDUCE, 231);
   _actionMap[696][ROWLIMIT] = ActionEntry(SHIFT, 736);
   _jumpMap[696][NoLimit] = 735;
   _jumpMap[696][LimitOpt] = 734;
   _actionMap[697][ROWLIMIT] = ActionEntry(REDUCE, 219);
   _actionMap[697][UNION] = ActionEntry(REDUCE, 219);
   _actionMap[697][ENDTOKEN] = ActionEntry(REDUCE, 219);
   _actionMap[697][RB] = ActionEntry(REDUCE, 219);
   _actionMap[697][SEMICOLON] = ActionEntry(REDUCE, 219);
   _actionMap[698][BY] = ActionEntry(SHIFT, 737);
   _actionMap[699][IDENTIFIER] = ActionEntry(SHIFT, 740);
   _actionMap[699][QUALIFIEDOBJ] = ActionEntry(SHIFT, 741);
   _actionMap[699][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _jumpMap[699][Attribute] = 739;
   _jumpMap[699][GroupList] = 738;
   _actionMap[700][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[700][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[700][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[700][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[700][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[700][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[700][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[700][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[700][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[700][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[700][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[700][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[700][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[700][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[700][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[700][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[700][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[700][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[700][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[700][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[700][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[700][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[700][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[700][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[700][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[700][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[700][BITAND] = ActionEntry(SHIFT, 97);
}
void Cego::loadParser32()
{
   _actionMap[700][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[700][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[700][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[700][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[700][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[700][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[700][LB] = ActionEntry(SHIFT, 347);
   _actionMap[700][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[700][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[700][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[700][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[700][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[700][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[700][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[700][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[700][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[700][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[700][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[700][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[700][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[700][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[700][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[700][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[700][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[700][EXISTS] = ActionEntry(SHIFT, 345);
   _actionMap[700][NOT] = ActionEntry(SHIFT, 346);
   _jumpMap[700][ObjSpec] = 94;
   _jumpMap[700][Constant] = 93;
   _jumpMap[700][SignedFloat] = 92;
   _jumpMap[700][SignedInt] = 91;
   _jumpMap[700][Attribute] = 90;
   _jumpMap[700][QueryPredicate] = 344;
   _jumpMap[700][QueryCondition] = 742;
   _jumpMap[700][Function] = 89;
   _jumpMap[700][CasePrepare] = 88;
   _jumpMap[700][CaseClause] = 87;
   _jumpMap[700][Factor] = 86;
   _jumpMap[700][Term] = 85;
   _jumpMap[700][Expr] = 342;
   _actionMap[701][EXISTS] = ActionEntry(REDUCE, 207);
   _actionMap[701][LB] = ActionEntry(REDUCE, 207);
   _actionMap[701][NOT] = ActionEntry(REDUCE, 207);
   _actionMap[701][VARREF] = ActionEntry(REDUCE, 207);
   _actionMap[701][FETCH] = ActionEntry(REDUCE, 207);
   _actionMap[701][COUNT] = ActionEntry(REDUCE, 207);
   _actionMap[701][SUM] = ActionEntry(REDUCE, 207);
   _actionMap[701][AVG] = ActionEntry(REDUCE, 207);
   _actionMap[701][MIN] = ActionEntry(REDUCE, 207);
   _actionMap[701][MAX] = ActionEntry(REDUCE, 207);
   _actionMap[701][CASE] = ActionEntry(REDUCE, 207);
}
void Cego::loadParser33()
{
   _actionMap[701][TRIM] = ActionEntry(REDUCE, 207);
   _actionMap[701][RTRIM] = ActionEntry(REDUCE, 207);
   _actionMap[701][LTRIM] = ActionEntry(REDUCE, 207);
   _actionMap[701][ROUND] = ActionEntry(REDUCE, 207);
   _actionMap[701][DATE2STR] = ActionEntry(REDUCE, 207);
   _actionMap[701][DATE2INT] = ActionEntry(REDUCE, 207);
   _actionMap[701][INT2DATE] = ActionEntry(REDUCE, 207);
   _actionMap[701][LOWER] = ActionEntry(REDUCE, 207);
   _actionMap[701][UPPER] = ActionEntry(REDUCE, 207);
   _actionMap[701][LEFT] = ActionEntry(REDUCE, 207);
   _actionMap[701][RIGHT] = ActionEntry(REDUCE, 207);
   _actionMap[701][GETPOS] = ActionEntry(REDUCE, 207);
   _actionMap[701][SUBSTR] = ActionEntry(REDUCE, 207);
   _actionMap[701][REPLACE] = ActionEntry(REDUCE, 207);
   _actionMap[701][LENGTH] = ActionEntry(REDUCE, 207);
   _actionMap[701][TRUNC] = ActionEntry(REDUCE, 207);
   _actionMap[701][STR2INT] = ActionEntry(REDUCE, 207);
   _actionMap[701][STR2LONG] = ActionEntry(REDUCE, 207);
   _actionMap[701][RANDSTR] = ActionEntry(REDUCE, 207);
   _actionMap[701][RANDINT] = ActionEntry(REDUCE, 207);
   _actionMap[701][MOD] = ActionEntry(REDUCE, 207);
   _actionMap[701][DIV] = ActionEntry(REDUCE, 207);
   _actionMap[701][POWER] = ActionEntry(REDUCE, 207);
   _actionMap[701][BITAND] = ActionEntry(REDUCE, 207);
   _actionMap[701][BITOR] = ActionEntry(REDUCE, 207);
   _actionMap[701][BITXOR] = ActionEntry(REDUCE, 207);
   _actionMap[701][NEXTCOUNT] = ActionEntry(REDUCE, 207);
   _actionMap[701][IDENTIFIER] = ActionEntry(REDUCE, 207);
   _actionMap[701][QUALIFIEDOBJ] = ActionEntry(REDUCE, 207);
   _actionMap[701][QUALIFIEDTS] = ActionEntry(REDUCE, 207);
   _actionMap[701][QUALIFIEDPRE] = ActionEntry(REDUCE, 207);
   _actionMap[701][STRINGVAL] = ActionEntry(REDUCE, 207);
   _actionMap[701][DATE] = ActionEntry(REDUCE, 207);
   _actionMap[701][SYSDATE] = ActionEntry(REDUCE, 207);
   _actionMap[701][NULLTOKEN] = ActionEntry(REDUCE, 207);
   _actionMap[701][TRUEVAL] = ActionEntry(REDUCE, 207);
   _actionMap[701][FALSEVAL] = ActionEntry(REDUCE, 207);
   _actionMap[701][LAB] = ActionEntry(REDUCE, 207);
   _actionMap[701][COUNTERID] = ActionEntry(REDUCE, 207);
   _actionMap[701][FLOATVAL] = ActionEntry(REDUCE, 207);
   _actionMap[701][MINUS] = ActionEntry(REDUCE, 207);
   _actionMap[701][INTVAL] = ActionEntry(REDUCE, 207);
   _actionMap[702][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[702][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[702][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[702][ObjSpec] = 407;
   _jumpMap[702][Table] = 743;
   _actionMap[703][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[703][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[703][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
}
void Cego::loadParser34()
{
   _jumpMap[703][ObjSpec] = 407;
   _jumpMap[703][Table] = 744;
   _actionMap[704][KSEP] = ActionEntry(SHIFT, 745);
   _actionMap[704][SEMICOLON] = ActionEntry(REDUCE, 236);
   _actionMap[705][SEMICOLON] = ActionEntry(REDUCE, 239);
   _actionMap[705][KSEP] = ActionEntry(REDUCE, 239);
   _actionMap[706][EQU] = ActionEntry(SHIFT, 746);
   _actionMap[551][SEMICOLON] = ActionEntry(REDUCE, 243);
   _actionMap[552][COLUMN] = ActionEntry(SHIFT, 418);
   _actionMap[553][ON] = ActionEntry(SHIFT, 649);
   _actionMap[554][SEMICOLON] = ActionEntry(REDUCE, 246);
   _actionMap[554][KSEP] = ActionEntry(REDUCE, 246);
   _actionMap[555][IDENTIFIER] = ActionEntry(SHIFT, 650);
   _actionMap[556][SEMICOLON] = ActionEntry(REDUCE, 245);
   _actionMap[556][KSEP] = ActionEntry(REDUCE, 245);
   _actionMap[557][SEMICOLON] = ActionEntry(REDUCE, 247);
   _actionMap[557][KSEP] = ActionEntry(REDUCE, 247);
   _actionMap[558][TO] = ActionEntry(SHIFT, 651);
   _actionMap[559][IDENTIFIER] = ActionEntry(SHIFT, 652);
   _actionMap[560][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[560][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[560][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[560][KSEP] = ActionEntry(REDUCE, 109);
   _actionMap[560][RB] = ActionEntry(REDUCE, 109);
   _actionMap[561][ELSE] = ActionEntry(REDUCE, 104);
   _actionMap[561][ELSIF] = ActionEntry(REDUCE, 104);
   _actionMap[561][EXCEPTION] = ActionEntry(REDUCE, 104);
   _actionMap[561][END_TOKEN] = ActionEntry(REDUCE, 104);
   _actionMap[562][WHEN] = ActionEntry(SHIFT, 653);
   _actionMap[563][EXCEPTION] = ActionEntry(REDUCE, 83);
   _actionMap[563][END_TOKEN] = ActionEntry(REDUCE, 83);
   _actionMap[563][ELSE] = ActionEntry(REDUCE, 83);
   _actionMap[563][ELSIF] = ActionEntry(REDUCE, 83);
   _actionMap[563][VAR] = ActionEntry(REDUCE, 83);
   _actionMap[563][CURSOR] = ActionEntry(REDUCE, 83);
   _actionMap[563][CLOSE] = ActionEntry(REDUCE, 83);
   _actionMap[563][VARREF] = ActionEntry(REDUCE, 83);
   _actionMap[563][NOOP] = ActionEntry(REDUCE, 83);
   _actionMap[563][RETURNTOKEN] = ActionEntry(REDUCE, 83);
   _actionMap[563][WHILE] = ActionEntry(REDUCE, 83);
   _actionMap[563][IF] = ActionEntry(REDUCE, 83);
   _actionMap[563][BEGIN] = ActionEntry(REDUCE, 83);
   _actionMap[563][ROLLBACK] = ActionEntry(REDUCE, 83);
   _actionMap[563][COMMIT] = ActionEntry(REDUCE, 83);
   _actionMap[563][START_TOKEN] = ActionEntry(REDUCE, 83);
   _actionMap[563][UPDATE] = ActionEntry(REDUCE, 83);
   _actionMap[563][DELETETOK] = ActionEntry(REDUCE, 83);
   _actionMap[563][INSERT] = ActionEntry(REDUCE, 83);
   _actionMap[563][FETCH] = ActionEntry(REDUCE, 83);
   _actionMap[563][LB] = ActionEntry(REDUCE, 83);
}
void Cego::loadParser35()
{
   _actionMap[563][COUNT] = ActionEntry(REDUCE, 83);
   _actionMap[563][SUM] = ActionEntry(REDUCE, 83);
   _actionMap[563][AVG] = ActionEntry(REDUCE, 83);
   _actionMap[563][MIN] = ActionEntry(REDUCE, 83);
   _actionMap[563][MAX] = ActionEntry(REDUCE, 83);
   _actionMap[563][CASE] = ActionEntry(REDUCE, 83);
   _actionMap[563][TRIM] = ActionEntry(REDUCE, 83);
   _actionMap[563][RTRIM] = ActionEntry(REDUCE, 83);
   _actionMap[563][LTRIM] = ActionEntry(REDUCE, 83);
   _actionMap[563][ROUND] = ActionEntry(REDUCE, 83);
   _actionMap[563][DATE2STR] = ActionEntry(REDUCE, 83);
   _actionMap[563][DATE2INT] = ActionEntry(REDUCE, 83);
   _actionMap[563][INT2DATE] = ActionEntry(REDUCE, 83);
   _actionMap[563][LOWER] = ActionEntry(REDUCE, 83);
   _actionMap[563][UPPER] = ActionEntry(REDUCE, 83);
   _actionMap[563][LEFT] = ActionEntry(REDUCE, 83);
   _actionMap[563][RIGHT] = ActionEntry(REDUCE, 83);
   _actionMap[563][GETPOS] = ActionEntry(REDUCE, 83);
   _actionMap[563][SUBSTR] = ActionEntry(REDUCE, 83);
   _actionMap[563][REPLACE] = ActionEntry(REDUCE, 83);
   _actionMap[563][LENGTH] = ActionEntry(REDUCE, 83);
   _actionMap[563][TRUNC] = ActionEntry(REDUCE, 83);
   _actionMap[563][STR2INT] = ActionEntry(REDUCE, 83);
   _actionMap[563][STR2LONG] = ActionEntry(REDUCE, 83);
   _actionMap[563][RANDSTR] = ActionEntry(REDUCE, 83);
   _actionMap[563][RANDINT] = ActionEntry(REDUCE, 83);
   _actionMap[563][MOD] = ActionEntry(REDUCE, 83);
   _actionMap[563][DIV] = ActionEntry(REDUCE, 83);
   _actionMap[563][POWER] = ActionEntry(REDUCE, 83);
   _actionMap[563][BITAND] = ActionEntry(REDUCE, 83);
   _actionMap[563][BITOR] = ActionEntry(REDUCE, 83);
   _actionMap[563][BITXOR] = ActionEntry(REDUCE, 83);
   _actionMap[563][NEXTCOUNT] = ActionEntry(REDUCE, 83);
   _actionMap[563][IDENTIFIER] = ActionEntry(REDUCE, 83);
   _actionMap[563][QUALIFIEDOBJ] = ActionEntry(REDUCE, 83);
   _actionMap[563][QUALIFIEDTS] = ActionEntry(REDUCE, 83);
   _actionMap[563][QUALIFIEDPRE] = ActionEntry(REDUCE, 83);
   _actionMap[563][STRINGVAL] = ActionEntry(REDUCE, 83);
   _actionMap[563][DATE] = ActionEntry(REDUCE, 83);
   _actionMap[563][SYSDATE] = ActionEntry(REDUCE, 83);
   _actionMap[563][NULLTOKEN] = ActionEntry(REDUCE, 83);
   _actionMap[563][TRUEVAL] = ActionEntry(REDUCE, 83);
   _actionMap[563][FALSEVAL] = ActionEntry(REDUCE, 83);
   _actionMap[563][LAB] = ActionEntry(REDUCE, 83);
   _actionMap[563][COUNTERID] = ActionEntry(REDUCE, 83);
   _actionMap[563][FLOATVAL] = ActionEntry(REDUCE, 83);
   _actionMap[563][MINUS] = ActionEntry(REDUCE, 83);
   _actionMap[563][INTVAL] = ActionEntry(REDUCE, 83);
   _actionMap[564][SEMICOLON] = ActionEntry(REDUCE, 102);
   _actionMap[565][END_TOKEN] = ActionEntry(SHIFT, 568);
}
void Cego::loadParser36()
{
   _actionMap[566][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[566][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[566][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[566][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[566][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[566][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[566][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[566][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[566][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[566][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[566][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[566][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[566][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[566][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[566][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[566][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[566][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[566][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[566][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[566][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[566][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[566][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[566][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[566][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[566][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[566][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[566][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[566][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[566][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[566][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[566][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[566][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[566][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[566][LB] = ActionEntry(SHIFT, 135);
   _actionMap[566][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[566][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[566][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[566][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[566][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[566][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[566][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[566][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[566][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[566][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[566][VARREF] = ActionEntry(SHIFT, 320);
   _actionMap[566][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[566][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[566][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[566][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[566][MIN] = ActionEntry(SHIFT, 114);
}
void Cego::loadParser37()
{
   _actionMap[566][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[566][IF] = ActionEntry(SHIFT, 315);
   _actionMap[566][BEGIN] = ActionEntry(SHIFT, 312);
   _actionMap[566][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[566][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[566][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[566][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[566][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[566][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[566][VAR] = ActionEntry(SHIFT, 318);
   _actionMap[566][CURSOR] = ActionEntry(SHIFT, 314);
   _actionMap[566][CLOSE] = ActionEntry(SHIFT, 313);
   _actionMap[566][NOOP] = ActionEntry(SHIFT, 316);
   _actionMap[566][RETURNTOKEN] = ActionEntry(SHIFT, 317);
   _actionMap[566][WHILE] = ActionEntry(SHIFT, 319);
   _jumpMap[566][ObjSpec] = 94;
   _jumpMap[566][Constant] = 93;
   _jumpMap[566][SignedFloat] = 92;
   _jumpMap[566][SignedInt] = 91;
   _jumpMap[566][Attribute] = 90;
   _jumpMap[566][Function] = 89;
   _jumpMap[566][DeleteStatement] = 311;
   _jumpMap[566][UpdateStatement] = 310;
   _jumpMap[566][InsertStatement] = 309;
   _jumpMap[566][RollbackStatement] = 308;
   _jumpMap[566][CommitStatement] = 307;
   _jumpMap[566][StartStatement] = 306;
   _jumpMap[566][CasePrepare] = 88;
   _jumpMap[566][CaseClause] = 87;
   _jumpMap[566][Factor] = 86;
   _jumpMap[566][Term] = 85;
   _jumpMap[566][Expr] = 305;
   _jumpMap[566][ProcStatement] = 304;
   _jumpMap[566][ProcIfPart] = 303;
   _jumpMap[566][ProcBlockStart] = 302;
   _jumpMap[566][ProcStatementList] = 301;
   _jumpMap[566][ProcStmtBlock] = 654;
   _actionMap[567][VAR] = ActionEntry(REDUCE, 119);
   _actionMap[567][CURSOR] = ActionEntry(REDUCE, 119);
   _actionMap[567][CLOSE] = ActionEntry(REDUCE, 119);
   _actionMap[567][VARREF] = ActionEntry(REDUCE, 119);
   _actionMap[567][NOOP] = ActionEntry(REDUCE, 119);
   _actionMap[567][RETURNTOKEN] = ActionEntry(REDUCE, 119);
   _actionMap[567][WHILE] = ActionEntry(REDUCE, 119);
   _actionMap[567][IF] = ActionEntry(REDUCE, 119);
   _actionMap[567][BEGIN] = ActionEntry(REDUCE, 119);
   _actionMap[567][ROLLBACK] = ActionEntry(REDUCE, 119);
   _actionMap[567][COMMIT] = ActionEntry(REDUCE, 119);
   _actionMap[567][START_TOKEN] = ActionEntry(REDUCE, 119);
   _actionMap[567][UPDATE] = ActionEntry(REDUCE, 119);
}
void Cego::loadParser38()
{
   _actionMap[567][DELETETOK] = ActionEntry(REDUCE, 119);
   _actionMap[567][INSERT] = ActionEntry(REDUCE, 119);
   _actionMap[567][FETCH] = ActionEntry(REDUCE, 119);
   _actionMap[567][LB] = ActionEntry(REDUCE, 119);
   _actionMap[567][COUNT] = ActionEntry(REDUCE, 119);
   _actionMap[567][SUM] = ActionEntry(REDUCE, 119);
   _actionMap[567][AVG] = ActionEntry(REDUCE, 119);
   _actionMap[567][MIN] = ActionEntry(REDUCE, 119);
   _actionMap[567][MAX] = ActionEntry(REDUCE, 119);
   _actionMap[567][CASE] = ActionEntry(REDUCE, 119);
   _actionMap[567][TRIM] = ActionEntry(REDUCE, 119);
   _actionMap[567][RTRIM] = ActionEntry(REDUCE, 119);
   _actionMap[567][LTRIM] = ActionEntry(REDUCE, 119);
   _actionMap[567][ROUND] = ActionEntry(REDUCE, 119);
   _actionMap[567][DATE2STR] = ActionEntry(REDUCE, 119);
   _actionMap[567][DATE2INT] = ActionEntry(REDUCE, 119);
   _actionMap[567][INT2DATE] = ActionEntry(REDUCE, 119);
   _actionMap[567][LOWER] = ActionEntry(REDUCE, 119);
   _actionMap[567][UPPER] = ActionEntry(REDUCE, 119);
   _actionMap[567][LEFT] = ActionEntry(REDUCE, 119);
   _actionMap[567][RIGHT] = ActionEntry(REDUCE, 119);
   _actionMap[567][GETPOS] = ActionEntry(REDUCE, 119);
   _actionMap[567][SUBSTR] = ActionEntry(REDUCE, 119);
   _actionMap[567][REPLACE] = ActionEntry(REDUCE, 119);
   _actionMap[567][LENGTH] = ActionEntry(REDUCE, 119);
   _actionMap[567][TRUNC] = ActionEntry(REDUCE, 119);
   _actionMap[567][STR2INT] = ActionEntry(REDUCE, 119);
   _actionMap[567][STR2LONG] = ActionEntry(REDUCE, 119);
   _actionMap[567][RANDSTR] = ActionEntry(REDUCE, 119);
   _actionMap[567][RANDINT] = ActionEntry(REDUCE, 119);
   _actionMap[567][MOD] = ActionEntry(REDUCE, 119);
   _actionMap[567][DIV] = ActionEntry(REDUCE, 119);
   _actionMap[567][POWER] = ActionEntry(REDUCE, 119);
   _actionMap[567][BITAND] = ActionEntry(REDUCE, 119);
   _actionMap[567][BITOR] = ActionEntry(REDUCE, 119);
   _actionMap[567][BITXOR] = ActionEntry(REDUCE, 119);
   _actionMap[567][NEXTCOUNT] = ActionEntry(REDUCE, 119);
   _actionMap[567][IDENTIFIER] = ActionEntry(REDUCE, 119);
   _actionMap[567][QUALIFIEDOBJ] = ActionEntry(REDUCE, 119);
   _actionMap[567][QUALIFIEDTS] = ActionEntry(REDUCE, 119);
   _actionMap[567][QUALIFIEDPRE] = ActionEntry(REDUCE, 119);
   _actionMap[567][STRINGVAL] = ActionEntry(REDUCE, 119);
   _actionMap[567][DATE] = ActionEntry(REDUCE, 119);
   _actionMap[567][SYSDATE] = ActionEntry(REDUCE, 119);
   _actionMap[567][NULLTOKEN] = ActionEntry(REDUCE, 119);
   _actionMap[567][TRUEVAL] = ActionEntry(REDUCE, 119);
   _actionMap[567][FALSEVAL] = ActionEntry(REDUCE, 119);
   _actionMap[567][LAB] = ActionEntry(REDUCE, 119);
   _actionMap[567][COUNTERID] = ActionEntry(REDUCE, 119);
   _actionMap[567][FLOATVAL] = ActionEntry(REDUCE, 119);
}
void Cego::loadParser39()
{
   _actionMap[567][MINUS] = ActionEntry(REDUCE, 119);
   _actionMap[567][INTVAL] = ActionEntry(REDUCE, 119);
   _actionMap[568][SEMICOLON] = ActionEntry(REDUCE, 112);
   _actionMap[569][END_TOKEN] = ActionEntry(REDUCE, 114);
   _actionMap[569][ELSE] = ActionEntry(REDUCE, 114);
   _actionMap[570][THEN] = ActionEntry(SHIFT, 655);
   _actionMap[571][OR] = ActionEntry(SHIFT, 575);
   _actionMap[571][AND] = ActionEntry(SHIFT, 574);
   _actionMap[571][THEN] = ActionEntry(REDUCE, 121);
   _actionMap[572][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[572][SelectStatement] = 656;
   _actionMap[573][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[573][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[573][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[573][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[573][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[573][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[573][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[573][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[573][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[573][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[573][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[573][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[573][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[573][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[573][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[573][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[573][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[573][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[573][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[573][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[573][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[573][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[573][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[573][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[573][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[573][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[573][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[573][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[573][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[573][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[573][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[573][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[573][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[573][LB] = ActionEntry(SHIFT, 135);
   _actionMap[573][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[573][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[573][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[573][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[573][TRUEVAL] = ActionEntry(SHIFT, 132);
}
void Cego::loadParser40()
{
   _actionMap[573][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[573][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[573][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[573][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[573][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[573][VARREF] = ActionEntry(SHIFT, 320);
   _actionMap[573][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[573][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[573][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[573][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[573][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[573][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[573][IF] = ActionEntry(SHIFT, 315);
   _actionMap[573][BEGIN] = ActionEntry(SHIFT, 312);
   _actionMap[573][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[573][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[573][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[573][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[573][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[573][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[573][VAR] = ActionEntry(SHIFT, 318);
   _actionMap[573][CURSOR] = ActionEntry(SHIFT, 314);
   _actionMap[573][CLOSE] = ActionEntry(SHIFT, 313);
   _actionMap[573][NOOP] = ActionEntry(SHIFT, 316);
   _actionMap[573][RETURNTOKEN] = ActionEntry(SHIFT, 317);
   _actionMap[573][WHILE] = ActionEntry(SHIFT, 319);
   _jumpMap[573][ObjSpec] = 94;
   _jumpMap[573][Constant] = 93;
   _jumpMap[573][SignedFloat] = 92;
   _jumpMap[573][SignedInt] = 91;
   _jumpMap[573][Attribute] = 90;
   _jumpMap[573][Function] = 89;
   _jumpMap[573][DeleteStatement] = 311;
   _jumpMap[573][UpdateStatement] = 310;
   _jumpMap[573][InsertStatement] = 309;
   _jumpMap[573][RollbackStatement] = 308;
   _jumpMap[573][CommitStatement] = 307;
   _jumpMap[573][StartStatement] = 306;
   _jumpMap[573][CasePrepare] = 88;
   _jumpMap[573][CaseClause] = 87;
   _jumpMap[573][Factor] = 86;
   _jumpMap[573][Term] = 85;
   _jumpMap[573][Expr] = 305;
   _jumpMap[573][ProcStatement] = 304;
   _jumpMap[573][ProcIfPart] = 303;
   _jumpMap[573][ProcBlockStart] = 302;
   _jumpMap[573][ProcStatementList] = 301;
   _jumpMap[573][ProcStmtBlock] = 657;
   _actionMap[574][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[574][MINUS] = ActionEntry(SHIFT, 137);
}
void Cego::loadParser41()
{
   _actionMap[574][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[574][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[574][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[574][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[574][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[574][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[574][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[574][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[574][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[574][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[574][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[574][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[574][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[574][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[574][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[574][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[574][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[574][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[574][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[574][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[574][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[574][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[574][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[574][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[574][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[574][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[574][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[574][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[574][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[574][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[574][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[574][LB] = ActionEntry(SHIFT, 439);
   _actionMap[574][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[574][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[574][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[574][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[574][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[574][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[574][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[574][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[574][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[574][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[574][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[574][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[574][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[574][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[574][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[574][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[574][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[574][ObjSpec] = 94;
}
void Cego::loadParser42()
{
   _jumpMap[574][Constant] = 93;
   _jumpMap[574][SignedFloat] = 92;
   _jumpMap[574][SignedInt] = 91;
   _jumpMap[574][Attribute] = 90;
   _jumpMap[574][Function] = 89;
   _jumpMap[574][CasePrepare] = 88;
   _jumpMap[574][CaseClause] = 87;
   _jumpMap[574][Factor] = 86;
   _jumpMap[574][Term] = 85;
   _jumpMap[574][Expr] = 438;
   _jumpMap[574][ProcPredicate] = 658;
   _actionMap[575][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[575][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[575][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[575][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[575][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[575][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[575][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[575][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[575][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[575][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[575][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[575][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[575][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[575][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[575][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[575][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[575][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[575][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[575][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[575][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[575][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[575][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[575][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[575][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[575][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[575][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[575][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[575][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[575][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[575][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[575][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[575][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[575][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[575][LB] = ActionEntry(SHIFT, 439);
   _actionMap[575][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[575][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[575][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[575][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[575][TRUEVAL] = ActionEntry(SHIFT, 132);
}
void Cego::loadParser43()
{
   _actionMap[575][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[575][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[575][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[575][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[575][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[575][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[575][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[575][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[575][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[575][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[575][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[575][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[575][ObjSpec] = 94;
   _jumpMap[575][Constant] = 93;
   _jumpMap[575][SignedFloat] = 92;
   _jumpMap[575][SignedInt] = 91;
   _jumpMap[575][Attribute] = 90;
   _jumpMap[575][Function] = 89;
   _jumpMap[575][CasePrepare] = 88;
   _jumpMap[575][CaseClause] = 87;
   _jumpMap[575][Factor] = 86;
   _jumpMap[575][Term] = 85;
   _jumpMap[575][Expr] = 438;
   _jumpMap[575][ProcPredicate] = 659;
   _actionMap[576][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[576][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[576][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[576][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[576][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[576][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[576][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[576][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[576][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[576][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[576][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[576][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[576][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[576][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[576][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[576][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[576][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[576][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[576][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[576][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[576][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[576][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[576][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[576][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[576][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[576][POWER] = ActionEntry(SHIFT, 119);
}
void Cego::loadParser44()
{
   _actionMap[576][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[576][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[576][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[576][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[576][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[576][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[576][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[576][LB] = ActionEntry(SHIFT, 135);
   _actionMap[576][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[576][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[576][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[576][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[576][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[576][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[576][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[576][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[576][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[576][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[576][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[576][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[576][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[576][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[576][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[576][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[576][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[576][ObjSpec] = 94;
   _jumpMap[576][Constant] = 93;
   _jumpMap[576][SignedFloat] = 92;
   _jumpMap[576][SignedInt] = 91;
   _jumpMap[576][Attribute] = 90;
   _jumpMap[576][Function] = 89;
   _jumpMap[576][CasePrepare] = 88;
   _jumpMap[576][CaseClause] = 87;
   _jumpMap[576][Factor] = 86;
   _jumpMap[576][Term] = 85;
   _jumpMap[576][Expr] = 660;
   _actionMap[577][NOT] = ActionEntry(SHIFT, 661);
   _actionMap[577][NULLTOKEN] = ActionEntry(SHIFT, 662);
   _actionMap[578][RB] = ActionEntry(SHIFT, 663);
   _actionMap[578][OR] = ActionEntry(SHIFT, 575);
   _actionMap[578][AND] = ActionEntry(SHIFT, 574);
   _actionMap[579][RB] = ActionEntry(SHIFT, 387);
   _actionMap[579][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[579][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[579][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[579][IS] = ActionEntry(SHIFT, 577);
   _actionMap[579][EQU] = ActionEntry(SHIFT, 471);
   _actionMap[579][NEGATION] = ActionEntry(SHIFT, 474);
   _actionMap[579][LT] = ActionEntry(SHIFT, 472);
   _actionMap[579][MT] = ActionEntry(SHIFT, 473);
}
void Cego::loadParser45()
{
   _jumpMap[579][Comparison] = 576;
   _actionMap[580][SEMICOLON] = ActionEntry(REDUCE, 93);
   _actionMap[580][EQU] = ActionEntry(SHIFT, 666);
   _jumpMap[580][ProcNoAssignment] = 665;
   _jumpMap[580][ProcInitialAssignment] = 664;
   _actionMap[581][LB] = ActionEntry(SHIFT, 667);
   _actionMap[582][BEGIN] = ActionEntry(REDUCE, 315);
   _actionMap[582][DEFAULT] = ActionEntry(REDUCE, 315);
   _actionMap[582][NULLTOKEN] = ActionEntry(REDUCE, 315);
   _actionMap[582][NOT] = ActionEntry(REDUCE, 315);
   _actionMap[582][KSEP] = ActionEntry(REDUCE, 315);
   _actionMap[582][RB] = ActionEntry(REDUCE, 315);
   _actionMap[582][EQU] = ActionEntry(REDUCE, 315);
   _actionMap[582][SEMICOLON] = ActionEntry(REDUCE, 315);
   _actionMap[583][BEGIN] = ActionEntry(REDUCE, 307);
   _actionMap[583][DEFAULT] = ActionEntry(REDUCE, 307);
   _actionMap[583][NULLTOKEN] = ActionEntry(REDUCE, 307);
   _actionMap[583][NOT] = ActionEntry(REDUCE, 307);
   _actionMap[583][KSEP] = ActionEntry(REDUCE, 307);
   _actionMap[583][RB] = ActionEntry(REDUCE, 307);
   _actionMap[583][EQU] = ActionEntry(REDUCE, 307);
   _actionMap[583][SEMICOLON] = ActionEntry(REDUCE, 307);
   _actionMap[584][BEGIN] = ActionEntry(REDUCE, 306);
   _actionMap[584][DEFAULT] = ActionEntry(REDUCE, 306);
   _actionMap[584][NULLTOKEN] = ActionEntry(REDUCE, 306);
   _actionMap[584][NOT] = ActionEntry(REDUCE, 306);
   _actionMap[584][KSEP] = ActionEntry(REDUCE, 306);
   _actionMap[584][RB] = ActionEntry(REDUCE, 306);
   _actionMap[584][EQU] = ActionEntry(REDUCE, 306);
   _actionMap[584][SEMICOLON] = ActionEntry(REDUCE, 306);
   _actionMap[585][LB] = ActionEntry(SHIFT, 668);
   _actionMap[586][BEGIN] = ActionEntry(REDUCE, 310);
   _actionMap[586][DEFAULT] = ActionEntry(REDUCE, 310);
   _actionMap[586][NULLTOKEN] = ActionEntry(REDUCE, 310);
   _actionMap[586][NOT] = ActionEntry(REDUCE, 310);
   _actionMap[586][KSEP] = ActionEntry(REDUCE, 310);
   _actionMap[586][RB] = ActionEntry(REDUCE, 310);
   _actionMap[586][EQU] = ActionEntry(REDUCE, 310);
   _actionMap[586][SEMICOLON] = ActionEntry(REDUCE, 310);
   _actionMap[587][LB] = ActionEntry(SHIFT, 669);
   _actionMap[588][BEGIN] = ActionEntry(REDUCE, 309);
   _actionMap[588][DEFAULT] = ActionEntry(REDUCE, 309);
   _actionMap[588][NULLTOKEN] = ActionEntry(REDUCE, 309);
   _actionMap[588][NOT] = ActionEntry(REDUCE, 309);
   _actionMap[588][KSEP] = ActionEntry(REDUCE, 309);
   _actionMap[588][RB] = ActionEntry(REDUCE, 309);
   _actionMap[588][EQU] = ActionEntry(REDUCE, 309);
   _actionMap[588][SEMICOLON] = ActionEntry(REDUCE, 309);
   _actionMap[589][BEGIN] = ActionEntry(REDUCE, 303);
   _actionMap[589][DEFAULT] = ActionEntry(REDUCE, 303);
}
void Cego::loadParser46()
{
   _actionMap[589][NULLTOKEN] = ActionEntry(REDUCE, 303);
   _actionMap[589][NOT] = ActionEntry(REDUCE, 303);
   _actionMap[589][KSEP] = ActionEntry(REDUCE, 303);
   _actionMap[589][RB] = ActionEntry(REDUCE, 303);
   _actionMap[589][EQU] = ActionEntry(REDUCE, 303);
   _actionMap[589][SEMICOLON] = ActionEntry(REDUCE, 303);
   _actionMap[590][BEGIN] = ActionEntry(REDUCE, 304);
   _actionMap[590][DEFAULT] = ActionEntry(REDUCE, 304);
   _actionMap[590][NULLTOKEN] = ActionEntry(REDUCE, 304);
   _actionMap[590][NOT] = ActionEntry(REDUCE, 304);
   _actionMap[590][KSEP] = ActionEntry(REDUCE, 304);
   _actionMap[590][RB] = ActionEntry(REDUCE, 304);
   _actionMap[590][EQU] = ActionEntry(REDUCE, 304);
   _actionMap[590][SEMICOLON] = ActionEntry(REDUCE, 304);
   _actionMap[591][BEGIN] = ActionEntry(REDUCE, 311);
   _actionMap[591][DEFAULT] = ActionEntry(REDUCE, 311);
   _actionMap[591][NULLTOKEN] = ActionEntry(REDUCE, 311);
   _actionMap[591][NOT] = ActionEntry(REDUCE, 311);
   _actionMap[591][KSEP] = ActionEntry(REDUCE, 311);
   _actionMap[591][RB] = ActionEntry(REDUCE, 311);
   _actionMap[591][EQU] = ActionEntry(REDUCE, 311);
   _actionMap[591][SEMICOLON] = ActionEntry(REDUCE, 311);
   _actionMap[592][LB] = ActionEntry(SHIFT, 670);
   _actionMap[593][BEGIN] = ActionEntry(REDUCE, 312);
   _actionMap[593][DEFAULT] = ActionEntry(REDUCE, 312);
   _actionMap[593][NULLTOKEN] = ActionEntry(REDUCE, 312);
   _actionMap[593][NOT] = ActionEntry(REDUCE, 312);
   _actionMap[593][KSEP] = ActionEntry(REDUCE, 312);
   _actionMap[593][RB] = ActionEntry(REDUCE, 312);
   _actionMap[593][EQU] = ActionEntry(REDUCE, 312);
   _actionMap[593][SEMICOLON] = ActionEntry(REDUCE, 312);
   _actionMap[594][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[594][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[594][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[594][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[594][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[594][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[594][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[594][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[594][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[594][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[594][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[594][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[594][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[594][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[594][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[594][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[594][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[594][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[594][TRUNC] = ActionEntry(SHIFT, 133);
}
void Cego::loadParser47()
{
   _actionMap[594][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[594][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[594][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[594][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[594][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[594][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[594][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[594][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[594][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[594][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[594][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[594][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[594][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[594][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[594][LB] = ActionEntry(SHIFT, 135);
   _actionMap[594][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[594][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[594][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[594][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[594][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[594][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[594][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[594][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[594][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[594][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[594][VARREF] = ActionEntry(SHIFT, 320);
   _actionMap[594][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[594][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[594][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[594][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[594][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[594][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[594][IF] = ActionEntry(SHIFT, 315);
   _actionMap[594][BEGIN] = ActionEntry(SHIFT, 312);
   _actionMap[594][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[594][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[594][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[594][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[594][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[594][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[594][VAR] = ActionEntry(SHIFT, 318);
   _actionMap[594][CURSOR] = ActionEntry(SHIFT, 314);
   _actionMap[594][CLOSE] = ActionEntry(SHIFT, 313);
   _actionMap[594][NOOP] = ActionEntry(SHIFT, 316);
   _actionMap[594][RETURNTOKEN] = ActionEntry(SHIFT, 317);
   _actionMap[594][WHILE] = ActionEntry(SHIFT, 319);
   _jumpMap[594][ObjSpec] = 94;
   _jumpMap[594][Constant] = 93;
   _jumpMap[594][SignedFloat] = 92;
   _jumpMap[594][SignedInt] = 91;
}
void Cego::loadParser48()
{
   _jumpMap[594][Attribute] = 90;
   _jumpMap[594][Function] = 89;
   _jumpMap[594][DeleteStatement] = 311;
   _jumpMap[594][UpdateStatement] = 310;
   _jumpMap[594][InsertStatement] = 309;
   _jumpMap[594][RollbackStatement] = 308;
   _jumpMap[594][CommitStatement] = 307;
   _jumpMap[594][StartStatement] = 306;
   _jumpMap[594][CasePrepare] = 88;
   _jumpMap[594][CaseClause] = 87;
   _jumpMap[594][Factor] = 86;
   _jumpMap[594][Term] = 85;
   _jumpMap[594][Expr] = 305;
   _jumpMap[594][ProcStatement] = 304;
   _jumpMap[594][ProcIfPart] = 303;
   _jumpMap[594][ProcBlockStart] = 302;
   _jumpMap[594][ProcStatementList] = 301;
   _jumpMap[594][ProcStmtBlock] = 671;
   _actionMap[595][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[595][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[595][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[595][SEMICOLON] = ActionEntry(REDUCE, 88);
   _actionMap[596][LB] = ActionEntry(SHIFT, 672);
   _actionMap[597][IDENTIFIER] = ActionEntry(SHIFT, 675);
   _jumpMap[597][SimpleAttr] = 674;
   _jumpMap[597][SimpleAttrList] = 673;
   _actionMap[598][IDENTIFIER] = ActionEntry(SHIFT, 451);
   _jumpMap[598][ProcArg] = 676;
   _actionMap[599][BEGIN] = ActionEntry(REDUCE, 72);
   _actionMap[600][INT] = ActionEntry(SHIFT, 589);
   _actionMap[600][LONG] = ActionEntry(SHIFT, 590);
   _actionMap[600][STRING] = ActionEntry(SHIFT, 592);
   _actionMap[600][DATETIME] = ActionEntry(SHIFT, 584);
   _actionMap[600][BOOL] = ActionEntry(SHIFT, 583);
   _actionMap[600][BIGINT] = ActionEntry(SHIFT, 581);
   _actionMap[600][FLOAT] = ActionEntry(SHIFT, 588);
   _actionMap[600][DOUBLE] = ActionEntry(SHIFT, 586);
   _actionMap[600][SMALLINT] = ActionEntry(SHIFT, 591);
   _actionMap[600][TINYINT] = ActionEntry(SHIFT, 593);
   _actionMap[600][DECIMAL] = ActionEntry(SHIFT, 585);
   _actionMap[600][FIXED] = ActionEntry(SHIFT, 587);
   _actionMap[600][BLOB] = ActionEntry(SHIFT, 582);
   _jumpMap[600][DataTypeProd] = 677;
   _actionMap[601][INT] = ActionEntry(SHIFT, 589);
   _actionMap[601][LONG] = ActionEntry(SHIFT, 590);
   _actionMap[601][STRING] = ActionEntry(SHIFT, 592);
   _actionMap[601][DATETIME] = ActionEntry(SHIFT, 584);
   _actionMap[601][BOOL] = ActionEntry(SHIFT, 583);
   _actionMap[601][BIGINT] = ActionEntry(SHIFT, 581);
   _actionMap[601][FLOAT] = ActionEntry(SHIFT, 588);
}
void Cego::loadParser49()
{
   _actionMap[601][DOUBLE] = ActionEntry(SHIFT, 586);
   _actionMap[601][SMALLINT] = ActionEntry(SHIFT, 591);
   _actionMap[601][TINYINT] = ActionEntry(SHIFT, 593);
   _actionMap[601][DECIMAL] = ActionEntry(SHIFT, 585);
   _actionMap[601][FIXED] = ActionEntry(SHIFT, 587);
   _actionMap[601][BLOB] = ActionEntry(SHIFT, 582);
   _jumpMap[601][DataTypeProd] = 678;
   _actionMap[602][INT] = ActionEntry(SHIFT, 589);
   _actionMap[602][LONG] = ActionEntry(SHIFT, 590);
   _actionMap[602][STRING] = ActionEntry(SHIFT, 592);
   _actionMap[602][DATETIME] = ActionEntry(SHIFT, 584);
   _actionMap[602][BOOL] = ActionEntry(SHIFT, 583);
   _actionMap[602][BIGINT] = ActionEntry(SHIFT, 581);
   _actionMap[602][FLOAT] = ActionEntry(SHIFT, 588);
   _actionMap[602][DOUBLE] = ActionEntry(SHIFT, 586);
   _actionMap[602][SMALLINT] = ActionEntry(SHIFT, 591);
   _actionMap[602][TINYINT] = ActionEntry(SHIFT, 593);
   _actionMap[602][DECIMAL] = ActionEntry(SHIFT, 585);
   _actionMap[602][FIXED] = ActionEntry(SHIFT, 587);
   _actionMap[602][BLOB] = ActionEntry(SHIFT, 582);
   _jumpMap[602][DataTypeProd] = 679;
   _actionMap[603][IDENTIFIER] = ActionEntry(SHIFT, 456);
   _actionMap[603][PRIMARY] = ActionEntry(SHIFT, 455);
   _jumpMap[603][ColumnDesc] = 454;
   _jumpMap[603][KeyColumn] = 680;
   _actionMap[604][SEMICOLON] = ActionEntry(REDUCE, 49);
   _actionMap[605][KSEP] = ActionEntry(REDUCE, 161);
   _actionMap[605][RB] = ActionEntry(REDUCE, 161);
   _actionMap[606][RB] = ActionEntry(REDUCE, 170);
   _actionMap[606][SEMICOLON] = ActionEntry(REDUCE, 170);
   _actionMap[606][KSEP] = ActionEntry(REDUCE, 170);
   _actionMap[606][NOT] = ActionEntry(REDUCE, 170);
   _actionMap[606][NULLTOKEN] = ActionEntry(REDUCE, 170);
   _actionMap[606][DEFAULT] = ActionEntry(SHIFT, 683);
   _jumpMap[606][DefaultDefOpt] = 682;
   _jumpMap[606][DefaultOpt] = 681;
   _actionMap[607][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[607][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[607][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[607][KSEP] = ActionEntry(REDUCE, 187);
   _actionMap[607][RB] = ActionEntry(REDUCE, 187);
   _actionMap[608][RB] = ActionEntry(SHIFT, 685);
   _actionMap[608][KSEP] = ActionEntry(SHIFT, 684);
   _actionMap[609][IDENTIFIER] = ActionEntry(SHIFT, 686);
   _actionMap[610][SELECT] = ActionEntry(REDUCE, 181);
   _actionMap[610][VALUES] = ActionEntry(REDUCE, 181);
   _actionMap[611][WHEN] = ActionEntry(REDUCE, 152);
   _actionMap[611][ELSE] = ActionEntry(REDUCE, 152);
   _actionMap[611][LEFT] = ActionEntry(REDUCE, 152);
   _actionMap[611][RIGHT] = ActionEntry(REDUCE, 152);
}
void Cego::loadParser50()
{
   _actionMap[611][INNER] = ActionEntry(REDUCE, 152);
   _actionMap[611][JOIN] = ActionEntry(REDUCE, 152);
   _actionMap[611][RETURNTOKEN] = ActionEntry(REDUCE, 152);
   _actionMap[611][ORDER] = ActionEntry(REDUCE, 152);
   _actionMap[611][GROUP] = ActionEntry(REDUCE, 152);
   _actionMap[611][WHERE] = ActionEntry(REDUCE, 152);
   _actionMap[611][BEGIN] = ActionEntry(REDUCE, 152);
   _actionMap[611][THEN] = ActionEntry(REDUCE, 152);
   _actionMap[611][OR] = ActionEntry(REDUCE, 152);
   _actionMap[611][FROM] = ActionEntry(REDUCE, 152);
   _actionMap[611][AS] = ActionEntry(REDUCE, 152);
   _actionMap[611][END_TOKEN] = ActionEntry(REDUCE, 152);
   _actionMap[611][AND] = ActionEntry(REDUCE, 152);
   _actionMap[611][INTOK] = ActionEntry(REDUCE, 152);
   _actionMap[611][NOT] = ActionEntry(REDUCE, 152);
   _actionMap[611][BETWEEN] = ActionEntry(REDUCE, 152);
   _actionMap[611][IS] = ActionEntry(REDUCE, 152);
   _actionMap[611][LIKE] = ActionEntry(REDUCE, 152);
   _actionMap[611][MT] = ActionEntry(REDUCE, 152);
   _actionMap[611][LT] = ActionEntry(REDUCE, 152);
   _actionMap[611][NEGATION] = ActionEntry(REDUCE, 152);
   _actionMap[611][EQU] = ActionEntry(REDUCE, 152);
   _actionMap[611][RB] = ActionEntry(REDUCE, 152);
   _actionMap[611][ENDTOKEN] = ActionEntry(REDUCE, 152);
   _actionMap[611][UNION] = ActionEntry(REDUCE, 152);
   _actionMap[611][ROWLIMIT] = ActionEntry(REDUCE, 152);
   _actionMap[611][KSEP] = ActionEntry(REDUCE, 152);
   _actionMap[611][ASC] = ActionEntry(REDUCE, 152);
   _actionMap[611][DESC] = ActionEntry(REDUCE, 152);
   _actionMap[611][SEMICOLON] = ActionEntry(REDUCE, 152);
   _actionMap[611][PLUS] = ActionEntry(REDUCE, 152);
   _actionMap[611][MINUS] = ActionEntry(REDUCE, 152);
   _actionMap[611][DIVISION] = ActionEntry(REDUCE, 152);
   _actionMap[611][STAR] = ActionEntry(REDUCE, 152);
   _actionMap[611][CONCAT] = ActionEntry(REDUCE, 152);
   _actionMap[612][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[612][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[612][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[612][LEFT] = ActionEntry(REDUCE, 295);
   _actionMap[612][RIGHT] = ActionEntry(REDUCE, 295);
   _actionMap[612][INNER] = ActionEntry(REDUCE, 295);
   _actionMap[612][JOIN] = ActionEntry(REDUCE, 295);
   _actionMap[612][RETURNTOKEN] = ActionEntry(REDUCE, 295);
   _actionMap[612][SEMICOLON] = ActionEntry(REDUCE, 295);
   _actionMap[612][ENDTOKEN] = ActionEntry(REDUCE, 295);
   _actionMap[612][UNION] = ActionEntry(REDUCE, 295);
   _actionMap[612][ROWLIMIT] = ActionEntry(REDUCE, 295);
   _actionMap[612][ORDER] = ActionEntry(REDUCE, 295);
   _actionMap[612][GROUP] = ActionEntry(REDUCE, 295);
   _actionMap[612][WHERE] = ActionEntry(REDUCE, 295);
}
void Cego::loadParser51()
{
   _actionMap[612][THEN] = ActionEntry(REDUCE, 295);
   _actionMap[612][AND] = ActionEntry(REDUCE, 295);
   _actionMap[612][OR] = ActionEntry(REDUCE, 295);
   _actionMap[612][RB] = ActionEntry(REDUCE, 295);
   _actionMap[613][AND] = ActionEntry(SHIFT, 687);
   _actionMap[613][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[613][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[613][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[614][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[614][SelectStatement] = 688;
   _actionMap[615][NULLTOKEN] = ActionEntry(SHIFT, 689);
   _actionMap[616][LEFT] = ActionEntry(REDUCE, 297);
   _actionMap[616][RIGHT] = ActionEntry(REDUCE, 297);
   _actionMap[616][INNER] = ActionEntry(REDUCE, 297);
   _actionMap[616][JOIN] = ActionEntry(REDUCE, 297);
   _actionMap[616][RETURNTOKEN] = ActionEntry(REDUCE, 297);
   _actionMap[616][SEMICOLON] = ActionEntry(REDUCE, 297);
   _actionMap[616][ENDTOKEN] = ActionEntry(REDUCE, 297);
   _actionMap[616][UNION] = ActionEntry(REDUCE, 297);
   _actionMap[616][ROWLIMIT] = ActionEntry(REDUCE, 297);
   _actionMap[616][ORDER] = ActionEntry(REDUCE, 297);
   _actionMap[616][GROUP] = ActionEntry(REDUCE, 297);
   _actionMap[616][WHERE] = ActionEntry(REDUCE, 297);
   _actionMap[616][THEN] = ActionEntry(REDUCE, 297);
   _actionMap[616][AND] = ActionEntry(REDUCE, 297);
   _actionMap[616][OR] = ActionEntry(REDUCE, 297);
   _actionMap[616][RB] = ActionEntry(REDUCE, 297);
   _actionMap[617][LEFT] = ActionEntry(REDUCE, 299);
   _actionMap[617][RIGHT] = ActionEntry(REDUCE, 299);
   _actionMap[617][INNER] = ActionEntry(REDUCE, 299);
   _actionMap[617][JOIN] = ActionEntry(REDUCE, 299);
   _actionMap[617][RETURNTOKEN] = ActionEntry(REDUCE, 299);
   _actionMap[617][SEMICOLON] = ActionEntry(REDUCE, 299);
   _actionMap[617][ENDTOKEN] = ActionEntry(REDUCE, 299);
   _actionMap[617][UNION] = ActionEntry(REDUCE, 299);
   _actionMap[617][ROWLIMIT] = ActionEntry(REDUCE, 299);
   _actionMap[617][ORDER] = ActionEntry(REDUCE, 299);
   _actionMap[617][GROUP] = ActionEntry(REDUCE, 299);
   _actionMap[617][WHERE] = ActionEntry(REDUCE, 299);
   _actionMap[617][THEN] = ActionEntry(REDUCE, 299);
   _actionMap[617][AND] = ActionEntry(REDUCE, 299);
   _actionMap[617][OR] = ActionEntry(REDUCE, 299);
   _actionMap[617][RB] = ActionEntry(REDUCE, 299);
   _actionMap[618][LB] = ActionEntry(SHIFT, 690);
   _actionMap[619][STRINGVAL] = ActionEntry(SHIFT, 691);
   _actionMap[620][VARREF] = ActionEntry(REDUCE, 320);
   _actionMap[620][FETCH] = ActionEntry(REDUCE, 320);
   _actionMap[620][LB] = ActionEntry(REDUCE, 320);
   _actionMap[620][COUNT] = ActionEntry(REDUCE, 320);
   _actionMap[620][SUM] = ActionEntry(REDUCE, 320);
}
void Cego::loadParser52()
{
   _actionMap[620][AVG] = ActionEntry(REDUCE, 320);
   _actionMap[620][MIN] = ActionEntry(REDUCE, 320);
   _actionMap[620][MAX] = ActionEntry(REDUCE, 320);
   _actionMap[620][CASE] = ActionEntry(REDUCE, 320);
   _actionMap[620][TRIM] = ActionEntry(REDUCE, 320);
   _actionMap[620][RTRIM] = ActionEntry(REDUCE, 320);
   _actionMap[620][LTRIM] = ActionEntry(REDUCE, 320);
   _actionMap[620][ROUND] = ActionEntry(REDUCE, 320);
   _actionMap[620][DATE2STR] = ActionEntry(REDUCE, 320);
   _actionMap[620][DATE2INT] = ActionEntry(REDUCE, 320);
   _actionMap[620][INT2DATE] = ActionEntry(REDUCE, 320);
   _actionMap[620][LOWER] = ActionEntry(REDUCE, 320);
   _actionMap[620][UPPER] = ActionEntry(REDUCE, 320);
   _actionMap[620][LEFT] = ActionEntry(REDUCE, 320);
   _actionMap[620][RIGHT] = ActionEntry(REDUCE, 320);
   _actionMap[620][GETPOS] = ActionEntry(REDUCE, 320);
   _actionMap[620][SUBSTR] = ActionEntry(REDUCE, 320);
   _actionMap[620][REPLACE] = ActionEntry(REDUCE, 320);
   _actionMap[620][LENGTH] = ActionEntry(REDUCE, 320);
   _actionMap[620][TRUNC] = ActionEntry(REDUCE, 320);
   _actionMap[620][STR2INT] = ActionEntry(REDUCE, 320);
   _actionMap[620][STR2LONG] = ActionEntry(REDUCE, 320);
   _actionMap[620][RANDSTR] = ActionEntry(REDUCE, 320);
   _actionMap[620][RANDINT] = ActionEntry(REDUCE, 320);
   _actionMap[620][MOD] = ActionEntry(REDUCE, 320);
   _actionMap[620][DIV] = ActionEntry(REDUCE, 320);
   _actionMap[620][POWER] = ActionEntry(REDUCE, 320);
   _actionMap[620][BITAND] = ActionEntry(REDUCE, 320);
   _actionMap[620][BITOR] = ActionEntry(REDUCE, 320);
   _actionMap[620][BITXOR] = ActionEntry(REDUCE, 320);
   _actionMap[620][NEXTCOUNT] = ActionEntry(REDUCE, 320);
   _actionMap[620][IDENTIFIER] = ActionEntry(REDUCE, 320);
   _actionMap[620][QUALIFIEDOBJ] = ActionEntry(REDUCE, 320);
   _actionMap[620][QUALIFIEDTS] = ActionEntry(REDUCE, 320);
   _actionMap[620][QUALIFIEDPRE] = ActionEntry(REDUCE, 320);
   _actionMap[620][STRINGVAL] = ActionEntry(REDUCE, 320);
   _actionMap[620][DATE] = ActionEntry(REDUCE, 320);
   _actionMap[620][SYSDATE] = ActionEntry(REDUCE, 320);
   _actionMap[620][NULLTOKEN] = ActionEntry(REDUCE, 320);
   _actionMap[620][TRUEVAL] = ActionEntry(REDUCE, 320);
   _actionMap[620][FALSEVAL] = ActionEntry(REDUCE, 320);
   _actionMap[620][LAB] = ActionEntry(REDUCE, 320);
   _actionMap[620][COUNTERID] = ActionEntry(REDUCE, 320);
   _actionMap[620][FLOATVAL] = ActionEntry(REDUCE, 320);
   _actionMap[620][MINUS] = ActionEntry(REDUCE, 320);
   _actionMap[620][INTVAL] = ActionEntry(REDUCE, 320);
   _actionMap[621][VARREF] = ActionEntry(REDUCE, 321);
   _actionMap[621][FETCH] = ActionEntry(REDUCE, 321);
   _actionMap[621][LB] = ActionEntry(REDUCE, 321);
   _actionMap[621][COUNT] = ActionEntry(REDUCE, 321);
}
void Cego::loadParser53()
{
   _actionMap[621][SUM] = ActionEntry(REDUCE, 321);
   _actionMap[621][AVG] = ActionEntry(REDUCE, 321);
   _actionMap[621][MIN] = ActionEntry(REDUCE, 321);
   _actionMap[621][MAX] = ActionEntry(REDUCE, 321);
   _actionMap[621][CASE] = ActionEntry(REDUCE, 321);
   _actionMap[621][TRIM] = ActionEntry(REDUCE, 321);
   _actionMap[621][RTRIM] = ActionEntry(REDUCE, 321);
   _actionMap[621][LTRIM] = ActionEntry(REDUCE, 321);
   _actionMap[621][ROUND] = ActionEntry(REDUCE, 321);
   _actionMap[621][DATE2STR] = ActionEntry(REDUCE, 321);
   _actionMap[621][DATE2INT] = ActionEntry(REDUCE, 321);
   _actionMap[621][INT2DATE] = ActionEntry(REDUCE, 321);
   _actionMap[621][LOWER] = ActionEntry(REDUCE, 321);
   _actionMap[621][UPPER] = ActionEntry(REDUCE, 321);
   _actionMap[621][LEFT] = ActionEntry(REDUCE, 321);
   _actionMap[621][RIGHT] = ActionEntry(REDUCE, 321);
   _actionMap[621][GETPOS] = ActionEntry(REDUCE, 321);
   _actionMap[621][SUBSTR] = ActionEntry(REDUCE, 321);
   _actionMap[621][REPLACE] = ActionEntry(REDUCE, 321);
   _actionMap[621][LENGTH] = ActionEntry(REDUCE, 321);
   _actionMap[621][TRUNC] = ActionEntry(REDUCE, 321);
   _actionMap[621][STR2INT] = ActionEntry(REDUCE, 321);
   _actionMap[621][STR2LONG] = ActionEntry(REDUCE, 321);
   _actionMap[621][RANDSTR] = ActionEntry(REDUCE, 321);
   _actionMap[621][RANDINT] = ActionEntry(REDUCE, 321);
   _actionMap[621][MOD] = ActionEntry(REDUCE, 321);
   _actionMap[621][DIV] = ActionEntry(REDUCE, 321);
   _actionMap[621][POWER] = ActionEntry(REDUCE, 321);
   _actionMap[621][BITAND] = ActionEntry(REDUCE, 321);
   _actionMap[621][BITOR] = ActionEntry(REDUCE, 321);
   _actionMap[621][BITXOR] = ActionEntry(REDUCE, 321);
   _actionMap[621][NEXTCOUNT] = ActionEntry(REDUCE, 321);
   _actionMap[621][IDENTIFIER] = ActionEntry(REDUCE, 321);
   _actionMap[621][QUALIFIEDOBJ] = ActionEntry(REDUCE, 321);
   _actionMap[621][QUALIFIEDTS] = ActionEntry(REDUCE, 321);
   _actionMap[621][QUALIFIEDPRE] = ActionEntry(REDUCE, 321);
   _actionMap[621][STRINGVAL] = ActionEntry(REDUCE, 321);
   _actionMap[621][DATE] = ActionEntry(REDUCE, 321);
   _actionMap[621][SYSDATE] = ActionEntry(REDUCE, 321);
   _actionMap[621][NULLTOKEN] = ActionEntry(REDUCE, 321);
   _actionMap[621][TRUEVAL] = ActionEntry(REDUCE, 321);
   _actionMap[621][FALSEVAL] = ActionEntry(REDUCE, 321);
   _actionMap[621][LAB] = ActionEntry(REDUCE, 321);
   _actionMap[621][COUNTERID] = ActionEntry(REDUCE, 321);
   _actionMap[621][FLOATVAL] = ActionEntry(REDUCE, 321);
   _actionMap[621][MINUS] = ActionEntry(REDUCE, 321);
   _actionMap[621][INTVAL] = ActionEntry(REDUCE, 321);
   _actionMap[622][VARREF] = ActionEntry(REDUCE, 317);
   _actionMap[622][FETCH] = ActionEntry(REDUCE, 317);
   _actionMap[622][LB] = ActionEntry(REDUCE, 317);
}
void Cego::loadParser54()
{
   _actionMap[622][COUNT] = ActionEntry(REDUCE, 317);
   _actionMap[622][SUM] = ActionEntry(REDUCE, 317);
   _actionMap[622][AVG] = ActionEntry(REDUCE, 317);
   _actionMap[622][MIN] = ActionEntry(REDUCE, 317);
   _actionMap[622][MAX] = ActionEntry(REDUCE, 317);
   _actionMap[622][CASE] = ActionEntry(REDUCE, 317);
   _actionMap[622][TRIM] = ActionEntry(REDUCE, 317);
   _actionMap[622][RTRIM] = ActionEntry(REDUCE, 317);
   _actionMap[622][LTRIM] = ActionEntry(REDUCE, 317);
   _actionMap[622][ROUND] = ActionEntry(REDUCE, 317);
   _actionMap[622][DATE2STR] = ActionEntry(REDUCE, 317);
   _actionMap[622][DATE2INT] = ActionEntry(REDUCE, 317);
   _actionMap[622][INT2DATE] = ActionEntry(REDUCE, 317);
   _actionMap[622][LOWER] = ActionEntry(REDUCE, 317);
   _actionMap[622][UPPER] = ActionEntry(REDUCE, 317);
   _actionMap[622][LEFT] = ActionEntry(REDUCE, 317);
   _actionMap[622][RIGHT] = ActionEntry(REDUCE, 317);
   _actionMap[622][GETPOS] = ActionEntry(REDUCE, 317);
   _actionMap[622][SUBSTR] = ActionEntry(REDUCE, 317);
   _actionMap[622][REPLACE] = ActionEntry(REDUCE, 317);
   _actionMap[622][LENGTH] = ActionEntry(REDUCE, 317);
   _actionMap[622][TRUNC] = ActionEntry(REDUCE, 317);
   _actionMap[622][STR2INT] = ActionEntry(REDUCE, 317);
   _actionMap[622][STR2LONG] = ActionEntry(REDUCE, 317);
   _actionMap[622][RANDSTR] = ActionEntry(REDUCE, 317);
   _actionMap[622][RANDINT] = ActionEntry(REDUCE, 317);
   _actionMap[622][MOD] = ActionEntry(REDUCE, 317);
   _actionMap[622][DIV] = ActionEntry(REDUCE, 317);
   _actionMap[622][POWER] = ActionEntry(REDUCE, 317);
   _actionMap[622][BITAND] = ActionEntry(REDUCE, 317);
   _actionMap[622][BITOR] = ActionEntry(REDUCE, 317);
   _actionMap[622][BITXOR] = ActionEntry(REDUCE, 317);
   _actionMap[622][NEXTCOUNT] = ActionEntry(REDUCE, 317);
   _actionMap[622][IDENTIFIER] = ActionEntry(REDUCE, 317);
   _actionMap[622][QUALIFIEDOBJ] = ActionEntry(REDUCE, 317);
   _actionMap[622][QUALIFIEDTS] = ActionEntry(REDUCE, 317);
   _actionMap[622][QUALIFIEDPRE] = ActionEntry(REDUCE, 317);
   _actionMap[622][STRINGVAL] = ActionEntry(REDUCE, 317);
   _actionMap[622][DATE] = ActionEntry(REDUCE, 317);
   _actionMap[622][SYSDATE] = ActionEntry(REDUCE, 317);
   _actionMap[622][NULLTOKEN] = ActionEntry(REDUCE, 317);
   _actionMap[622][TRUEVAL] = ActionEntry(REDUCE, 317);
   _actionMap[622][FALSEVAL] = ActionEntry(REDUCE, 317);
   _actionMap[622][LAB] = ActionEntry(REDUCE, 317);
   _actionMap[622][COUNTERID] = ActionEntry(REDUCE, 317);
   _actionMap[622][FLOATVAL] = ActionEntry(REDUCE, 317);
   _actionMap[622][MINUS] = ActionEntry(REDUCE, 317);
   _actionMap[622][INTVAL] = ActionEntry(REDUCE, 317);
   _actionMap[623][THEN] = ActionEntry(REDUCE, 289);
   _actionMap[623][LEFT] = ActionEntry(REDUCE, 289);
}
void Cego::loadParser55()
{
   _actionMap[623][RIGHT] = ActionEntry(REDUCE, 289);
   _actionMap[623][INNER] = ActionEntry(REDUCE, 289);
   _actionMap[623][JOIN] = ActionEntry(REDUCE, 289);
   _actionMap[623][RETURNTOKEN] = ActionEntry(REDUCE, 289);
   _actionMap[623][SEMICOLON] = ActionEntry(REDUCE, 289);
   _actionMap[623][RB] = ActionEntry(REDUCE, 289);
   _actionMap[623][ENDTOKEN] = ActionEntry(REDUCE, 289);
   _actionMap[623][UNION] = ActionEntry(REDUCE, 289);
   _actionMap[623][ROWLIMIT] = ActionEntry(REDUCE, 289);
   _actionMap[623][ORDER] = ActionEntry(REDUCE, 289);
   _actionMap[623][GROUP] = ActionEntry(REDUCE, 289);
   _actionMap[623][WHERE] = ActionEntry(REDUCE, 289);
   _actionMap[623][OR] = ActionEntry(REDUCE, 289);
   _actionMap[623][AND] = ActionEntry(REDUCE, 289);
   _actionMap[624][THEN] = ActionEntry(REDUCE, 290);
   _actionMap[624][LEFT] = ActionEntry(REDUCE, 290);
   _actionMap[624][RIGHT] = ActionEntry(REDUCE, 290);
   _actionMap[624][INNER] = ActionEntry(REDUCE, 290);
   _actionMap[624][JOIN] = ActionEntry(REDUCE, 290);
   _actionMap[624][RETURNTOKEN] = ActionEntry(REDUCE, 290);
   _actionMap[624][SEMICOLON] = ActionEntry(REDUCE, 290);
   _actionMap[624][RB] = ActionEntry(REDUCE, 290);
   _actionMap[624][ENDTOKEN] = ActionEntry(REDUCE, 290);
   _actionMap[624][UNION] = ActionEntry(REDUCE, 290);
   _actionMap[624][ROWLIMIT] = ActionEntry(REDUCE, 290);
   _actionMap[624][ORDER] = ActionEntry(REDUCE, 290);
   _actionMap[624][GROUP] = ActionEntry(REDUCE, 290);
   _actionMap[624][WHERE] = ActionEntry(REDUCE, 290);
   _actionMap[624][OR] = ActionEntry(REDUCE, 290);
   _actionMap[624][AND] = ActionEntry(REDUCE, 290);
   _actionMap[625][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[625][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[625][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[625][WHEN] = ActionEntry(REDUCE, 155);
   _actionMap[625][ELSE] = ActionEntry(REDUCE, 155);
   _actionMap[626][RB] = ActionEntry(SHIFT, 692);
   _actionMap[627][THEN] = ActionEntry(REDUCE, 301);
   _actionMap[627][LEFT] = ActionEntry(REDUCE, 301);
   _actionMap[627][RIGHT] = ActionEntry(REDUCE, 301);
   _actionMap[627][INNER] = ActionEntry(REDUCE, 301);
   _actionMap[627][JOIN] = ActionEntry(REDUCE, 301);
   _actionMap[627][RETURNTOKEN] = ActionEntry(REDUCE, 301);
   _actionMap[627][SEMICOLON] = ActionEntry(REDUCE, 301);
   _actionMap[627][RB] = ActionEntry(REDUCE, 301);
   _actionMap[627][ENDTOKEN] = ActionEntry(REDUCE, 301);
   _actionMap[627][UNION] = ActionEntry(REDUCE, 301);
   _actionMap[627][ROWLIMIT] = ActionEntry(REDUCE, 301);
   _actionMap[627][ORDER] = ActionEntry(REDUCE, 301);
   _actionMap[627][GROUP] = ActionEntry(REDUCE, 301);
   _actionMap[627][WHERE] = ActionEntry(REDUCE, 301);
}
void Cego::loadParser56()
{
   _actionMap[627][AND] = ActionEntry(REDUCE, 301);
   _actionMap[627][OR] = ActionEntry(REDUCE, 301);
   _actionMap[628][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[628][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[628][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[628][KSEP] = ActionEntry(REDUCE, 284);
   _actionMap[628][RB] = ActionEntry(REDUCE, 284);
   _actionMap[629][RB] = ActionEntry(SHIFT, 693);
   _actionMap[630][RB] = ActionEntry(REDUCE, 347);
   _actionMap[631][RB] = ActionEntry(SHIFT, 695);
   _actionMap[631][KSEP] = ActionEntry(SHIFT, 694);
   _actionMap[632][KSEP] = ActionEntry(REDUCE, 158);
   _actionMap[632][RB] = ActionEntry(REDUCE, 158);
   _actionMap[633][WHEN] = ActionEntry(REDUCE, 344);
   _actionMap[633][ELSE] = ActionEntry(REDUCE, 344);
   _actionMap[633][LEFT] = ActionEntry(REDUCE, 344);
   _actionMap[633][RIGHT] = ActionEntry(REDUCE, 344);
   _actionMap[633][INNER] = ActionEntry(REDUCE, 344);
   _actionMap[633][JOIN] = ActionEntry(REDUCE, 344);
   _actionMap[633][RETURNTOKEN] = ActionEntry(REDUCE, 344);
   _actionMap[633][ORDER] = ActionEntry(REDUCE, 344);
   _actionMap[633][GROUP] = ActionEntry(REDUCE, 344);
   _actionMap[633][WHERE] = ActionEntry(REDUCE, 344);
   _actionMap[633][FROM] = ActionEntry(REDUCE, 344);
   _actionMap[633][AS] = ActionEntry(REDUCE, 344);
   _actionMap[633][END_TOKEN] = ActionEntry(REDUCE, 344);
   _actionMap[633][BEGIN] = ActionEntry(REDUCE, 344);
   _actionMap[633][THEN] = ActionEntry(REDUCE, 344);
   _actionMap[633][OR] = ActionEntry(REDUCE, 344);
   _actionMap[633][AND] = ActionEntry(REDUCE, 344);
   _actionMap[633][NULLTOKEN] = ActionEntry(REDUCE, 344);
   _actionMap[633][INTOK] = ActionEntry(REDUCE, 344);
   _actionMap[633][NOT] = ActionEntry(REDUCE, 344);
   _actionMap[633][BETWEEN] = ActionEntry(REDUCE, 344);
   _actionMap[633][IS] = ActionEntry(REDUCE, 344);
   _actionMap[633][LIKE] = ActionEntry(REDUCE, 344);
   _actionMap[633][MT] = ActionEntry(REDUCE, 344);
   _actionMap[633][LT] = ActionEntry(REDUCE, 344);
   _actionMap[633][NEGATION] = ActionEntry(REDUCE, 344);
   _actionMap[633][EQU] = ActionEntry(REDUCE, 344);
   _actionMap[633][RB] = ActionEntry(REDUCE, 344);
   _actionMap[633][ENDTOKEN] = ActionEntry(REDUCE, 344);
   _actionMap[633][UNION] = ActionEntry(REDUCE, 344);
   _actionMap[633][ROWLIMIT] = ActionEntry(REDUCE, 344);
   _actionMap[633][KSEP] = ActionEntry(REDUCE, 344);
   _actionMap[633][ASC] = ActionEntry(REDUCE, 344);
   _actionMap[633][DESC] = ActionEntry(REDUCE, 344);
   _actionMap[633][SEMICOLON] = ActionEntry(REDUCE, 344);
   _actionMap[633][PLUS] = ActionEntry(REDUCE, 344);
   _actionMap[633][MINUS] = ActionEntry(REDUCE, 344);
}
void Cego::loadParser57()
{
   _actionMap[633][DIVISION] = ActionEntry(REDUCE, 344);
   _actionMap[633][STAR] = ActionEntry(REDUCE, 344);
   _actionMap[633][CONCAT] = ActionEntry(REDUCE, 344);
   _actionMap[634][SEMICOLON] = ActionEntry(REDUCE, 220);
   _actionMap[634][RB] = ActionEntry(REDUCE, 220);
   _actionMap[634][ENDTOKEN] = ActionEntry(REDUCE, 220);
   _actionMap[634][UNION] = ActionEntry(REDUCE, 220);
   _actionMap[634][ROWLIMIT] = ActionEntry(REDUCE, 220);
   _actionMap[634][ORDER] = ActionEntry(SHIFT, 698);
   _jumpMap[634][NoOrdering] = 697;
   _jumpMap[634][OrderingClause] = 696;
   _actionMap[635][ORDER] = ActionEntry(REDUCE, 211);
   _actionMap[635][ROWLIMIT] = ActionEntry(REDUCE, 211);
   _actionMap[635][UNION] = ActionEntry(REDUCE, 211);
   _actionMap[635][ENDTOKEN] = ActionEntry(REDUCE, 211);
   _actionMap[635][RB] = ActionEntry(REDUCE, 211);
   _actionMap[635][SEMICOLON] = ActionEntry(REDUCE, 211);
   _actionMap[636][BY] = ActionEntry(SHIFT, 699);
   _actionMap[637][ON] = ActionEntry(SHIFT, 701);
   _jumpMap[637][JoinTableOn] = 700;
   _actionMap[638][IDENTIFIER] = ActionEntry(REDUCE, 201);
   _actionMap[638][QUALIFIEDOBJ] = ActionEntry(REDUCE, 201);
   _actionMap[638][QUALIFIEDTS] = ActionEntry(REDUCE, 201);
   _actionMap[639][JOIN] = ActionEntry(SHIFT, 702);
   _actionMap[640][JOIN] = ActionEntry(SHIFT, 703);
   _actionMap[641][RETURNTOKEN] = ActionEntry(REDUCE, 203);
   _actionMap[641][SEMICOLON] = ActionEntry(REDUCE, 203);
   _actionMap[641][RB] = ActionEntry(REDUCE, 203);
   _actionMap[641][ENDTOKEN] = ActionEntry(REDUCE, 203);
   _actionMap[641][UNION] = ActionEntry(REDUCE, 203);
   _actionMap[641][ROWLIMIT] = ActionEntry(REDUCE, 203);
   _actionMap[641][ORDER] = ActionEntry(REDUCE, 203);
   _actionMap[641][GROUP] = ActionEntry(REDUCE, 203);
   _actionMap[641][WHERE] = ActionEntry(REDUCE, 203);
   _actionMap[642][KSEP] = ActionEntry(SHIFT, 543);
   _actionMap[642][RETURNTOKEN] = ActionEntry(REDUCE, 204);
   _actionMap[642][SEMICOLON] = ActionEntry(REDUCE, 204);
   _actionMap[642][RB] = ActionEntry(REDUCE, 204);
   _actionMap[642][ENDTOKEN] = ActionEntry(REDUCE, 204);
   _actionMap[642][UNION] = ActionEntry(REDUCE, 204);
   _actionMap[642][ROWLIMIT] = ActionEntry(REDUCE, 204);
   _actionMap[642][ORDER] = ActionEntry(REDUCE, 204);
   _actionMap[642][GROUP] = ActionEntry(REDUCE, 204);
   _actionMap[642][WHERE] = ActionEntry(REDUCE, 204);
   _actionMap[643][SEMICOLON] = ActionEntry(REDUCE, 232);
   _actionMap[644][VARREF] = ActionEntry(SHIFT, 706);
   _jumpMap[644][ReturnVar] = 705;
   _jumpMap[644][ReturnVarList] = 704;
   _actionMap[645][KSEP] = ActionEntry(REDUCE, 233);
   _actionMap[645][WHERE] = ActionEntry(REDUCE, 233);
}
void Cego::loadParser58()
{
   _actionMap[645][GROUP] = ActionEntry(REDUCE, 233);
   _actionMap[645][ORDER] = ActionEntry(REDUCE, 233);
   _actionMap[645][ROWLIMIT] = ActionEntry(REDUCE, 233);
   _actionMap[645][UNION] = ActionEntry(REDUCE, 233);
   _actionMap[645][ENDTOKEN] = ActionEntry(REDUCE, 233);
   _actionMap[645][RB] = ActionEntry(REDUCE, 233);
   _actionMap[645][SEMICOLON] = ActionEntry(REDUCE, 233);
   _actionMap[645][RETURNTOKEN] = ActionEntry(REDUCE, 233);
   _actionMap[646][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[646][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[646][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[646][KSEP] = ActionEntry(REDUCE, 235);
   _actionMap[646][WHERE] = ActionEntry(REDUCE, 235);
   _actionMap[646][GROUP] = ActionEntry(REDUCE, 235);
   _actionMap[646][ORDER] = ActionEntry(REDUCE, 235);
   _actionMap[646][ROWLIMIT] = ActionEntry(REDUCE, 235);
   _actionMap[646][UNION] = ActionEntry(REDUCE, 235);
   _actionMap[646][ENDTOKEN] = ActionEntry(REDUCE, 235);
   _actionMap[646][RB] = ActionEntry(REDUCE, 235);
   _actionMap[646][SEMICOLON] = ActionEntry(REDUCE, 235);
   _actionMap[646][RETURNTOKEN] = ActionEntry(REDUCE, 235);
   _actionMap[647][RB] = ActionEntry(SHIFT, 648);
   _actionMap[648][SEMICOLON] = ActionEntry(REDUCE, 48);
   _actionMap[416][DROP] = ActionEntry(SHIFT, 292);
   _actionMap[416][ADD] = ActionEntry(SHIFT, 552);
   _actionMap[416][MODIFY] = ActionEntry(SHIFT, 293);
   _actionMap[416][RENAME] = ActionEntry(SHIFT, 294);
   _jumpMap[416][AlterOption] = 290;
   _jumpMap[416][AlterList] = 551;
   _actionMap[417][IDENTIFIER] = ActionEntry(SHIFT, 553);
   _actionMap[418][IDENTIFIER] = ActionEntry(SHIFT, 456);
   _jumpMap[418][ColumnDesc] = 554;
   _actionMap[419][KEY] = ActionEntry(SHIFT, 555);
   _actionMap[420][IDENTIFIER] = ActionEntry(SHIFT, 556);
   _actionMap[421][IDENTIFIER] = ActionEntry(SHIFT, 456);
   _jumpMap[421][ColumnDesc] = 557;
   _actionMap[422][IDENTIFIER] = ActionEntry(SHIFT, 558);
   _actionMap[423][FOR] = ActionEntry(SHIFT, 559);
   _actionMap[424][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[424][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[424][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[424][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[424][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[424][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[424][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[424][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[424][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[424][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[424][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[424][UPPER] = ActionEntry(SHIFT, 134);
}
void Cego::loadParser59()
{
   _actionMap[424][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[424][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[424][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[424][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[424][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[424][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[424][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[424][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[424][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[424][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[424][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[424][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[424][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[424][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[424][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[424][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[424][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[424][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[424][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[424][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[424][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[424][LB] = ActionEntry(SHIFT, 135);
   _actionMap[424][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[424][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[424][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[424][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[424][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[424][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[424][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[424][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[424][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[424][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[424][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[424][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[424][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[424][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[424][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[424][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[424][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[424][ObjSpec] = 94;
   _jumpMap[424][Constant] = 93;
   _jumpMap[424][SignedFloat] = 92;
   _jumpMap[424][SignedInt] = 91;
   _jumpMap[424][Attribute] = 90;
   _jumpMap[424][Function] = 89;
   _jumpMap[424][CasePrepare] = 88;
   _jumpMap[424][CaseClause] = 87;
   _jumpMap[424][Factor] = 86;
   _jumpMap[424][Term] = 85;
   _jumpMap[424][Expr] = 560;
}
void Cego::loadParser60()
{
   _actionMap[425][SEMICOLON] = ActionEntry(REDUCE, 73);
   _actionMap[426][ELSE] = ActionEntry(REDUCE, 82);
   _actionMap[426][ELSIF] = ActionEntry(REDUCE, 82);
   _actionMap[426][END_TOKEN] = ActionEntry(REDUCE, 82);
   _actionMap[426][EXCEPTION] = ActionEntry(SHIFT, 562);
   _jumpMap[426][ProcExceptionStmt] = 561;
   _actionMap[427][SEMICOLON] = ActionEntry(SHIFT, 563);
   _actionMap[428][END_TOKEN] = ActionEntry(SHIFT, 564);
   _actionMap[429][ELSE] = ActionEntry(SHIFT, 567);
   _actionMap[429][END_TOKEN] = ActionEntry(REDUCE, 118);
   _jumpMap[429][ProcElsePart] = 566;
   _jumpMap[429][ProcElseOpt] = 565;
   _actionMap[430][ELSIF] = ActionEntry(SHIFT, 431);
   _actionMap[430][END_TOKEN] = ActionEntry(REDUCE, 115);
   _actionMap[430][ELSE] = ActionEntry(REDUCE, 115);
   _jumpMap[430][ProcElsIfOpt] = 430;
   _jumpMap[430][ProcElsIfList] = 569;
   _actionMap[431][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[431][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[431][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[431][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[431][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[431][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[431][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[431][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[431][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[431][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[431][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[431][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[431][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[431][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[431][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[431][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[431][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[431][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[431][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[431][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[431][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[431][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[431][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[431][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[431][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[431][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[431][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[431][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[431][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[431][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[431][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[431][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[431][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
}
void Cego::loadParser61()
{
   _actionMap[431][LB] = ActionEntry(SHIFT, 439);
   _actionMap[431][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[431][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[431][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[431][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[431][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[431][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[431][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[431][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[431][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[431][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[431][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[431][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[431][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[431][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[431][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[431][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[431][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[431][ObjSpec] = 94;
   _jumpMap[431][Constant] = 93;
   _jumpMap[431][SignedFloat] = 92;
   _jumpMap[431][SignedInt] = 91;
   _jumpMap[431][Attribute] = 90;
   _jumpMap[431][Function] = 89;
   _jumpMap[431][CasePrepare] = 88;
   _jumpMap[431][CaseClause] = 87;
   _jumpMap[431][Factor] = 86;
   _jumpMap[431][Term] = 85;
   _jumpMap[431][Expr] = 438;
   _jumpMap[431][ProcPredicate] = 437;
   _jumpMap[431][ProcCondition] = 571;
   _jumpMap[431][ProcElsIfCondition] = 570;
   _actionMap[432][EXCEPTION] = ActionEntry(REDUCE, 84);
   _actionMap[432][END_TOKEN] = ActionEntry(REDUCE, 84);
   _actionMap[432][ELSE] = ActionEntry(REDUCE, 84);
   _actionMap[432][ELSIF] = ActionEntry(REDUCE, 84);
   _actionMap[432][VAR] = ActionEntry(REDUCE, 84);
   _actionMap[432][CURSOR] = ActionEntry(REDUCE, 84);
   _actionMap[432][CLOSE] = ActionEntry(REDUCE, 84);
   _actionMap[432][VARREF] = ActionEntry(REDUCE, 84);
   _actionMap[432][NOOP] = ActionEntry(REDUCE, 84);
   _actionMap[432][RETURNTOKEN] = ActionEntry(REDUCE, 84);
   _actionMap[432][WHILE] = ActionEntry(REDUCE, 84);
   _actionMap[432][IF] = ActionEntry(REDUCE, 84);
   _actionMap[432][BEGIN] = ActionEntry(REDUCE, 84);
   _actionMap[432][ROLLBACK] = ActionEntry(REDUCE, 84);
   _actionMap[432][COMMIT] = ActionEntry(REDUCE, 84);
   _actionMap[432][START_TOKEN] = ActionEntry(REDUCE, 84);
   _actionMap[432][UPDATE] = ActionEntry(REDUCE, 84);
   _actionMap[432][DELETETOK] = ActionEntry(REDUCE, 84);
}
void Cego::loadParser62()
{
   _actionMap[432][INSERT] = ActionEntry(REDUCE, 84);
   _actionMap[432][FETCH] = ActionEntry(REDUCE, 84);
   _actionMap[432][LB] = ActionEntry(REDUCE, 84);
   _actionMap[432][COUNT] = ActionEntry(REDUCE, 84);
   _actionMap[432][SUM] = ActionEntry(REDUCE, 84);
   _actionMap[432][AVG] = ActionEntry(REDUCE, 84);
   _actionMap[432][MIN] = ActionEntry(REDUCE, 84);
   _actionMap[432][MAX] = ActionEntry(REDUCE, 84);
   _actionMap[432][CASE] = ActionEntry(REDUCE, 84);
   _actionMap[432][TRIM] = ActionEntry(REDUCE, 84);
   _actionMap[432][RTRIM] = ActionEntry(REDUCE, 84);
   _actionMap[432][LTRIM] = ActionEntry(REDUCE, 84);
   _actionMap[432][ROUND] = ActionEntry(REDUCE, 84);
   _actionMap[432][DATE2STR] = ActionEntry(REDUCE, 84);
   _actionMap[432][DATE2INT] = ActionEntry(REDUCE, 84);
   _actionMap[432][INT2DATE] = ActionEntry(REDUCE, 84);
   _actionMap[432][LOWER] = ActionEntry(REDUCE, 84);
   _actionMap[432][UPPER] = ActionEntry(REDUCE, 84);
   _actionMap[432][LEFT] = ActionEntry(REDUCE, 84);
   _actionMap[432][RIGHT] = ActionEntry(REDUCE, 84);
   _actionMap[432][GETPOS] = ActionEntry(REDUCE, 84);
   _actionMap[432][SUBSTR] = ActionEntry(REDUCE, 84);
   _actionMap[432][REPLACE] = ActionEntry(REDUCE, 84);
   _actionMap[432][LENGTH] = ActionEntry(REDUCE, 84);
   _actionMap[432][TRUNC] = ActionEntry(REDUCE, 84);
   _actionMap[432][STR2INT] = ActionEntry(REDUCE, 84);
   _actionMap[432][STR2LONG] = ActionEntry(REDUCE, 84);
   _actionMap[432][RANDSTR] = ActionEntry(REDUCE, 84);
   _actionMap[432][RANDINT] = ActionEntry(REDUCE, 84);
   _actionMap[432][MOD] = ActionEntry(REDUCE, 84);
   _actionMap[432][DIV] = ActionEntry(REDUCE, 84);
   _actionMap[432][POWER] = ActionEntry(REDUCE, 84);
   _actionMap[432][BITAND] = ActionEntry(REDUCE, 84);
   _actionMap[432][BITOR] = ActionEntry(REDUCE, 84);
   _actionMap[432][BITXOR] = ActionEntry(REDUCE, 84);
   _actionMap[432][NEXTCOUNT] = ActionEntry(REDUCE, 84);
   _actionMap[432][IDENTIFIER] = ActionEntry(REDUCE, 84);
   _actionMap[432][QUALIFIEDOBJ] = ActionEntry(REDUCE, 84);
   _actionMap[432][QUALIFIEDTS] = ActionEntry(REDUCE, 84);
   _actionMap[432][QUALIFIEDPRE] = ActionEntry(REDUCE, 84);
   _actionMap[432][STRINGVAL] = ActionEntry(REDUCE, 84);
   _actionMap[432][DATE] = ActionEntry(REDUCE, 84);
   _actionMap[432][SYSDATE] = ActionEntry(REDUCE, 84);
   _actionMap[432][NULLTOKEN] = ActionEntry(REDUCE, 84);
   _actionMap[432][TRUEVAL] = ActionEntry(REDUCE, 84);
   _actionMap[432][FALSEVAL] = ActionEntry(REDUCE, 84);
   _actionMap[432][LAB] = ActionEntry(REDUCE, 84);
   _actionMap[432][COUNTERID] = ActionEntry(REDUCE, 84);
   _actionMap[432][FLOATVAL] = ActionEntry(REDUCE, 84);
   _actionMap[432][MINUS] = ActionEntry(REDUCE, 84);
}
void Cego::loadParser63()
{
   _actionMap[432][INTVAL] = ActionEntry(REDUCE, 84);
   _actionMap[433][SEMICOLON] = ActionEntry(REDUCE, 87);
   _actionMap[434][AS] = ActionEntry(SHIFT, 572);
   _actionMap[435][THEN] = ActionEntry(SHIFT, 573);
   _actionMap[436][OR] = ActionEntry(SHIFT, 575);
   _actionMap[436][AND] = ActionEntry(SHIFT, 574);
   _actionMap[436][THEN] = ActionEntry(REDUCE, 120);
   _actionMap[437][BEGIN] = ActionEntry(REDUCE, 126);
   _actionMap[437][RB] = ActionEntry(REDUCE, 126);
   _actionMap[437][AND] = ActionEntry(REDUCE, 126);
   _actionMap[437][OR] = ActionEntry(REDUCE, 126);
   _actionMap[437][THEN] = ActionEntry(REDUCE, 126);
   _actionMap[438][IS] = ActionEntry(SHIFT, 577);
   _actionMap[438][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[438][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[438][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[438][EQU] = ActionEntry(SHIFT, 471);
   _actionMap[438][NEGATION] = ActionEntry(SHIFT, 474);
   _actionMap[438][LT] = ActionEntry(SHIFT, 472);
   _actionMap[438][MT] = ActionEntry(SHIFT, 473);
   _jumpMap[438][Comparison] = 576;
   _actionMap[439][LONG] = ActionEntry(SHIFT, 257);
   _actionMap[439][BIGINT] = ActionEntry(SHIFT, 253);
   _actionMap[439][SMALLINT] = ActionEntry(SHIFT, 258);
   _actionMap[439][TINYINT] = ActionEntry(SHIFT, 259);
   _actionMap[439][DOUBLE] = ActionEntry(SHIFT, 255);
   _actionMap[439][DECIMAL] = ActionEntry(SHIFT, 254);
   _actionMap[439][FIXED] = ActionEntry(SHIFT, 256);
   _actionMap[439][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[439][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[439][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[439][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[439][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[439][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[439][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[439][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[439][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[439][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[439][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[439][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[439][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[439][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[439][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[439][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[439][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[439][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[439][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[439][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[439][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[439][RANDSTR] = ActionEntry(SHIFT, 120);
}
void Cego::loadParser64()
{
   _actionMap[439][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[439][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[439][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[439][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[439][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[439][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[439][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[439][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[439][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[439][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[439][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[439][LB] = ActionEntry(SHIFT, 439);
   _actionMap[439][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[439][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[439][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[439][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[439][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[439][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[439][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[439][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[439][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[439][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[439][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[439][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[439][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[439][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[439][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[439][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[439][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[439][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[439][ObjSpec] = 94;
   _jumpMap[439][Constant] = 93;
   _jumpMap[439][SignedFloat] = 92;
   _jumpMap[439][SignedInt] = 91;
   _jumpMap[439][Attribute] = 90;
   _jumpMap[439][Function] = 89;
   _jumpMap[439][SelectStatement] = 252;
   _jumpMap[439][CasePrepare] = 88;
   _jumpMap[439][CaseClause] = 87;
   _jumpMap[439][Factor] = 86;
   _jumpMap[439][Term] = 85;
   _jumpMap[439][Expr] = 579;
   _jumpMap[439][ProcPredicate] = 437;
   _jumpMap[439][ProcCondition] = 578;
   _actionMap[440][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[440][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[440][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[440][SEMICOLON] = ActionEntry(REDUCE, 101);
   _actionMap[441][INT] = ActionEntry(SHIFT, 589);
   _actionMap[441][LONG] = ActionEntry(SHIFT, 590);
}
void Cego::loadParser65()
{
   _actionMap[441][STRING] = ActionEntry(SHIFT, 592);
   _actionMap[441][DATETIME] = ActionEntry(SHIFT, 584);
   _actionMap[441][BOOL] = ActionEntry(SHIFT, 583);
   _actionMap[441][BIGINT] = ActionEntry(SHIFT, 581);
   _actionMap[441][FLOAT] = ActionEntry(SHIFT, 588);
   _actionMap[441][DOUBLE] = ActionEntry(SHIFT, 586);
   _actionMap[441][SMALLINT] = ActionEntry(SHIFT, 591);
   _actionMap[441][TINYINT] = ActionEntry(SHIFT, 593);
   _actionMap[441][DECIMAL] = ActionEntry(SHIFT, 585);
   _actionMap[441][FIXED] = ActionEntry(SHIFT, 587);
   _actionMap[441][BLOB] = ActionEntry(SHIFT, 582);
   _jumpMap[441][DataTypeProd] = 580;
   _actionMap[442][BEGIN] = ActionEntry(SHIFT, 594);
   _actionMap[443][OR] = ActionEntry(SHIFT, 575);
   _actionMap[443][AND] = ActionEntry(SHIFT, 574);
   _actionMap[443][BEGIN] = ActionEntry(REDUCE, 123);
   _actionMap[444][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[444][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[444][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[444][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[444][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[444][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[444][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[444][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[444][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[444][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[444][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[444][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[444][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[444][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[444][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[444][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[444][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[444][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[444][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[444][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[444][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[444][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[444][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[444][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[444][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[444][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[444][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[444][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[444][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[444][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[444][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[444][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[444][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[444][LB] = ActionEntry(SHIFT, 135);
}
void Cego::loadParser66()
{
   _actionMap[444][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[444][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[444][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[444][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[444][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[444][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[444][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[444][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[444][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[444][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[444][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[444][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[444][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[444][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[444][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[444][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[444][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[444][ObjSpec] = 94;
   _jumpMap[444][Constant] = 93;
   _jumpMap[444][SignedFloat] = 92;
   _jumpMap[444][SignedInt] = 91;
   _jumpMap[444][Attribute] = 90;
   _jumpMap[444][Function] = 89;
   _jumpMap[444][CasePrepare] = 88;
   _jumpMap[444][CaseClause] = 87;
   _jumpMap[444][Factor] = 86;
   _jumpMap[444][Term] = 85;
   _jumpMap[444][Expr] = 595;
   _actionMap[445][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[445][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[445][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[445][ObjSpec] = 596;
   _actionMap[446][LB] = ActionEntry(SHIFT, 597);
   _actionMap[447][RB] = ActionEntry(SHIFT, 450);
   _actionMap[448][KSEP] = ActionEntry(SHIFT, 598);
   _actionMap[448][RB] = ActionEntry(REDUCE, 76);
   _actionMap[449][KSEP] = ActionEntry(REDUCE, 79);
   _actionMap[449][RB] = ActionEntry(REDUCE, 79);
   _actionMap[450][RETURNTOKEN] = ActionEntry(SHIFT, 600);
   _actionMap[450][BEGIN] = ActionEntry(REDUCE, 75);
   _jumpMap[450][ReturnOpt] = 599;
   _actionMap[451][INTOK] = ActionEntry(SHIFT, 601);
   _actionMap[451][OUTTOK] = ActionEntry(SHIFT, 602);
   _actionMap[452][RB] = ActionEntry(SHIFT, 604);
   _actionMap[452][KSEP] = ActionEntry(SHIFT, 603);
   _actionMap[453][KSEP] = ActionEntry(REDUCE, 160);
   _actionMap[453][RB] = ActionEntry(REDUCE, 160);
   _actionMap[454][KSEP] = ActionEntry(REDUCE, 162);
   _actionMap[454][RB] = ActionEntry(REDUCE, 162);
   _actionMap[455][IDENTIFIER] = ActionEntry(SHIFT, 456);
}
void Cego::loadParser67()
{
   _jumpMap[455][ColumnDesc] = 605;
   _actionMap[456][INT] = ActionEntry(SHIFT, 589);
   _actionMap[456][LONG] = ActionEntry(SHIFT, 590);
   _actionMap[456][STRING] = ActionEntry(SHIFT, 592);
   _actionMap[456][DATETIME] = ActionEntry(SHIFT, 584);
   _actionMap[456][BOOL] = ActionEntry(SHIFT, 583);
   _actionMap[456][BIGINT] = ActionEntry(SHIFT, 581);
   _actionMap[456][FLOAT] = ActionEntry(SHIFT, 588);
   _actionMap[456][DOUBLE] = ActionEntry(SHIFT, 586);
   _actionMap[456][SMALLINT] = ActionEntry(SHIFT, 591);
   _actionMap[456][TINYINT] = ActionEntry(SHIFT, 593);
   _actionMap[456][DECIMAL] = ActionEntry(SHIFT, 585);
   _actionMap[456][FIXED] = ActionEntry(SHIFT, 587);
   _actionMap[456][BLOB] = ActionEntry(SHIFT, 582);
   _jumpMap[456][DataTypeProd] = 606;
   _actionMap[457][SEMICOLON] = ActionEntry(REDUCE, 43);
   _actionMap[458][AND] = ActionEntry(SHIFT, 475);
   _actionMap[458][OR] = ActionEntry(SHIFT, 476);
   _actionMap[458][RETURNTOKEN] = ActionEntry(REDUCE, 286);
   _actionMap[458][GROUP] = ActionEntry(REDUCE, 286);
   _actionMap[458][ORDER] = ActionEntry(REDUCE, 286);
   _actionMap[458][ROWLIMIT] = ActionEntry(REDUCE, 286);
   _actionMap[458][UNION] = ActionEntry(REDUCE, 286);
   _actionMap[458][ENDTOKEN] = ActionEntry(REDUCE, 286);
   _actionMap[458][RB] = ActionEntry(REDUCE, 286);
   _actionMap[458][SEMICOLON] = ActionEntry(REDUCE, 286);
   _actionMap[459][SEMICOLON] = ActionEntry(REDUCE, 179);
   _actionMap[460][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[460][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[460][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[460][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[460][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[460][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[460][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[460][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[460][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[460][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[460][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[460][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[460][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[460][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[460][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[460][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[460][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[460][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[460][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[460][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[460][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[460][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[460][RANDINT] = ActionEntry(SHIFT, 121);
}
void Cego::loadParser68()
{
   _actionMap[460][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[460][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[460][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[460][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[460][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[460][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[460][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[460][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[460][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[460][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[460][LB] = ActionEntry(SHIFT, 135);
   _actionMap[460][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[460][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[460][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[460][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[460][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[460][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[460][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[460][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[460][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[460][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[460][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[460][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[460][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[460][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[460][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[460][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[460][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[460][ObjSpec] = 94;
   _jumpMap[460][Constant] = 93;
   _jumpMap[460][SignedFloat] = 92;
   _jumpMap[460][SignedInt] = 91;
   _jumpMap[460][Attribute] = 90;
   _jumpMap[460][Function] = 89;
   _jumpMap[460][InsertValueList] = 608;
   _jumpMap[460][CasePrepare] = 88;
   _jumpMap[460][CaseClause] = 87;
   _jumpMap[460][Factor] = 86;
   _jumpMap[460][Term] = 85;
   _jumpMap[460][Expr] = 607;
   _actionMap[461][RB] = ActionEntry(SHIFT, 610);
   _actionMap[461][KSEP] = ActionEntry(SHIFT, 609);
   _actionMap[462][KSEP] = ActionEntry(REDUCE, 185);
   _actionMap[462][RB] = ActionEntry(REDUCE, 185);
   _actionMap[463][SEMICOLON] = ActionEntry(REDUCE, 44);
   _actionMap[464][END_TOKEN] = ActionEntry(SHIFT, 611);
   _actionMap[464][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[464][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[464][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[465][FLOATVAL] = ActionEntry(SHIFT, 139);
}
void Cego::loadParser69()
{
   _actionMap[465][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[465][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[465][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[465][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[465][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[465][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[465][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[465][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[465][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[465][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[465][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[465][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[465][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[465][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[465][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[465][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[465][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[465][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[465][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[465][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[465][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[465][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[465][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[465][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[465][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[465][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[465][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[465][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[465][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[465][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[465][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[465][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[465][LB] = ActionEntry(SHIFT, 135);
   _actionMap[465][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[465][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[465][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[465][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[465][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[465][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[465][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[465][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[465][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[465][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[465][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[465][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[465][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[465][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[465][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[465][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[465][MAX] = ActionEntry(SHIFT, 115);
}
void Cego::loadParser70()
{
   _jumpMap[465][ObjSpec] = 94;
   _jumpMap[465][Constant] = 93;
   _jumpMap[465][SignedFloat] = 92;
   _jumpMap[465][SignedInt] = 91;
   _jumpMap[465][Attribute] = 90;
   _jumpMap[465][Function] = 89;
   _jumpMap[465][CasePrepare] = 88;
   _jumpMap[465][CaseClause] = 87;
   _jumpMap[465][Factor] = 86;
   _jumpMap[465][Term] = 85;
   _jumpMap[465][Expr] = 612;
   _actionMap[466][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[466][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[466][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[466][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[466][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[466][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[466][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[466][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[466][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[466][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[466][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[466][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[466][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[466][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[466][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[466][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[466][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[466][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[466][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[466][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[466][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[466][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[466][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[466][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[466][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[466][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[466][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[466][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[466][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[466][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[466][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[466][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[466][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[466][LB] = ActionEntry(SHIFT, 135);
   _actionMap[466][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[466][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[466][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[466][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[466][TRUEVAL] = ActionEntry(SHIFT, 132);
}
void Cego::loadParser71()
{
   _actionMap[466][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[466][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[466][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[466][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[466][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[466][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[466][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[466][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[466][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[466][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[466][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[466][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[466][ObjSpec] = 94;
   _jumpMap[466][Constant] = 93;
   _jumpMap[466][SignedFloat] = 92;
   _jumpMap[466][SignedInt] = 91;
   _jumpMap[466][Attribute] = 90;
   _jumpMap[466][Function] = 89;
   _jumpMap[466][CasePrepare] = 88;
   _jumpMap[466][CaseClause] = 87;
   _jumpMap[466][Factor] = 86;
   _jumpMap[466][Term] = 85;
   _jumpMap[466][Expr] = 613;
   _actionMap[467][LB] = ActionEntry(SHIFT, 614);
   _actionMap[468][NOT] = ActionEntry(SHIFT, 615);
   _actionMap[468][NULLTOKEN] = ActionEntry(SHIFT, 616);
   _actionMap[469][STRINGVAL] = ActionEntry(SHIFT, 617);
   _actionMap[470][LIKE] = ActionEntry(SHIFT, 619);
   _actionMap[470][INTOK] = ActionEntry(SHIFT, 618);
   _actionMap[471][VARREF] = ActionEntry(REDUCE, 316);
   _actionMap[471][FETCH] = ActionEntry(REDUCE, 316);
   _actionMap[471][LB] = ActionEntry(REDUCE, 316);
   _actionMap[471][COUNT] = ActionEntry(REDUCE, 316);
   _actionMap[471][SUM] = ActionEntry(REDUCE, 316);
   _actionMap[471][AVG] = ActionEntry(REDUCE, 316);
   _actionMap[471][MIN] = ActionEntry(REDUCE, 316);
   _actionMap[471][MAX] = ActionEntry(REDUCE, 316);
   _actionMap[471][CASE] = ActionEntry(REDUCE, 316);
   _actionMap[471][TRIM] = ActionEntry(REDUCE, 316);
   _actionMap[471][RTRIM] = ActionEntry(REDUCE, 316);
   _actionMap[471][LTRIM] = ActionEntry(REDUCE, 316);
   _actionMap[471][ROUND] = ActionEntry(REDUCE, 316);
   _actionMap[471][DATE2STR] = ActionEntry(REDUCE, 316);
   _actionMap[471][DATE2INT] = ActionEntry(REDUCE, 316);
   _actionMap[471][INT2DATE] = ActionEntry(REDUCE, 316);
   _actionMap[471][LOWER] = ActionEntry(REDUCE, 316);
   _actionMap[471][UPPER] = ActionEntry(REDUCE, 316);
   _actionMap[471][LEFT] = ActionEntry(REDUCE, 316);
   _actionMap[471][RIGHT] = ActionEntry(REDUCE, 316);
   _actionMap[471][GETPOS] = ActionEntry(REDUCE, 316);
}
void Cego::loadParser72()
{
   _actionMap[471][SUBSTR] = ActionEntry(REDUCE, 316);
   _actionMap[471][REPLACE] = ActionEntry(REDUCE, 316);
   _actionMap[471][LENGTH] = ActionEntry(REDUCE, 316);
   _actionMap[471][TRUNC] = ActionEntry(REDUCE, 316);
   _actionMap[471][STR2INT] = ActionEntry(REDUCE, 316);
   _actionMap[471][STR2LONG] = ActionEntry(REDUCE, 316);
   _actionMap[471][RANDSTR] = ActionEntry(REDUCE, 316);
   _actionMap[471][RANDINT] = ActionEntry(REDUCE, 316);
   _actionMap[471][MOD] = ActionEntry(REDUCE, 316);
   _actionMap[471][DIV] = ActionEntry(REDUCE, 316);
   _actionMap[471][POWER] = ActionEntry(REDUCE, 316);
   _actionMap[471][BITAND] = ActionEntry(REDUCE, 316);
   _actionMap[471][BITOR] = ActionEntry(REDUCE, 316);
   _actionMap[471][BITXOR] = ActionEntry(REDUCE, 316);
   _actionMap[471][NEXTCOUNT] = ActionEntry(REDUCE, 316);
   _actionMap[471][IDENTIFIER] = ActionEntry(REDUCE, 316);
   _actionMap[471][QUALIFIEDOBJ] = ActionEntry(REDUCE, 316);
   _actionMap[471][QUALIFIEDTS] = ActionEntry(REDUCE, 316);
   _actionMap[471][QUALIFIEDPRE] = ActionEntry(REDUCE, 316);
   _actionMap[471][STRINGVAL] = ActionEntry(REDUCE, 316);
   _actionMap[471][DATE] = ActionEntry(REDUCE, 316);
   _actionMap[471][SYSDATE] = ActionEntry(REDUCE, 316);
   _actionMap[471][NULLTOKEN] = ActionEntry(REDUCE, 316);
   _actionMap[471][TRUEVAL] = ActionEntry(REDUCE, 316);
   _actionMap[471][FALSEVAL] = ActionEntry(REDUCE, 316);
   _actionMap[471][LAB] = ActionEntry(REDUCE, 316);
   _actionMap[471][COUNTERID] = ActionEntry(REDUCE, 316);
   _actionMap[471][FLOATVAL] = ActionEntry(REDUCE, 316);
   _actionMap[471][MINUS] = ActionEntry(REDUCE, 316);
   _actionMap[471][INTVAL] = ActionEntry(REDUCE, 316);
   _actionMap[472][VARREF] = ActionEntry(REDUCE, 318);
   _actionMap[472][FETCH] = ActionEntry(REDUCE, 318);
   _actionMap[472][LB] = ActionEntry(REDUCE, 318);
   _actionMap[472][COUNT] = ActionEntry(REDUCE, 318);
   _actionMap[472][SUM] = ActionEntry(REDUCE, 318);
   _actionMap[472][AVG] = ActionEntry(REDUCE, 318);
   _actionMap[472][MIN] = ActionEntry(REDUCE, 318);
   _actionMap[472][MAX] = ActionEntry(REDUCE, 318);
   _actionMap[472][CASE] = ActionEntry(REDUCE, 318);
   _actionMap[472][TRIM] = ActionEntry(REDUCE, 318);
   _actionMap[472][RTRIM] = ActionEntry(REDUCE, 318);
   _actionMap[472][LTRIM] = ActionEntry(REDUCE, 318);
   _actionMap[472][ROUND] = ActionEntry(REDUCE, 318);
   _actionMap[472][DATE2STR] = ActionEntry(REDUCE, 318);
   _actionMap[472][DATE2INT] = ActionEntry(REDUCE, 318);
   _actionMap[472][INT2DATE] = ActionEntry(REDUCE, 318);
   _actionMap[472][LOWER] = ActionEntry(REDUCE, 318);
   _actionMap[472][UPPER] = ActionEntry(REDUCE, 318);
   _actionMap[472][LEFT] = ActionEntry(REDUCE, 318);
   _actionMap[472][RIGHT] = ActionEntry(REDUCE, 318);
}
void Cego::loadParser73()
{
   _actionMap[472][GETPOS] = ActionEntry(REDUCE, 318);
   _actionMap[472][SUBSTR] = ActionEntry(REDUCE, 318);
   _actionMap[472][REPLACE] = ActionEntry(REDUCE, 318);
   _actionMap[472][LENGTH] = ActionEntry(REDUCE, 318);
   _actionMap[472][TRUNC] = ActionEntry(REDUCE, 318);
   _actionMap[472][STR2INT] = ActionEntry(REDUCE, 318);
   _actionMap[472][STR2LONG] = ActionEntry(REDUCE, 318);
   _actionMap[472][RANDSTR] = ActionEntry(REDUCE, 318);
   _actionMap[472][RANDINT] = ActionEntry(REDUCE, 318);
   _actionMap[472][MOD] = ActionEntry(REDUCE, 318);
   _actionMap[472][DIV] = ActionEntry(REDUCE, 318);
   _actionMap[472][POWER] = ActionEntry(REDUCE, 318);
   _actionMap[472][BITAND] = ActionEntry(REDUCE, 318);
   _actionMap[472][BITOR] = ActionEntry(REDUCE, 318);
   _actionMap[472][BITXOR] = ActionEntry(REDUCE, 318);
   _actionMap[472][NEXTCOUNT] = ActionEntry(REDUCE, 318);
   _actionMap[472][IDENTIFIER] = ActionEntry(REDUCE, 318);
   _actionMap[472][QUALIFIEDOBJ] = ActionEntry(REDUCE, 318);
   _actionMap[472][QUALIFIEDTS] = ActionEntry(REDUCE, 318);
   _actionMap[472][QUALIFIEDPRE] = ActionEntry(REDUCE, 318);
   _actionMap[472][STRINGVAL] = ActionEntry(REDUCE, 318);
   _actionMap[472][DATE] = ActionEntry(REDUCE, 318);
   _actionMap[472][SYSDATE] = ActionEntry(REDUCE, 318);
   _actionMap[472][NULLTOKEN] = ActionEntry(REDUCE, 318);
   _actionMap[472][TRUEVAL] = ActionEntry(REDUCE, 318);
   _actionMap[472][FALSEVAL] = ActionEntry(REDUCE, 318);
   _actionMap[472][LAB] = ActionEntry(REDUCE, 318);
   _actionMap[472][COUNTERID] = ActionEntry(REDUCE, 318);
   _actionMap[472][FLOATVAL] = ActionEntry(REDUCE, 318);
   _actionMap[472][MINUS] = ActionEntry(REDUCE, 318);
   _actionMap[472][INTVAL] = ActionEntry(REDUCE, 318);
   _actionMap[472][EQU] = ActionEntry(SHIFT, 620);
   _actionMap[473][VARREF] = ActionEntry(REDUCE, 319);
   _actionMap[473][FETCH] = ActionEntry(REDUCE, 319);
   _actionMap[473][LB] = ActionEntry(REDUCE, 319);
   _actionMap[473][COUNT] = ActionEntry(REDUCE, 319);
   _actionMap[473][SUM] = ActionEntry(REDUCE, 319);
   _actionMap[473][AVG] = ActionEntry(REDUCE, 319);
   _actionMap[473][MIN] = ActionEntry(REDUCE, 319);
   _actionMap[473][MAX] = ActionEntry(REDUCE, 319);
   _actionMap[473][CASE] = ActionEntry(REDUCE, 319);
   _actionMap[473][TRIM] = ActionEntry(REDUCE, 319);
   _actionMap[473][RTRIM] = ActionEntry(REDUCE, 319);
   _actionMap[473][LTRIM] = ActionEntry(REDUCE, 319);
   _actionMap[473][ROUND] = ActionEntry(REDUCE, 319);
   _actionMap[473][DATE2STR] = ActionEntry(REDUCE, 319);
   _actionMap[473][DATE2INT] = ActionEntry(REDUCE, 319);
   _actionMap[473][INT2DATE] = ActionEntry(REDUCE, 319);
   _actionMap[473][LOWER] = ActionEntry(REDUCE, 319);
   _actionMap[473][UPPER] = ActionEntry(REDUCE, 319);
}
void Cego::loadParser74()
{
   _actionMap[473][LEFT] = ActionEntry(REDUCE, 319);
   _actionMap[473][RIGHT] = ActionEntry(REDUCE, 319);
   _actionMap[473][GETPOS] = ActionEntry(REDUCE, 319);
   _actionMap[473][SUBSTR] = ActionEntry(REDUCE, 319);
   _actionMap[473][REPLACE] = ActionEntry(REDUCE, 319);
   _actionMap[473][LENGTH] = ActionEntry(REDUCE, 319);
   _actionMap[473][TRUNC] = ActionEntry(REDUCE, 319);
   _actionMap[473][STR2INT] = ActionEntry(REDUCE, 319);
   _actionMap[473][STR2LONG] = ActionEntry(REDUCE, 319);
   _actionMap[473][RANDSTR] = ActionEntry(REDUCE, 319);
   _actionMap[473][RANDINT] = ActionEntry(REDUCE, 319);
   _actionMap[473][MOD] = ActionEntry(REDUCE, 319);
   _actionMap[473][DIV] = ActionEntry(REDUCE, 319);
   _actionMap[473][POWER] = ActionEntry(REDUCE, 319);
   _actionMap[473][BITAND] = ActionEntry(REDUCE, 319);
   _actionMap[473][BITOR] = ActionEntry(REDUCE, 319);
   _actionMap[473][BITXOR] = ActionEntry(REDUCE, 319);
   _actionMap[473][NEXTCOUNT] = ActionEntry(REDUCE, 319);
   _actionMap[473][IDENTIFIER] = ActionEntry(REDUCE, 319);
   _actionMap[473][QUALIFIEDOBJ] = ActionEntry(REDUCE, 319);
   _actionMap[473][QUALIFIEDTS] = ActionEntry(REDUCE, 319);
   _actionMap[473][QUALIFIEDPRE] = ActionEntry(REDUCE, 319);
   _actionMap[473][STRINGVAL] = ActionEntry(REDUCE, 319);
   _actionMap[473][DATE] = ActionEntry(REDUCE, 319);
   _actionMap[473][SYSDATE] = ActionEntry(REDUCE, 319);
   _actionMap[473][NULLTOKEN] = ActionEntry(REDUCE, 319);
   _actionMap[473][TRUEVAL] = ActionEntry(REDUCE, 319);
   _actionMap[473][FALSEVAL] = ActionEntry(REDUCE, 319);
   _actionMap[473][LAB] = ActionEntry(REDUCE, 319);
   _actionMap[473][COUNTERID] = ActionEntry(REDUCE, 319);
   _actionMap[473][FLOATVAL] = ActionEntry(REDUCE, 319);
   _actionMap[473][MINUS] = ActionEntry(REDUCE, 319);
   _actionMap[473][INTVAL] = ActionEntry(REDUCE, 319);
   _actionMap[473][EQU] = ActionEntry(SHIFT, 621);
   _actionMap[474][EQU] = ActionEntry(SHIFT, 622);
   _actionMap[475][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[475][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[475][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[475][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[475][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[475][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[475][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[475][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[475][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[475][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[475][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[475][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[475][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[475][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[475][GETPOS] = ActionEntry(SHIFT, 108);
}
void Cego::loadParser75()
{
   _actionMap[475][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[475][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[475][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[475][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[475][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[475][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[475][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[475][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[475][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[475][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[475][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[475][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[475][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[475][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[475][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[475][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[475][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[475][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[475][LB] = ActionEntry(SHIFT, 347);
   _actionMap[475][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[475][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[475][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[475][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[475][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[475][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[475][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[475][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[475][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[475][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[475][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[475][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[475][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[475][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[475][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[475][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[475][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[475][EXISTS] = ActionEntry(SHIFT, 345);
   _actionMap[475][NOT] = ActionEntry(SHIFT, 346);
   _jumpMap[475][ObjSpec] = 94;
   _jumpMap[475][Constant] = 93;
   _jumpMap[475][SignedFloat] = 92;
   _jumpMap[475][SignedInt] = 91;
   _jumpMap[475][Attribute] = 90;
   _jumpMap[475][QueryPredicate] = 623;
   _jumpMap[475][Function] = 89;
   _jumpMap[475][CasePrepare] = 88;
   _jumpMap[475][CaseClause] = 87;
   _jumpMap[475][Factor] = 86;
   _jumpMap[475][Term] = 85;
   _jumpMap[475][Expr] = 342;
}
void Cego::loadParser76()
{
   _actionMap[476][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[476][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[476][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[476][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[476][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[476][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[476][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[476][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[476][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[476][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[476][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[476][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[476][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[476][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[476][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[476][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[476][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[476][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[476][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[476][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[476][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[476][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[476][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[476][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[476][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[476][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[476][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[476][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[476][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[476][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[476][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[476][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[476][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[476][LB] = ActionEntry(SHIFT, 347);
   _actionMap[476][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[476][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[476][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[476][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[476][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[476][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[476][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[476][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[476][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[476][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[476][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[476][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[476][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[476][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[476][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[476][MIN] = ActionEntry(SHIFT, 114);
}
void Cego::loadParser77()
{
   _actionMap[476][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[476][EXISTS] = ActionEntry(SHIFT, 345);
   _actionMap[476][NOT] = ActionEntry(SHIFT, 346);
   _jumpMap[476][ObjSpec] = 94;
   _jumpMap[476][Constant] = 93;
   _jumpMap[476][SignedFloat] = 92;
   _jumpMap[476][SignedInt] = 91;
   _jumpMap[476][Attribute] = 90;
   _jumpMap[476][QueryPredicate] = 624;
   _jumpMap[476][Function] = 89;
   _jumpMap[476][CasePrepare] = 88;
   _jumpMap[476][CaseClause] = 87;
   _jumpMap[476][Factor] = 86;
   _jumpMap[476][Term] = 85;
   _jumpMap[476][Expr] = 342;
   _actionMap[477][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[477][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[477][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[477][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[477][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[477][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[477][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[477][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[477][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[477][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[477][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[477][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[477][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[477][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[477][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[477][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[477][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[477][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[477][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[477][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[477][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[477][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[477][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[477][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[477][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[477][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[477][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[477][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[477][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[477][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[477][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[477][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[477][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[477][LB] = ActionEntry(SHIFT, 135);
   _actionMap[477][STRINGVAL] = ActionEntry(SHIFT, 95);
}
void Cego::loadParser78()
{
   _actionMap[477][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[477][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[477][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[477][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[477][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[477][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[477][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[477][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[477][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[477][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[477][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[477][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[477][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[477][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[477][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[477][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[477][ObjSpec] = 94;
   _jumpMap[477][Constant] = 93;
   _jumpMap[477][SignedFloat] = 92;
   _jumpMap[477][SignedInt] = 91;
   _jumpMap[477][Attribute] = 90;
   _jumpMap[477][Function] = 89;
   _jumpMap[477][CasePrepare] = 88;
   _jumpMap[477][CaseClause] = 87;
   _jumpMap[477][Factor] = 86;
   _jumpMap[477][Term] = 85;
   _jumpMap[477][Expr] = 625;
   _actionMap[478][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[478][SelectStatement] = 626;
   _actionMap[479][THEN] = ActionEntry(REDUCE, 302);
   _actionMap[479][LEFT] = ActionEntry(REDUCE, 302);
   _actionMap[479][RIGHT] = ActionEntry(REDUCE, 302);
   _actionMap[479][INNER] = ActionEntry(REDUCE, 302);
   _actionMap[479][JOIN] = ActionEntry(REDUCE, 302);
   _actionMap[479][RETURNTOKEN] = ActionEntry(REDUCE, 302);
   _actionMap[479][SEMICOLON] = ActionEntry(REDUCE, 302);
   _actionMap[479][RB] = ActionEntry(REDUCE, 302);
   _actionMap[479][ENDTOKEN] = ActionEntry(REDUCE, 302);
   _actionMap[479][UNION] = ActionEntry(REDUCE, 302);
   _actionMap[479][ROWLIMIT] = ActionEntry(REDUCE, 302);
   _actionMap[479][ORDER] = ActionEntry(REDUCE, 302);
   _actionMap[479][GROUP] = ActionEntry(REDUCE, 302);
   _actionMap[479][WHERE] = ActionEntry(REDUCE, 302);
   _actionMap[479][AND] = ActionEntry(REDUCE, 302);
   _actionMap[479][OR] = ActionEntry(REDUCE, 302);
   _actionMap[480][RB] = ActionEntry(SHIFT, 387);
   _actionMap[480][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[480][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[480][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[480][INTOK] = ActionEntry(SHIFT, 467);
}
void Cego::loadParser79()
{
   _actionMap[480][NOT] = ActionEntry(SHIFT, 470);
   _actionMap[480][BETWEEN] = ActionEntry(SHIFT, 466);
   _actionMap[480][IS] = ActionEntry(SHIFT, 468);
   _actionMap[480][LIKE] = ActionEntry(SHIFT, 469);
   _actionMap[480][EQU] = ActionEntry(SHIFT, 471);
   _actionMap[480][NEGATION] = ActionEntry(SHIFT, 474);
   _actionMap[480][LT] = ActionEntry(SHIFT, 472);
   _actionMap[480][MT] = ActionEntry(SHIFT, 473);
   _jumpMap[480][Comparison] = 465;
   _actionMap[481][RB] = ActionEntry(SHIFT, 627);
   _actionMap[481][AND] = ActionEntry(SHIFT, 475);
   _actionMap[481][OR] = ActionEntry(SHIFT, 476);
   _actionMap[482][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[482][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[482][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[482][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[482][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[482][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[482][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[482][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[482][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[482][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[482][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[482][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[482][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[482][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[482][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[482][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[482][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[482][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[482][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[482][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[482][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[482][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[482][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[482][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[482][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[482][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[482][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[482][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[482][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[482][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[482][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[482][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[482][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[482][LB] = ActionEntry(SHIFT, 135);
   _actionMap[482][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[482][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[482][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[482][NULLTOKEN] = ActionEntry(SHIFT, 118);
}
void Cego::loadParser80()
{
   _actionMap[482][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[482][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[482][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[482][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[482][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[482][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[482][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[482][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[482][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[482][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[482][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[482][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[482][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[482][ObjSpec] = 94;
   _jumpMap[482][Constant] = 93;
   _jumpMap[482][SignedFloat] = 92;
   _jumpMap[482][SignedInt] = 91;
   _jumpMap[482][Attribute] = 90;
   _jumpMap[482][Function] = 89;
   _jumpMap[482][CasePrepare] = 88;
   _jumpMap[482][CaseClause] = 87;
   _jumpMap[482][Factor] = 86;
   _jumpMap[482][Term] = 85;
   _jumpMap[482][Expr] = 628;
   _actionMap[483][WHEN] = ActionEntry(REDUCE, 282);
   _actionMap[483][ELSE] = ActionEntry(REDUCE, 282);
   _actionMap[483][LEFT] = ActionEntry(REDUCE, 282);
   _actionMap[483][RIGHT] = ActionEntry(REDUCE, 282);
   _actionMap[483][INNER] = ActionEntry(REDUCE, 282);
   _actionMap[483][JOIN] = ActionEntry(REDUCE, 282);
   _actionMap[483][RETURNTOKEN] = ActionEntry(REDUCE, 282);
   _actionMap[483][ORDER] = ActionEntry(REDUCE, 282);
   _actionMap[483][GROUP] = ActionEntry(REDUCE, 282);
   _actionMap[483][WHERE] = ActionEntry(REDUCE, 282);
   _actionMap[483][FROM] = ActionEntry(REDUCE, 282);
   _actionMap[483][AS] = ActionEntry(REDUCE, 282);
   _actionMap[483][END_TOKEN] = ActionEntry(REDUCE, 282);
   _actionMap[483][BEGIN] = ActionEntry(REDUCE, 282);
   _actionMap[483][THEN] = ActionEntry(REDUCE, 282);
   _actionMap[483][OR] = ActionEntry(REDUCE, 282);
   _actionMap[483][AND] = ActionEntry(REDUCE, 282);
   _actionMap[483][INTOK] = ActionEntry(REDUCE, 282);
   _actionMap[483][NOT] = ActionEntry(REDUCE, 282);
   _actionMap[483][BETWEEN] = ActionEntry(REDUCE, 282);
   _actionMap[483][IS] = ActionEntry(REDUCE, 282);
   _actionMap[483][LIKE] = ActionEntry(REDUCE, 282);
   _actionMap[483][MT] = ActionEntry(REDUCE, 282);
   _actionMap[483][LT] = ActionEntry(REDUCE, 282);
   _actionMap[483][NEGATION] = ActionEntry(REDUCE, 282);
   _actionMap[483][EQU] = ActionEntry(REDUCE, 282);
}
void Cego::loadParser81()
{
   _actionMap[483][RB] = ActionEntry(REDUCE, 282);
   _actionMap[483][ENDTOKEN] = ActionEntry(REDUCE, 282);
   _actionMap[483][UNION] = ActionEntry(REDUCE, 282);
   _actionMap[483][ROWLIMIT] = ActionEntry(REDUCE, 282);
   _actionMap[483][KSEP] = ActionEntry(REDUCE, 282);
   _actionMap[483][ASC] = ActionEntry(REDUCE, 282);
   _actionMap[483][DESC] = ActionEntry(REDUCE, 282);
   _actionMap[483][SEMICOLON] = ActionEntry(REDUCE, 282);
   _actionMap[483][PLUS] = ActionEntry(REDUCE, 282);
   _actionMap[483][MINUS] = ActionEntry(REDUCE, 282);
   _actionMap[483][DIVISION] = ActionEntry(REDUCE, 282);
   _actionMap[483][STAR] = ActionEntry(REDUCE, 282);
   _actionMap[483][CONCAT] = ActionEntry(REDUCE, 282);
   _actionMap[484][WHEN] = ActionEntry(REDUCE, 148);
   _actionMap[484][ELSE] = ActionEntry(REDUCE, 148);
   _actionMap[484][LEFT] = ActionEntry(REDUCE, 148);
   _actionMap[484][RIGHT] = ActionEntry(REDUCE, 148);
   _actionMap[484][INNER] = ActionEntry(REDUCE, 148);
   _actionMap[484][JOIN] = ActionEntry(REDUCE, 148);
   _actionMap[484][RETURNTOKEN] = ActionEntry(REDUCE, 148);
   _actionMap[484][ORDER] = ActionEntry(REDUCE, 148);
   _actionMap[484][GROUP] = ActionEntry(REDUCE, 148);
   _actionMap[484][WHERE] = ActionEntry(REDUCE, 148);
   _actionMap[484][AS] = ActionEntry(REDUCE, 148);
   _actionMap[484][FROM] = ActionEntry(REDUCE, 148);
   _actionMap[484][END_TOKEN] = ActionEntry(REDUCE, 148);
   _actionMap[484][BEGIN] = ActionEntry(REDUCE, 148);
   _actionMap[484][THEN] = ActionEntry(REDUCE, 148);
   _actionMap[484][OR] = ActionEntry(REDUCE, 148);
   _actionMap[484][AND] = ActionEntry(REDUCE, 148);
   _actionMap[484][LIKE] = ActionEntry(REDUCE, 148);
   _actionMap[484][IS] = ActionEntry(REDUCE, 148);
   _actionMap[484][BETWEEN] = ActionEntry(REDUCE, 148);
   _actionMap[484][NOT] = ActionEntry(REDUCE, 148);
   _actionMap[484][INTOK] = ActionEntry(REDUCE, 148);
   _actionMap[484][EQU] = ActionEntry(REDUCE, 148);
   _actionMap[484][NEGATION] = ActionEntry(REDUCE, 148);
   _actionMap[484][LT] = ActionEntry(REDUCE, 148);
   _actionMap[484][MT] = ActionEntry(REDUCE, 148);
   _actionMap[484][DESC] = ActionEntry(REDUCE, 148);
   _actionMap[484][ASC] = ActionEntry(REDUCE, 148);
   _actionMap[484][KSEP] = ActionEntry(REDUCE, 148);
   _actionMap[484][ROWLIMIT] = ActionEntry(REDUCE, 148);
   _actionMap[484][UNION] = ActionEntry(REDUCE, 148);
   _actionMap[484][ENDTOKEN] = ActionEntry(REDUCE, 148);
   _actionMap[484][RB] = ActionEntry(REDUCE, 148);
   _actionMap[484][SEMICOLON] = ActionEntry(REDUCE, 148);
   _actionMap[484][CONCAT] = ActionEntry(REDUCE, 148);
   _actionMap[484][STAR] = ActionEntry(REDUCE, 148);
   _actionMap[484][DIVISION] = ActionEntry(REDUCE, 148);
}
void Cego::loadParser82()
{
   _actionMap[484][MINUS] = ActionEntry(REDUCE, 148);
   _actionMap[484][PLUS] = ActionEntry(REDUCE, 148);
   _actionMap[485][WHEN] = ActionEntry(REDUCE, 278);
   _actionMap[485][ELSE] = ActionEntry(REDUCE, 278);
   _actionMap[485][LEFT] = ActionEntry(REDUCE, 278);
   _actionMap[485][RIGHT] = ActionEntry(REDUCE, 278);
   _actionMap[485][INNER] = ActionEntry(REDUCE, 278);
   _actionMap[485][JOIN] = ActionEntry(REDUCE, 278);
   _actionMap[485][RETURNTOKEN] = ActionEntry(REDUCE, 278);
   _actionMap[485][ORDER] = ActionEntry(REDUCE, 278);
   _actionMap[485][GROUP] = ActionEntry(REDUCE, 278);
   _actionMap[485][WHERE] = ActionEntry(REDUCE, 278);
   _actionMap[485][FROM] = ActionEntry(REDUCE, 278);
   _actionMap[485][AS] = ActionEntry(REDUCE, 278);
   _actionMap[485][END_TOKEN] = ActionEntry(REDUCE, 278);
   _actionMap[485][BEGIN] = ActionEntry(REDUCE, 278);
   _actionMap[485][THEN] = ActionEntry(REDUCE, 278);
   _actionMap[485][OR] = ActionEntry(REDUCE, 278);
   _actionMap[485][AND] = ActionEntry(REDUCE, 278);
   _actionMap[485][INTOK] = ActionEntry(REDUCE, 278);
   _actionMap[485][NOT] = ActionEntry(REDUCE, 278);
   _actionMap[485][BETWEEN] = ActionEntry(REDUCE, 278);
   _actionMap[485][IS] = ActionEntry(REDUCE, 278);
   _actionMap[485][LIKE] = ActionEntry(REDUCE, 278);
   _actionMap[485][MT] = ActionEntry(REDUCE, 278);
   _actionMap[485][LT] = ActionEntry(REDUCE, 278);
   _actionMap[485][NEGATION] = ActionEntry(REDUCE, 278);
   _actionMap[485][EQU] = ActionEntry(REDUCE, 278);
   _actionMap[485][RB] = ActionEntry(REDUCE, 278);
   _actionMap[485][ENDTOKEN] = ActionEntry(REDUCE, 278);
   _actionMap[485][UNION] = ActionEntry(REDUCE, 278);
   _actionMap[485][ROWLIMIT] = ActionEntry(REDUCE, 278);
   _actionMap[485][KSEP] = ActionEntry(REDUCE, 278);
   _actionMap[485][ASC] = ActionEntry(REDUCE, 278);
   _actionMap[485][DESC] = ActionEntry(REDUCE, 278);
   _actionMap[485][SEMICOLON] = ActionEntry(REDUCE, 278);
   _actionMap[485][PLUS] = ActionEntry(REDUCE, 278);
   _actionMap[485][MINUS] = ActionEntry(REDUCE, 278);
   _actionMap[485][DIVISION] = ActionEntry(REDUCE, 278);
   _actionMap[485][STAR] = ActionEntry(REDUCE, 278);
   _actionMap[485][CONCAT] = ActionEntry(REDUCE, 278);
   _actionMap[486][WHEN] = ActionEntry(REDUCE, 279);
   _actionMap[486][ELSE] = ActionEntry(REDUCE, 279);
   _actionMap[486][LEFT] = ActionEntry(REDUCE, 279);
   _actionMap[486][RIGHT] = ActionEntry(REDUCE, 279);
   _actionMap[486][INNER] = ActionEntry(REDUCE, 279);
   _actionMap[486][JOIN] = ActionEntry(REDUCE, 279);
   _actionMap[486][RETURNTOKEN] = ActionEntry(REDUCE, 279);
   _actionMap[486][ORDER] = ActionEntry(REDUCE, 279);
   _actionMap[486][GROUP] = ActionEntry(REDUCE, 279);
}
void Cego::loadParser83()
{
   _actionMap[486][WHERE] = ActionEntry(REDUCE, 279);
   _actionMap[486][FROM] = ActionEntry(REDUCE, 279);
   _actionMap[486][AS] = ActionEntry(REDUCE, 279);
   _actionMap[486][END_TOKEN] = ActionEntry(REDUCE, 279);
   _actionMap[486][BEGIN] = ActionEntry(REDUCE, 279);
   _actionMap[486][THEN] = ActionEntry(REDUCE, 279);
   _actionMap[486][OR] = ActionEntry(REDUCE, 279);
   _actionMap[486][AND] = ActionEntry(REDUCE, 279);
   _actionMap[486][INTOK] = ActionEntry(REDUCE, 279);
   _actionMap[486][NOT] = ActionEntry(REDUCE, 279);
   _actionMap[486][BETWEEN] = ActionEntry(REDUCE, 279);
   _actionMap[486][IS] = ActionEntry(REDUCE, 279);
   _actionMap[486][LIKE] = ActionEntry(REDUCE, 279);
   _actionMap[486][MT] = ActionEntry(REDUCE, 279);
   _actionMap[486][LT] = ActionEntry(REDUCE, 279);
   _actionMap[486][NEGATION] = ActionEntry(REDUCE, 279);
   _actionMap[486][EQU] = ActionEntry(REDUCE, 279);
   _actionMap[486][RB] = ActionEntry(REDUCE, 279);
   _actionMap[486][ENDTOKEN] = ActionEntry(REDUCE, 279);
   _actionMap[486][UNION] = ActionEntry(REDUCE, 279);
   _actionMap[486][ROWLIMIT] = ActionEntry(REDUCE, 279);
   _actionMap[486][KSEP] = ActionEntry(REDUCE, 279);
   _actionMap[486][ASC] = ActionEntry(REDUCE, 279);
   _actionMap[486][DESC] = ActionEntry(REDUCE, 279);
   _actionMap[486][SEMICOLON] = ActionEntry(REDUCE, 279);
   _actionMap[486][PLUS] = ActionEntry(REDUCE, 279);
   _actionMap[486][MINUS] = ActionEntry(REDUCE, 279);
   _actionMap[486][DIVISION] = ActionEntry(REDUCE, 279);
   _actionMap[486][STAR] = ActionEntry(REDUCE, 279);
   _actionMap[486][CONCAT] = ActionEntry(REDUCE, 279);
   _actionMap[487][WHEN] = ActionEntry(REDUCE, 280);
   _actionMap[487][ELSE] = ActionEntry(REDUCE, 280);
   _actionMap[487][LEFT] = ActionEntry(REDUCE, 280);
   _actionMap[487][RIGHT] = ActionEntry(REDUCE, 280);
   _actionMap[487][INNER] = ActionEntry(REDUCE, 280);
   _actionMap[487][JOIN] = ActionEntry(REDUCE, 280);
   _actionMap[487][RETURNTOKEN] = ActionEntry(REDUCE, 280);
   _actionMap[487][ORDER] = ActionEntry(REDUCE, 280);
   _actionMap[487][GROUP] = ActionEntry(REDUCE, 280);
   _actionMap[487][WHERE] = ActionEntry(REDUCE, 280);
   _actionMap[487][FROM] = ActionEntry(REDUCE, 280);
   _actionMap[487][AS] = ActionEntry(REDUCE, 280);
   _actionMap[487][END_TOKEN] = ActionEntry(REDUCE, 280);
   _actionMap[487][BEGIN] = ActionEntry(REDUCE, 280);
   _actionMap[487][THEN] = ActionEntry(REDUCE, 280);
   _actionMap[487][OR] = ActionEntry(REDUCE, 280);
   _actionMap[487][AND] = ActionEntry(REDUCE, 280);
   _actionMap[487][INTOK] = ActionEntry(REDUCE, 280);
   _actionMap[487][NOT] = ActionEntry(REDUCE, 280);
   _actionMap[487][BETWEEN] = ActionEntry(REDUCE, 280);
}
void Cego::loadParser84()
{
   _actionMap[487][IS] = ActionEntry(REDUCE, 280);
   _actionMap[487][LIKE] = ActionEntry(REDUCE, 280);
   _actionMap[487][MT] = ActionEntry(REDUCE, 280);
   _actionMap[487][LT] = ActionEntry(REDUCE, 280);
   _actionMap[487][NEGATION] = ActionEntry(REDUCE, 280);
   _actionMap[487][EQU] = ActionEntry(REDUCE, 280);
   _actionMap[487][RB] = ActionEntry(REDUCE, 280);
   _actionMap[487][ENDTOKEN] = ActionEntry(REDUCE, 280);
   _actionMap[487][UNION] = ActionEntry(REDUCE, 280);
   _actionMap[487][ROWLIMIT] = ActionEntry(REDUCE, 280);
   _actionMap[487][KSEP] = ActionEntry(REDUCE, 280);
   _actionMap[487][ASC] = ActionEntry(REDUCE, 280);
   _actionMap[487][DESC] = ActionEntry(REDUCE, 280);
   _actionMap[487][SEMICOLON] = ActionEntry(REDUCE, 280);
   _actionMap[487][PLUS] = ActionEntry(REDUCE, 280);
   _actionMap[487][MINUS] = ActionEntry(REDUCE, 280);
   _actionMap[487][DIVISION] = ActionEntry(REDUCE, 280);
   _actionMap[487][STAR] = ActionEntry(REDUCE, 280);
   _actionMap[487][CONCAT] = ActionEntry(REDUCE, 280);
   _actionMap[488][WHEN] = ActionEntry(REDUCE, 149);
   _actionMap[488][ELSE] = ActionEntry(REDUCE, 149);
   _actionMap[488][LEFT] = ActionEntry(REDUCE, 149);
   _actionMap[488][RIGHT] = ActionEntry(REDUCE, 149);
   _actionMap[488][INNER] = ActionEntry(REDUCE, 149);
   _actionMap[488][JOIN] = ActionEntry(REDUCE, 149);
   _actionMap[488][RETURNTOKEN] = ActionEntry(REDUCE, 149);
   _actionMap[488][ORDER] = ActionEntry(REDUCE, 149);
   _actionMap[488][GROUP] = ActionEntry(REDUCE, 149);
   _actionMap[488][WHERE] = ActionEntry(REDUCE, 149);
   _actionMap[488][AS] = ActionEntry(REDUCE, 149);
   _actionMap[488][FROM] = ActionEntry(REDUCE, 149);
   _actionMap[488][END_TOKEN] = ActionEntry(REDUCE, 149);
   _actionMap[488][BEGIN] = ActionEntry(REDUCE, 149);
   _actionMap[488][THEN] = ActionEntry(REDUCE, 149);
   _actionMap[488][OR] = ActionEntry(REDUCE, 149);
   _actionMap[488][AND] = ActionEntry(REDUCE, 149);
   _actionMap[488][LIKE] = ActionEntry(REDUCE, 149);
   _actionMap[488][IS] = ActionEntry(REDUCE, 149);
   _actionMap[488][BETWEEN] = ActionEntry(REDUCE, 149);
   _actionMap[488][NOT] = ActionEntry(REDUCE, 149);
   _actionMap[488][INTOK] = ActionEntry(REDUCE, 149);
   _actionMap[488][EQU] = ActionEntry(REDUCE, 149);
   _actionMap[488][NEGATION] = ActionEntry(REDUCE, 149);
   _actionMap[488][LT] = ActionEntry(REDUCE, 149);
   _actionMap[488][MT] = ActionEntry(REDUCE, 149);
   _actionMap[488][DESC] = ActionEntry(REDUCE, 149);
   _actionMap[488][ASC] = ActionEntry(REDUCE, 149);
   _actionMap[488][KSEP] = ActionEntry(REDUCE, 149);
   _actionMap[488][ROWLIMIT] = ActionEntry(REDUCE, 149);
   _actionMap[488][UNION] = ActionEntry(REDUCE, 149);
}
void Cego::loadParser85()
{
   _actionMap[488][ENDTOKEN] = ActionEntry(REDUCE, 149);
   _actionMap[488][RB] = ActionEntry(REDUCE, 149);
   _actionMap[488][SEMICOLON] = ActionEntry(REDUCE, 149);
   _actionMap[488][CONCAT] = ActionEntry(REDUCE, 149);
   _actionMap[488][STAR] = ActionEntry(REDUCE, 149);
   _actionMap[488][DIVISION] = ActionEntry(REDUCE, 149);
   _actionMap[488][MINUS] = ActionEntry(REDUCE, 149);
   _actionMap[488][PLUS] = ActionEntry(REDUCE, 149);
   _actionMap[489][WHEN] = ActionEntry(REDUCE, 146);
   _actionMap[489][ELSE] = ActionEntry(REDUCE, 146);
   _actionMap[489][LEFT] = ActionEntry(REDUCE, 146);
   _actionMap[489][RIGHT] = ActionEntry(REDUCE, 146);
   _actionMap[489][INNER] = ActionEntry(REDUCE, 146);
   _actionMap[489][JOIN] = ActionEntry(REDUCE, 146);
   _actionMap[489][RETURNTOKEN] = ActionEntry(REDUCE, 146);
   _actionMap[489][ORDER] = ActionEntry(REDUCE, 146);
   _actionMap[489][GROUP] = ActionEntry(REDUCE, 146);
   _actionMap[489][WHERE] = ActionEntry(REDUCE, 146);
   _actionMap[489][AS] = ActionEntry(REDUCE, 146);
   _actionMap[489][FROM] = ActionEntry(REDUCE, 146);
   _actionMap[489][END_TOKEN] = ActionEntry(REDUCE, 146);
   _actionMap[489][BEGIN] = ActionEntry(REDUCE, 146);
   _actionMap[489][THEN] = ActionEntry(REDUCE, 146);
   _actionMap[489][OR] = ActionEntry(REDUCE, 146);
   _actionMap[489][AND] = ActionEntry(REDUCE, 146);
   _actionMap[489][LIKE] = ActionEntry(REDUCE, 146);
   _actionMap[489][IS] = ActionEntry(REDUCE, 146);
   _actionMap[489][BETWEEN] = ActionEntry(REDUCE, 146);
   _actionMap[489][NOT] = ActionEntry(REDUCE, 146);
   _actionMap[489][INTOK] = ActionEntry(REDUCE, 146);
   _actionMap[489][EQU] = ActionEntry(REDUCE, 146);
   _actionMap[489][NEGATION] = ActionEntry(REDUCE, 146);
   _actionMap[489][LT] = ActionEntry(REDUCE, 146);
   _actionMap[489][MT] = ActionEntry(REDUCE, 146);
   _actionMap[489][DESC] = ActionEntry(REDUCE, 146);
   _actionMap[489][ASC] = ActionEntry(REDUCE, 146);
   _actionMap[489][KSEP] = ActionEntry(REDUCE, 146);
   _actionMap[489][ROWLIMIT] = ActionEntry(REDUCE, 146);
   _actionMap[489][UNION] = ActionEntry(REDUCE, 146);
   _actionMap[489][ENDTOKEN] = ActionEntry(REDUCE, 146);
   _actionMap[489][RB] = ActionEntry(REDUCE, 146);
   _actionMap[489][SEMICOLON] = ActionEntry(REDUCE, 146);
   _actionMap[489][CONCAT] = ActionEntry(REDUCE, 146);
   _actionMap[489][STAR] = ActionEntry(REDUCE, 146);
   _actionMap[489][DIVISION] = ActionEntry(REDUCE, 146);
   _actionMap[489][MINUS] = ActionEntry(REDUCE, 146);
   _actionMap[489][PLUS] = ActionEntry(REDUCE, 146);
   _actionMap[490][STRINGVAL] = ActionEntry(SHIFT, 630);
   _jumpMap[490][DateValue] = 629;
   _actionMap[491][WHEN] = ActionEntry(REDUCE, 259);
}
void Cego::loadParser86()
{
   _actionMap[491][ELSE] = ActionEntry(REDUCE, 259);
   _actionMap[491][LEFT] = ActionEntry(REDUCE, 259);
   _actionMap[491][RIGHT] = ActionEntry(REDUCE, 259);
   _actionMap[491][INNER] = ActionEntry(REDUCE, 259);
   _actionMap[491][JOIN] = ActionEntry(REDUCE, 259);
   _actionMap[491][RETURNTOKEN] = ActionEntry(REDUCE, 259);
   _actionMap[491][ORDER] = ActionEntry(REDUCE, 259);
   _actionMap[491][GROUP] = ActionEntry(REDUCE, 259);
   _actionMap[491][WHERE] = ActionEntry(REDUCE, 259);
   _actionMap[491][FROM] = ActionEntry(REDUCE, 259);
   _actionMap[491][AS] = ActionEntry(REDUCE, 259);
   _actionMap[491][END_TOKEN] = ActionEntry(REDUCE, 259);
   _actionMap[491][BEGIN] = ActionEntry(REDUCE, 259);
   _actionMap[491][THEN] = ActionEntry(REDUCE, 259);
   _actionMap[491][OR] = ActionEntry(REDUCE, 259);
   _actionMap[491][AND] = ActionEntry(REDUCE, 259);
   _actionMap[491][INTOK] = ActionEntry(REDUCE, 259);
   _actionMap[491][NOT] = ActionEntry(REDUCE, 259);
   _actionMap[491][BETWEEN] = ActionEntry(REDUCE, 259);
   _actionMap[491][IS] = ActionEntry(REDUCE, 259);
   _actionMap[491][LIKE] = ActionEntry(REDUCE, 259);
   _actionMap[491][MT] = ActionEntry(REDUCE, 259);
   _actionMap[491][LT] = ActionEntry(REDUCE, 259);
   _actionMap[491][NEGATION] = ActionEntry(REDUCE, 259);
   _actionMap[491][EQU] = ActionEntry(REDUCE, 259);
   _actionMap[491][RB] = ActionEntry(REDUCE, 259);
   _actionMap[491][ENDTOKEN] = ActionEntry(REDUCE, 259);
   _actionMap[491][UNION] = ActionEntry(REDUCE, 259);
   _actionMap[491][ROWLIMIT] = ActionEntry(REDUCE, 259);
   _actionMap[491][KSEP] = ActionEntry(REDUCE, 259);
   _actionMap[491][ASC] = ActionEntry(REDUCE, 259);
   _actionMap[491][DESC] = ActionEntry(REDUCE, 259);
   _actionMap[491][SEMICOLON] = ActionEntry(REDUCE, 259);
   _actionMap[491][PLUS] = ActionEntry(REDUCE, 259);
   _actionMap[491][MINUS] = ActionEntry(REDUCE, 259);
   _actionMap[491][DIVISION] = ActionEntry(REDUCE, 259);
   _actionMap[491][STAR] = ActionEntry(REDUCE, 259);
   _actionMap[491][CONCAT] = ActionEntry(REDUCE, 259);
   _actionMap[492][WHEN] = ActionEntry(REDUCE, 260);
   _actionMap[492][ELSE] = ActionEntry(REDUCE, 260);
   _actionMap[492][LEFT] = ActionEntry(REDUCE, 260);
   _actionMap[492][RIGHT] = ActionEntry(REDUCE, 260);
   _actionMap[492][INNER] = ActionEntry(REDUCE, 260);
   _actionMap[492][JOIN] = ActionEntry(REDUCE, 260);
   _actionMap[492][RETURNTOKEN] = ActionEntry(REDUCE, 260);
   _actionMap[492][ORDER] = ActionEntry(REDUCE, 260);
   _actionMap[492][GROUP] = ActionEntry(REDUCE, 260);
   _actionMap[492][WHERE] = ActionEntry(REDUCE, 260);
   _actionMap[492][FROM] = ActionEntry(REDUCE, 260);
   _actionMap[492][AS] = ActionEntry(REDUCE, 260);
}
void Cego::loadParser87()
{
   _actionMap[492][END_TOKEN] = ActionEntry(REDUCE, 260);
   _actionMap[492][BEGIN] = ActionEntry(REDUCE, 260);
   _actionMap[492][THEN] = ActionEntry(REDUCE, 260);
   _actionMap[492][OR] = ActionEntry(REDUCE, 260);
   _actionMap[492][AND] = ActionEntry(REDUCE, 260);
   _actionMap[492][INTOK] = ActionEntry(REDUCE, 260);
   _actionMap[492][NOT] = ActionEntry(REDUCE, 260);
   _actionMap[492][BETWEEN] = ActionEntry(REDUCE, 260);
   _actionMap[492][IS] = ActionEntry(REDUCE, 260);
   _actionMap[492][LIKE] = ActionEntry(REDUCE, 260);
   _actionMap[492][MT] = ActionEntry(REDUCE, 260);
   _actionMap[492][LT] = ActionEntry(REDUCE, 260);
   _actionMap[492][NEGATION] = ActionEntry(REDUCE, 260);
   _actionMap[492][EQU] = ActionEntry(REDUCE, 260);
   _actionMap[492][RB] = ActionEntry(REDUCE, 260);
   _actionMap[492][ENDTOKEN] = ActionEntry(REDUCE, 260);
   _actionMap[492][UNION] = ActionEntry(REDUCE, 260);
   _actionMap[492][ROWLIMIT] = ActionEntry(REDUCE, 260);
   _actionMap[492][KSEP] = ActionEntry(REDUCE, 260);
   _actionMap[492][ASC] = ActionEntry(REDUCE, 260);
   _actionMap[492][DESC] = ActionEntry(REDUCE, 260);
   _actionMap[492][SEMICOLON] = ActionEntry(REDUCE, 260);
   _actionMap[492][PLUS] = ActionEntry(REDUCE, 260);
   _actionMap[492][MINUS] = ActionEntry(REDUCE, 260);
   _actionMap[492][DIVISION] = ActionEntry(REDUCE, 260);
   _actionMap[492][STAR] = ActionEntry(REDUCE, 260);
   _actionMap[492][CONCAT] = ActionEntry(REDUCE, 260);
   _actionMap[493][WHEN] = ActionEntry(REDUCE, 276);
   _actionMap[493][ELSE] = ActionEntry(REDUCE, 276);
   _actionMap[493][LEFT] = ActionEntry(REDUCE, 276);
   _actionMap[493][RIGHT] = ActionEntry(REDUCE, 276);
   _actionMap[493][INNER] = ActionEntry(REDUCE, 276);
   _actionMap[493][JOIN] = ActionEntry(REDUCE, 276);
   _actionMap[493][RETURNTOKEN] = ActionEntry(REDUCE, 276);
   _actionMap[493][ORDER] = ActionEntry(REDUCE, 276);
   _actionMap[493][GROUP] = ActionEntry(REDUCE, 276);
   _actionMap[493][WHERE] = ActionEntry(REDUCE, 276);
   _actionMap[493][FROM] = ActionEntry(REDUCE, 276);
   _actionMap[493][AS] = ActionEntry(REDUCE, 276);
   _actionMap[493][END_TOKEN] = ActionEntry(REDUCE, 276);
   _actionMap[493][BEGIN] = ActionEntry(REDUCE, 276);
   _actionMap[493][THEN] = ActionEntry(REDUCE, 276);
   _actionMap[493][OR] = ActionEntry(REDUCE, 276);
   _actionMap[493][AND] = ActionEntry(REDUCE, 276);
   _actionMap[493][INTOK] = ActionEntry(REDUCE, 276);
   _actionMap[493][NOT] = ActionEntry(REDUCE, 276);
   _actionMap[493][BETWEEN] = ActionEntry(REDUCE, 276);
   _actionMap[493][IS] = ActionEntry(REDUCE, 276);
   _actionMap[493][LIKE] = ActionEntry(REDUCE, 276);
   _actionMap[493][MT] = ActionEntry(REDUCE, 276);
}
void Cego::loadParser88()
{
   _actionMap[493][LT] = ActionEntry(REDUCE, 276);
   _actionMap[493][NEGATION] = ActionEntry(REDUCE, 276);
   _actionMap[493][EQU] = ActionEntry(REDUCE, 276);
   _actionMap[493][RB] = ActionEntry(REDUCE, 276);
   _actionMap[493][ENDTOKEN] = ActionEntry(REDUCE, 276);
   _actionMap[493][UNION] = ActionEntry(REDUCE, 276);
   _actionMap[493][ROWLIMIT] = ActionEntry(REDUCE, 276);
   _actionMap[493][KSEP] = ActionEntry(REDUCE, 276);
   _actionMap[493][ASC] = ActionEntry(REDUCE, 276);
   _actionMap[493][DESC] = ActionEntry(REDUCE, 276);
   _actionMap[493][SEMICOLON] = ActionEntry(REDUCE, 276);
   _actionMap[493][PLUS] = ActionEntry(REDUCE, 276);
   _actionMap[493][MINUS] = ActionEntry(REDUCE, 276);
   _actionMap[493][DIVISION] = ActionEntry(REDUCE, 276);
   _actionMap[493][STAR] = ActionEntry(REDUCE, 276);
   _actionMap[493][CONCAT] = ActionEntry(REDUCE, 276);
   _actionMap[494][VARREF] = ActionEntry(SHIFT, 632);
   _jumpMap[494][FetchArgList] = 631;
   _actionMap[495][WHEN] = ActionEntry(REDUCE, 266);
   _actionMap[495][ELSE] = ActionEntry(REDUCE, 266);
   _actionMap[495][LEFT] = ActionEntry(REDUCE, 266);
   _actionMap[495][RIGHT] = ActionEntry(REDUCE, 266);
   _actionMap[495][INNER] = ActionEntry(REDUCE, 266);
   _actionMap[495][JOIN] = ActionEntry(REDUCE, 266);
   _actionMap[495][RETURNTOKEN] = ActionEntry(REDUCE, 266);
   _actionMap[495][ORDER] = ActionEntry(REDUCE, 266);
   _actionMap[495][GROUP] = ActionEntry(REDUCE, 266);
   _actionMap[495][WHERE] = ActionEntry(REDUCE, 266);
   _actionMap[495][FROM] = ActionEntry(REDUCE, 266);
   _actionMap[495][AS] = ActionEntry(REDUCE, 266);
   _actionMap[495][END_TOKEN] = ActionEntry(REDUCE, 266);
   _actionMap[495][BEGIN] = ActionEntry(REDUCE, 266);
   _actionMap[495][THEN] = ActionEntry(REDUCE, 266);
   _actionMap[495][OR] = ActionEntry(REDUCE, 266);
   _actionMap[495][AND] = ActionEntry(REDUCE, 266);
   _actionMap[495][INTOK] = ActionEntry(REDUCE, 266);
   _actionMap[495][NOT] = ActionEntry(REDUCE, 266);
   _actionMap[495][BETWEEN] = ActionEntry(REDUCE, 266);
   _actionMap[495][IS] = ActionEntry(REDUCE, 266);
   _actionMap[495][LIKE] = ActionEntry(REDUCE, 266);
   _actionMap[495][MT] = ActionEntry(REDUCE, 266);
   _actionMap[495][LT] = ActionEntry(REDUCE, 266);
   _actionMap[495][NEGATION] = ActionEntry(REDUCE, 266);
   _actionMap[495][EQU] = ActionEntry(REDUCE, 266);
   _actionMap[495][RB] = ActionEntry(REDUCE, 266);
   _actionMap[495][ENDTOKEN] = ActionEntry(REDUCE, 266);
   _actionMap[495][UNION] = ActionEntry(REDUCE, 266);
   _actionMap[495][ROWLIMIT] = ActionEntry(REDUCE, 266);
   _actionMap[495][KSEP] = ActionEntry(REDUCE, 266);
   _actionMap[495][ASC] = ActionEntry(REDUCE, 266);
}
void Cego::loadParser89()
{
   _actionMap[495][DESC] = ActionEntry(REDUCE, 266);
   _actionMap[495][SEMICOLON] = ActionEntry(REDUCE, 266);
   _actionMap[495][PLUS] = ActionEntry(REDUCE, 266);
   _actionMap[495][MINUS] = ActionEntry(REDUCE, 266);
   _actionMap[495][DIVISION] = ActionEntry(REDUCE, 266);
   _actionMap[495][STAR] = ActionEntry(REDUCE, 266);
   _actionMap[495][CONCAT] = ActionEntry(REDUCE, 266);
   _actionMap[496][WHEN] = ActionEntry(REDUCE, 261);
   _actionMap[496][ELSE] = ActionEntry(REDUCE, 261);
   _actionMap[496][LEFT] = ActionEntry(REDUCE, 261);
   _actionMap[496][RIGHT] = ActionEntry(REDUCE, 261);
   _actionMap[496][INNER] = ActionEntry(REDUCE, 261);
   _actionMap[496][JOIN] = ActionEntry(REDUCE, 261);
   _actionMap[496][RETURNTOKEN] = ActionEntry(REDUCE, 261);
   _actionMap[496][ORDER] = ActionEntry(REDUCE, 261);
   _actionMap[496][GROUP] = ActionEntry(REDUCE, 261);
   _actionMap[496][WHERE] = ActionEntry(REDUCE, 261);
   _actionMap[496][FROM] = ActionEntry(REDUCE, 261);
   _actionMap[496][AS] = ActionEntry(REDUCE, 261);
   _actionMap[496][END_TOKEN] = ActionEntry(REDUCE, 261);
   _actionMap[496][BEGIN] = ActionEntry(REDUCE, 261);
   _actionMap[496][THEN] = ActionEntry(REDUCE, 261);
   _actionMap[496][OR] = ActionEntry(REDUCE, 261);
   _actionMap[496][AND] = ActionEntry(REDUCE, 261);
   _actionMap[496][INTOK] = ActionEntry(REDUCE, 261);
   _actionMap[496][NOT] = ActionEntry(REDUCE, 261);
   _actionMap[496][BETWEEN] = ActionEntry(REDUCE, 261);
   _actionMap[496][IS] = ActionEntry(REDUCE, 261);
   _actionMap[496][LIKE] = ActionEntry(REDUCE, 261);
   _actionMap[496][MT] = ActionEntry(REDUCE, 261);
   _actionMap[496][LT] = ActionEntry(REDUCE, 261);
   _actionMap[496][NEGATION] = ActionEntry(REDUCE, 261);
   _actionMap[496][EQU] = ActionEntry(REDUCE, 261);
   _actionMap[496][RB] = ActionEntry(REDUCE, 261);
   _actionMap[496][ENDTOKEN] = ActionEntry(REDUCE, 261);
   _actionMap[496][UNION] = ActionEntry(REDUCE, 261);
   _actionMap[496][ROWLIMIT] = ActionEntry(REDUCE, 261);
   _actionMap[496][KSEP] = ActionEntry(REDUCE, 261);
   _actionMap[496][ASC] = ActionEntry(REDUCE, 261);
   _actionMap[496][DESC] = ActionEntry(REDUCE, 261);
   _actionMap[496][SEMICOLON] = ActionEntry(REDUCE, 261);
   _actionMap[496][PLUS] = ActionEntry(REDUCE, 261);
   _actionMap[496][MINUS] = ActionEntry(REDUCE, 261);
   _actionMap[496][DIVISION] = ActionEntry(REDUCE, 261);
   _actionMap[496][STAR] = ActionEntry(REDUCE, 261);
   _actionMap[496][CONCAT] = ActionEntry(REDUCE, 261);
   _actionMap[497][WHEN] = ActionEntry(REDUCE, 264);
   _actionMap[497][ELSE] = ActionEntry(REDUCE, 264);
   _actionMap[497][LEFT] = ActionEntry(REDUCE, 264);
   _actionMap[497][RIGHT] = ActionEntry(REDUCE, 264);
}
void Cego::loadParser90()
{
   _actionMap[497][INNER] = ActionEntry(REDUCE, 264);
   _actionMap[497][JOIN] = ActionEntry(REDUCE, 264);
   _actionMap[497][RETURNTOKEN] = ActionEntry(REDUCE, 264);
   _actionMap[497][ORDER] = ActionEntry(REDUCE, 264);
   _actionMap[497][GROUP] = ActionEntry(REDUCE, 264);
   _actionMap[497][WHERE] = ActionEntry(REDUCE, 264);
   _actionMap[497][FROM] = ActionEntry(REDUCE, 264);
   _actionMap[497][AS] = ActionEntry(REDUCE, 264);
   _actionMap[497][END_TOKEN] = ActionEntry(REDUCE, 264);
   _actionMap[497][BEGIN] = ActionEntry(REDUCE, 264);
   _actionMap[497][THEN] = ActionEntry(REDUCE, 264);
   _actionMap[497][OR] = ActionEntry(REDUCE, 264);
   _actionMap[497][AND] = ActionEntry(REDUCE, 264);
   _actionMap[497][INTOK] = ActionEntry(REDUCE, 264);
   _actionMap[497][NOT] = ActionEntry(REDUCE, 264);
   _actionMap[497][BETWEEN] = ActionEntry(REDUCE, 264);
   _actionMap[497][IS] = ActionEntry(REDUCE, 264);
   _actionMap[497][LIKE] = ActionEntry(REDUCE, 264);
   _actionMap[497][MT] = ActionEntry(REDUCE, 264);
   _actionMap[497][LT] = ActionEntry(REDUCE, 264);
   _actionMap[497][NEGATION] = ActionEntry(REDUCE, 264);
   _actionMap[497][EQU] = ActionEntry(REDUCE, 264);
   _actionMap[497][RB] = ActionEntry(REDUCE, 264);
   _actionMap[497][ENDTOKEN] = ActionEntry(REDUCE, 264);
   _actionMap[497][UNION] = ActionEntry(REDUCE, 264);
   _actionMap[497][ROWLIMIT] = ActionEntry(REDUCE, 264);
   _actionMap[497][KSEP] = ActionEntry(REDUCE, 264);
   _actionMap[497][ASC] = ActionEntry(REDUCE, 264);
   _actionMap[497][DESC] = ActionEntry(REDUCE, 264);
   _actionMap[497][SEMICOLON] = ActionEntry(REDUCE, 264);
   _actionMap[497][PLUS] = ActionEntry(REDUCE, 264);
   _actionMap[497][MINUS] = ActionEntry(REDUCE, 264);
   _actionMap[497][DIVISION] = ActionEntry(REDUCE, 264);
   _actionMap[497][STAR] = ActionEntry(REDUCE, 264);
   _actionMap[497][CONCAT] = ActionEntry(REDUCE, 264);
   _actionMap[498][WHEN] = ActionEntry(REDUCE, 269);
   _actionMap[498][ELSE] = ActionEntry(REDUCE, 269);
   _actionMap[498][LEFT] = ActionEntry(REDUCE, 269);
   _actionMap[498][RIGHT] = ActionEntry(REDUCE, 269);
   _actionMap[498][INNER] = ActionEntry(REDUCE, 269);
   _actionMap[498][JOIN] = ActionEntry(REDUCE, 269);
   _actionMap[498][RETURNTOKEN] = ActionEntry(REDUCE, 269);
   _actionMap[498][ORDER] = ActionEntry(REDUCE, 269);
   _actionMap[498][GROUP] = ActionEntry(REDUCE, 269);
   _actionMap[498][WHERE] = ActionEntry(REDUCE, 269);
   _actionMap[498][FROM] = ActionEntry(REDUCE, 269);
   _actionMap[498][AS] = ActionEntry(REDUCE, 269);
   _actionMap[498][END_TOKEN] = ActionEntry(REDUCE, 269);
   _actionMap[498][BEGIN] = ActionEntry(REDUCE, 269);
   _actionMap[498][THEN] = ActionEntry(REDUCE, 269);
}
void Cego::loadParser91()
{
   _actionMap[498][OR] = ActionEntry(REDUCE, 269);
   _actionMap[498][AND] = ActionEntry(REDUCE, 269);
   _actionMap[498][INTOK] = ActionEntry(REDUCE, 269);
   _actionMap[498][NOT] = ActionEntry(REDUCE, 269);
   _actionMap[498][BETWEEN] = ActionEntry(REDUCE, 269);
   _actionMap[498][IS] = ActionEntry(REDUCE, 269);
   _actionMap[498][LIKE] = ActionEntry(REDUCE, 269);
   _actionMap[498][MT] = ActionEntry(REDUCE, 269);
   _actionMap[498][LT] = ActionEntry(REDUCE, 269);
   _actionMap[498][NEGATION] = ActionEntry(REDUCE, 269);
   _actionMap[498][EQU] = ActionEntry(REDUCE, 269);
   _actionMap[498][RB] = ActionEntry(REDUCE, 269);
   _actionMap[498][ENDTOKEN] = ActionEntry(REDUCE, 269);
   _actionMap[498][UNION] = ActionEntry(REDUCE, 269);
   _actionMap[498][ROWLIMIT] = ActionEntry(REDUCE, 269);
   _actionMap[498][KSEP] = ActionEntry(REDUCE, 269);
   _actionMap[498][ASC] = ActionEntry(REDUCE, 269);
   _actionMap[498][DESC] = ActionEntry(REDUCE, 269);
   _actionMap[498][SEMICOLON] = ActionEntry(REDUCE, 269);
   _actionMap[498][PLUS] = ActionEntry(REDUCE, 269);
   _actionMap[498][MINUS] = ActionEntry(REDUCE, 269);
   _actionMap[498][DIVISION] = ActionEntry(REDUCE, 269);
   _actionMap[498][STAR] = ActionEntry(REDUCE, 269);
   _actionMap[498][CONCAT] = ActionEntry(REDUCE, 269);
   _actionMap[499][WHEN] = ActionEntry(REDUCE, 262);
   _actionMap[499][ELSE] = ActionEntry(REDUCE, 262);
   _actionMap[499][LEFT] = ActionEntry(REDUCE, 262);
   _actionMap[499][RIGHT] = ActionEntry(REDUCE, 262);
   _actionMap[499][INNER] = ActionEntry(REDUCE, 262);
   _actionMap[499][JOIN] = ActionEntry(REDUCE, 262);
   _actionMap[499][RETURNTOKEN] = ActionEntry(REDUCE, 262);
   _actionMap[499][ORDER] = ActionEntry(REDUCE, 262);
   _actionMap[499][GROUP] = ActionEntry(REDUCE, 262);
   _actionMap[499][WHERE] = ActionEntry(REDUCE, 262);
   _actionMap[499][FROM] = ActionEntry(REDUCE, 262);
   _actionMap[499][AS] = ActionEntry(REDUCE, 262);
   _actionMap[499][END_TOKEN] = ActionEntry(REDUCE, 262);
   _actionMap[499][BEGIN] = ActionEntry(REDUCE, 262);
   _actionMap[499][THEN] = ActionEntry(REDUCE, 262);
   _actionMap[499][OR] = ActionEntry(REDUCE, 262);
   _actionMap[499][AND] = ActionEntry(REDUCE, 262);
   _actionMap[499][INTOK] = ActionEntry(REDUCE, 262);
   _actionMap[499][NOT] = ActionEntry(REDUCE, 262);
   _actionMap[499][BETWEEN] = ActionEntry(REDUCE, 262);
   _actionMap[499][IS] = ActionEntry(REDUCE, 262);
   _actionMap[499][LIKE] = ActionEntry(REDUCE, 262);
   _actionMap[499][MT] = ActionEntry(REDUCE, 262);
   _actionMap[499][LT] = ActionEntry(REDUCE, 262);
   _actionMap[499][NEGATION] = ActionEntry(REDUCE, 262);
   _actionMap[499][EQU] = ActionEntry(REDUCE, 262);
}
void Cego::loadParser92()
{
   _actionMap[499][RB] = ActionEntry(REDUCE, 262);
   _actionMap[499][ENDTOKEN] = ActionEntry(REDUCE, 262);
   _actionMap[499][UNION] = ActionEntry(REDUCE, 262);
   _actionMap[499][ROWLIMIT] = ActionEntry(REDUCE, 262);
   _actionMap[499][KSEP] = ActionEntry(REDUCE, 262);
   _actionMap[499][ASC] = ActionEntry(REDUCE, 262);
   _actionMap[499][DESC] = ActionEntry(REDUCE, 262);
   _actionMap[499][SEMICOLON] = ActionEntry(REDUCE, 262);
   _actionMap[499][PLUS] = ActionEntry(REDUCE, 262);
   _actionMap[499][MINUS] = ActionEntry(REDUCE, 262);
   _actionMap[499][DIVISION] = ActionEntry(REDUCE, 262);
   _actionMap[499][STAR] = ActionEntry(REDUCE, 262);
   _actionMap[499][CONCAT] = ActionEntry(REDUCE, 262);
   _actionMap[500][WHEN] = ActionEntry(REDUCE, 257);
   _actionMap[500][ELSE] = ActionEntry(REDUCE, 257);
   _actionMap[500][LEFT] = ActionEntry(REDUCE, 257);
   _actionMap[500][RIGHT] = ActionEntry(REDUCE, 257);
   _actionMap[500][INNER] = ActionEntry(REDUCE, 257);
   _actionMap[500][JOIN] = ActionEntry(REDUCE, 257);
   _actionMap[500][RETURNTOKEN] = ActionEntry(REDUCE, 257);
   _actionMap[500][ORDER] = ActionEntry(REDUCE, 257);
   _actionMap[500][GROUP] = ActionEntry(REDUCE, 257);
   _actionMap[500][WHERE] = ActionEntry(REDUCE, 257);
   _actionMap[500][FROM] = ActionEntry(REDUCE, 257);
   _actionMap[500][AS] = ActionEntry(REDUCE, 257);
   _actionMap[500][END_TOKEN] = ActionEntry(REDUCE, 257);
   _actionMap[500][BEGIN] = ActionEntry(REDUCE, 257);
   _actionMap[500][THEN] = ActionEntry(REDUCE, 257);
   _actionMap[500][OR] = ActionEntry(REDUCE, 257);
   _actionMap[500][AND] = ActionEntry(REDUCE, 257);
   _actionMap[500][INTOK] = ActionEntry(REDUCE, 257);
   _actionMap[500][NOT] = ActionEntry(REDUCE, 257);
   _actionMap[500][BETWEEN] = ActionEntry(REDUCE, 257);
   _actionMap[500][IS] = ActionEntry(REDUCE, 257);
   _actionMap[500][LIKE] = ActionEntry(REDUCE, 257);
   _actionMap[500][MT] = ActionEntry(REDUCE, 257);
   _actionMap[500][LT] = ActionEntry(REDUCE, 257);
   _actionMap[500][NEGATION] = ActionEntry(REDUCE, 257);
   _actionMap[500][EQU] = ActionEntry(REDUCE, 257);
   _actionMap[500][RB] = ActionEntry(REDUCE, 257);
   _actionMap[500][ENDTOKEN] = ActionEntry(REDUCE, 257);
   _actionMap[500][UNION] = ActionEntry(REDUCE, 257);
   _actionMap[500][ROWLIMIT] = ActionEntry(REDUCE, 257);
   _actionMap[500][KSEP] = ActionEntry(REDUCE, 257);
   _actionMap[500][ASC] = ActionEntry(REDUCE, 257);
   _actionMap[500][DESC] = ActionEntry(REDUCE, 257);
   _actionMap[500][SEMICOLON] = ActionEntry(REDUCE, 257);
   _actionMap[500][PLUS] = ActionEntry(REDUCE, 257);
   _actionMap[500][MINUS] = ActionEntry(REDUCE, 257);
   _actionMap[500][DIVISION] = ActionEntry(REDUCE, 257);
}
void Cego::loadParser93()
{
   _actionMap[500][STAR] = ActionEntry(REDUCE, 257);
   _actionMap[500][CONCAT] = ActionEntry(REDUCE, 257);
   _actionMap[501][WHEN] = ActionEntry(REDUCE, 150);
   _actionMap[501][ELSE] = ActionEntry(REDUCE, 150);
   _actionMap[501][LEFT] = ActionEntry(REDUCE, 150);
   _actionMap[501][RIGHT] = ActionEntry(REDUCE, 150);
   _actionMap[501][INNER] = ActionEntry(REDUCE, 150);
   _actionMap[501][JOIN] = ActionEntry(REDUCE, 150);
   _actionMap[501][RETURNTOKEN] = ActionEntry(REDUCE, 150);
   _actionMap[501][ORDER] = ActionEntry(REDUCE, 150);
   _actionMap[501][GROUP] = ActionEntry(REDUCE, 150);
   _actionMap[501][WHERE] = ActionEntry(REDUCE, 150);
   _actionMap[501][AS] = ActionEntry(REDUCE, 150);
   _actionMap[501][FROM] = ActionEntry(REDUCE, 150);
   _actionMap[501][END_TOKEN] = ActionEntry(REDUCE, 150);
   _actionMap[501][BEGIN] = ActionEntry(REDUCE, 150);
   _actionMap[501][THEN] = ActionEntry(REDUCE, 150);
   _actionMap[501][OR] = ActionEntry(REDUCE, 150);
   _actionMap[501][AND] = ActionEntry(REDUCE, 150);
   _actionMap[501][LIKE] = ActionEntry(REDUCE, 150);
   _actionMap[501][IS] = ActionEntry(REDUCE, 150);
   _actionMap[501][BETWEEN] = ActionEntry(REDUCE, 150);
   _actionMap[501][NOT] = ActionEntry(REDUCE, 150);
   _actionMap[501][INTOK] = ActionEntry(REDUCE, 150);
   _actionMap[501][EQU] = ActionEntry(REDUCE, 150);
   _actionMap[501][NEGATION] = ActionEntry(REDUCE, 150);
   _actionMap[501][LT] = ActionEntry(REDUCE, 150);
   _actionMap[501][MT] = ActionEntry(REDUCE, 150);
   _actionMap[501][DESC] = ActionEntry(REDUCE, 150);
   _actionMap[501][ASC] = ActionEntry(REDUCE, 150);
   _actionMap[501][KSEP] = ActionEntry(REDUCE, 150);
   _actionMap[501][ROWLIMIT] = ActionEntry(REDUCE, 150);
   _actionMap[501][UNION] = ActionEntry(REDUCE, 150);
   _actionMap[501][ENDTOKEN] = ActionEntry(REDUCE, 150);
   _actionMap[501][RB] = ActionEntry(REDUCE, 150);
   _actionMap[501][SEMICOLON] = ActionEntry(REDUCE, 150);
   _actionMap[501][CONCAT] = ActionEntry(REDUCE, 150);
   _actionMap[501][STAR] = ActionEntry(REDUCE, 150);
   _actionMap[501][DIVISION] = ActionEntry(REDUCE, 150);
   _actionMap[501][MINUS] = ActionEntry(REDUCE, 150);
   _actionMap[501][PLUS] = ActionEntry(REDUCE, 150);
   _actionMap[502][WHEN] = ActionEntry(REDUCE, 151);
   _actionMap[502][ELSE] = ActionEntry(REDUCE, 151);
   _actionMap[502][LEFT] = ActionEntry(REDUCE, 151);
   _actionMap[502][RIGHT] = ActionEntry(REDUCE, 151);
   _actionMap[502][INNER] = ActionEntry(REDUCE, 151);
   _actionMap[502][JOIN] = ActionEntry(REDUCE, 151);
   _actionMap[502][RETURNTOKEN] = ActionEntry(REDUCE, 151);
   _actionMap[502][ORDER] = ActionEntry(REDUCE, 151);
   _actionMap[502][GROUP] = ActionEntry(REDUCE, 151);
}
void Cego::loadParser94()
{
   _actionMap[502][WHERE] = ActionEntry(REDUCE, 151);
   _actionMap[502][AS] = ActionEntry(REDUCE, 151);
   _actionMap[502][FROM] = ActionEntry(REDUCE, 151);
   _actionMap[502][END_TOKEN] = ActionEntry(REDUCE, 151);
   _actionMap[502][BEGIN] = ActionEntry(REDUCE, 151);
   _actionMap[502][THEN] = ActionEntry(REDUCE, 151);
   _actionMap[502][OR] = ActionEntry(REDUCE, 151);
   _actionMap[502][AND] = ActionEntry(REDUCE, 151);
   _actionMap[502][LIKE] = ActionEntry(REDUCE, 151);
   _actionMap[502][IS] = ActionEntry(REDUCE, 151);
   _actionMap[502][BETWEEN] = ActionEntry(REDUCE, 151);
   _actionMap[502][NOT] = ActionEntry(REDUCE, 151);
   _actionMap[502][INTOK] = ActionEntry(REDUCE, 151);
   _actionMap[502][EQU] = ActionEntry(REDUCE, 151);
   _actionMap[502][NEGATION] = ActionEntry(REDUCE, 151);
   _actionMap[502][LT] = ActionEntry(REDUCE, 151);
   _actionMap[502][MT] = ActionEntry(REDUCE, 151);
   _actionMap[502][DESC] = ActionEntry(REDUCE, 151);
   _actionMap[502][ASC] = ActionEntry(REDUCE, 151);
   _actionMap[502][KSEP] = ActionEntry(REDUCE, 151);
   _actionMap[502][ROWLIMIT] = ActionEntry(REDUCE, 151);
   _actionMap[502][UNION] = ActionEntry(REDUCE, 151);
   _actionMap[502][ENDTOKEN] = ActionEntry(REDUCE, 151);
   _actionMap[502][RB] = ActionEntry(REDUCE, 151);
   _actionMap[502][SEMICOLON] = ActionEntry(REDUCE, 151);
   _actionMap[502][CONCAT] = ActionEntry(REDUCE, 151);
   _actionMap[502][STAR] = ActionEntry(REDUCE, 151);
   _actionMap[502][DIVISION] = ActionEntry(REDUCE, 151);
   _actionMap[502][MINUS] = ActionEntry(REDUCE, 151);
   _actionMap[502][PLUS] = ActionEntry(REDUCE, 151);
   _actionMap[503][WHEN] = ActionEntry(REDUCE, 275);
   _actionMap[503][ELSE] = ActionEntry(REDUCE, 275);
   _actionMap[503][LEFT] = ActionEntry(REDUCE, 275);
   _actionMap[503][RIGHT] = ActionEntry(REDUCE, 275);
   _actionMap[503][INNER] = ActionEntry(REDUCE, 275);
   _actionMap[503][JOIN] = ActionEntry(REDUCE, 275);
   _actionMap[503][RETURNTOKEN] = ActionEntry(REDUCE, 275);
   _actionMap[503][ORDER] = ActionEntry(REDUCE, 275);
   _actionMap[503][GROUP] = ActionEntry(REDUCE, 275);
   _actionMap[503][WHERE] = ActionEntry(REDUCE, 275);
   _actionMap[503][FROM] = ActionEntry(REDUCE, 275);
   _actionMap[503][AS] = ActionEntry(REDUCE, 275);
   _actionMap[503][END_TOKEN] = ActionEntry(REDUCE, 275);
   _actionMap[503][BEGIN] = ActionEntry(REDUCE, 275);
   _actionMap[503][THEN] = ActionEntry(REDUCE, 275);
   _actionMap[503][OR] = ActionEntry(REDUCE, 275);
   _actionMap[503][AND] = ActionEntry(REDUCE, 275);
   _actionMap[503][INTOK] = ActionEntry(REDUCE, 275);
   _actionMap[503][NOT] = ActionEntry(REDUCE, 275);
   _actionMap[503][BETWEEN] = ActionEntry(REDUCE, 275);
}
void Cego::loadParser95()
{
   _actionMap[503][IS] = ActionEntry(REDUCE, 275);
   _actionMap[503][LIKE] = ActionEntry(REDUCE, 275);
   _actionMap[503][MT] = ActionEntry(REDUCE, 275);
   _actionMap[503][LT] = ActionEntry(REDUCE, 275);
   _actionMap[503][NEGATION] = ActionEntry(REDUCE, 275);
   _actionMap[503][EQU] = ActionEntry(REDUCE, 275);
   _actionMap[503][RB] = ActionEntry(REDUCE, 275);
   _actionMap[503][ENDTOKEN] = ActionEntry(REDUCE, 275);
   _actionMap[503][UNION] = ActionEntry(REDUCE, 275);
   _actionMap[503][ROWLIMIT] = ActionEntry(REDUCE, 275);
   _actionMap[503][KSEP] = ActionEntry(REDUCE, 275);
   _actionMap[503][ASC] = ActionEntry(REDUCE, 275);
   _actionMap[503][DESC] = ActionEntry(REDUCE, 275);
   _actionMap[503][SEMICOLON] = ActionEntry(REDUCE, 275);
   _actionMap[503][PLUS] = ActionEntry(REDUCE, 275);
   _actionMap[503][MINUS] = ActionEntry(REDUCE, 275);
   _actionMap[503][DIVISION] = ActionEntry(REDUCE, 275);
   _actionMap[503][STAR] = ActionEntry(REDUCE, 275);
   _actionMap[503][CONCAT] = ActionEntry(REDUCE, 275);
   _actionMap[504][WHEN] = ActionEntry(REDUCE, 281);
   _actionMap[504][ELSE] = ActionEntry(REDUCE, 281);
   _actionMap[504][LEFT] = ActionEntry(REDUCE, 281);
   _actionMap[504][RIGHT] = ActionEntry(REDUCE, 281);
   _actionMap[504][INNER] = ActionEntry(REDUCE, 281);
   _actionMap[504][JOIN] = ActionEntry(REDUCE, 281);
   _actionMap[504][RETURNTOKEN] = ActionEntry(REDUCE, 281);
   _actionMap[504][ORDER] = ActionEntry(REDUCE, 281);
   _actionMap[504][GROUP] = ActionEntry(REDUCE, 281);
   _actionMap[504][WHERE] = ActionEntry(REDUCE, 281);
   _actionMap[504][FROM] = ActionEntry(REDUCE, 281);
   _actionMap[504][AS] = ActionEntry(REDUCE, 281);
   _actionMap[504][END_TOKEN] = ActionEntry(REDUCE, 281);
   _actionMap[504][BEGIN] = ActionEntry(REDUCE, 281);
   _actionMap[504][THEN] = ActionEntry(REDUCE, 281);
   _actionMap[504][OR] = ActionEntry(REDUCE, 281);
   _actionMap[504][AND] = ActionEntry(REDUCE, 281);
   _actionMap[504][INTOK] = ActionEntry(REDUCE, 281);
   _actionMap[504][NOT] = ActionEntry(REDUCE, 281);
   _actionMap[504][BETWEEN] = ActionEntry(REDUCE, 281);
   _actionMap[504][IS] = ActionEntry(REDUCE, 281);
   _actionMap[504][LIKE] = ActionEntry(REDUCE, 281);
   _actionMap[504][MT] = ActionEntry(REDUCE, 281);
   _actionMap[504][LT] = ActionEntry(REDUCE, 281);
   _actionMap[504][NEGATION] = ActionEntry(REDUCE, 281);
   _actionMap[504][EQU] = ActionEntry(REDUCE, 281);
   _actionMap[504][RB] = ActionEntry(REDUCE, 281);
   _actionMap[504][ENDTOKEN] = ActionEntry(REDUCE, 281);
   _actionMap[504][UNION] = ActionEntry(REDUCE, 281);
   _actionMap[504][ROWLIMIT] = ActionEntry(REDUCE, 281);
   _actionMap[504][KSEP] = ActionEntry(REDUCE, 281);
}
void Cego::loadParser96()
{
   _actionMap[504][ASC] = ActionEntry(REDUCE, 281);
   _actionMap[504][DESC] = ActionEntry(REDUCE, 281);
   _actionMap[504][SEMICOLON] = ActionEntry(REDUCE, 281);
   _actionMap[504][PLUS] = ActionEntry(REDUCE, 281);
   _actionMap[504][MINUS] = ActionEntry(REDUCE, 281);
   _actionMap[504][DIVISION] = ActionEntry(REDUCE, 281);
   _actionMap[504][STAR] = ActionEntry(REDUCE, 281);
   _actionMap[504][CONCAT] = ActionEntry(REDUCE, 281);
   _actionMap[505][WHEN] = ActionEntry(REDUCE, 277);
   _actionMap[505][ELSE] = ActionEntry(REDUCE, 277);
   _actionMap[505][LEFT] = ActionEntry(REDUCE, 277);
   _actionMap[505][RIGHT] = ActionEntry(REDUCE, 277);
   _actionMap[505][INNER] = ActionEntry(REDUCE, 277);
   _actionMap[505][JOIN] = ActionEntry(REDUCE, 277);
   _actionMap[505][RETURNTOKEN] = ActionEntry(REDUCE, 277);
   _actionMap[505][ORDER] = ActionEntry(REDUCE, 277);
   _actionMap[505][GROUP] = ActionEntry(REDUCE, 277);
   _actionMap[505][WHERE] = ActionEntry(REDUCE, 277);
   _actionMap[505][FROM] = ActionEntry(REDUCE, 277);
   _actionMap[505][AS] = ActionEntry(REDUCE, 277);
   _actionMap[505][END_TOKEN] = ActionEntry(REDUCE, 277);
   _actionMap[505][BEGIN] = ActionEntry(REDUCE, 277);
   _actionMap[505][THEN] = ActionEntry(REDUCE, 277);
   _actionMap[505][OR] = ActionEntry(REDUCE, 277);
   _actionMap[505][AND] = ActionEntry(REDUCE, 277);
   _actionMap[505][INTOK] = ActionEntry(REDUCE, 277);
   _actionMap[505][NOT] = ActionEntry(REDUCE, 277);
   _actionMap[505][BETWEEN] = ActionEntry(REDUCE, 277);
   _actionMap[505][IS] = ActionEntry(REDUCE, 277);
   _actionMap[505][LIKE] = ActionEntry(REDUCE, 277);
   _actionMap[505][MT] = ActionEntry(REDUCE, 277);
   _actionMap[505][LT] = ActionEntry(REDUCE, 277);
   _actionMap[505][NEGATION] = ActionEntry(REDUCE, 277);
   _actionMap[505][EQU] = ActionEntry(REDUCE, 277);
   _actionMap[505][RB] = ActionEntry(REDUCE, 277);
   _actionMap[505][ENDTOKEN] = ActionEntry(REDUCE, 277);
   _actionMap[505][UNION] = ActionEntry(REDUCE, 277);
   _actionMap[505][ROWLIMIT] = ActionEntry(REDUCE, 277);
   _actionMap[505][KSEP] = ActionEntry(REDUCE, 277);
   _actionMap[505][ASC] = ActionEntry(REDUCE, 277);
   _actionMap[505][DESC] = ActionEntry(REDUCE, 277);
   _actionMap[505][SEMICOLON] = ActionEntry(REDUCE, 277);
   _actionMap[505][PLUS] = ActionEntry(REDUCE, 277);
   _actionMap[505][MINUS] = ActionEntry(REDUCE, 277);
   _actionMap[505][DIVISION] = ActionEntry(REDUCE, 277);
   _actionMap[505][STAR] = ActionEntry(REDUCE, 277);
   _actionMap[505][CONCAT] = ActionEntry(REDUCE, 277);
   _actionMap[506][WHEN] = ActionEntry(REDUCE, 273);
   _actionMap[506][ELSE] = ActionEntry(REDUCE, 273);
   _actionMap[506][LEFT] = ActionEntry(REDUCE, 273);
}
void Cego::loadParser97()
{
   _actionMap[506][RIGHT] = ActionEntry(REDUCE, 273);
   _actionMap[506][INNER] = ActionEntry(REDUCE, 273);
   _actionMap[506][JOIN] = ActionEntry(REDUCE, 273);
   _actionMap[506][RETURNTOKEN] = ActionEntry(REDUCE, 273);
   _actionMap[506][ORDER] = ActionEntry(REDUCE, 273);
   _actionMap[506][GROUP] = ActionEntry(REDUCE, 273);
   _actionMap[506][WHERE] = ActionEntry(REDUCE, 273);
   _actionMap[506][FROM] = ActionEntry(REDUCE, 273);
   _actionMap[506][AS] = ActionEntry(REDUCE, 273);
   _actionMap[506][END_TOKEN] = ActionEntry(REDUCE, 273);
   _actionMap[506][BEGIN] = ActionEntry(REDUCE, 273);
   _actionMap[506][THEN] = ActionEntry(REDUCE, 273);
   _actionMap[506][OR] = ActionEntry(REDUCE, 273);
   _actionMap[506][AND] = ActionEntry(REDUCE, 273);
   _actionMap[506][INTOK] = ActionEntry(REDUCE, 273);
   _actionMap[506][NOT] = ActionEntry(REDUCE, 273);
   _actionMap[506][BETWEEN] = ActionEntry(REDUCE, 273);
   _actionMap[506][IS] = ActionEntry(REDUCE, 273);
   _actionMap[506][LIKE] = ActionEntry(REDUCE, 273);
   _actionMap[506][MT] = ActionEntry(REDUCE, 273);
   _actionMap[506][LT] = ActionEntry(REDUCE, 273);
   _actionMap[506][NEGATION] = ActionEntry(REDUCE, 273);
   _actionMap[506][EQU] = ActionEntry(REDUCE, 273);
   _actionMap[506][RB] = ActionEntry(REDUCE, 273);
   _actionMap[506][ENDTOKEN] = ActionEntry(REDUCE, 273);
   _actionMap[506][UNION] = ActionEntry(REDUCE, 273);
   _actionMap[506][ROWLIMIT] = ActionEntry(REDUCE, 273);
   _actionMap[506][KSEP] = ActionEntry(REDUCE, 273);
   _actionMap[506][ASC] = ActionEntry(REDUCE, 273);
   _actionMap[506][DESC] = ActionEntry(REDUCE, 273);
   _actionMap[506][SEMICOLON] = ActionEntry(REDUCE, 273);
   _actionMap[506][PLUS] = ActionEntry(REDUCE, 273);
   _actionMap[506][MINUS] = ActionEntry(REDUCE, 273);
   _actionMap[506][DIVISION] = ActionEntry(REDUCE, 273);
   _actionMap[506][STAR] = ActionEntry(REDUCE, 273);
   _actionMap[506][CONCAT] = ActionEntry(REDUCE, 273);
   _actionMap[507][WHEN] = ActionEntry(REDUCE, 274);
   _actionMap[507][ELSE] = ActionEntry(REDUCE, 274);
   _actionMap[507][LEFT] = ActionEntry(REDUCE, 274);
   _actionMap[507][RIGHT] = ActionEntry(REDUCE, 274);
   _actionMap[507][INNER] = ActionEntry(REDUCE, 274);
   _actionMap[507][JOIN] = ActionEntry(REDUCE, 274);
   _actionMap[507][RETURNTOKEN] = ActionEntry(REDUCE, 274);
   _actionMap[507][ORDER] = ActionEntry(REDUCE, 274);
   _actionMap[507][GROUP] = ActionEntry(REDUCE, 274);
   _actionMap[507][WHERE] = ActionEntry(REDUCE, 274);
   _actionMap[507][FROM] = ActionEntry(REDUCE, 274);
   _actionMap[507][AS] = ActionEntry(REDUCE, 274);
   _actionMap[507][END_TOKEN] = ActionEntry(REDUCE, 274);
   _actionMap[507][BEGIN] = ActionEntry(REDUCE, 274);
}
void Cego::loadParser98()
{
   _actionMap[507][THEN] = ActionEntry(REDUCE, 274);
   _actionMap[507][OR] = ActionEntry(REDUCE, 274);
   _actionMap[507][AND] = ActionEntry(REDUCE, 274);
   _actionMap[507][INTOK] = ActionEntry(REDUCE, 274);
   _actionMap[507][NOT] = ActionEntry(REDUCE, 274);
   _actionMap[507][BETWEEN] = ActionEntry(REDUCE, 274);
   _actionMap[507][IS] = ActionEntry(REDUCE, 274);
   _actionMap[507][LIKE] = ActionEntry(REDUCE, 274);
   _actionMap[507][MT] = ActionEntry(REDUCE, 274);
   _actionMap[507][LT] = ActionEntry(REDUCE, 274);
   _actionMap[507][NEGATION] = ActionEntry(REDUCE, 274);
   _actionMap[507][EQU] = ActionEntry(REDUCE, 274);
   _actionMap[507][RB] = ActionEntry(REDUCE, 274);
   _actionMap[507][ENDTOKEN] = ActionEntry(REDUCE, 274);
   _actionMap[507][UNION] = ActionEntry(REDUCE, 274);
   _actionMap[507][ROWLIMIT] = ActionEntry(REDUCE, 274);
   _actionMap[507][KSEP] = ActionEntry(REDUCE, 274);
   _actionMap[507][ASC] = ActionEntry(REDUCE, 274);
   _actionMap[507][DESC] = ActionEntry(REDUCE, 274);
   _actionMap[507][SEMICOLON] = ActionEntry(REDUCE, 274);
   _actionMap[507][PLUS] = ActionEntry(REDUCE, 274);
   _actionMap[507][MINUS] = ActionEntry(REDUCE, 274);
   _actionMap[507][DIVISION] = ActionEntry(REDUCE, 274);
   _actionMap[507][STAR] = ActionEntry(REDUCE, 274);
   _actionMap[507][CONCAT] = ActionEntry(REDUCE, 274);
   _actionMap[508][WHEN] = ActionEntry(REDUCE, 268);
   _actionMap[508][ELSE] = ActionEntry(REDUCE, 268);
   _actionMap[508][LEFT] = ActionEntry(REDUCE, 268);
   _actionMap[508][RIGHT] = ActionEntry(REDUCE, 268);
   _actionMap[508][INNER] = ActionEntry(REDUCE, 268);
   _actionMap[508][JOIN] = ActionEntry(REDUCE, 268);
   _actionMap[508][RETURNTOKEN] = ActionEntry(REDUCE, 268);
   _actionMap[508][ORDER] = ActionEntry(REDUCE, 268);
   _actionMap[508][GROUP] = ActionEntry(REDUCE, 268);
   _actionMap[508][WHERE] = ActionEntry(REDUCE, 268);
   _actionMap[508][FROM] = ActionEntry(REDUCE, 268);
   _actionMap[508][AS] = ActionEntry(REDUCE, 268);
   _actionMap[508][END_TOKEN] = ActionEntry(REDUCE, 268);
   _actionMap[508][BEGIN] = ActionEntry(REDUCE, 268);
   _actionMap[508][THEN] = ActionEntry(REDUCE, 268);
   _actionMap[508][OR] = ActionEntry(REDUCE, 268);
   _actionMap[508][AND] = ActionEntry(REDUCE, 268);
   _actionMap[508][INTOK] = ActionEntry(REDUCE, 268);
   _actionMap[508][NOT] = ActionEntry(REDUCE, 268);
   _actionMap[508][BETWEEN] = ActionEntry(REDUCE, 268);
   _actionMap[508][IS] = ActionEntry(REDUCE, 268);
   _actionMap[508][LIKE] = ActionEntry(REDUCE, 268);
   _actionMap[508][MT] = ActionEntry(REDUCE, 268);
   _actionMap[508][LT] = ActionEntry(REDUCE, 268);
   _actionMap[508][NEGATION] = ActionEntry(REDUCE, 268);
}
void Cego::loadParser99()
{
   _actionMap[508][EQU] = ActionEntry(REDUCE, 268);
   _actionMap[508][RB] = ActionEntry(REDUCE, 268);
   _actionMap[508][ENDTOKEN] = ActionEntry(REDUCE, 268);
   _actionMap[508][UNION] = ActionEntry(REDUCE, 268);
   _actionMap[508][ROWLIMIT] = ActionEntry(REDUCE, 268);
   _actionMap[508][KSEP] = ActionEntry(REDUCE, 268);
   _actionMap[508][ASC] = ActionEntry(REDUCE, 268);
   _actionMap[508][DESC] = ActionEntry(REDUCE, 268);
   _actionMap[508][SEMICOLON] = ActionEntry(REDUCE, 268);
   _actionMap[508][PLUS] = ActionEntry(REDUCE, 268);
   _actionMap[508][MINUS] = ActionEntry(REDUCE, 268);
   _actionMap[508][DIVISION] = ActionEntry(REDUCE, 268);
   _actionMap[508][STAR] = ActionEntry(REDUCE, 268);
   _actionMap[508][CONCAT] = ActionEntry(REDUCE, 268);
   _actionMap[509][WHEN] = ActionEntry(REDUCE, 265);
   _actionMap[509][ELSE] = ActionEntry(REDUCE, 265);
   _actionMap[509][LEFT] = ActionEntry(REDUCE, 265);
   _actionMap[509][RIGHT] = ActionEntry(REDUCE, 265);
   _actionMap[509][INNER] = ActionEntry(REDUCE, 265);
   _actionMap[509][JOIN] = ActionEntry(REDUCE, 265);
   _actionMap[509][RETURNTOKEN] = ActionEntry(REDUCE, 265);
   _actionMap[509][ORDER] = ActionEntry(REDUCE, 265);
   _actionMap[509][GROUP] = ActionEntry(REDUCE, 265);
   _actionMap[509][WHERE] = ActionEntry(REDUCE, 265);
   _actionMap[509][FROM] = ActionEntry(REDUCE, 265);
   _actionMap[509][AS] = ActionEntry(REDUCE, 265);
   _actionMap[509][END_TOKEN] = ActionEntry(REDUCE, 265);
   _actionMap[509][BEGIN] = ActionEntry(REDUCE, 265);
   _actionMap[509][THEN] = ActionEntry(REDUCE, 265);
   _actionMap[509][OR] = ActionEntry(REDUCE, 265);
   _actionMap[509][AND] = ActionEntry(REDUCE, 265);
   _actionMap[509][INTOK] = ActionEntry(REDUCE, 265);
   _actionMap[509][NOT] = ActionEntry(REDUCE, 265);
   _actionMap[509][BETWEEN] = ActionEntry(REDUCE, 265);
   _actionMap[509][IS] = ActionEntry(REDUCE, 265);
   _actionMap[509][LIKE] = ActionEntry(REDUCE, 265);
   _actionMap[509][MT] = ActionEntry(REDUCE, 265);
   _actionMap[509][LT] = ActionEntry(REDUCE, 265);
   _actionMap[509][NEGATION] = ActionEntry(REDUCE, 265);
   _actionMap[509][EQU] = ActionEntry(REDUCE, 265);
   _actionMap[509][RB] = ActionEntry(REDUCE, 265);
   _actionMap[509][ENDTOKEN] = ActionEntry(REDUCE, 265);
   _actionMap[509][UNION] = ActionEntry(REDUCE, 265);
   _actionMap[509][ROWLIMIT] = ActionEntry(REDUCE, 265);
   _actionMap[509][KSEP] = ActionEntry(REDUCE, 265);
   _actionMap[509][ASC] = ActionEntry(REDUCE, 265);
   _actionMap[509][DESC] = ActionEntry(REDUCE, 265);
   _actionMap[509][SEMICOLON] = ActionEntry(REDUCE, 265);
   _actionMap[509][PLUS] = ActionEntry(REDUCE, 265);
   _actionMap[509][MINUS] = ActionEntry(REDUCE, 265);
}
void Cego::loadParser100()
{
   _actionMap[509][DIVISION] = ActionEntry(REDUCE, 265);
   _actionMap[509][STAR] = ActionEntry(REDUCE, 265);
   _actionMap[509][CONCAT] = ActionEntry(REDUCE, 265);
   _actionMap[510][WHEN] = ActionEntry(REDUCE, 258);
   _actionMap[510][ELSE] = ActionEntry(REDUCE, 258);
   _actionMap[510][LEFT] = ActionEntry(REDUCE, 258);
   _actionMap[510][RIGHT] = ActionEntry(REDUCE, 258);
   _actionMap[510][INNER] = ActionEntry(REDUCE, 258);
   _actionMap[510][JOIN] = ActionEntry(REDUCE, 258);
   _actionMap[510][RETURNTOKEN] = ActionEntry(REDUCE, 258);
   _actionMap[510][ORDER] = ActionEntry(REDUCE, 258);
   _actionMap[510][GROUP] = ActionEntry(REDUCE, 258);
   _actionMap[510][WHERE] = ActionEntry(REDUCE, 258);
   _actionMap[510][FROM] = ActionEntry(REDUCE, 258);
   _actionMap[510][AS] = ActionEntry(REDUCE, 258);
   _actionMap[510][END_TOKEN] = ActionEntry(REDUCE, 258);
   _actionMap[510][BEGIN] = ActionEntry(REDUCE, 258);
   _actionMap[510][THEN] = ActionEntry(REDUCE, 258);
   _actionMap[510][OR] = ActionEntry(REDUCE, 258);
   _actionMap[510][AND] = ActionEntry(REDUCE, 258);
   _actionMap[510][INTOK] = ActionEntry(REDUCE, 258);
   _actionMap[510][NOT] = ActionEntry(REDUCE, 258);
   _actionMap[510][BETWEEN] = ActionEntry(REDUCE, 258);
   _actionMap[510][IS] = ActionEntry(REDUCE, 258);
   _actionMap[510][LIKE] = ActionEntry(REDUCE, 258);
   _actionMap[510][MT] = ActionEntry(REDUCE, 258);
   _actionMap[510][LT] = ActionEntry(REDUCE, 258);
   _actionMap[510][NEGATION] = ActionEntry(REDUCE, 258);
   _actionMap[510][EQU] = ActionEntry(REDUCE, 258);
   _actionMap[510][RB] = ActionEntry(REDUCE, 258);
   _actionMap[510][ENDTOKEN] = ActionEntry(REDUCE, 258);
   _actionMap[510][UNION] = ActionEntry(REDUCE, 258);
   _actionMap[510][ROWLIMIT] = ActionEntry(REDUCE, 258);
   _actionMap[510][KSEP] = ActionEntry(REDUCE, 258);
   _actionMap[510][ASC] = ActionEntry(REDUCE, 258);
   _actionMap[510][DESC] = ActionEntry(REDUCE, 258);
   _actionMap[510][SEMICOLON] = ActionEntry(REDUCE, 258);
   _actionMap[510][PLUS] = ActionEntry(REDUCE, 258);
   _actionMap[510][MINUS] = ActionEntry(REDUCE, 258);
   _actionMap[510][DIVISION] = ActionEntry(REDUCE, 258);
   _actionMap[510][STAR] = ActionEntry(REDUCE, 258);
   _actionMap[510][CONCAT] = ActionEntry(REDUCE, 258);
   _actionMap[511][WHEN] = ActionEntry(REDUCE, 256);
   _actionMap[511][ELSE] = ActionEntry(REDUCE, 256);
   _actionMap[511][LEFT] = ActionEntry(REDUCE, 256);
   _actionMap[511][RIGHT] = ActionEntry(REDUCE, 256);
   _actionMap[511][INNER] = ActionEntry(REDUCE, 256);
   _actionMap[511][JOIN] = ActionEntry(REDUCE, 256);
   _actionMap[511][RETURNTOKEN] = ActionEntry(REDUCE, 256);
   _actionMap[511][ORDER] = ActionEntry(REDUCE, 256);
}
void Cego::loadParser101()
{
   _actionMap[511][GROUP] = ActionEntry(REDUCE, 256);
   _actionMap[511][WHERE] = ActionEntry(REDUCE, 256);
   _actionMap[511][FROM] = ActionEntry(REDUCE, 256);
   _actionMap[511][AS] = ActionEntry(REDUCE, 256);
   _actionMap[511][END_TOKEN] = ActionEntry(REDUCE, 256);
   _actionMap[511][BEGIN] = ActionEntry(REDUCE, 256);
   _actionMap[511][THEN] = ActionEntry(REDUCE, 256);
   _actionMap[511][OR] = ActionEntry(REDUCE, 256);
   _actionMap[511][AND] = ActionEntry(REDUCE, 256);
   _actionMap[511][INTOK] = ActionEntry(REDUCE, 256);
   _actionMap[511][NOT] = ActionEntry(REDUCE, 256);
   _actionMap[511][BETWEEN] = ActionEntry(REDUCE, 256);
   _actionMap[511][IS] = ActionEntry(REDUCE, 256);
   _actionMap[511][LIKE] = ActionEntry(REDUCE, 256);
   _actionMap[511][MT] = ActionEntry(REDUCE, 256);
   _actionMap[511][LT] = ActionEntry(REDUCE, 256);
   _actionMap[511][NEGATION] = ActionEntry(REDUCE, 256);
   _actionMap[511][EQU] = ActionEntry(REDUCE, 256);
   _actionMap[511][RB] = ActionEntry(REDUCE, 256);
   _actionMap[511][ENDTOKEN] = ActionEntry(REDUCE, 256);
   _actionMap[511][UNION] = ActionEntry(REDUCE, 256);
   _actionMap[511][ROWLIMIT] = ActionEntry(REDUCE, 256);
   _actionMap[511][KSEP] = ActionEntry(REDUCE, 256);
   _actionMap[511][ASC] = ActionEntry(REDUCE, 256);
   _actionMap[511][DESC] = ActionEntry(REDUCE, 256);
   _actionMap[511][SEMICOLON] = ActionEntry(REDUCE, 256);
   _actionMap[511][PLUS] = ActionEntry(REDUCE, 256);
   _actionMap[511][MINUS] = ActionEntry(REDUCE, 256);
   _actionMap[511][DIVISION] = ActionEntry(REDUCE, 256);
   _actionMap[511][STAR] = ActionEntry(REDUCE, 256);
   _actionMap[511][CONCAT] = ActionEntry(REDUCE, 256);
   _actionMap[512][WHEN] = ActionEntry(REDUCE, 267);
   _actionMap[512][ELSE] = ActionEntry(REDUCE, 267);
   _actionMap[512][LEFT] = ActionEntry(REDUCE, 267);
   _actionMap[512][RIGHT] = ActionEntry(REDUCE, 267);
   _actionMap[512][INNER] = ActionEntry(REDUCE, 267);
   _actionMap[512][JOIN] = ActionEntry(REDUCE, 267);
   _actionMap[512][RETURNTOKEN] = ActionEntry(REDUCE, 267);
   _actionMap[512][ORDER] = ActionEntry(REDUCE, 267);
   _actionMap[512][GROUP] = ActionEntry(REDUCE, 267);
   _actionMap[512][WHERE] = ActionEntry(REDUCE, 267);
   _actionMap[512][FROM] = ActionEntry(REDUCE, 267);
   _actionMap[512][AS] = ActionEntry(REDUCE, 267);
   _actionMap[512][END_TOKEN] = ActionEntry(REDUCE, 267);
   _actionMap[512][BEGIN] = ActionEntry(REDUCE, 267);
   _actionMap[512][THEN] = ActionEntry(REDUCE, 267);
   _actionMap[512][OR] = ActionEntry(REDUCE, 267);
   _actionMap[512][AND] = ActionEntry(REDUCE, 267);
   _actionMap[512][INTOK] = ActionEntry(REDUCE, 267);
   _actionMap[512][NOT] = ActionEntry(REDUCE, 267);
}
void Cego::loadParser102()
{
   _actionMap[512][BETWEEN] = ActionEntry(REDUCE, 267);
   _actionMap[512][IS] = ActionEntry(REDUCE, 267);
   _actionMap[512][LIKE] = ActionEntry(REDUCE, 267);
   _actionMap[512][MT] = ActionEntry(REDUCE, 267);
   _actionMap[512][LT] = ActionEntry(REDUCE, 267);
   _actionMap[512][NEGATION] = ActionEntry(REDUCE, 267);
   _actionMap[512][EQU] = ActionEntry(REDUCE, 267);
   _actionMap[512][RB] = ActionEntry(REDUCE, 267);
   _actionMap[512][ENDTOKEN] = ActionEntry(REDUCE, 267);
   _actionMap[512][UNION] = ActionEntry(REDUCE, 267);
   _actionMap[512][ROWLIMIT] = ActionEntry(REDUCE, 267);
   _actionMap[512][KSEP] = ActionEntry(REDUCE, 267);
   _actionMap[512][ASC] = ActionEntry(REDUCE, 267);
   _actionMap[512][DESC] = ActionEntry(REDUCE, 267);
   _actionMap[512][SEMICOLON] = ActionEntry(REDUCE, 267);
   _actionMap[512][PLUS] = ActionEntry(REDUCE, 267);
   _actionMap[512][MINUS] = ActionEntry(REDUCE, 267);
   _actionMap[512][DIVISION] = ActionEntry(REDUCE, 267);
   _actionMap[512][STAR] = ActionEntry(REDUCE, 267);
   _actionMap[512][CONCAT] = ActionEntry(REDUCE, 267);
   _actionMap[513][WHEN] = ActionEntry(REDUCE, 147);
   _actionMap[513][ELSE] = ActionEntry(REDUCE, 147);
   _actionMap[513][LEFT] = ActionEntry(REDUCE, 147);
   _actionMap[513][RIGHT] = ActionEntry(REDUCE, 147);
   _actionMap[513][INNER] = ActionEntry(REDUCE, 147);
   _actionMap[513][JOIN] = ActionEntry(REDUCE, 147);
   _actionMap[513][RETURNTOKEN] = ActionEntry(REDUCE, 147);
   _actionMap[513][ORDER] = ActionEntry(REDUCE, 147);
   _actionMap[513][GROUP] = ActionEntry(REDUCE, 147);
   _actionMap[513][WHERE] = ActionEntry(REDUCE, 147);
   _actionMap[513][AS] = ActionEntry(REDUCE, 147);
   _actionMap[513][FROM] = ActionEntry(REDUCE, 147);
   _actionMap[513][END_TOKEN] = ActionEntry(REDUCE, 147);
   _actionMap[513][BEGIN] = ActionEntry(REDUCE, 147);
   _actionMap[513][THEN] = ActionEntry(REDUCE, 147);
   _actionMap[513][OR] = ActionEntry(REDUCE, 147);
   _actionMap[513][AND] = ActionEntry(REDUCE, 147);
   _actionMap[513][LIKE] = ActionEntry(REDUCE, 147);
   _actionMap[513][IS] = ActionEntry(REDUCE, 147);
   _actionMap[513][BETWEEN] = ActionEntry(REDUCE, 147);
   _actionMap[513][NOT] = ActionEntry(REDUCE, 147);
   _actionMap[513][INTOK] = ActionEntry(REDUCE, 147);
   _actionMap[513][EQU] = ActionEntry(REDUCE, 147);
   _actionMap[513][NEGATION] = ActionEntry(REDUCE, 147);
   _actionMap[513][LT] = ActionEntry(REDUCE, 147);
   _actionMap[513][MT] = ActionEntry(REDUCE, 147);
   _actionMap[513][DESC] = ActionEntry(REDUCE, 147);
   _actionMap[513][ASC] = ActionEntry(REDUCE, 147);
   _actionMap[513][KSEP] = ActionEntry(REDUCE, 147);
   _actionMap[513][ROWLIMIT] = ActionEntry(REDUCE, 147);
}
void Cego::loadParser103()
{
   _actionMap[513][UNION] = ActionEntry(REDUCE, 147);
   _actionMap[513][ENDTOKEN] = ActionEntry(REDUCE, 147);
   _actionMap[513][RB] = ActionEntry(REDUCE, 147);
   _actionMap[513][SEMICOLON] = ActionEntry(REDUCE, 147);
   _actionMap[513][CONCAT] = ActionEntry(REDUCE, 147);
   _actionMap[513][STAR] = ActionEntry(REDUCE, 147);
   _actionMap[513][DIVISION] = ActionEntry(REDUCE, 147);
   _actionMap[513][MINUS] = ActionEntry(REDUCE, 147);
   _actionMap[513][PLUS] = ActionEntry(REDUCE, 147);
   _actionMap[514][WHEN] = ActionEntry(REDUCE, 271);
   _actionMap[514][ELSE] = ActionEntry(REDUCE, 271);
   _actionMap[514][LEFT] = ActionEntry(REDUCE, 271);
   _actionMap[514][RIGHT] = ActionEntry(REDUCE, 271);
   _actionMap[514][INNER] = ActionEntry(REDUCE, 271);
   _actionMap[514][JOIN] = ActionEntry(REDUCE, 271);
   _actionMap[514][RETURNTOKEN] = ActionEntry(REDUCE, 271);
   _actionMap[514][ORDER] = ActionEntry(REDUCE, 271);
   _actionMap[514][GROUP] = ActionEntry(REDUCE, 271);
   _actionMap[514][WHERE] = ActionEntry(REDUCE, 271);
   _actionMap[514][FROM] = ActionEntry(REDUCE, 271);
   _actionMap[514][AS] = ActionEntry(REDUCE, 271);
   _actionMap[514][END_TOKEN] = ActionEntry(REDUCE, 271);
   _actionMap[514][BEGIN] = ActionEntry(REDUCE, 271);
   _actionMap[514][THEN] = ActionEntry(REDUCE, 271);
   _actionMap[514][OR] = ActionEntry(REDUCE, 271);
   _actionMap[514][AND] = ActionEntry(REDUCE, 271);
   _actionMap[514][INTOK] = ActionEntry(REDUCE, 271);
   _actionMap[514][NOT] = ActionEntry(REDUCE, 271);
   _actionMap[514][BETWEEN] = ActionEntry(REDUCE, 271);
   _actionMap[514][IS] = ActionEntry(REDUCE, 271);
   _actionMap[514][LIKE] = ActionEntry(REDUCE, 271);
   _actionMap[514][MT] = ActionEntry(REDUCE, 271);
   _actionMap[514][LT] = ActionEntry(REDUCE, 271);
   _actionMap[514][NEGATION] = ActionEntry(REDUCE, 271);
   _actionMap[514][EQU] = ActionEntry(REDUCE, 271);
   _actionMap[514][RB] = ActionEntry(REDUCE, 271);
   _actionMap[514][ENDTOKEN] = ActionEntry(REDUCE, 271);
   _actionMap[514][UNION] = ActionEntry(REDUCE, 271);
   _actionMap[514][ROWLIMIT] = ActionEntry(REDUCE, 271);
   _actionMap[514][KSEP] = ActionEntry(REDUCE, 271);
   _actionMap[514][ASC] = ActionEntry(REDUCE, 271);
   _actionMap[514][DESC] = ActionEntry(REDUCE, 271);
   _actionMap[514][SEMICOLON] = ActionEntry(REDUCE, 271);
   _actionMap[514][PLUS] = ActionEntry(REDUCE, 271);
   _actionMap[514][MINUS] = ActionEntry(REDUCE, 271);
   _actionMap[514][DIVISION] = ActionEntry(REDUCE, 271);
   _actionMap[514][STAR] = ActionEntry(REDUCE, 271);
   _actionMap[514][CONCAT] = ActionEntry(REDUCE, 271);
   _actionMap[515][WHEN] = ActionEntry(REDUCE, 272);
   _actionMap[515][ELSE] = ActionEntry(REDUCE, 272);
}
void Cego::loadParser104()
{
   _actionMap[515][LEFT] = ActionEntry(REDUCE, 272);
   _actionMap[515][RIGHT] = ActionEntry(REDUCE, 272);
   _actionMap[515][INNER] = ActionEntry(REDUCE, 272);
   _actionMap[515][JOIN] = ActionEntry(REDUCE, 272);
   _actionMap[515][RETURNTOKEN] = ActionEntry(REDUCE, 272);
   _actionMap[515][ORDER] = ActionEntry(REDUCE, 272);
   _actionMap[515][GROUP] = ActionEntry(REDUCE, 272);
   _actionMap[515][WHERE] = ActionEntry(REDUCE, 272);
   _actionMap[515][FROM] = ActionEntry(REDUCE, 272);
   _actionMap[515][AS] = ActionEntry(REDUCE, 272);
   _actionMap[515][END_TOKEN] = ActionEntry(REDUCE, 272);
   _actionMap[515][BEGIN] = ActionEntry(REDUCE, 272);
   _actionMap[515][THEN] = ActionEntry(REDUCE, 272);
   _actionMap[515][OR] = ActionEntry(REDUCE, 272);
   _actionMap[515][AND] = ActionEntry(REDUCE, 272);
   _actionMap[515][INTOK] = ActionEntry(REDUCE, 272);
   _actionMap[515][NOT] = ActionEntry(REDUCE, 272);
   _actionMap[515][BETWEEN] = ActionEntry(REDUCE, 272);
   _actionMap[515][IS] = ActionEntry(REDUCE, 272);
   _actionMap[515][LIKE] = ActionEntry(REDUCE, 272);
   _actionMap[515][MT] = ActionEntry(REDUCE, 272);
   _actionMap[515][LT] = ActionEntry(REDUCE, 272);
   _actionMap[515][NEGATION] = ActionEntry(REDUCE, 272);
   _actionMap[515][EQU] = ActionEntry(REDUCE, 272);
   _actionMap[515][RB] = ActionEntry(REDUCE, 272);
   _actionMap[515][ENDTOKEN] = ActionEntry(REDUCE, 272);
   _actionMap[515][UNION] = ActionEntry(REDUCE, 272);
   _actionMap[515][ROWLIMIT] = ActionEntry(REDUCE, 272);
   _actionMap[515][KSEP] = ActionEntry(REDUCE, 272);
   _actionMap[515][ASC] = ActionEntry(REDUCE, 272);
   _actionMap[515][DESC] = ActionEntry(REDUCE, 272);
   _actionMap[515][SEMICOLON] = ActionEntry(REDUCE, 272);
   _actionMap[515][PLUS] = ActionEntry(REDUCE, 272);
   _actionMap[515][MINUS] = ActionEntry(REDUCE, 272);
   _actionMap[515][DIVISION] = ActionEntry(REDUCE, 272);
   _actionMap[515][STAR] = ActionEntry(REDUCE, 272);
   _actionMap[515][CONCAT] = ActionEntry(REDUCE, 272);
   _actionMap[516][WHEN] = ActionEntry(REDUCE, 255);
   _actionMap[516][ELSE] = ActionEntry(REDUCE, 255);
   _actionMap[516][LEFT] = ActionEntry(REDUCE, 255);
   _actionMap[516][RIGHT] = ActionEntry(REDUCE, 255);
   _actionMap[516][INNER] = ActionEntry(REDUCE, 255);
   _actionMap[516][JOIN] = ActionEntry(REDUCE, 255);
   _actionMap[516][RETURNTOKEN] = ActionEntry(REDUCE, 255);
   _actionMap[516][ORDER] = ActionEntry(REDUCE, 255);
   _actionMap[516][GROUP] = ActionEntry(REDUCE, 255);
   _actionMap[516][WHERE] = ActionEntry(REDUCE, 255);
   _actionMap[516][FROM] = ActionEntry(REDUCE, 255);
   _actionMap[516][AS] = ActionEntry(REDUCE, 255);
   _actionMap[516][END_TOKEN] = ActionEntry(REDUCE, 255);
}
void Cego::loadParser105()
{
   _actionMap[516][BEGIN] = ActionEntry(REDUCE, 255);
   _actionMap[516][THEN] = ActionEntry(REDUCE, 255);
   _actionMap[516][OR] = ActionEntry(REDUCE, 255);
   _actionMap[516][AND] = ActionEntry(REDUCE, 255);
   _actionMap[516][INTOK] = ActionEntry(REDUCE, 255);
   _actionMap[516][NOT] = ActionEntry(REDUCE, 255);
   _actionMap[516][BETWEEN] = ActionEntry(REDUCE, 255);
   _actionMap[516][IS] = ActionEntry(REDUCE, 255);
   _actionMap[516][LIKE] = ActionEntry(REDUCE, 255);
   _actionMap[516][MT] = ActionEntry(REDUCE, 255);
   _actionMap[516][LT] = ActionEntry(REDUCE, 255);
   _actionMap[516][NEGATION] = ActionEntry(REDUCE, 255);
   _actionMap[516][EQU] = ActionEntry(REDUCE, 255);
   _actionMap[516][RB] = ActionEntry(REDUCE, 255);
   _actionMap[516][ENDTOKEN] = ActionEntry(REDUCE, 255);
   _actionMap[516][UNION] = ActionEntry(REDUCE, 255);
   _actionMap[516][ROWLIMIT] = ActionEntry(REDUCE, 255);
   _actionMap[516][KSEP] = ActionEntry(REDUCE, 255);
   _actionMap[516][ASC] = ActionEntry(REDUCE, 255);
   _actionMap[516][DESC] = ActionEntry(REDUCE, 255);
   _actionMap[516][SEMICOLON] = ActionEntry(REDUCE, 255);
   _actionMap[516][PLUS] = ActionEntry(REDUCE, 255);
   _actionMap[516][MINUS] = ActionEntry(REDUCE, 255);
   _actionMap[516][DIVISION] = ActionEntry(REDUCE, 255);
   _actionMap[516][STAR] = ActionEntry(REDUCE, 255);
   _actionMap[516][CONCAT] = ActionEntry(REDUCE, 255);
   _actionMap[517][WHEN] = ActionEntry(REDUCE, 270);
   _actionMap[517][ELSE] = ActionEntry(REDUCE, 270);
   _actionMap[517][LEFT] = ActionEntry(REDUCE, 270);
   _actionMap[517][RIGHT] = ActionEntry(REDUCE, 270);
   _actionMap[517][INNER] = ActionEntry(REDUCE, 270);
   _actionMap[517][JOIN] = ActionEntry(REDUCE, 270);
   _actionMap[517][RETURNTOKEN] = ActionEntry(REDUCE, 270);
   _actionMap[517][ORDER] = ActionEntry(REDUCE, 270);
   _actionMap[517][GROUP] = ActionEntry(REDUCE, 270);
   _actionMap[517][WHERE] = ActionEntry(REDUCE, 270);
   _actionMap[517][FROM] = ActionEntry(REDUCE, 270);
   _actionMap[517][AS] = ActionEntry(REDUCE, 270);
   _actionMap[517][END_TOKEN] = ActionEntry(REDUCE, 270);
   _actionMap[517][BEGIN] = ActionEntry(REDUCE, 270);
   _actionMap[517][THEN] = ActionEntry(REDUCE, 270);
   _actionMap[517][OR] = ActionEntry(REDUCE, 270);
   _actionMap[517][AND] = ActionEntry(REDUCE, 270);
   _actionMap[517][INTOK] = ActionEntry(REDUCE, 270);
   _actionMap[517][NOT] = ActionEntry(REDUCE, 270);
   _actionMap[517][BETWEEN] = ActionEntry(REDUCE, 270);
   _actionMap[517][IS] = ActionEntry(REDUCE, 270);
   _actionMap[517][LIKE] = ActionEntry(REDUCE, 270);
   _actionMap[517][MT] = ActionEntry(REDUCE, 270);
   _actionMap[517][LT] = ActionEntry(REDUCE, 270);
}
void Cego::loadParser106()
{
   _actionMap[517][NEGATION] = ActionEntry(REDUCE, 270);
   _actionMap[517][EQU] = ActionEntry(REDUCE, 270);
   _actionMap[517][RB] = ActionEntry(REDUCE, 270);
   _actionMap[517][ENDTOKEN] = ActionEntry(REDUCE, 270);
   _actionMap[517][UNION] = ActionEntry(REDUCE, 270);
   _actionMap[517][ROWLIMIT] = ActionEntry(REDUCE, 270);
   _actionMap[517][KSEP] = ActionEntry(REDUCE, 270);
   _actionMap[517][ASC] = ActionEntry(REDUCE, 270);
   _actionMap[517][DESC] = ActionEntry(REDUCE, 270);
   _actionMap[517][SEMICOLON] = ActionEntry(REDUCE, 270);
   _actionMap[517][PLUS] = ActionEntry(REDUCE, 270);
   _actionMap[517][MINUS] = ActionEntry(REDUCE, 270);
   _actionMap[517][DIVISION] = ActionEntry(REDUCE, 270);
   _actionMap[517][STAR] = ActionEntry(REDUCE, 270);
   _actionMap[517][CONCAT] = ActionEntry(REDUCE, 270);
   _actionMap[518][WHEN] = ActionEntry(REDUCE, 263);
   _actionMap[518][ELSE] = ActionEntry(REDUCE, 263);
   _actionMap[518][LEFT] = ActionEntry(REDUCE, 263);
   _actionMap[518][RIGHT] = ActionEntry(REDUCE, 263);
   _actionMap[518][INNER] = ActionEntry(REDUCE, 263);
   _actionMap[518][JOIN] = ActionEntry(REDUCE, 263);
   _actionMap[518][RETURNTOKEN] = ActionEntry(REDUCE, 263);
   _actionMap[518][ORDER] = ActionEntry(REDUCE, 263);
   _actionMap[518][GROUP] = ActionEntry(REDUCE, 263);
   _actionMap[518][WHERE] = ActionEntry(REDUCE, 263);
   _actionMap[518][FROM] = ActionEntry(REDUCE, 263);
   _actionMap[518][AS] = ActionEntry(REDUCE, 263);
   _actionMap[518][END_TOKEN] = ActionEntry(REDUCE, 263);
   _actionMap[518][BEGIN] = ActionEntry(REDUCE, 263);
   _actionMap[518][THEN] = ActionEntry(REDUCE, 263);
   _actionMap[518][OR] = ActionEntry(REDUCE, 263);
   _actionMap[518][AND] = ActionEntry(REDUCE, 263);
   _actionMap[518][INTOK] = ActionEntry(REDUCE, 263);
   _actionMap[518][NOT] = ActionEntry(REDUCE, 263);
   _actionMap[518][BETWEEN] = ActionEntry(REDUCE, 263);
   _actionMap[518][IS] = ActionEntry(REDUCE, 263);
   _actionMap[518][LIKE] = ActionEntry(REDUCE, 263);
   _actionMap[518][MT] = ActionEntry(REDUCE, 263);
   _actionMap[518][LT] = ActionEntry(REDUCE, 263);
   _actionMap[518][NEGATION] = ActionEntry(REDUCE, 263);
   _actionMap[518][EQU] = ActionEntry(REDUCE, 263);
   _actionMap[518][RB] = ActionEntry(REDUCE, 263);
   _actionMap[518][ENDTOKEN] = ActionEntry(REDUCE, 263);
   _actionMap[518][UNION] = ActionEntry(REDUCE, 263);
   _actionMap[518][ROWLIMIT] = ActionEntry(REDUCE, 263);
   _actionMap[518][KSEP] = ActionEntry(REDUCE, 263);
   _actionMap[518][ASC] = ActionEntry(REDUCE, 263);
   _actionMap[518][DESC] = ActionEntry(REDUCE, 263);
   _actionMap[518][SEMICOLON] = ActionEntry(REDUCE, 263);
   _actionMap[518][PLUS] = ActionEntry(REDUCE, 263);
}
void Cego::loadParser107()
{
   _actionMap[518][MINUS] = ActionEntry(REDUCE, 263);
   _actionMap[518][DIVISION] = ActionEntry(REDUCE, 263);
   _actionMap[518][STAR] = ActionEntry(REDUCE, 263);
   _actionMap[518][CONCAT] = ActionEntry(REDUCE, 263);
   _actionMap[519][WHEN] = ActionEntry(REDUCE, 331);
   _actionMap[519][ELSE] = ActionEntry(REDUCE, 331);
   _actionMap[519][LEFT] = ActionEntry(REDUCE, 331);
   _actionMap[519][RIGHT] = ActionEntry(REDUCE, 331);
   _actionMap[519][INNER] = ActionEntry(REDUCE, 331);
   _actionMap[519][JOIN] = ActionEntry(REDUCE, 331);
   _actionMap[519][RETURNTOKEN] = ActionEntry(REDUCE, 331);
   _actionMap[519][ORDER] = ActionEntry(REDUCE, 331);
   _actionMap[519][GROUP] = ActionEntry(REDUCE, 331);
   _actionMap[519][WHERE] = ActionEntry(REDUCE, 331);
   _actionMap[519][FROM] = ActionEntry(REDUCE, 331);
   _actionMap[519][AS] = ActionEntry(REDUCE, 331);
   _actionMap[519][END_TOKEN] = ActionEntry(REDUCE, 331);
   _actionMap[519][BEGIN] = ActionEntry(REDUCE, 331);
   _actionMap[519][THEN] = ActionEntry(REDUCE, 331);
   _actionMap[519][OR] = ActionEntry(REDUCE, 331);
   _actionMap[519][AND] = ActionEntry(REDUCE, 331);
   _actionMap[519][ENDTOKEN] = ActionEntry(REDUCE, 331);
   _actionMap[519][UNION] = ActionEntry(REDUCE, 331);
   _actionMap[519][ROWLIMIT] = ActionEntry(REDUCE, 331);
   _actionMap[519][ASC] = ActionEntry(REDUCE, 331);
   _actionMap[519][DESC] = ActionEntry(REDUCE, 331);
   _actionMap[519][INTOK] = ActionEntry(REDUCE, 331);
   _actionMap[519][BETWEEN] = ActionEntry(REDUCE, 331);
   _actionMap[519][LIKE] = ActionEntry(REDUCE, 331);
   _actionMap[519][PLUS] = ActionEntry(REDUCE, 331);
   _actionMap[519][MINUS] = ActionEntry(REDUCE, 331);
   _actionMap[519][CONCAT] = ActionEntry(REDUCE, 331);
   _actionMap[519][DIVISION] = ActionEntry(REDUCE, 331);
   _actionMap[519][STAR] = ActionEntry(REDUCE, 331);
   _actionMap[519][MT] = ActionEntry(REDUCE, 331);
   _actionMap[519][LT] = ActionEntry(REDUCE, 331);
   _actionMap[519][NEGATION] = ActionEntry(REDUCE, 331);
   _actionMap[519][EQU] = ActionEntry(REDUCE, 331);
   _actionMap[519][IS] = ActionEntry(REDUCE, 331);
   _actionMap[519][NULLTOKEN] = ActionEntry(REDUCE, 331);
   _actionMap[519][NOT] = ActionEntry(REDUCE, 331);
   _actionMap[519][KSEP] = ActionEntry(REDUCE, 331);
   _actionMap[519][SEMICOLON] = ActionEntry(REDUCE, 331);
   _actionMap[519][RB] = ActionEntry(REDUCE, 331);
   _actionMap[520][INTVAL] = ActionEntry(SHIFT, 261);
   _actionMap[521][WHEN] = ActionEntry(REDUCE, 337);
   _actionMap[521][ELSE] = ActionEntry(REDUCE, 337);
   _actionMap[521][LEFT] = ActionEntry(REDUCE, 337);
   _actionMap[521][RIGHT] = ActionEntry(REDUCE, 337);
   _actionMap[521][INNER] = ActionEntry(REDUCE, 337);
}
void Cego::loadParser108()
{
   _actionMap[521][JOIN] = ActionEntry(REDUCE, 337);
   _actionMap[521][RETURNTOKEN] = ActionEntry(REDUCE, 337);
   _actionMap[521][ORDER] = ActionEntry(REDUCE, 337);
   _actionMap[521][GROUP] = ActionEntry(REDUCE, 337);
   _actionMap[521][WHERE] = ActionEntry(REDUCE, 337);
   _actionMap[521][FROM] = ActionEntry(REDUCE, 337);
   _actionMap[521][AS] = ActionEntry(REDUCE, 337);
   _actionMap[521][END_TOKEN] = ActionEntry(REDUCE, 337);
   _actionMap[521][BEGIN] = ActionEntry(REDUCE, 337);
   _actionMap[521][THEN] = ActionEntry(REDUCE, 337);
   _actionMap[521][OR] = ActionEntry(REDUCE, 337);
   _actionMap[521][AND] = ActionEntry(REDUCE, 337);
   _actionMap[521][ENDTOKEN] = ActionEntry(REDUCE, 337);
   _actionMap[521][UNION] = ActionEntry(REDUCE, 337);
   _actionMap[521][ROWLIMIT] = ActionEntry(REDUCE, 337);
   _actionMap[521][ASC] = ActionEntry(REDUCE, 337);
   _actionMap[521][DESC] = ActionEntry(REDUCE, 337);
   _actionMap[521][INTOK] = ActionEntry(REDUCE, 337);
   _actionMap[521][BETWEEN] = ActionEntry(REDUCE, 337);
   _actionMap[521][LIKE] = ActionEntry(REDUCE, 337);
   _actionMap[521][PLUS] = ActionEntry(REDUCE, 337);
   _actionMap[521][MINUS] = ActionEntry(REDUCE, 337);
   _actionMap[521][CONCAT] = ActionEntry(REDUCE, 337);
   _actionMap[521][DIVISION] = ActionEntry(REDUCE, 337);
   _actionMap[521][STAR] = ActionEntry(REDUCE, 337);
   _actionMap[521][MT] = ActionEntry(REDUCE, 337);
   _actionMap[521][LT] = ActionEntry(REDUCE, 337);
   _actionMap[521][NEGATION] = ActionEntry(REDUCE, 337);
   _actionMap[521][EQU] = ActionEntry(REDUCE, 337);
   _actionMap[521][IS] = ActionEntry(REDUCE, 337);
   _actionMap[521][NULLTOKEN] = ActionEntry(REDUCE, 337);
   _actionMap[521][NOT] = ActionEntry(REDUCE, 337);
   _actionMap[521][KSEP] = ActionEntry(REDUCE, 337);
   _actionMap[521][SEMICOLON] = ActionEntry(REDUCE, 337);
   _actionMap[521][RB] = ActionEntry(REDUCE, 337);
   _actionMap[522][FLOATVAL] = ActionEntry(SHIFT, 262);
   _actionMap[523][WHEN] = ActionEntry(REDUCE, 336);
   _actionMap[523][ELSE] = ActionEntry(REDUCE, 336);
   _actionMap[523][LEFT] = ActionEntry(REDUCE, 336);
   _actionMap[523][RIGHT] = ActionEntry(REDUCE, 336);
   _actionMap[523][INNER] = ActionEntry(REDUCE, 336);
   _actionMap[523][JOIN] = ActionEntry(REDUCE, 336);
   _actionMap[523][RETURNTOKEN] = ActionEntry(REDUCE, 336);
   _actionMap[523][ORDER] = ActionEntry(REDUCE, 336);
   _actionMap[523][GROUP] = ActionEntry(REDUCE, 336);
   _actionMap[523][WHERE] = ActionEntry(REDUCE, 336);
   _actionMap[523][FROM] = ActionEntry(REDUCE, 336);
   _actionMap[523][AS] = ActionEntry(REDUCE, 336);
   _actionMap[523][END_TOKEN] = ActionEntry(REDUCE, 336);
   _actionMap[523][BEGIN] = ActionEntry(REDUCE, 336);
}
void Cego::loadParser109()
{
   _actionMap[523][THEN] = ActionEntry(REDUCE, 336);
   _actionMap[523][OR] = ActionEntry(REDUCE, 336);
   _actionMap[523][AND] = ActionEntry(REDUCE, 336);
   _actionMap[523][ENDTOKEN] = ActionEntry(REDUCE, 336);
   _actionMap[523][UNION] = ActionEntry(REDUCE, 336);
   _actionMap[523][ROWLIMIT] = ActionEntry(REDUCE, 336);
   _actionMap[523][ASC] = ActionEntry(REDUCE, 336);
   _actionMap[523][DESC] = ActionEntry(REDUCE, 336);
   _actionMap[523][INTOK] = ActionEntry(REDUCE, 336);
   _actionMap[523][BETWEEN] = ActionEntry(REDUCE, 336);
   _actionMap[523][LIKE] = ActionEntry(REDUCE, 336);
   _actionMap[523][PLUS] = ActionEntry(REDUCE, 336);
   _actionMap[523][MINUS] = ActionEntry(REDUCE, 336);
   _actionMap[523][CONCAT] = ActionEntry(REDUCE, 336);
   _actionMap[523][DIVISION] = ActionEntry(REDUCE, 336);
   _actionMap[523][STAR] = ActionEntry(REDUCE, 336);
   _actionMap[523][MT] = ActionEntry(REDUCE, 336);
   _actionMap[523][LT] = ActionEntry(REDUCE, 336);
   _actionMap[523][NEGATION] = ActionEntry(REDUCE, 336);
   _actionMap[523][EQU] = ActionEntry(REDUCE, 336);
   _actionMap[523][IS] = ActionEntry(REDUCE, 336);
   _actionMap[523][NULLTOKEN] = ActionEntry(REDUCE, 336);
   _actionMap[523][NOT] = ActionEntry(REDUCE, 336);
   _actionMap[523][KSEP] = ActionEntry(REDUCE, 336);
   _actionMap[523][SEMICOLON] = ActionEntry(REDUCE, 336);
   _actionMap[523][RB] = ActionEntry(REDUCE, 336);
   _actionMap[524][WHEN] = ActionEntry(REDUCE, 338);
   _actionMap[524][ELSE] = ActionEntry(REDUCE, 338);
   _actionMap[524][LEFT] = ActionEntry(REDUCE, 338);
   _actionMap[524][RIGHT] = ActionEntry(REDUCE, 338);
   _actionMap[524][INNER] = ActionEntry(REDUCE, 338);
   _actionMap[524][JOIN] = ActionEntry(REDUCE, 338);
   _actionMap[524][RETURNTOKEN] = ActionEntry(REDUCE, 338);
   _actionMap[524][ORDER] = ActionEntry(REDUCE, 338);
   _actionMap[524][GROUP] = ActionEntry(REDUCE, 338);
   _actionMap[524][WHERE] = ActionEntry(REDUCE, 338);
   _actionMap[524][FROM] = ActionEntry(REDUCE, 338);
   _actionMap[524][AS] = ActionEntry(REDUCE, 338);
   _actionMap[524][END_TOKEN] = ActionEntry(REDUCE, 338);
   _actionMap[524][BEGIN] = ActionEntry(REDUCE, 338);
   _actionMap[524][THEN] = ActionEntry(REDUCE, 338);
   _actionMap[524][OR] = ActionEntry(REDUCE, 338);
   _actionMap[524][AND] = ActionEntry(REDUCE, 338);
   _actionMap[524][ENDTOKEN] = ActionEntry(REDUCE, 338);
   _actionMap[524][UNION] = ActionEntry(REDUCE, 338);
   _actionMap[524][ROWLIMIT] = ActionEntry(REDUCE, 338);
   _actionMap[524][ASC] = ActionEntry(REDUCE, 338);
   _actionMap[524][DESC] = ActionEntry(REDUCE, 338);
   _actionMap[524][INTOK] = ActionEntry(REDUCE, 338);
   _actionMap[524][BETWEEN] = ActionEntry(REDUCE, 338);
}
void Cego::loadParser110()
{
   _actionMap[524][LIKE] = ActionEntry(REDUCE, 338);
   _actionMap[524][PLUS] = ActionEntry(REDUCE, 338);
   _actionMap[524][MINUS] = ActionEntry(REDUCE, 338);
   _actionMap[524][CONCAT] = ActionEntry(REDUCE, 338);
   _actionMap[524][DIVISION] = ActionEntry(REDUCE, 338);
   _actionMap[524][STAR] = ActionEntry(REDUCE, 338);
   _actionMap[524][MT] = ActionEntry(REDUCE, 338);
   _actionMap[524][LT] = ActionEntry(REDUCE, 338);
   _actionMap[524][NEGATION] = ActionEntry(REDUCE, 338);
   _actionMap[524][EQU] = ActionEntry(REDUCE, 338);
   _actionMap[524][IS] = ActionEntry(REDUCE, 338);
   _actionMap[524][NULLTOKEN] = ActionEntry(REDUCE, 338);
   _actionMap[524][NOT] = ActionEntry(REDUCE, 338);
   _actionMap[524][KSEP] = ActionEntry(REDUCE, 338);
   _actionMap[524][SEMICOLON] = ActionEntry(REDUCE, 338);
   _actionMap[524][RB] = ActionEntry(REDUCE, 338);
   _actionMap[525][WHEN] = ActionEntry(REDUCE, 330);
   _actionMap[525][ELSE] = ActionEntry(REDUCE, 330);
   _actionMap[525][LEFT] = ActionEntry(REDUCE, 330);
   _actionMap[525][RIGHT] = ActionEntry(REDUCE, 330);
   _actionMap[525][INNER] = ActionEntry(REDUCE, 330);
   _actionMap[525][JOIN] = ActionEntry(REDUCE, 330);
   _actionMap[525][RETURNTOKEN] = ActionEntry(REDUCE, 330);
   _actionMap[525][ORDER] = ActionEntry(REDUCE, 330);
   _actionMap[525][GROUP] = ActionEntry(REDUCE, 330);
   _actionMap[525][WHERE] = ActionEntry(REDUCE, 330);
   _actionMap[525][FROM] = ActionEntry(REDUCE, 330);
   _actionMap[525][AS] = ActionEntry(REDUCE, 330);
   _actionMap[525][END_TOKEN] = ActionEntry(REDUCE, 330);
   _actionMap[525][BEGIN] = ActionEntry(REDUCE, 330);
   _actionMap[525][THEN] = ActionEntry(REDUCE, 330);
   _actionMap[525][OR] = ActionEntry(REDUCE, 330);
   _actionMap[525][AND] = ActionEntry(REDUCE, 330);
   _actionMap[525][ENDTOKEN] = ActionEntry(REDUCE, 330);
   _actionMap[525][UNION] = ActionEntry(REDUCE, 330);
   _actionMap[525][ROWLIMIT] = ActionEntry(REDUCE, 330);
   _actionMap[525][ASC] = ActionEntry(REDUCE, 330);
   _actionMap[525][DESC] = ActionEntry(REDUCE, 330);
   _actionMap[525][INTOK] = ActionEntry(REDUCE, 330);
   _actionMap[525][BETWEEN] = ActionEntry(REDUCE, 330);
   _actionMap[525][LIKE] = ActionEntry(REDUCE, 330);
   _actionMap[525][PLUS] = ActionEntry(REDUCE, 330);
   _actionMap[525][MINUS] = ActionEntry(REDUCE, 330);
   _actionMap[525][CONCAT] = ActionEntry(REDUCE, 330);
   _actionMap[525][DIVISION] = ActionEntry(REDUCE, 330);
   _actionMap[525][STAR] = ActionEntry(REDUCE, 330);
   _actionMap[525][MT] = ActionEntry(REDUCE, 330);
   _actionMap[525][LT] = ActionEntry(REDUCE, 330);
   _actionMap[525][NEGATION] = ActionEntry(REDUCE, 330);
   _actionMap[525][EQU] = ActionEntry(REDUCE, 330);
}
void Cego::loadParser111()
{
   _actionMap[525][IS] = ActionEntry(REDUCE, 330);
   _actionMap[525][NULLTOKEN] = ActionEntry(REDUCE, 330);
   _actionMap[525][NOT] = ActionEntry(REDUCE, 330);
   _actionMap[525][KSEP] = ActionEntry(REDUCE, 330);
   _actionMap[525][SEMICOLON] = ActionEntry(REDUCE, 330);
   _actionMap[525][RB] = ActionEntry(REDUCE, 330);
   _actionMap[526][WHEN] = ActionEntry(REDUCE, 332);
   _actionMap[526][ELSE] = ActionEntry(REDUCE, 332);
   _actionMap[526][LEFT] = ActionEntry(REDUCE, 332);
   _actionMap[526][RIGHT] = ActionEntry(REDUCE, 332);
   _actionMap[526][INNER] = ActionEntry(REDUCE, 332);
   _actionMap[526][JOIN] = ActionEntry(REDUCE, 332);
   _actionMap[526][RETURNTOKEN] = ActionEntry(REDUCE, 332);
   _actionMap[526][ORDER] = ActionEntry(REDUCE, 332);
   _actionMap[526][GROUP] = ActionEntry(REDUCE, 332);
   _actionMap[526][WHERE] = ActionEntry(REDUCE, 332);
   _actionMap[526][FROM] = ActionEntry(REDUCE, 332);
   _actionMap[526][AS] = ActionEntry(REDUCE, 332);
   _actionMap[526][END_TOKEN] = ActionEntry(REDUCE, 332);
   _actionMap[526][BEGIN] = ActionEntry(REDUCE, 332);
   _actionMap[526][THEN] = ActionEntry(REDUCE, 332);
   _actionMap[526][OR] = ActionEntry(REDUCE, 332);
   _actionMap[526][AND] = ActionEntry(REDUCE, 332);
   _actionMap[526][ENDTOKEN] = ActionEntry(REDUCE, 332);
   _actionMap[526][UNION] = ActionEntry(REDUCE, 332);
   _actionMap[526][ROWLIMIT] = ActionEntry(REDUCE, 332);
   _actionMap[526][ASC] = ActionEntry(REDUCE, 332);
   _actionMap[526][DESC] = ActionEntry(REDUCE, 332);
   _actionMap[526][INTOK] = ActionEntry(REDUCE, 332);
   _actionMap[526][BETWEEN] = ActionEntry(REDUCE, 332);
   _actionMap[526][LIKE] = ActionEntry(REDUCE, 332);
   _actionMap[526][PLUS] = ActionEntry(REDUCE, 332);
   _actionMap[526][MINUS] = ActionEntry(REDUCE, 332);
   _actionMap[526][CONCAT] = ActionEntry(REDUCE, 332);
   _actionMap[526][DIVISION] = ActionEntry(REDUCE, 332);
   _actionMap[526][STAR] = ActionEntry(REDUCE, 332);
   _actionMap[526][MT] = ActionEntry(REDUCE, 332);
   _actionMap[526][LT] = ActionEntry(REDUCE, 332);
   _actionMap[526][NEGATION] = ActionEntry(REDUCE, 332);
   _actionMap[526][EQU] = ActionEntry(REDUCE, 332);
   _actionMap[526][IS] = ActionEntry(REDUCE, 332);
   _actionMap[526][NULLTOKEN] = ActionEntry(REDUCE, 332);
   _actionMap[526][NOT] = ActionEntry(REDUCE, 332);
   _actionMap[526][KSEP] = ActionEntry(REDUCE, 332);
   _actionMap[526][SEMICOLON] = ActionEntry(REDUCE, 332);
   _actionMap[526][RB] = ActionEntry(REDUCE, 332);
   _actionMap[527][WHEN] = ActionEntry(REDUCE, 333);
   _actionMap[527][ELSE] = ActionEntry(REDUCE, 333);
   _actionMap[527][LEFT] = ActionEntry(REDUCE, 333);
   _actionMap[527][RIGHT] = ActionEntry(REDUCE, 333);
}
void Cego::loadParser112()
{
   _actionMap[527][INNER] = ActionEntry(REDUCE, 333);
   _actionMap[527][JOIN] = ActionEntry(REDUCE, 333);
   _actionMap[527][RETURNTOKEN] = ActionEntry(REDUCE, 333);
   _actionMap[527][ORDER] = ActionEntry(REDUCE, 333);
   _actionMap[527][GROUP] = ActionEntry(REDUCE, 333);
   _actionMap[527][WHERE] = ActionEntry(REDUCE, 333);
   _actionMap[527][FROM] = ActionEntry(REDUCE, 333);
   _actionMap[527][AS] = ActionEntry(REDUCE, 333);
   _actionMap[527][END_TOKEN] = ActionEntry(REDUCE, 333);
   _actionMap[527][BEGIN] = ActionEntry(REDUCE, 333);
   _actionMap[527][THEN] = ActionEntry(REDUCE, 333);
   _actionMap[527][OR] = ActionEntry(REDUCE, 333);
   _actionMap[527][AND] = ActionEntry(REDUCE, 333);
   _actionMap[527][ENDTOKEN] = ActionEntry(REDUCE, 333);
   _actionMap[527][UNION] = ActionEntry(REDUCE, 333);
   _actionMap[527][ROWLIMIT] = ActionEntry(REDUCE, 333);
   _actionMap[527][ASC] = ActionEntry(REDUCE, 333);
   _actionMap[527][DESC] = ActionEntry(REDUCE, 333);
   _actionMap[527][INTOK] = ActionEntry(REDUCE, 333);
   _actionMap[527][BETWEEN] = ActionEntry(REDUCE, 333);
   _actionMap[527][LIKE] = ActionEntry(REDUCE, 333);
   _actionMap[527][PLUS] = ActionEntry(REDUCE, 333);
   _actionMap[527][MINUS] = ActionEntry(REDUCE, 333);
   _actionMap[527][CONCAT] = ActionEntry(REDUCE, 333);
   _actionMap[527][DIVISION] = ActionEntry(REDUCE, 333);
   _actionMap[527][STAR] = ActionEntry(REDUCE, 333);
   _actionMap[527][MT] = ActionEntry(REDUCE, 333);
   _actionMap[527][LT] = ActionEntry(REDUCE, 333);
   _actionMap[527][NEGATION] = ActionEntry(REDUCE, 333);
   _actionMap[527][EQU] = ActionEntry(REDUCE, 333);
   _actionMap[527][IS] = ActionEntry(REDUCE, 333);
   _actionMap[527][NULLTOKEN] = ActionEntry(REDUCE, 333);
   _actionMap[527][NOT] = ActionEntry(REDUCE, 333);
   _actionMap[527][KSEP] = ActionEntry(REDUCE, 333);
   _actionMap[527][SEMICOLON] = ActionEntry(REDUCE, 333);
   _actionMap[527][RB] = ActionEntry(REDUCE, 333);
   _actionMap[528][RAB] = ActionEntry(SHIFT, 633);
   _actionMap[529][SEMICOLON] = ActionEntry(REDUCE, 254);
   _actionMap[530][SEMICOLON] = ActionEntry(REDUCE, 250);
   _actionMap[531][SEMICOLON] = ActionEntry(REDUCE, 251);
   _actionMap[532][SEMICOLON] = ActionEntry(REDUCE, 252);
   _actionMap[533][SEMICOLON] = ActionEntry(REDUCE, 249);
   _actionMap[534][SEMICOLON] = ActionEntry(REDUCE, 253);
   _actionMap[535][SEMICOLON] = ActionEntry(REDUCE, 212);
   _actionMap[535][RB] = ActionEntry(REDUCE, 212);
   _actionMap[535][ENDTOKEN] = ActionEntry(REDUCE, 212);
   _actionMap[535][UNION] = ActionEntry(REDUCE, 212);
   _actionMap[535][ROWLIMIT] = ActionEntry(REDUCE, 212);
   _actionMap[535][ORDER] = ActionEntry(REDUCE, 212);
   _actionMap[535][GROUP] = ActionEntry(SHIFT, 636);
}
void Cego::loadParser113()
{
   _jumpMap[535][NoGroup] = 635;
   _jumpMap[535][GroupClause] = 634;
   _actionMap[536][LEFT] = ActionEntry(REDUCE, 196);
   _actionMap[536][RIGHT] = ActionEntry(REDUCE, 196);
   _actionMap[536][INNER] = ActionEntry(REDUCE, 196);
   _actionMap[536][JOIN] = ActionEntry(REDUCE, 196);
   _actionMap[536][RETURNTOKEN] = ActionEntry(REDUCE, 196);
   _actionMap[536][SEMICOLON] = ActionEntry(REDUCE, 196);
   _actionMap[536][RB] = ActionEntry(REDUCE, 196);
   _actionMap[536][ENDTOKEN] = ActionEntry(REDUCE, 196);
   _actionMap[536][UNION] = ActionEntry(REDUCE, 196);
   _actionMap[536][ROWLIMIT] = ActionEntry(REDUCE, 196);
   _actionMap[536][ORDER] = ActionEntry(REDUCE, 196);
   _actionMap[536][GROUP] = ActionEntry(REDUCE, 196);
   _actionMap[536][WHERE] = ActionEntry(REDUCE, 196);
   _actionMap[537][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[537][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[537][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[537][ObjSpec] = 407;
   _jumpMap[537][Table] = 637;
   _actionMap[538][JOIN] = ActionEntry(SHIFT, 638);
   _actionMap[539][IDENTIFIER] = ActionEntry(REDUCE, 202);
   _actionMap[539][QUALIFIEDOBJ] = ActionEntry(REDUCE, 202);
   _actionMap[539][QUALIFIEDTS] = ActionEntry(REDUCE, 202);
   _actionMap[540][OUTER] = ActionEntry(SHIFT, 639);
   _actionMap[541][OUTER] = ActionEntry(SHIFT, 640);
   _actionMap[542][LEFT] = ActionEntry(REDUCE, 197);
   _actionMap[542][RIGHT] = ActionEntry(REDUCE, 197);
   _actionMap[542][INNER] = ActionEntry(REDUCE, 197);
   _actionMap[542][JOIN] = ActionEntry(REDUCE, 197);
   _actionMap[542][RETURNTOKEN] = ActionEntry(REDUCE, 197);
   _actionMap[542][SEMICOLON] = ActionEntry(REDUCE, 197);
   _actionMap[542][RB] = ActionEntry(REDUCE, 197);
   _actionMap[542][ENDTOKEN] = ActionEntry(REDUCE, 197);
   _actionMap[542][UNION] = ActionEntry(REDUCE, 197);
   _actionMap[542][ROWLIMIT] = ActionEntry(REDUCE, 197);
   _actionMap[542][ORDER] = ActionEntry(REDUCE, 197);
   _actionMap[542][GROUP] = ActionEntry(REDUCE, 197);
   _actionMap[542][WHERE] = ActionEntry(REDUCE, 197);
   _actionMap[543][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[543][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[543][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[543][ObjSpec] = 407;
   _jumpMap[543][Table] = 642;
   _jumpMap[543][TableList] = 641;
   _actionMap[544][WHERE] = ActionEntry(REDUCE, 206);
   _actionMap[544][GROUP] = ActionEntry(REDUCE, 206);
   _actionMap[544][ORDER] = ActionEntry(REDUCE, 206);
   _actionMap[544][ROWLIMIT] = ActionEntry(REDUCE, 206);
   _actionMap[544][UNION] = ActionEntry(REDUCE, 206);
}
void Cego::loadParser114()
{
   _actionMap[544][ENDTOKEN] = ActionEntry(REDUCE, 206);
   _actionMap[544][RB] = ActionEntry(REDUCE, 206);
   _actionMap[544][SEMICOLON] = ActionEntry(REDUCE, 206);
   _actionMap[544][RETURNTOKEN] = ActionEntry(REDUCE, 206);
   _actionMap[544][LEFT] = ActionEntry(REDUCE, 206);
   _actionMap[544][RIGHT] = ActionEntry(REDUCE, 206);
   _actionMap[544][INNER] = ActionEntry(REDUCE, 206);
   _actionMap[544][JOIN] = ActionEntry(REDUCE, 206);
   _actionMap[544][KSEP] = ActionEntry(REDUCE, 206);
   _actionMap[544][ON] = ActionEntry(REDUCE, 206);
   _actionMap[545][FROM] = ActionEntry(REDUCE, 208);
   _actionMap[545][KSEP] = ActionEntry(REDUCE, 208);
   _actionMap[546][FROM] = ActionEntry(REDUCE, 191);
   _actionMap[546][KSEP] = ActionEntry(REDUCE, 191);
   _actionMap[547][RETURNTOKEN] = ActionEntry(SHIFT, 644);
   _actionMap[547][SEMICOLON] = ActionEntry(REDUCE, 237);
   _jumpMap[547][UpdReturnOpt] = 643;
   _actionMap[548][IDENTIFIER] = ActionEntry(SHIFT, 414);
   _jumpMap[548][Assignment] = 645;
   _actionMap[549][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[549][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[549][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[549][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[549][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[549][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[549][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[549][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[549][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[549][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[549][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[549][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[549][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[549][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[549][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[549][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[549][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[549][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[549][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[549][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[549][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[549][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[549][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[549][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[549][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[549][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[549][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[549][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[549][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[549][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[549][IDENTIFIER] = ActionEntry(SHIFT, 140);
}
void Cego::loadParser115()
{
   _actionMap[549][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[549][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[549][LB] = ActionEntry(SHIFT, 135);
   _actionMap[549][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[549][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[549][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[549][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[549][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[549][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[549][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[549][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[549][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[549][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[549][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[549][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[549][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[549][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[549][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[549][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[549][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[549][ObjSpec] = 94;
   _jumpMap[549][Constant] = 93;
   _jumpMap[549][SignedFloat] = 92;
   _jumpMap[549][SignedInt] = 91;
   _jumpMap[549][Attribute] = 90;
   _jumpMap[549][Function] = 89;
   _jumpMap[549][CasePrepare] = 88;
   _jumpMap[549][CaseClause] = 87;
   _jumpMap[549][Factor] = 86;
   _jumpMap[549][Term] = 85;
   _jumpMap[549][Expr] = 646;
   _actionMap[550][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[550][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[550][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[550][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[550][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[550][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[550][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[550][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[550][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[550][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[550][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[550][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[550][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[550][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[550][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[550][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[550][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[550][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[550][TRUNC] = ActionEntry(SHIFT, 133);
}
void Cego::loadParser116()
{
   _actionMap[550][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[550][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[550][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[550][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[550][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[550][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[550][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[550][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[550][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[550][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[550][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[550][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[550][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[550][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[550][LB] = ActionEntry(SHIFT, 135);
   _actionMap[550][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[550][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[550][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[550][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[550][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[550][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[550][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[550][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[550][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[550][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[550][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[550][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[550][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[550][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[550][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[550][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[550][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[550][RB] = ActionEntry(REDUCE, 108);
   _jumpMap[550][ObjSpec] = 94;
   _jumpMap[550][Constant] = 93;
   _jumpMap[550][SignedFloat] = 92;
   _jumpMap[550][SignedInt] = 91;
   _jumpMap[550][Attribute] = 90;
   _jumpMap[550][Function] = 89;
   _jumpMap[550][CasePrepare] = 88;
   _jumpMap[550][CaseClause] = 87;
   _jumpMap[550][Factor] = 86;
   _jumpMap[550][Term] = 85;
   _jumpMap[550][Expr] = 298;
   _jumpMap[550][ProcValueList] = 297;
   _jumpMap[550][ProcValueListOpt] = 647;
   _actionMap[288][SEMICOLON] = ActionEntry(REDUCE, 56);
   _actionMap[289][SEMICOLON] = ActionEntry(REDUCE, 242);
   _actionMap[290][KSEP] = ActionEntry(SHIFT, 416);
   _actionMap[290][SEMICOLON] = ActionEntry(REDUCE, 244);
}
void Cego::loadParser117()
{
   _actionMap[291][CHECK] = ActionEntry(SHIFT, 417);
   _actionMap[291][FOREIGN] = ActionEntry(SHIFT, 419);
   _actionMap[291][COLUMN] = ActionEntry(SHIFT, 418);
   _actionMap[292][COLUMN] = ActionEntry(SHIFT, 420);
   _actionMap[293][COLUMN] = ActionEntry(SHIFT, 421);
   _actionMap[294][COLUMN] = ActionEntry(SHIFT, 422);
   _actionMap[295][STRINGVAL] = ActionEntry(SHIFT, 423);
   _actionMap[296][RB] = ActionEntry(SHIFT, 299);
   _actionMap[297][KSEP] = ActionEntry(SHIFT, 424);
   _actionMap[297][RB] = ActionEntry(REDUCE, 107);
   _actionMap[298][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[298][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[298][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[298][KSEP] = ActionEntry(REDUCE, 110);
   _actionMap[298][RB] = ActionEntry(REDUCE, 110);
   _actionMap[299][SEMICOLON] = ActionEntry(REDUCE, 47);
   _actionMap[300][END_TOKEN] = ActionEntry(SHIFT, 425);
   _actionMap[301][EXCEPTION] = ActionEntry(REDUCE, 105);
   _actionMap[301][ELSE] = ActionEntry(REDUCE, 105);
   _actionMap[301][ELSIF] = ActionEntry(REDUCE, 105);
   _actionMap[301][END_TOKEN] = ActionEntry(REDUCE, 105);
   _actionMap[301][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[301][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[301][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[301][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[301][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[301][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[301][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[301][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[301][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[301][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[301][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[301][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[301][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[301][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[301][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[301][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[301][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[301][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[301][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[301][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[301][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[301][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[301][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[301][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[301][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[301][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[301][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[301][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[301][BITXOR] = ActionEntry(SHIFT, 99);
}
void Cego::loadParser118()
{
   _actionMap[301][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[301][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[301][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[301][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[301][LB] = ActionEntry(SHIFT, 135);
   _actionMap[301][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[301][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[301][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[301][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[301][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[301][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[301][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[301][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[301][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[301][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[301][VARREF] = ActionEntry(SHIFT, 320);
   _actionMap[301][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[301][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[301][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[301][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[301][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[301][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[301][IF] = ActionEntry(SHIFT, 315);
   _actionMap[301][BEGIN] = ActionEntry(SHIFT, 312);
   _actionMap[301][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[301][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[301][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[301][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[301][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[301][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[301][VAR] = ActionEntry(SHIFT, 318);
   _actionMap[301][CURSOR] = ActionEntry(SHIFT, 314);
   _actionMap[301][CLOSE] = ActionEntry(SHIFT, 313);
   _actionMap[301][NOOP] = ActionEntry(SHIFT, 316);
   _actionMap[301][RETURNTOKEN] = ActionEntry(SHIFT, 317);
   _actionMap[301][WHILE] = ActionEntry(SHIFT, 319);
   _jumpMap[301][ObjSpec] = 94;
   _jumpMap[301][Constant] = 93;
   _jumpMap[301][SignedFloat] = 92;
   _jumpMap[301][SignedInt] = 91;
   _jumpMap[301][Attribute] = 90;
   _jumpMap[301][Function] = 89;
   _jumpMap[301][DeleteStatement] = 311;
   _jumpMap[301][UpdateStatement] = 310;
   _jumpMap[301][InsertStatement] = 309;
   _jumpMap[301][RollbackStatement] = 308;
   _jumpMap[301][CommitStatement] = 307;
   _jumpMap[301][StartStatement] = 306;
   _jumpMap[301][CasePrepare] = 88;
   _jumpMap[301][CaseClause] = 87;
}
void Cego::loadParser119()
{
   _jumpMap[301][Factor] = 86;
   _jumpMap[301][Term] = 85;
   _jumpMap[301][Expr] = 305;
   _jumpMap[301][ProcStatement] = 427;
   _jumpMap[301][ProcIfPart] = 303;
   _jumpMap[301][ProcExceptionList] = 426;
   _jumpMap[301][ProcBlockStart] = 302;
   _actionMap[302][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[302][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[302][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[302][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[302][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[302][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[302][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[302][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[302][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[302][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[302][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[302][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[302][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[302][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[302][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[302][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[302][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[302][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[302][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[302][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[302][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[302][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[302][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[302][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[302][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[302][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[302][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[302][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[302][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[302][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[302][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[302][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[302][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[302][LB] = ActionEntry(SHIFT, 135);
   _actionMap[302][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[302][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[302][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[302][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[302][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[302][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[302][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[302][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[302][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
}
void Cego::loadParser120()
{
   _actionMap[302][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[302][VARREF] = ActionEntry(SHIFT, 320);
   _actionMap[302][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[302][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[302][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[302][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[302][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[302][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[302][IF] = ActionEntry(SHIFT, 315);
   _actionMap[302][BEGIN] = ActionEntry(SHIFT, 312);
   _actionMap[302][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[302][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[302][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[302][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[302][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[302][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[302][VAR] = ActionEntry(SHIFT, 318);
   _actionMap[302][CURSOR] = ActionEntry(SHIFT, 314);
   _actionMap[302][CLOSE] = ActionEntry(SHIFT, 313);
   _actionMap[302][NOOP] = ActionEntry(SHIFT, 316);
   _actionMap[302][RETURNTOKEN] = ActionEntry(SHIFT, 317);
   _actionMap[302][WHILE] = ActionEntry(SHIFT, 319);
   _jumpMap[302][ObjSpec] = 94;
   _jumpMap[302][Constant] = 93;
   _jumpMap[302][SignedFloat] = 92;
   _jumpMap[302][SignedInt] = 91;
   _jumpMap[302][Attribute] = 90;
   _jumpMap[302][Function] = 89;
   _jumpMap[302][DeleteStatement] = 311;
   _jumpMap[302][UpdateStatement] = 310;
   _jumpMap[302][InsertStatement] = 309;
   _jumpMap[302][RollbackStatement] = 308;
   _jumpMap[302][CommitStatement] = 307;
   _jumpMap[302][StartStatement] = 306;
   _jumpMap[302][CasePrepare] = 88;
   _jumpMap[302][CaseClause] = 87;
   _jumpMap[302][Factor] = 86;
   _jumpMap[302][Term] = 85;
   _jumpMap[302][Expr] = 305;
   _jumpMap[302][ProcStatement] = 304;
   _jumpMap[302][ProcIfPart] = 303;
   _jumpMap[302][ProcBlockStart] = 302;
   _jumpMap[302][ProcStatementList] = 301;
   _jumpMap[302][ProcStmtBlock] = 428;
   _actionMap[303][ELSIF] = ActionEntry(SHIFT, 431);
   _actionMap[303][END_TOKEN] = ActionEntry(REDUCE, 115);
   _actionMap[303][ELSE] = ActionEntry(REDUCE, 115);
   _jumpMap[303][ProcElsIfOpt] = 430;
   _jumpMap[303][ProcElsIfList] = 429;
   _actionMap[304][SEMICOLON] = ActionEntry(SHIFT, 432);
}
void Cego::loadParser121()
{
   _actionMap[305][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[305][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[305][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[305][SEMICOLON] = ActionEntry(REDUCE, 89);
   _actionMap[306][SEMICOLON] = ActionEntry(REDUCE, 97);
   _actionMap[307][SEMICOLON] = ActionEntry(REDUCE, 98);
   _actionMap[308][SEMICOLON] = ActionEntry(REDUCE, 99);
   _actionMap[309][SEMICOLON] = ActionEntry(REDUCE, 94);
   _actionMap[310][SEMICOLON] = ActionEntry(REDUCE, 96);
   _actionMap[311][SEMICOLON] = ActionEntry(REDUCE, 95);
   _actionMap[312][VAR] = ActionEntry(REDUCE, 103);
   _actionMap[312][CURSOR] = ActionEntry(REDUCE, 103);
   _actionMap[312][CLOSE] = ActionEntry(REDUCE, 103);
   _actionMap[312][VARREF] = ActionEntry(REDUCE, 103);
   _actionMap[312][NOOP] = ActionEntry(REDUCE, 103);
   _actionMap[312][RETURNTOKEN] = ActionEntry(REDUCE, 103);
   _actionMap[312][WHILE] = ActionEntry(REDUCE, 103);
   _actionMap[312][IF] = ActionEntry(REDUCE, 103);
   _actionMap[312][BEGIN] = ActionEntry(REDUCE, 103);
   _actionMap[312][ROLLBACK] = ActionEntry(REDUCE, 103);
   _actionMap[312][COMMIT] = ActionEntry(REDUCE, 103);
   _actionMap[312][START_TOKEN] = ActionEntry(REDUCE, 103);
   _actionMap[312][UPDATE] = ActionEntry(REDUCE, 103);
   _actionMap[312][DELETETOK] = ActionEntry(REDUCE, 103);
   _actionMap[312][INSERT] = ActionEntry(REDUCE, 103);
   _actionMap[312][FETCH] = ActionEntry(REDUCE, 103);
   _actionMap[312][LB] = ActionEntry(REDUCE, 103);
   _actionMap[312][COUNT] = ActionEntry(REDUCE, 103);
   _actionMap[312][SUM] = ActionEntry(REDUCE, 103);
   _actionMap[312][AVG] = ActionEntry(REDUCE, 103);
   _actionMap[312][MIN] = ActionEntry(REDUCE, 103);
   _actionMap[312][MAX] = ActionEntry(REDUCE, 103);
   _actionMap[312][CASE] = ActionEntry(REDUCE, 103);
   _actionMap[312][TRIM] = ActionEntry(REDUCE, 103);
   _actionMap[312][RTRIM] = ActionEntry(REDUCE, 103);
   _actionMap[312][LTRIM] = ActionEntry(REDUCE, 103);
   _actionMap[312][ROUND] = ActionEntry(REDUCE, 103);
   _actionMap[312][DATE2STR] = ActionEntry(REDUCE, 103);
   _actionMap[312][DATE2INT] = ActionEntry(REDUCE, 103);
   _actionMap[312][INT2DATE] = ActionEntry(REDUCE, 103);
   _actionMap[312][LOWER] = ActionEntry(REDUCE, 103);
   _actionMap[312][UPPER] = ActionEntry(REDUCE, 103);
   _actionMap[312][LEFT] = ActionEntry(REDUCE, 103);
   _actionMap[312][RIGHT] = ActionEntry(REDUCE, 103);
   _actionMap[312][GETPOS] = ActionEntry(REDUCE, 103);
   _actionMap[312][SUBSTR] = ActionEntry(REDUCE, 103);
   _actionMap[312][REPLACE] = ActionEntry(REDUCE, 103);
   _actionMap[312][LENGTH] = ActionEntry(REDUCE, 103);
   _actionMap[312][TRUNC] = ActionEntry(REDUCE, 103);
   _actionMap[312][STR2INT] = ActionEntry(REDUCE, 103);
}
void Cego::loadParser122()
{
   _actionMap[312][STR2LONG] = ActionEntry(REDUCE, 103);
   _actionMap[312][RANDSTR] = ActionEntry(REDUCE, 103);
   _actionMap[312][RANDINT] = ActionEntry(REDUCE, 103);
   _actionMap[312][MOD] = ActionEntry(REDUCE, 103);
   _actionMap[312][DIV] = ActionEntry(REDUCE, 103);
   _actionMap[312][POWER] = ActionEntry(REDUCE, 103);
   _actionMap[312][BITAND] = ActionEntry(REDUCE, 103);
   _actionMap[312][BITOR] = ActionEntry(REDUCE, 103);
   _actionMap[312][BITXOR] = ActionEntry(REDUCE, 103);
   _actionMap[312][NEXTCOUNT] = ActionEntry(REDUCE, 103);
   _actionMap[312][IDENTIFIER] = ActionEntry(REDUCE, 103);
   _actionMap[312][QUALIFIEDOBJ] = ActionEntry(REDUCE, 103);
   _actionMap[312][QUALIFIEDTS] = ActionEntry(REDUCE, 103);
   _actionMap[312][QUALIFIEDPRE] = ActionEntry(REDUCE, 103);
   _actionMap[312][STRINGVAL] = ActionEntry(REDUCE, 103);
   _actionMap[312][DATE] = ActionEntry(REDUCE, 103);
   _actionMap[312][SYSDATE] = ActionEntry(REDUCE, 103);
   _actionMap[312][NULLTOKEN] = ActionEntry(REDUCE, 103);
   _actionMap[312][TRUEVAL] = ActionEntry(REDUCE, 103);
   _actionMap[312][FALSEVAL] = ActionEntry(REDUCE, 103);
   _actionMap[312][LAB] = ActionEntry(REDUCE, 103);
   _actionMap[312][COUNTERID] = ActionEntry(REDUCE, 103);
   _actionMap[312][FLOATVAL] = ActionEntry(REDUCE, 103);
   _actionMap[312][MINUS] = ActionEntry(REDUCE, 103);
   _actionMap[312][INTVAL] = ActionEntry(REDUCE, 103);
   _actionMap[313][IDENTIFIER] = ActionEntry(SHIFT, 433);
   _actionMap[314][IDENTIFIER] = ActionEntry(SHIFT, 434);
   _actionMap[315][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[315][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[315][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[315][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[315][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[315][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[315][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[315][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[315][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[315][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[315][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[315][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[315][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[315][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[315][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[315][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[315][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[315][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[315][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[315][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[315][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[315][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[315][RANDINT] = ActionEntry(SHIFT, 121);
}
void Cego::loadParser123()
{
   _actionMap[315][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[315][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[315][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[315][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[315][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[315][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[315][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[315][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[315][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[315][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[315][LB] = ActionEntry(SHIFT, 439);
   _actionMap[315][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[315][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[315][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[315][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[315][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[315][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[315][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[315][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[315][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[315][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[315][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[315][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[315][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[315][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[315][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[315][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[315][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[315][ObjSpec] = 94;
   _jumpMap[315][Constant] = 93;
   _jumpMap[315][SignedFloat] = 92;
   _jumpMap[315][SignedInt] = 91;
   _jumpMap[315][Attribute] = 90;
   _jumpMap[315][Function] = 89;
   _jumpMap[315][CasePrepare] = 88;
   _jumpMap[315][CaseClause] = 87;
   _jumpMap[315][Factor] = 86;
   _jumpMap[315][Term] = 85;
   _jumpMap[315][Expr] = 438;
   _jumpMap[315][ProcPredicate] = 437;
   _jumpMap[315][ProcCondition] = 436;
   _jumpMap[315][ProcIfCondition] = 435;
   _actionMap[316][SEMICOLON] = ActionEntry(REDUCE, 90);
   _actionMap[317][SEMICOLON] = ActionEntry(REDUCE, 100);
   _actionMap[317][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[317][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[317][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[317][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[317][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[317][LTRIM] = ActionEntry(SHIFT, 113);
}
void Cego::loadParser124()
{
   _actionMap[317][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[317][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[317][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[317][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[317][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[317][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[317][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[317][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[317][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[317][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[317][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[317][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[317][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[317][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[317][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[317][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[317][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[317][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[317][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[317][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[317][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[317][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[317][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[317][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[317][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[317][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[317][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[317][LB] = ActionEntry(SHIFT, 135);
   _actionMap[317][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[317][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[317][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[317][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[317][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[317][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[317][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[317][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[317][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[317][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[317][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[317][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[317][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[317][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[317][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[317][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[317][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[317][ObjSpec] = 94;
   _jumpMap[317][Constant] = 93;
   _jumpMap[317][SignedFloat] = 92;
   _jumpMap[317][SignedInt] = 91;
   _jumpMap[317][Attribute] = 90;
}
void Cego::loadParser125()
{
   _jumpMap[317][Function] = 89;
   _jumpMap[317][CasePrepare] = 88;
   _jumpMap[317][CaseClause] = 87;
   _jumpMap[317][Factor] = 86;
   _jumpMap[317][Term] = 85;
   _jumpMap[317][Expr] = 440;
   _actionMap[318][IDENTIFIER] = ActionEntry(SHIFT, 441);
   _actionMap[319][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[319][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[319][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[319][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[319][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[319][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[319][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[319][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[319][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[319][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[319][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[319][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[319][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[319][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[319][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[319][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[319][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[319][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[319][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[319][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[319][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[319][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[319][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[319][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[319][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[319][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[319][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[319][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[319][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[319][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[319][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[319][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[319][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[319][LB] = ActionEntry(SHIFT, 439);
   _actionMap[319][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[319][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[319][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[319][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[319][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[319][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[319][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[319][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[319][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
}
void Cego::loadParser126()
{
   _actionMap[319][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[319][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[319][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[319][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[319][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[319][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[319][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[319][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[319][ObjSpec] = 94;
   _jumpMap[319][Constant] = 93;
   _jumpMap[319][SignedFloat] = 92;
   _jumpMap[319][SignedInt] = 91;
   _jumpMap[319][Attribute] = 90;
   _jumpMap[319][Function] = 89;
   _jumpMap[319][CasePrepare] = 88;
   _jumpMap[319][CaseClause] = 87;
   _jumpMap[319][Factor] = 86;
   _jumpMap[319][Term] = 85;
   _jumpMap[319][Expr] = 438;
   _jumpMap[319][ProcPredicate] = 437;
   _jumpMap[319][ProcCondition] = 443;
   _jumpMap[319][ProcWhileCondition] = 442;
   _actionMap[320][CONCAT] = ActionEntry(REDUCE, 138);
   _actionMap[320][STAR] = ActionEntry(REDUCE, 138);
   _actionMap[320][DIVISION] = ActionEntry(REDUCE, 138);
   _actionMap[320][MINUS] = ActionEntry(REDUCE, 138);
   _actionMap[320][PLUS] = ActionEntry(REDUCE, 138);
   _actionMap[320][SEMICOLON] = ActionEntry(REDUCE, 138);
   _actionMap[320][EQU] = ActionEntry(SHIFT, 444);
   _actionMap[321][ON] = ActionEntry(SHIFT, 445);
   _actionMap[322][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[322][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[322][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[322][ObjSpec] = 446;
   _actionMap[323][IDENTIFIER] = ActionEntry(SHIFT, 451);
   _actionMap[323][RB] = ActionEntry(REDUCE, 77);
   _jumpMap[323][ProcArg] = 449;
   _jumpMap[323][ProcArgList] = 448;
   _jumpMap[323][ProcArgOpt] = 447;
   _actionMap[324][IDENTIFIER] = ActionEntry(SHIFT, 456);
   _actionMap[324][PRIMARY] = ActionEntry(SHIFT, 455);
   _jumpMap[324][ColumnDesc] = 454;
   _jumpMap[324][KeyColumn] = 453;
   _jumpMap[324][ColumnList] = 452;
   _actionMap[325][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[325][SelectStatement] = 457;
   _actionMap[326][SEMICOLON] = ActionEntry(REDUCE, 241);
   _actionMap[327][RETURNTOKEN] = ActionEntry(REDUCE, 287);
   _actionMap[327][GROUP] = ActionEntry(REDUCE, 287);
   _actionMap[327][ORDER] = ActionEntry(REDUCE, 287);
}
void Cego::loadParser127()
{
   _actionMap[327][ROWLIMIT] = ActionEntry(REDUCE, 287);
   _actionMap[327][UNION] = ActionEntry(REDUCE, 287);
   _actionMap[327][ENDTOKEN] = ActionEntry(REDUCE, 287);
   _actionMap[327][RB] = ActionEntry(REDUCE, 287);
   _actionMap[327][SEMICOLON] = ActionEntry(REDUCE, 287);
   _actionMap[328][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[328][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[328][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[328][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[328][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[328][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[328][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[328][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[328][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[328][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[328][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[328][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[328][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[328][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[328][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[328][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[328][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[328][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[328][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[328][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[328][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[328][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[328][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[328][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[328][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[328][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[328][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[328][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[328][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[328][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[328][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[328][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[328][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[328][LB] = ActionEntry(SHIFT, 347);
   _actionMap[328][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[328][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[328][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[328][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[328][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[328][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[328][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[328][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[328][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[328][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[328][VARREF] = ActionEntry(SHIFT, 141);
}
void Cego::loadParser128()
{
   _actionMap[328][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[328][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[328][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[328][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[328][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[328][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[328][EXISTS] = ActionEntry(SHIFT, 345);
   _actionMap[328][NOT] = ActionEntry(SHIFT, 346);
   _jumpMap[328][ObjSpec] = 94;
   _jumpMap[328][Constant] = 93;
   _jumpMap[328][SignedFloat] = 92;
   _jumpMap[328][SignedInt] = 91;
   _jumpMap[328][Attribute] = 90;
   _jumpMap[328][QueryPredicate] = 344;
   _jumpMap[328][QueryCondition] = 458;
   _jumpMap[328][Function] = 89;
   _jumpMap[328][CasePrepare] = 88;
   _jumpMap[328][CaseClause] = 87;
   _jumpMap[328][Factor] = 86;
   _jumpMap[328][Term] = 85;
   _jumpMap[328][Expr] = 342;
   _actionMap[329][VALUES] = ActionEntry(SHIFT, 331);
   _actionMap[329][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[329][SelectStatement] = 330;
   _actionMap[330][SEMICOLON] = ActionEntry(REDUCE, 180);
   _actionMap[331][LB] = ActionEntry(SHIFT, 460);
   _jumpMap[331][InsertValueSpec] = 459;
   _actionMap[332][IDENTIFIER] = ActionEntry(SHIFT, 462);
   _jumpMap[332][InsertArgList] = 461;
   _actionMap[333][SEMICOLON] = ActionEntry(REDUCE, 11);
   _actionMap[334][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[334][SelectStatement] = 463;
   _actionMap[335][STAR] = ActionEntry(SHIFT, 211);
   _actionMap[335][DIVISION] = ActionEntry(SHIFT, 212);
   _actionMap[335][WHEN] = ActionEntry(REDUCE, 134);
   _actionMap[335][ELSE] = ActionEntry(REDUCE, 134);
   _actionMap[335][LEFT] = ActionEntry(REDUCE, 134);
   _actionMap[335][RIGHT] = ActionEntry(REDUCE, 134);
   _actionMap[335][INNER] = ActionEntry(REDUCE, 134);
   _actionMap[335][JOIN] = ActionEntry(REDUCE, 134);
   _actionMap[335][RETURNTOKEN] = ActionEntry(REDUCE, 134);
   _actionMap[335][ORDER] = ActionEntry(REDUCE, 134);
   _actionMap[335][GROUP] = ActionEntry(REDUCE, 134);
   _actionMap[335][WHERE] = ActionEntry(REDUCE, 134);
   _actionMap[335][BEGIN] = ActionEntry(REDUCE, 134);
   _actionMap[335][THEN] = ActionEntry(REDUCE, 134);
   _actionMap[335][OR] = ActionEntry(REDUCE, 134);
   _actionMap[335][AS] = ActionEntry(REDUCE, 134);
   _actionMap[335][FROM] = ActionEntry(REDUCE, 134);
   _actionMap[335][LIKE] = ActionEntry(REDUCE, 134);
}
void Cego::loadParser129()
{
   _actionMap[335][BETWEEN] = ActionEntry(REDUCE, 134);
   _actionMap[335][NOT] = ActionEntry(REDUCE, 134);
   _actionMap[335][INTOK] = ActionEntry(REDUCE, 134);
   _actionMap[335][END_TOKEN] = ActionEntry(REDUCE, 134);
   _actionMap[335][AND] = ActionEntry(REDUCE, 134);
   _actionMap[335][IS] = ActionEntry(REDUCE, 134);
   _actionMap[335][EQU] = ActionEntry(REDUCE, 134);
   _actionMap[335][NEGATION] = ActionEntry(REDUCE, 134);
   _actionMap[335][LT] = ActionEntry(REDUCE, 134);
   _actionMap[335][MT] = ActionEntry(REDUCE, 134);
   _actionMap[335][DESC] = ActionEntry(REDUCE, 134);
   _actionMap[335][ASC] = ActionEntry(REDUCE, 134);
   _actionMap[335][KSEP] = ActionEntry(REDUCE, 134);
   _actionMap[335][ROWLIMIT] = ActionEntry(REDUCE, 134);
   _actionMap[335][UNION] = ActionEntry(REDUCE, 134);
   _actionMap[335][ENDTOKEN] = ActionEntry(REDUCE, 134);
   _actionMap[335][RB] = ActionEntry(REDUCE, 134);
   _actionMap[335][SEMICOLON] = ActionEntry(REDUCE, 134);
   _actionMap[335][CONCAT] = ActionEntry(REDUCE, 134);
   _actionMap[335][MINUS] = ActionEntry(REDUCE, 134);
   _actionMap[335][PLUS] = ActionEntry(REDUCE, 134);
   _actionMap[336][STAR] = ActionEntry(SHIFT, 211);
   _actionMap[336][DIVISION] = ActionEntry(SHIFT, 212);
   _actionMap[336][WHEN] = ActionEntry(REDUCE, 132);
   _actionMap[336][ELSE] = ActionEntry(REDUCE, 132);
   _actionMap[336][LEFT] = ActionEntry(REDUCE, 132);
   _actionMap[336][RIGHT] = ActionEntry(REDUCE, 132);
   _actionMap[336][INNER] = ActionEntry(REDUCE, 132);
   _actionMap[336][JOIN] = ActionEntry(REDUCE, 132);
   _actionMap[336][RETURNTOKEN] = ActionEntry(REDUCE, 132);
   _actionMap[336][ORDER] = ActionEntry(REDUCE, 132);
   _actionMap[336][GROUP] = ActionEntry(REDUCE, 132);
   _actionMap[336][WHERE] = ActionEntry(REDUCE, 132);
   _actionMap[336][BEGIN] = ActionEntry(REDUCE, 132);
   _actionMap[336][THEN] = ActionEntry(REDUCE, 132);
   _actionMap[336][OR] = ActionEntry(REDUCE, 132);
   _actionMap[336][AS] = ActionEntry(REDUCE, 132);
   _actionMap[336][FROM] = ActionEntry(REDUCE, 132);
   _actionMap[336][LIKE] = ActionEntry(REDUCE, 132);
   _actionMap[336][BETWEEN] = ActionEntry(REDUCE, 132);
   _actionMap[336][NOT] = ActionEntry(REDUCE, 132);
   _actionMap[336][INTOK] = ActionEntry(REDUCE, 132);
   _actionMap[336][END_TOKEN] = ActionEntry(REDUCE, 132);
   _actionMap[336][AND] = ActionEntry(REDUCE, 132);
   _actionMap[336][IS] = ActionEntry(REDUCE, 132);
   _actionMap[336][EQU] = ActionEntry(REDUCE, 132);
   _actionMap[336][NEGATION] = ActionEntry(REDUCE, 132);
   _actionMap[336][LT] = ActionEntry(REDUCE, 132);
   _actionMap[336][MT] = ActionEntry(REDUCE, 132);
   _actionMap[336][DESC] = ActionEntry(REDUCE, 132);
}
void Cego::loadParser130()
{
   _actionMap[336][ASC] = ActionEntry(REDUCE, 132);
   _actionMap[336][KSEP] = ActionEntry(REDUCE, 132);
   _actionMap[336][ROWLIMIT] = ActionEntry(REDUCE, 132);
   _actionMap[336][UNION] = ActionEntry(REDUCE, 132);
   _actionMap[336][ENDTOKEN] = ActionEntry(REDUCE, 132);
   _actionMap[336][RB] = ActionEntry(REDUCE, 132);
   _actionMap[336][SEMICOLON] = ActionEntry(REDUCE, 132);
   _actionMap[336][CONCAT] = ActionEntry(REDUCE, 132);
   _actionMap[336][MINUS] = ActionEntry(REDUCE, 132);
   _actionMap[336][PLUS] = ActionEntry(REDUCE, 132);
   _actionMap[337][STAR] = ActionEntry(SHIFT, 211);
   _actionMap[337][DIVISION] = ActionEntry(SHIFT, 212);
   _actionMap[337][WHEN] = ActionEntry(REDUCE, 131);
   _actionMap[337][ELSE] = ActionEntry(REDUCE, 131);
   _actionMap[337][LEFT] = ActionEntry(REDUCE, 131);
   _actionMap[337][RIGHT] = ActionEntry(REDUCE, 131);
   _actionMap[337][INNER] = ActionEntry(REDUCE, 131);
   _actionMap[337][JOIN] = ActionEntry(REDUCE, 131);
   _actionMap[337][RETURNTOKEN] = ActionEntry(REDUCE, 131);
   _actionMap[337][ORDER] = ActionEntry(REDUCE, 131);
   _actionMap[337][GROUP] = ActionEntry(REDUCE, 131);
   _actionMap[337][WHERE] = ActionEntry(REDUCE, 131);
   _actionMap[337][BEGIN] = ActionEntry(REDUCE, 131);
   _actionMap[337][THEN] = ActionEntry(REDUCE, 131);
   _actionMap[337][OR] = ActionEntry(REDUCE, 131);
   _actionMap[337][AS] = ActionEntry(REDUCE, 131);
   _actionMap[337][FROM] = ActionEntry(REDUCE, 131);
   _actionMap[337][LIKE] = ActionEntry(REDUCE, 131);
   _actionMap[337][BETWEEN] = ActionEntry(REDUCE, 131);
   _actionMap[337][NOT] = ActionEntry(REDUCE, 131);
   _actionMap[337][INTOK] = ActionEntry(REDUCE, 131);
   _actionMap[337][END_TOKEN] = ActionEntry(REDUCE, 131);
   _actionMap[337][AND] = ActionEntry(REDUCE, 131);
   _actionMap[337][IS] = ActionEntry(REDUCE, 131);
   _actionMap[337][EQU] = ActionEntry(REDUCE, 131);
   _actionMap[337][NEGATION] = ActionEntry(REDUCE, 131);
   _actionMap[337][LT] = ActionEntry(REDUCE, 131);
   _actionMap[337][MT] = ActionEntry(REDUCE, 131);
   _actionMap[337][DESC] = ActionEntry(REDUCE, 131);
   _actionMap[337][ASC] = ActionEntry(REDUCE, 131);
   _actionMap[337][KSEP] = ActionEntry(REDUCE, 131);
   _actionMap[337][ROWLIMIT] = ActionEntry(REDUCE, 131);
   _actionMap[337][UNION] = ActionEntry(REDUCE, 131);
   _actionMap[337][ENDTOKEN] = ActionEntry(REDUCE, 131);
   _actionMap[337][RB] = ActionEntry(REDUCE, 131);
   _actionMap[337][SEMICOLON] = ActionEntry(REDUCE, 131);
   _actionMap[337][CONCAT] = ActionEntry(REDUCE, 131);
   _actionMap[337][MINUS] = ActionEntry(REDUCE, 131);
   _actionMap[337][PLUS] = ActionEntry(REDUCE, 131);
   _actionMap[338][WHEN] = ActionEntry(REDUCE, 135);
}
void Cego::loadParser131()
{
   _actionMap[338][ELSE] = ActionEntry(REDUCE, 135);
   _actionMap[338][LEFT] = ActionEntry(REDUCE, 135);
   _actionMap[338][RIGHT] = ActionEntry(REDUCE, 135);
   _actionMap[338][INNER] = ActionEntry(REDUCE, 135);
   _actionMap[338][JOIN] = ActionEntry(REDUCE, 135);
   _actionMap[338][RETURNTOKEN] = ActionEntry(REDUCE, 135);
   _actionMap[338][ORDER] = ActionEntry(REDUCE, 135);
   _actionMap[338][GROUP] = ActionEntry(REDUCE, 135);
   _actionMap[338][WHERE] = ActionEntry(REDUCE, 135);
   _actionMap[338][BEGIN] = ActionEntry(REDUCE, 135);
   _actionMap[338][THEN] = ActionEntry(REDUCE, 135);
   _actionMap[338][OR] = ActionEntry(REDUCE, 135);
   _actionMap[338][FROM] = ActionEntry(REDUCE, 135);
   _actionMap[338][AS] = ActionEntry(REDUCE, 135);
   _actionMap[338][END_TOKEN] = ActionEntry(REDUCE, 135);
   _actionMap[338][AND] = ActionEntry(REDUCE, 135);
   _actionMap[338][INTOK] = ActionEntry(REDUCE, 135);
   _actionMap[338][NOT] = ActionEntry(REDUCE, 135);
   _actionMap[338][BETWEEN] = ActionEntry(REDUCE, 135);
   _actionMap[338][IS] = ActionEntry(REDUCE, 135);
   _actionMap[338][LIKE] = ActionEntry(REDUCE, 135);
   _actionMap[338][MT] = ActionEntry(REDUCE, 135);
   _actionMap[338][LT] = ActionEntry(REDUCE, 135);
   _actionMap[338][NEGATION] = ActionEntry(REDUCE, 135);
   _actionMap[338][EQU] = ActionEntry(REDUCE, 135);
   _actionMap[338][RB] = ActionEntry(REDUCE, 135);
   _actionMap[338][ENDTOKEN] = ActionEntry(REDUCE, 135);
   _actionMap[338][UNION] = ActionEntry(REDUCE, 135);
   _actionMap[338][ROWLIMIT] = ActionEntry(REDUCE, 135);
   _actionMap[338][KSEP] = ActionEntry(REDUCE, 135);
   _actionMap[338][ASC] = ActionEntry(REDUCE, 135);
   _actionMap[338][DESC] = ActionEntry(REDUCE, 135);
   _actionMap[338][SEMICOLON] = ActionEntry(REDUCE, 135);
   _actionMap[338][PLUS] = ActionEntry(REDUCE, 135);
   _actionMap[338][MINUS] = ActionEntry(REDUCE, 135);
   _actionMap[338][CONCAT] = ActionEntry(REDUCE, 135);
   _actionMap[338][DIVISION] = ActionEntry(REDUCE, 135);
   _actionMap[338][STAR] = ActionEntry(REDUCE, 135);
   _actionMap[339][WHEN] = ActionEntry(REDUCE, 136);
   _actionMap[339][ELSE] = ActionEntry(REDUCE, 136);
   _actionMap[339][LEFT] = ActionEntry(REDUCE, 136);
   _actionMap[339][RIGHT] = ActionEntry(REDUCE, 136);
   _actionMap[339][INNER] = ActionEntry(REDUCE, 136);
   _actionMap[339][JOIN] = ActionEntry(REDUCE, 136);
   _actionMap[339][RETURNTOKEN] = ActionEntry(REDUCE, 136);
   _actionMap[339][ORDER] = ActionEntry(REDUCE, 136);
   _actionMap[339][GROUP] = ActionEntry(REDUCE, 136);
   _actionMap[339][WHERE] = ActionEntry(REDUCE, 136);
   _actionMap[339][BEGIN] = ActionEntry(REDUCE, 136);
   _actionMap[339][THEN] = ActionEntry(REDUCE, 136);
}
void Cego::loadParser132()
{
   _actionMap[339][OR] = ActionEntry(REDUCE, 136);
   _actionMap[339][FROM] = ActionEntry(REDUCE, 136);
   _actionMap[339][AS] = ActionEntry(REDUCE, 136);
   _actionMap[339][END_TOKEN] = ActionEntry(REDUCE, 136);
   _actionMap[339][AND] = ActionEntry(REDUCE, 136);
   _actionMap[339][INTOK] = ActionEntry(REDUCE, 136);
   _actionMap[339][NOT] = ActionEntry(REDUCE, 136);
   _actionMap[339][BETWEEN] = ActionEntry(REDUCE, 136);
   _actionMap[339][IS] = ActionEntry(REDUCE, 136);
   _actionMap[339][LIKE] = ActionEntry(REDUCE, 136);
   _actionMap[339][MT] = ActionEntry(REDUCE, 136);
   _actionMap[339][LT] = ActionEntry(REDUCE, 136);
   _actionMap[339][NEGATION] = ActionEntry(REDUCE, 136);
   _actionMap[339][EQU] = ActionEntry(REDUCE, 136);
   _actionMap[339][RB] = ActionEntry(REDUCE, 136);
   _actionMap[339][ENDTOKEN] = ActionEntry(REDUCE, 136);
   _actionMap[339][UNION] = ActionEntry(REDUCE, 136);
   _actionMap[339][ROWLIMIT] = ActionEntry(REDUCE, 136);
   _actionMap[339][KSEP] = ActionEntry(REDUCE, 136);
   _actionMap[339][ASC] = ActionEntry(REDUCE, 136);
   _actionMap[339][DESC] = ActionEntry(REDUCE, 136);
   _actionMap[339][SEMICOLON] = ActionEntry(REDUCE, 136);
   _actionMap[339][PLUS] = ActionEntry(REDUCE, 136);
   _actionMap[339][MINUS] = ActionEntry(REDUCE, 136);
   _actionMap[339][CONCAT] = ActionEntry(REDUCE, 136);
   _actionMap[339][DIVISION] = ActionEntry(REDUCE, 136);
   _actionMap[339][STAR] = ActionEntry(REDUCE, 136);
   _actionMap[340][WHEN] = ActionEntry(REDUCE, 153);
   _actionMap[340][ELSE] = ActionEntry(REDUCE, 153);
   _actionMap[341][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[341][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[341][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[341][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[341][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[341][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[341][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[341][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[341][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[341][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[341][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[341][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[341][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[341][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[341][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[341][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[341][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[341][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[341][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[341][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[341][STR2LONG] = ActionEntry(SHIFT, 130);
}
void Cego::loadParser133()
{
   _actionMap[341][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[341][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[341][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[341][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[341][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[341][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[341][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[341][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[341][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[341][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[341][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[341][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[341][LB] = ActionEntry(SHIFT, 135);
   _actionMap[341][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[341][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[341][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[341][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[341][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[341][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[341][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[341][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[341][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[341][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[341][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[341][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[341][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[341][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[341][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[341][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[341][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[341][ObjSpec] = 94;
   _jumpMap[341][Constant] = 93;
   _jumpMap[341][SignedFloat] = 92;
   _jumpMap[341][SignedInt] = 91;
   _jumpMap[341][Attribute] = 90;
   _jumpMap[341][Function] = 89;
   _jumpMap[341][CasePrepare] = 88;
   _jumpMap[341][CaseClause] = 87;
   _jumpMap[341][Factor] = 86;
   _jumpMap[341][Term] = 85;
   _jumpMap[341][Expr] = 464;
   _actionMap[342][INTOK] = ActionEntry(SHIFT, 467);
   _actionMap[342][NOT] = ActionEntry(SHIFT, 470);
   _actionMap[342][BETWEEN] = ActionEntry(SHIFT, 466);
   _actionMap[342][IS] = ActionEntry(SHIFT, 468);
   _actionMap[342][LIKE] = ActionEntry(SHIFT, 469);
   _actionMap[342][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[342][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[342][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[342][EQU] = ActionEntry(SHIFT, 471);
}
void Cego::loadParser134()
{
   _actionMap[342][NEGATION] = ActionEntry(SHIFT, 474);
   _actionMap[342][LT] = ActionEntry(SHIFT, 472);
   _actionMap[342][MT] = ActionEntry(SHIFT, 473);
   _jumpMap[342][Comparison] = 465;
   _actionMap[343][THEN] = ActionEntry(SHIFT, 477);
   _actionMap[343][AND] = ActionEntry(SHIFT, 475);
   _actionMap[343][OR] = ActionEntry(SHIFT, 476);
   _actionMap[344][THEN] = ActionEntry(REDUCE, 291);
   _actionMap[344][LEFT] = ActionEntry(REDUCE, 291);
   _actionMap[344][RIGHT] = ActionEntry(REDUCE, 291);
   _actionMap[344][INNER] = ActionEntry(REDUCE, 291);
   _actionMap[344][JOIN] = ActionEntry(REDUCE, 291);
   _actionMap[344][RETURNTOKEN] = ActionEntry(REDUCE, 291);
   _actionMap[344][SEMICOLON] = ActionEntry(REDUCE, 291);
   _actionMap[344][RB] = ActionEntry(REDUCE, 291);
   _actionMap[344][ENDTOKEN] = ActionEntry(REDUCE, 291);
   _actionMap[344][UNION] = ActionEntry(REDUCE, 291);
   _actionMap[344][ROWLIMIT] = ActionEntry(REDUCE, 291);
   _actionMap[344][ORDER] = ActionEntry(REDUCE, 291);
   _actionMap[344][GROUP] = ActionEntry(REDUCE, 291);
   _actionMap[344][WHERE] = ActionEntry(REDUCE, 291);
   _actionMap[344][OR] = ActionEntry(REDUCE, 291);
   _actionMap[344][AND] = ActionEntry(REDUCE, 291);
   _actionMap[345][LB] = ActionEntry(SHIFT, 478);
   _actionMap[346][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[346][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[346][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[346][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[346][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[346][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[346][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[346][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[346][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[346][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[346][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[346][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[346][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[346][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[346][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[346][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[346][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[346][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[346][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[346][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[346][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[346][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[346][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[346][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[346][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[346][POWER] = ActionEntry(SHIFT, 119);
}
void Cego::loadParser135()
{
   _actionMap[346][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[346][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[346][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[346][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[346][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[346][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[346][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[346][LB] = ActionEntry(SHIFT, 347);
   _actionMap[346][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[346][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[346][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[346][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[346][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[346][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[346][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[346][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[346][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[346][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[346][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[346][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[346][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[346][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[346][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[346][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[346][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[346][EXISTS] = ActionEntry(SHIFT, 345);
   _actionMap[346][NOT] = ActionEntry(SHIFT, 346);
   _jumpMap[346][ObjSpec] = 94;
   _jumpMap[346][Constant] = 93;
   _jumpMap[346][SignedFloat] = 92;
   _jumpMap[346][SignedInt] = 91;
   _jumpMap[346][Attribute] = 90;
   _jumpMap[346][QueryPredicate] = 479;
   _jumpMap[346][Function] = 89;
   _jumpMap[346][CasePrepare] = 88;
   _jumpMap[346][CaseClause] = 87;
   _jumpMap[346][Factor] = 86;
   _jumpMap[346][Term] = 85;
   _jumpMap[346][Expr] = 342;
   _actionMap[347][LONG] = ActionEntry(SHIFT, 257);
   _actionMap[347][BIGINT] = ActionEntry(SHIFT, 253);
   _actionMap[347][SMALLINT] = ActionEntry(SHIFT, 258);
   _actionMap[347][TINYINT] = ActionEntry(SHIFT, 259);
   _actionMap[347][DOUBLE] = ActionEntry(SHIFT, 255);
   _actionMap[347][DECIMAL] = ActionEntry(SHIFT, 254);
   _actionMap[347][FIXED] = ActionEntry(SHIFT, 256);
   _actionMap[347][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[347][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[347][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[347][TRIM] = ActionEntry(SHIFT, 131);
}
void Cego::loadParser136()
{
   _actionMap[347][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[347][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[347][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[347][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[347][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[347][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[347][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[347][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[347][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[347][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[347][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[347][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[347][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[347][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[347][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[347][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[347][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[347][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[347][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[347][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[347][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[347][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[347][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[347][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[347][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[347][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[347][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[347][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[347][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[347][LB] = ActionEntry(SHIFT, 347);
   _actionMap[347][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[347][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[347][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[347][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[347][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[347][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[347][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[347][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[347][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[347][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[347][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[347][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[347][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[347][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[347][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[347][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[347][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[347][SELECT] = ActionEntry(SHIFT, 30);
   _actionMap[347][EXISTS] = ActionEntry(SHIFT, 345);
   _actionMap[347][NOT] = ActionEntry(SHIFT, 346);
}
void Cego::loadParser137()
{
   _jumpMap[347][ObjSpec] = 94;
   _jumpMap[347][Constant] = 93;
   _jumpMap[347][SignedFloat] = 92;
   _jumpMap[347][SignedInt] = 91;
   _jumpMap[347][Attribute] = 90;
   _jumpMap[347][QueryPredicate] = 344;
   _jumpMap[347][QueryCondition] = 481;
   _jumpMap[347][Function] = 89;
   _jumpMap[347][SelectStatement] = 252;
   _jumpMap[347][CasePrepare] = 88;
   _jumpMap[347][CaseClause] = 87;
   _jumpMap[347][Factor] = 86;
   _jumpMap[347][Term] = 85;
   _jumpMap[347][Expr] = 480;
   _actionMap[348][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[348][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[348][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[348][KSEP] = ActionEntry(REDUCE, 285);
   _actionMap[348][RB] = ActionEntry(REDUCE, 285);
   _actionMap[349][RB] = ActionEntry(SHIFT, 483);
   _actionMap[349][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[350][WHEN] = ActionEntry(REDUCE, 283);
   _actionMap[350][ELSE] = ActionEntry(REDUCE, 283);
   _actionMap[350][LEFT] = ActionEntry(REDUCE, 283);
   _actionMap[350][RIGHT] = ActionEntry(REDUCE, 283);
   _actionMap[350][INNER] = ActionEntry(REDUCE, 283);
   _actionMap[350][JOIN] = ActionEntry(REDUCE, 283);
   _actionMap[350][RETURNTOKEN] = ActionEntry(REDUCE, 283);
   _actionMap[350][ORDER] = ActionEntry(REDUCE, 283);
   _actionMap[350][GROUP] = ActionEntry(REDUCE, 283);
   _actionMap[350][WHERE] = ActionEntry(REDUCE, 283);
   _actionMap[350][FROM] = ActionEntry(REDUCE, 283);
   _actionMap[350][AS] = ActionEntry(REDUCE, 283);
   _actionMap[350][END_TOKEN] = ActionEntry(REDUCE, 283);
   _actionMap[350][BEGIN] = ActionEntry(REDUCE, 283);
   _actionMap[350][THEN] = ActionEntry(REDUCE, 283);
   _actionMap[350][OR] = ActionEntry(REDUCE, 283);
   _actionMap[350][AND] = ActionEntry(REDUCE, 283);
   _actionMap[350][INTOK] = ActionEntry(REDUCE, 283);
   _actionMap[350][NOT] = ActionEntry(REDUCE, 283);
   _actionMap[350][BETWEEN] = ActionEntry(REDUCE, 283);
   _actionMap[350][IS] = ActionEntry(REDUCE, 283);
   _actionMap[350][LIKE] = ActionEntry(REDUCE, 283);
   _actionMap[350][MT] = ActionEntry(REDUCE, 283);
   _actionMap[350][LT] = ActionEntry(REDUCE, 283);
   _actionMap[350][NEGATION] = ActionEntry(REDUCE, 283);
   _actionMap[350][EQU] = ActionEntry(REDUCE, 283);
   _actionMap[350][RB] = ActionEntry(REDUCE, 283);
   _actionMap[350][ENDTOKEN] = ActionEntry(REDUCE, 283);
   _actionMap[350][UNION] = ActionEntry(REDUCE, 283);
}
void Cego::loadParser138()
{
   _actionMap[350][ROWLIMIT] = ActionEntry(REDUCE, 283);
   _actionMap[350][KSEP] = ActionEntry(REDUCE, 283);
   _actionMap[350][ASC] = ActionEntry(REDUCE, 283);
   _actionMap[350][DESC] = ActionEntry(REDUCE, 283);
   _actionMap[350][SEMICOLON] = ActionEntry(REDUCE, 283);
   _actionMap[350][PLUS] = ActionEntry(REDUCE, 283);
   _actionMap[350][MINUS] = ActionEntry(REDUCE, 283);
   _actionMap[350][DIVISION] = ActionEntry(REDUCE, 283);
   _actionMap[350][STAR] = ActionEntry(REDUCE, 283);
   _actionMap[350][CONCAT] = ActionEntry(REDUCE, 283);
   _actionMap[351][RB] = ActionEntry(SHIFT, 484);
   _actionMap[351][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[351][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[351][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[352][RB] = ActionEntry(SHIFT, 485);
   _actionMap[352][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[353][RB] = ActionEntry(SHIFT, 486);
   _actionMap[353][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[354][RB] = ActionEntry(SHIFT, 487);
   _actionMap[354][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[355][RB] = ActionEntry(SHIFT, 488);
   _actionMap[355][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[355][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[355][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[356][RB] = ActionEntry(SHIFT, 489);
   _actionMap[357][KSEP] = ActionEntry(SHIFT, 490);
   _actionMap[358][KSEP] = ActionEntry(REDUCE, 346);
   _actionMap[359][RB] = ActionEntry(SHIFT, 491);
   _actionMap[359][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[360][RB] = ActionEntry(SHIFT, 492);
   _actionMap[360][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[361][RB] = ActionEntry(SHIFT, 493);
   _actionMap[361][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[362][LB] = ActionEntry(SHIFT, 494);
   _actionMap[363][RB] = ActionEntry(SHIFT, 495);
   _actionMap[363][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[364][RB] = ActionEntry(SHIFT, 496);
   _actionMap[364][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[365][RB] = ActionEntry(SHIFT, 497);
   _actionMap[365][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[366][RB] = ActionEntry(SHIFT, 498);
   _actionMap[366][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[367][RB] = ActionEntry(SHIFT, 499);
   _actionMap[367][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[368][RB] = ActionEntry(SHIFT, 500);
   _actionMap[368][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[369][RB] = ActionEntry(SHIFT, 501);
   _actionMap[369][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[369][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[369][CONCAT] = ActionEntry(SHIFT, 208);
}
void Cego::loadParser139()
{
   _actionMap[370][RB] = ActionEntry(SHIFT, 502);
   _actionMap[370][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[370][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[370][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[371][RB] = ActionEntry(SHIFT, 503);
   _actionMap[371][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[372][RB] = ActionEntry(SHIFT, 504);
   _actionMap[373][RB] = ActionEntry(SHIFT, 505);
   _actionMap[373][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[374][RB] = ActionEntry(SHIFT, 506);
   _actionMap[374][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[375][RB] = ActionEntry(SHIFT, 507);
   _actionMap[375][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[376][RB] = ActionEntry(SHIFT, 508);
   _actionMap[376][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[377][RB] = ActionEntry(SHIFT, 509);
   _actionMap[377][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[378][RB] = ActionEntry(SHIFT, 510);
   _actionMap[378][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[379][RB] = ActionEntry(SHIFT, 511);
   _actionMap[379][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[380][RB] = ActionEntry(SHIFT, 512);
   _actionMap[380][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[381][RB] = ActionEntry(SHIFT, 513);
   _actionMap[381][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[381][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[381][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[382][RB] = ActionEntry(SHIFT, 514);
   _actionMap[382][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[383][RB] = ActionEntry(SHIFT, 515);
   _actionMap[383][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[384][RB] = ActionEntry(SHIFT, 516);
   _actionMap[384][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[385][RB] = ActionEntry(SHIFT, 517);
   _actionMap[385][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[386][RB] = ActionEntry(SHIFT, 518);
   _actionMap[386][KSEP] = ActionEntry(SHIFT, 482);
   _actionMap[387][WHEN] = ActionEntry(REDUCE, 143);
   _actionMap[387][ELSE] = ActionEntry(REDUCE, 143);
   _actionMap[387][LEFT] = ActionEntry(REDUCE, 143);
   _actionMap[387][RIGHT] = ActionEntry(REDUCE, 143);
   _actionMap[387][INNER] = ActionEntry(REDUCE, 143);
   _actionMap[387][JOIN] = ActionEntry(REDUCE, 143);
   _actionMap[387][RETURNTOKEN] = ActionEntry(REDUCE, 143);
   _actionMap[387][ORDER] = ActionEntry(REDUCE, 143);
   _actionMap[387][GROUP] = ActionEntry(REDUCE, 143);
   _actionMap[387][WHERE] = ActionEntry(REDUCE, 143);
   _actionMap[387][AS] = ActionEntry(REDUCE, 143);
   _actionMap[387][FROM] = ActionEntry(REDUCE, 143);
   _actionMap[387][END_TOKEN] = ActionEntry(REDUCE, 143);
}
void Cego::loadParser140()
{
   _actionMap[387][BEGIN] = ActionEntry(REDUCE, 143);
   _actionMap[387][THEN] = ActionEntry(REDUCE, 143);
   _actionMap[387][OR] = ActionEntry(REDUCE, 143);
   _actionMap[387][AND] = ActionEntry(REDUCE, 143);
   _actionMap[387][DESC] = ActionEntry(REDUCE, 143);
   _actionMap[387][ASC] = ActionEntry(REDUCE, 143);
   _actionMap[387][KSEP] = ActionEntry(REDUCE, 143);
   _actionMap[387][ROWLIMIT] = ActionEntry(REDUCE, 143);
   _actionMap[387][UNION] = ActionEntry(REDUCE, 143);
   _actionMap[387][ENDTOKEN] = ActionEntry(REDUCE, 143);
   _actionMap[387][SEMICOLON] = ActionEntry(REDUCE, 143);
   _actionMap[387][LIKE] = ActionEntry(REDUCE, 143);
   _actionMap[387][BETWEEN] = ActionEntry(REDUCE, 143);
   _actionMap[387][NOT] = ActionEntry(REDUCE, 143);
   _actionMap[387][INTOK] = ActionEntry(REDUCE, 143);
   _actionMap[387][RB] = ActionEntry(REDUCE, 143);
   _actionMap[387][STAR] = ActionEntry(REDUCE, 143);
   _actionMap[387][DIVISION] = ActionEntry(REDUCE, 143);
   _actionMap[387][CONCAT] = ActionEntry(REDUCE, 143);
   _actionMap[387][MINUS] = ActionEntry(REDUCE, 143);
   _actionMap[387][PLUS] = ActionEntry(REDUCE, 143);
   _actionMap[387][IS] = ActionEntry(REDUCE, 143);
   _actionMap[387][EQU] = ActionEntry(REDUCE, 143);
   _actionMap[387][NEGATION] = ActionEntry(REDUCE, 143);
   _actionMap[387][LT] = ActionEntry(REDUCE, 143);
   _actionMap[387][MT] = ActionEntry(REDUCE, 143);
   _actionMap[388][WHEN] = ActionEntry(REDUCE, 144);
   _actionMap[388][ELSE] = ActionEntry(REDUCE, 144);
   _actionMap[388][LEFT] = ActionEntry(REDUCE, 144);
   _actionMap[388][RIGHT] = ActionEntry(REDUCE, 144);
   _actionMap[388][INNER] = ActionEntry(REDUCE, 144);
   _actionMap[388][JOIN] = ActionEntry(REDUCE, 144);
   _actionMap[388][RETURNTOKEN] = ActionEntry(REDUCE, 144);
   _actionMap[388][ORDER] = ActionEntry(REDUCE, 144);
   _actionMap[388][GROUP] = ActionEntry(REDUCE, 144);
   _actionMap[388][WHERE] = ActionEntry(REDUCE, 144);
   _actionMap[388][AS] = ActionEntry(REDUCE, 144);
   _actionMap[388][FROM] = ActionEntry(REDUCE, 144);
   _actionMap[388][END_TOKEN] = ActionEntry(REDUCE, 144);
   _actionMap[388][BEGIN] = ActionEntry(REDUCE, 144);
   _actionMap[388][THEN] = ActionEntry(REDUCE, 144);
   _actionMap[388][OR] = ActionEntry(REDUCE, 144);
   _actionMap[388][AND] = ActionEntry(REDUCE, 144);
   _actionMap[388][DESC] = ActionEntry(REDUCE, 144);
   _actionMap[388][ASC] = ActionEntry(REDUCE, 144);
   _actionMap[388][KSEP] = ActionEntry(REDUCE, 144);
   _actionMap[388][ROWLIMIT] = ActionEntry(REDUCE, 144);
   _actionMap[388][UNION] = ActionEntry(REDUCE, 144);
   _actionMap[388][ENDTOKEN] = ActionEntry(REDUCE, 144);
   _actionMap[388][SEMICOLON] = ActionEntry(REDUCE, 144);
}
void Cego::loadParser141()
{
   _actionMap[388][LIKE] = ActionEntry(REDUCE, 144);
   _actionMap[388][BETWEEN] = ActionEntry(REDUCE, 144);
   _actionMap[388][NOT] = ActionEntry(REDUCE, 144);
   _actionMap[388][INTOK] = ActionEntry(REDUCE, 144);
   _actionMap[388][RB] = ActionEntry(REDUCE, 144);
   _actionMap[388][STAR] = ActionEntry(REDUCE, 144);
   _actionMap[388][DIVISION] = ActionEntry(REDUCE, 144);
   _actionMap[388][CONCAT] = ActionEntry(REDUCE, 144);
   _actionMap[388][MINUS] = ActionEntry(REDUCE, 144);
   _actionMap[388][PLUS] = ActionEntry(REDUCE, 144);
   _actionMap[388][IS] = ActionEntry(REDUCE, 144);
   _actionMap[388][EQU] = ActionEntry(REDUCE, 144);
   _actionMap[388][NEGATION] = ActionEntry(REDUCE, 144);
   _actionMap[388][LT] = ActionEntry(REDUCE, 144);
   _actionMap[388][MT] = ActionEntry(REDUCE, 144);
   _actionMap[389][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[389][MINUS] = ActionEntry(SHIFT, 520);
   _jumpMap[389][SignedInt] = 519;
   _actionMap[390][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[390][MINUS] = ActionEntry(SHIFT, 522);
   _jumpMap[390][SignedFloat] = 521;
   _actionMap[391][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[391][MINUS] = ActionEntry(SHIFT, 522);
   _jumpMap[391][SignedFloat] = 523;
   _actionMap[392][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[392][MINUS] = ActionEntry(SHIFT, 522);
   _jumpMap[392][SignedFloat] = 524;
   _actionMap[393][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[393][MINUS] = ActionEntry(SHIFT, 520);
   _jumpMap[393][SignedInt] = 525;
   _actionMap[394][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[394][MINUS] = ActionEntry(SHIFT, 520);
   _jumpMap[394][SignedInt] = 526;
   _actionMap[395][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[395][MINUS] = ActionEntry(SHIFT, 520);
   _jumpMap[395][SignedInt] = 527;
   _actionMap[396][INTVAL] = ActionEntry(SHIFT, 528);
   _actionMap[397][IDENTIFIER] = ActionEntry(SHIFT, 529);
   _actionMap[398][IDENTIFIER] = ActionEntry(SHIFT, 530);
   _actionMap[399][IDENTIFIER] = ActionEntry(SHIFT, 531);
   _actionMap[400][IDENTIFIER] = ActionEntry(SHIFT, 532);
   _actionMap[401][IDENTIFIER] = ActionEntry(SHIFT, 533);
   _actionMap[402][IDENTIFIER] = ActionEntry(SHIFT, 534);
   _actionMap[403][SEMICOLON] = ActionEntry(REDUCE, 288);
   _actionMap[403][RB] = ActionEntry(REDUCE, 288);
   _actionMap[403][ENDTOKEN] = ActionEntry(REDUCE, 288);
   _actionMap[403][UNION] = ActionEntry(REDUCE, 288);
   _actionMap[403][ROWLIMIT] = ActionEntry(REDUCE, 288);
   _actionMap[403][ORDER] = ActionEntry(REDUCE, 288);
   _actionMap[403][GROUP] = ActionEntry(REDUCE, 288);
}
void Cego::loadParser142()
{
   _actionMap[403][WHERE] = ActionEntry(SHIFT, 328);
   _jumpMap[403][NoWhere] = 327;
   _jumpMap[403][WhereClause] = 535;
   _actionMap[404][WHERE] = ActionEntry(REDUCE, 195);
   _actionMap[404][GROUP] = ActionEntry(REDUCE, 195);
   _actionMap[404][ORDER] = ActionEntry(REDUCE, 195);
   _actionMap[404][ROWLIMIT] = ActionEntry(REDUCE, 195);
   _actionMap[404][UNION] = ActionEntry(REDUCE, 195);
   _actionMap[404][ENDTOKEN] = ActionEntry(REDUCE, 195);
   _actionMap[404][RB] = ActionEntry(REDUCE, 195);
   _actionMap[404][SEMICOLON] = ActionEntry(REDUCE, 195);
   _actionMap[404][RETURNTOKEN] = ActionEntry(REDUCE, 195);
   _actionMap[404][INNER] = ActionEntry(SHIFT, 538);
   _actionMap[404][JOIN] = ActionEntry(SHIFT, 539);
   _actionMap[404][LEFT] = ActionEntry(SHIFT, 540);
   _actionMap[404][RIGHT] = ActionEntry(SHIFT, 541);
   _jumpMap[404][InnerJoin] = 537;
   _jumpMap[404][JoinSpec] = 536;
   _actionMap[405][WHERE] = ActionEntry(REDUCE, 194);
   _actionMap[405][GROUP] = ActionEntry(REDUCE, 194);
   _actionMap[405][ORDER] = ActionEntry(REDUCE, 194);
   _actionMap[405][ROWLIMIT] = ActionEntry(REDUCE, 194);
   _actionMap[405][UNION] = ActionEntry(REDUCE, 194);
   _actionMap[405][ENDTOKEN] = ActionEntry(REDUCE, 194);
   _actionMap[405][RB] = ActionEntry(REDUCE, 194);
   _actionMap[405][SEMICOLON] = ActionEntry(REDUCE, 194);
   _actionMap[405][RETURNTOKEN] = ActionEntry(REDUCE, 194);
   _actionMap[406][KSEP] = ActionEntry(SHIFT, 543);
   _actionMap[406][RETURNTOKEN] = ActionEntry(REDUCE, 204);
   _actionMap[406][SEMICOLON] = ActionEntry(REDUCE, 204);
   _actionMap[406][RB] = ActionEntry(REDUCE, 204);
   _actionMap[406][ENDTOKEN] = ActionEntry(REDUCE, 204);
   _actionMap[406][UNION] = ActionEntry(REDUCE, 204);
   _actionMap[406][ROWLIMIT] = ActionEntry(REDUCE, 204);
   _actionMap[406][ORDER] = ActionEntry(REDUCE, 204);
   _actionMap[406][GROUP] = ActionEntry(REDUCE, 204);
   _actionMap[406][WHERE] = ActionEntry(REDUCE, 204);
   _actionMap[406][INNER] = ActionEntry(SHIFT, 538);
   _actionMap[406][JOIN] = ActionEntry(SHIFT, 539);
   _actionMap[406][LEFT] = ActionEntry(SHIFT, 540);
   _actionMap[406][RIGHT] = ActionEntry(SHIFT, 541);
   _jumpMap[406][InnerJoin] = 537;
   _jumpMap[406][JoinSpec] = 542;
   _actionMap[407][WHERE] = ActionEntry(REDUCE, 205);
   _actionMap[407][IDENTIFIER] = ActionEntry(SHIFT, 544);
   _actionMap[407][GROUP] = ActionEntry(REDUCE, 205);
   _actionMap[407][ORDER] = ActionEntry(REDUCE, 205);
   _actionMap[407][ROWLIMIT] = ActionEntry(REDUCE, 205);
   _actionMap[407][UNION] = ActionEntry(REDUCE, 205);
   _actionMap[407][ENDTOKEN] = ActionEntry(REDUCE, 205);
}
void Cego::loadParser143()
{
   _actionMap[407][RB] = ActionEntry(REDUCE, 205);
   _actionMap[407][SEMICOLON] = ActionEntry(REDUCE, 205);
   _actionMap[407][RETURNTOKEN] = ActionEntry(REDUCE, 205);
   _actionMap[407][LEFT] = ActionEntry(REDUCE, 205);
   _actionMap[407][RIGHT] = ActionEntry(REDUCE, 205);
   _actionMap[407][INNER] = ActionEntry(REDUCE, 205);
   _actionMap[407][JOIN] = ActionEntry(REDUCE, 205);
   _actionMap[407][KSEP] = ActionEntry(REDUCE, 205);
   _actionMap[407][ON] = ActionEntry(REDUCE, 205);
   _actionMap[408][FROM] = ActionEntry(REDUCE, 193);
   _actionMap[408][KSEP] = ActionEntry(REDUCE, 193);
   _actionMap[409][IDENTIFIER] = ActionEntry(SHIFT, 545);
   _actionMap[410][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[410][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[410][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[410][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[410][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[410][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[410][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[410][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[410][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[410][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[410][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[410][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[410][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[410][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[410][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[410][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[410][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[410][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[410][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[410][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[410][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[410][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[410][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[410][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[410][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[410][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[410][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[410][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[410][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[410][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[410][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[410][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[410][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[410][LB] = ActionEntry(SHIFT, 135);
   _actionMap[410][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[410][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[410][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[410][NULLTOKEN] = ActionEntry(SHIFT, 118);
}
void Cego::loadParser144()
{
   _actionMap[410][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[410][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[410][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[410][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[410][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[410][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[410][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[410][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[410][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[410][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[410][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[410][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[410][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[410][ObjSpec] = 94;
   _jumpMap[410][Constant] = 93;
   _jumpMap[410][SignedFloat] = 92;
   _jumpMap[410][SignedInt] = 91;
   _jumpMap[410][Attribute] = 90;
   _jumpMap[410][Function] = 89;
   _jumpMap[410][SelectItem] = 546;
   _jumpMap[410][CasePrepare] = 88;
   _jumpMap[410][CaseClause] = 87;
   _jumpMap[410][Factor] = 86;
   _jumpMap[410][Term] = 85;
   _jumpMap[410][Expr] = 273;
   _actionMap[411][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[411][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[411][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[411][SEMICOLON] = ActionEntry(REDUCE, 62);
   _actionMap[412][KSEP] = ActionEntry(SHIFT, 548);
   _actionMap[412][SEMICOLON] = ActionEntry(REDUCE, 288);
   _actionMap[412][RETURNTOKEN] = ActionEntry(REDUCE, 288);
   _actionMap[412][WHERE] = ActionEntry(SHIFT, 328);
   _jumpMap[412][NoWhere] = 327;
   _jumpMap[412][WhereClause] = 547;
   _actionMap[413][KSEP] = ActionEntry(REDUCE, 234);
   _actionMap[413][WHERE] = ActionEntry(REDUCE, 234);
   _actionMap[413][GROUP] = ActionEntry(REDUCE, 234);
   _actionMap[413][ORDER] = ActionEntry(REDUCE, 234);
   _actionMap[413][ROWLIMIT] = ActionEntry(REDUCE, 234);
   _actionMap[413][UNION] = ActionEntry(REDUCE, 234);
   _actionMap[413][ENDTOKEN] = ActionEntry(REDUCE, 234);
   _actionMap[413][RB] = ActionEntry(REDUCE, 234);
   _actionMap[413][SEMICOLON] = ActionEntry(REDUCE, 234);
   _actionMap[413][RETURNTOKEN] = ActionEntry(REDUCE, 234);
   _actionMap[414][EQU] = ActionEntry(SHIFT, 549);
   _actionMap[415][LB] = ActionEntry(SHIFT, 550);
   _actionMap[171][SEMICOLON] = ActionEntry(REDUCE, 57);
   _actionMap[172][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[172][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
}
void Cego::loadParser145()
{
   _actionMap[172][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[172][ObjSpec] = 288;
   _actionMap[173][SEMICOLON] = ActionEntry(REDUCE, 53);
   _actionMap[174][SEMICOLON] = ActionEntry(REDUCE, 55);
   _actionMap[175][SEMICOLON] = ActionEntry(REDUCE, 52);
   _actionMap[176][SEMICOLON] = ActionEntry(REDUCE, 54);
   _actionMap[177][ADD] = ActionEntry(SHIFT, 291);
   _actionMap[177][DROP] = ActionEntry(SHIFT, 292);
   _actionMap[177][MODIFY] = ActionEntry(SHIFT, 293);
   _actionMap[177][RENAME] = ActionEntry(SHIFT, 294);
   _jumpMap[177][AlterOption] = 290;
   _jumpMap[177][AlterList] = 289;
   _actionMap[178][BY] = ActionEntry(SHIFT, 295);
   _actionMap[179][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[179][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[179][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[179][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[179][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[179][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[179][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[179][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[179][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[179][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[179][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[179][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[179][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[179][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[179][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[179][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[179][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[179][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[179][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[179][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[179][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[179][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[179][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[179][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[179][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[179][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[179][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[179][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[179][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[179][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[179][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[179][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[179][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[179][LB] = ActionEntry(SHIFT, 135);
   _actionMap[179][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[179][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[179][SYSDATE] = ActionEntry(SHIFT, 128);
}
void Cego::loadParser146()
{
   _actionMap[179][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[179][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[179][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[179][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[179][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[179][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[179][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[179][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[179][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[179][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[179][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[179][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[179][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[179][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[179][RB] = ActionEntry(REDUCE, 108);
   _jumpMap[179][ObjSpec] = 94;
   _jumpMap[179][Constant] = 93;
   _jumpMap[179][SignedFloat] = 92;
   _jumpMap[179][SignedInt] = 91;
   _jumpMap[179][Attribute] = 90;
   _jumpMap[179][Function] = 89;
   _jumpMap[179][CasePrepare] = 88;
   _jumpMap[179][CaseClause] = 87;
   _jumpMap[179][Factor] = 86;
   _jumpMap[179][Term] = 85;
   _jumpMap[179][Expr] = 298;
   _jumpMap[179][ProcValueList] = 297;
   _jumpMap[179][ProcValueListOpt] = 296;
   _actionMap[180][SEMICOLON] = ActionEntry(REDUCE, 64);
   _actionMap[181][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[181][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[181][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[181][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[181][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[181][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[181][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[181][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[181][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[181][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[181][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[181][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[181][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[181][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[181][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[181][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[181][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[181][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[181][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[181][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[181][STR2LONG] = ActionEntry(SHIFT, 130);
}
void Cego::loadParser147()
{
   _actionMap[181][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[181][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[181][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[181][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[181][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[181][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[181][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[181][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[181][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[181][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[181][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[181][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[181][LB] = ActionEntry(SHIFT, 135);
   _actionMap[181][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[181][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[181][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[181][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[181][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[181][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[181][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[181][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[181][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[181][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[181][VARREF] = ActionEntry(SHIFT, 320);
   _actionMap[181][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[181][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[181][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[181][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[181][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[181][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[181][IF] = ActionEntry(SHIFT, 315);
   _actionMap[181][BEGIN] = ActionEntry(SHIFT, 312);
   _actionMap[181][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[181][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[181][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[181][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[181][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[181][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[181][VAR] = ActionEntry(SHIFT, 318);
   _actionMap[181][CURSOR] = ActionEntry(SHIFT, 314);
   _actionMap[181][CLOSE] = ActionEntry(SHIFT, 313);
   _actionMap[181][NOOP] = ActionEntry(SHIFT, 316);
   _actionMap[181][RETURNTOKEN] = ActionEntry(SHIFT, 317);
   _actionMap[181][WHILE] = ActionEntry(SHIFT, 319);
   _jumpMap[181][ObjSpec] = 94;
   _jumpMap[181][Constant] = 93;
   _jumpMap[181][SignedFloat] = 92;
   _jumpMap[181][SignedInt] = 91;
   _jumpMap[181][Attribute] = 90;
   _jumpMap[181][Function] = 89;
}
void Cego::loadParser148()
{
   _jumpMap[181][DeleteStatement] = 311;
   _jumpMap[181][UpdateStatement] = 310;
   _jumpMap[181][InsertStatement] = 309;
   _jumpMap[181][RollbackStatement] = 308;
   _jumpMap[181][CommitStatement] = 307;
   _jumpMap[181][StartStatement] = 306;
   _jumpMap[181][CasePrepare] = 88;
   _jumpMap[181][CaseClause] = 87;
   _jumpMap[181][Factor] = 86;
   _jumpMap[181][Term] = 85;
   _jumpMap[181][Expr] = 305;
   _jumpMap[181][ProcStatement] = 304;
   _jumpMap[181][ProcIfPart] = 303;
   _jumpMap[181][ProcBlockStart] = 302;
   _jumpMap[181][ProcStatementList] = 301;
   _jumpMap[181][ProcStmtBlock] = 300;
   _actionMap[182][IDENTIFIER] = ActionEntry(SHIFT, 321);
   _actionMap[183][SEMICOLON] = ActionEntry(REDUCE, 65);
   _actionMap[184][ON] = ActionEntry(SHIFT, 322);
   _actionMap[185][LB] = ActionEntry(SHIFT, 323);
   _actionMap[186][LB] = ActionEntry(SHIFT, 324);
   _actionMap[187][AS] = ActionEntry(SHIFT, 325);
   _actionMap[188][SEMICOLON] = ActionEntry(REDUCE, 288);
   _actionMap[188][WHERE] = ActionEntry(SHIFT, 328);
   _jumpMap[188][NoWhere] = 327;
   _jumpMap[188][WhereClause] = 326;
   _actionMap[189][SEMICOLON] = ActionEntry(REDUCE, 17);
   _actionMap[190][SEMICOLON] = ActionEntry(REDUCE, 19);
   _actionMap[191][SEMICOLON] = ActionEntry(REDUCE, 20);
   _actionMap[192][SEMICOLON] = ActionEntry(REDUCE, 16);
   _actionMap[193][SEMICOLON] = ActionEntry(REDUCE, 18);
   _actionMap[194][SEMICOLON] = ActionEntry(REDUCE, 66);
   _actionMap[195][CHECK] = ActionEntry(REDUCE, 59);
   _actionMap[195][FOREIGN] = ActionEntry(REDUCE, 59);
   _actionMap[195][PROCEDURE] = ActionEntry(REDUCE, 59);
   _actionMap[195][VIEW] = ActionEntry(REDUCE, 59);
   _actionMap[195][INDEX] = ActionEntry(REDUCE, 59);
   _actionMap[195][TABLE] = ActionEntry(REDUCE, 59);
   _actionMap[196][LB] = ActionEntry(SHIFT, 332);
   _actionMap[196][VALUES] = ActionEntry(REDUCE, 182);
   _actionMap[196][SELECT] = ActionEntry(REDUCE, 182);
   _jumpMap[196][SelectStatement] = 330;
   _jumpMap[196][InsertArgSpec] = 329;
   _actionMap[197][SEMICOLON] = ActionEntry(REDUCE, 68);
   _actionMap[197][IDENTIFIER] = ActionEntry(REDUCE, 68);
   _actionMap[198][SEMICOLON] = ActionEntry(REDUCE, 8);
   _actionMap[199][IDENTIFIER] = ActionEntry(SHIFT, 333);
   _actionMap[200][SEMICOLON] = ActionEntry(REDUCE, 6);
   _actionMap[201][SEMICOLON] = ActionEntry(REDUCE, 7);
   _actionMap[202][SEMICOLON] = ActionEntry(REDUCE, 4);
}
void Cego::loadParser149()
{
   _actionMap[203][SEMICOLON] = ActionEntry(REDUCE, 9);
   _actionMap[204][SEMICOLON] = ActionEntry(REDUCE, 3);
   _actionMap[205][SEMICOLON] = ActionEntry(REDUCE, 10);
   _actionMap[206][SEMICOLON] = ActionEntry(REDUCE, 5);
   _actionMap[207][AS] = ActionEntry(SHIFT, 334);
   _actionMap[208][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[208][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[208][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[208][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[208][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[208][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[208][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[208][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[208][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[208][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[208][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[208][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[208][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[208][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[208][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[208][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[208][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[208][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[208][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[208][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[208][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[208][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[208][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[208][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[208][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[208][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[208][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[208][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[208][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[208][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[208][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[208][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[208][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[208][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[208][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[208][LB] = ActionEntry(SHIFT, 135);
   _actionMap[208][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[208][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[208][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[208][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[208][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[208][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[208][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[208][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[208][VARREF] = ActionEntry(SHIFT, 141);
}
void Cego::loadParser150()
{
   _actionMap[208][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[208][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[208][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[208][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[208][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[208][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[208][ObjSpec] = 94;
   _jumpMap[208][Constant] = 93;
   _jumpMap[208][SignedFloat] = 92;
   _jumpMap[208][SignedInt] = 91;
   _jumpMap[208][Attribute] = 90;
   _jumpMap[208][Function] = 89;
   _jumpMap[208][CasePrepare] = 88;
   _jumpMap[208][CaseClause] = 87;
   _jumpMap[208][Factor] = 86;
   _jumpMap[208][Term] = 335;
   _actionMap[209][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[209][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[209][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[209][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[209][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[209][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[209][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[209][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[209][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[209][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[209][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[209][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[209][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[209][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[209][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[209][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[209][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[209][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[209][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[209][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[209][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[209][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[209][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[209][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[209][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[209][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[209][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[209][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[209][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[209][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[209][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[209][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[209][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[209][NEXTCOUNT] = ActionEntry(SHIFT, 117);
}
void Cego::loadParser151()
{
   _actionMap[209][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[209][LB] = ActionEntry(SHIFT, 135);
   _actionMap[209][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[209][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[209][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[209][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[209][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[209][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[209][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[209][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[209][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[209][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[209][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[209][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[209][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[209][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[209][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[209][ObjSpec] = 94;
   _jumpMap[209][Constant] = 93;
   _jumpMap[209][SignedFloat] = 92;
   _jumpMap[209][SignedInt] = 91;
   _jumpMap[209][Attribute] = 90;
   _jumpMap[209][Function] = 89;
   _jumpMap[209][CasePrepare] = 88;
   _jumpMap[209][CaseClause] = 87;
   _jumpMap[209][Factor] = 86;
   _jumpMap[209][Term] = 336;
   _actionMap[210][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[210][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[210][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[210][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[210][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[210][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[210][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[210][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[210][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[210][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[210][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[210][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[210][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[210][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[210][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[210][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[210][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[210][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[210][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[210][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[210][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[210][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[210][TRUNC] = ActionEntry(SHIFT, 133);
}
void Cego::loadParser152()
{
   _actionMap[210][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[210][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[210][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[210][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[210][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[210][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[210][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[210][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[210][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[210][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[210][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[210][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[210][LB] = ActionEntry(SHIFT, 135);
   _actionMap[210][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[210][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[210][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[210][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[210][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[210][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[210][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[210][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[210][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[210][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[210][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[210][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[210][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[210][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[210][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[210][ObjSpec] = 94;
   _jumpMap[210][Constant] = 93;
   _jumpMap[210][SignedFloat] = 92;
   _jumpMap[210][SignedInt] = 91;
   _jumpMap[210][Attribute] = 90;
   _jumpMap[210][Function] = 89;
   _jumpMap[210][CasePrepare] = 88;
   _jumpMap[210][CaseClause] = 87;
   _jumpMap[210][Factor] = 86;
   _jumpMap[210][Term] = 337;
   _actionMap[211][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[211][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[211][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[211][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[211][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[211][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[211][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[211][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[211][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[211][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[211][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[211][DATE2STR] = ActionEntry(SHIFT, 103);
}
void Cego::loadParser153()
{
   _actionMap[211][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[211][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[211][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[211][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[211][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[211][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[211][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[211][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[211][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[211][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[211][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[211][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[211][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[211][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[211][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[211][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[211][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[211][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[211][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[211][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[211][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[211][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[211][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[211][LB] = ActionEntry(SHIFT, 135);
   _actionMap[211][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[211][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[211][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[211][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[211][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[211][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[211][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[211][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[211][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[211][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[211][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[211][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[211][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[211][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[211][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[211][ObjSpec] = 94;
   _jumpMap[211][Constant] = 93;
   _jumpMap[211][SignedFloat] = 92;
   _jumpMap[211][SignedInt] = 91;
   _jumpMap[211][Attribute] = 90;
   _jumpMap[211][Function] = 89;
   _jumpMap[211][CasePrepare] = 88;
   _jumpMap[211][CaseClause] = 87;
   _jumpMap[211][Factor] = 338;
   _actionMap[212][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[212][MINUS] = ActionEntry(SHIFT, 137);
}
void Cego::loadParser154()
{
   _actionMap[212][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[212][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[212][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[212][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[212][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[212][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[212][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[212][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[212][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[212][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[212][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[212][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[212][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[212][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[212][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[212][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[212][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[212][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[212][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[212][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[212][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[212][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[212][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[212][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[212][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[212][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[212][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[212][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[212][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[212][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[212][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[212][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[212][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[212][LB] = ActionEntry(SHIFT, 135);
   _actionMap[212][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[212][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[212][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[212][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[212][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[212][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[212][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[212][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[212][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[212][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[212][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[212][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[212][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[212][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[212][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[212][ObjSpec] = 94;
}
void Cego::loadParser155()
{
   _jumpMap[212][Constant] = 93;
   _jumpMap[212][SignedFloat] = 92;
   _jumpMap[212][SignedInt] = 91;
   _jumpMap[212][Attribute] = 90;
   _jumpMap[212][Function] = 89;
   _jumpMap[212][CasePrepare] = 88;
   _jumpMap[212][CaseClause] = 87;
   _jumpMap[212][Factor] = 339;
   _actionMap[213][ELSE] = ActionEntry(SHIFT, 341);
   _actionMap[213][WHEN] = ActionEntry(SHIFT, 215);
   _jumpMap[213][CaseCondition] = 340;
   _actionMap[214][WHEN] = ActionEntry(REDUCE, 154);
   _actionMap[214][ELSE] = ActionEntry(REDUCE, 154);
   _actionMap[215][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[215][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[215][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[215][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[215][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[215][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[215][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[215][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[215][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[215][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[215][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[215][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[215][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[215][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[215][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[215][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[215][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[215][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[215][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[215][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[215][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[215][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[215][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[215][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[215][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[215][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[215][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[215][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[215][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[215][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[215][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[215][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[215][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[215][LB] = ActionEntry(SHIFT, 347);
   _actionMap[215][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[215][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[215][SYSDATE] = ActionEntry(SHIFT, 128);
}
void Cego::loadParser156()
{
   _actionMap[215][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[215][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[215][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[215][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[215][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[215][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[215][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[215][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[215][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[215][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[215][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[215][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[215][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[215][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[215][EXISTS] = ActionEntry(SHIFT, 345);
   _actionMap[215][NOT] = ActionEntry(SHIFT, 346);
   _jumpMap[215][ObjSpec] = 94;
   _jumpMap[215][Constant] = 93;
   _jumpMap[215][SignedFloat] = 92;
   _jumpMap[215][SignedInt] = 91;
   _jumpMap[215][Attribute] = 90;
   _jumpMap[215][QueryPredicate] = 344;
   _jumpMap[215][QueryCondition] = 343;
   _jumpMap[215][Function] = 89;
   _jumpMap[215][CasePrepare] = 88;
   _jumpMap[215][CaseClause] = 87;
   _jumpMap[215][Factor] = 86;
   _jumpMap[215][Term] = 85;
   _jumpMap[215][Expr] = 342;
   _actionMap[216][RB] = ActionEntry(SHIFT, 350);
   _actionMap[216][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[216][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[216][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[216][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[216][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[216][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[216][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[216][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[216][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[216][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[216][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[216][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[216][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[216][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[216][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[216][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[216][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[216][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[216][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[216][STR2INT] = ActionEntry(SHIFT, 129);
}
void Cego::loadParser157()
{
   _actionMap[216][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[216][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[216][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[216][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[216][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[216][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[216][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[216][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[216][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[216][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[216][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[216][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[216][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[216][LB] = ActionEntry(SHIFT, 135);
   _actionMap[216][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[216][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[216][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[216][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[216][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[216][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[216][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[216][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[216][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[216][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[216][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[216][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[216][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[216][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[216][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[216][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[216][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[216][ObjSpec] = 94;
   _jumpMap[216][Constant] = 93;
   _jumpMap[216][SignedFloat] = 92;
   _jumpMap[216][SignedInt] = 91;
   _jumpMap[216][Attribute] = 90;
   _jumpMap[216][ExpressionList] = 349;
   _jumpMap[216][Function] = 89;
   _jumpMap[216][CasePrepare] = 88;
   _jumpMap[216][CaseClause] = 87;
   _jumpMap[216][Factor] = 86;
   _jumpMap[216][Term] = 85;
   _jumpMap[216][Expr] = 348;
   _actionMap[217][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[217][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[217][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[217][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[217][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[217][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[217][ROUND] = ActionEntry(SHIFT, 124);
}
void Cego::loadParser158()
{
   _actionMap[217][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[217][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[217][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[217][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[217][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[217][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[217][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[217][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[217][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[217][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[217][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[217][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[217][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[217][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[217][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[217][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[217][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[217][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[217][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[217][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[217][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[217][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[217][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[217][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[217][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[217][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[217][LB] = ActionEntry(SHIFT, 135);
   _actionMap[217][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[217][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[217][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[217][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[217][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[217][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[217][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[217][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[217][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[217][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[217][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[217][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[217][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[217][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[217][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[217][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[217][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[217][ObjSpec] = 94;
   _jumpMap[217][Constant] = 93;
   _jumpMap[217][SignedFloat] = 92;
   _jumpMap[217][SignedInt] = 91;
   _jumpMap[217][Attribute] = 90;
   _jumpMap[217][Function] = 89;
}
void Cego::loadParser159()
{
   _jumpMap[217][CasePrepare] = 88;
   _jumpMap[217][CaseClause] = 87;
   _jumpMap[217][Factor] = 86;
   _jumpMap[217][Term] = 85;
   _jumpMap[217][Expr] = 351;
   _actionMap[218][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[218][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[218][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[218][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[218][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[218][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[218][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[218][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[218][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[218][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[218][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[218][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[218][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[218][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[218][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[218][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[218][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[218][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[218][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[218][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[218][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[218][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[218][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[218][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[218][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[218][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[218][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[218][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[218][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[218][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[218][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[218][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[218][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[218][LB] = ActionEntry(SHIFT, 135);
   _actionMap[218][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[218][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[218][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[218][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[218][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[218][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[218][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[218][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[218][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[218][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[218][VARREF] = ActionEntry(SHIFT, 141);
}
void Cego::loadParser160()
{
   _actionMap[218][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[218][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[218][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[218][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[218][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[218][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[218][ObjSpec] = 94;
   _jumpMap[218][Constant] = 93;
   _jumpMap[218][SignedFloat] = 92;
   _jumpMap[218][SignedInt] = 91;
   _jumpMap[218][Attribute] = 90;
   _jumpMap[218][ExpressionList] = 352;
   _jumpMap[218][Function] = 89;
   _jumpMap[218][CasePrepare] = 88;
   _jumpMap[218][CaseClause] = 87;
   _jumpMap[218][Factor] = 86;
   _jumpMap[218][Term] = 85;
   _jumpMap[218][Expr] = 348;
   _actionMap[219][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[219][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[219][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[219][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[219][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[219][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[219][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[219][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[219][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[219][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[219][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[219][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[219][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[219][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[219][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[219][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[219][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[219][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[219][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[219][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[219][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[219][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[219][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[219][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[219][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[219][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[219][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[219][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[219][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[219][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[219][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[219][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
}
void Cego::loadParser161()
{
   _actionMap[219][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[219][LB] = ActionEntry(SHIFT, 135);
   _actionMap[219][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[219][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[219][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[219][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[219][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[219][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[219][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[219][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[219][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[219][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[219][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[219][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[219][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[219][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[219][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[219][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[219][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[219][ObjSpec] = 94;
   _jumpMap[219][Constant] = 93;
   _jumpMap[219][SignedFloat] = 92;
   _jumpMap[219][SignedInt] = 91;
   _jumpMap[219][Attribute] = 90;
   _jumpMap[219][ExpressionList] = 353;
   _jumpMap[219][Function] = 89;
   _jumpMap[219][CasePrepare] = 88;
   _jumpMap[219][CaseClause] = 87;
   _jumpMap[219][Factor] = 86;
   _jumpMap[219][Term] = 85;
   _jumpMap[219][Expr] = 348;
   _actionMap[220][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[220][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[220][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[220][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[220][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[220][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[220][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[220][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[220][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[220][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[220][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[220][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[220][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[220][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[220][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[220][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[220][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[220][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[220][TRUNC] = ActionEntry(SHIFT, 133);
}
void Cego::loadParser162()
{
   _actionMap[220][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[220][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[220][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[220][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[220][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[220][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[220][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[220][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[220][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[220][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[220][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[220][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[220][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[220][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[220][LB] = ActionEntry(SHIFT, 135);
   _actionMap[220][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[220][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[220][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[220][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[220][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[220][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[220][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[220][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[220][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[220][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[220][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[220][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[220][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[220][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[220][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[220][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[220][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[220][ObjSpec] = 94;
   _jumpMap[220][Constant] = 93;
   _jumpMap[220][SignedFloat] = 92;
   _jumpMap[220][SignedInt] = 91;
   _jumpMap[220][Attribute] = 90;
   _jumpMap[220][ExpressionList] = 354;
   _jumpMap[220][Function] = 89;
   _jumpMap[220][CasePrepare] = 88;
   _jumpMap[220][CaseClause] = 87;
   _jumpMap[220][Factor] = 86;
   _jumpMap[220][Term] = 85;
   _jumpMap[220][Expr] = 348;
   _actionMap[221][STAR] = ActionEntry(SHIFT, 356);
   _actionMap[221][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[221][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[221][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[221][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[221][RTRIM] = ActionEntry(SHIFT, 125);
}
void Cego::loadParser163()
{
   _actionMap[221][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[221][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[221][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[221][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[221][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[221][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[221][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[221][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[221][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[221][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[221][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[221][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[221][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[221][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[221][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[221][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[221][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[221][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[221][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[221][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[221][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[221][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[221][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[221][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[221][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[221][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[221][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[221][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[221][LB] = ActionEntry(SHIFT, 135);
   _actionMap[221][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[221][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[221][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[221][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[221][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[221][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[221][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[221][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[221][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[221][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[221][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[221][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[221][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[221][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[221][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[221][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[221][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[221][ObjSpec] = 94;
   _jumpMap[221][Constant] = 93;
   _jumpMap[221][SignedFloat] = 92;
   _jumpMap[221][SignedInt] = 91;
}
void Cego::loadParser164()
{
   _jumpMap[221][Attribute] = 90;
   _jumpMap[221][Function] = 89;
   _jumpMap[221][CasePrepare] = 88;
   _jumpMap[221][CaseClause] = 87;
   _jumpMap[221][Factor] = 86;
   _jumpMap[221][Term] = 85;
   _jumpMap[221][Expr] = 355;
   _actionMap[222][STRINGVAL] = ActionEntry(SHIFT, 358);
   _jumpMap[222][DateFormat] = 357;
   _actionMap[223][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[223][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[223][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[223][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[223][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[223][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[223][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[223][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[223][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[223][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[223][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[223][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[223][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[223][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[223][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[223][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[223][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[223][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[223][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[223][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[223][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[223][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[223][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[223][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[223][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[223][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[223][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[223][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[223][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[223][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[223][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[223][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[223][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[223][LB] = ActionEntry(SHIFT, 135);
   _actionMap[223][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[223][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[223][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[223][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[223][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[223][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[223][LAB] = ActionEntry(SHIFT, 136);
}
void Cego::loadParser165()
{
   _actionMap[223][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[223][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[223][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[223][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[223][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[223][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[223][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[223][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[223][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[223][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[223][ObjSpec] = 94;
   _jumpMap[223][Constant] = 93;
   _jumpMap[223][SignedFloat] = 92;
   _jumpMap[223][SignedInt] = 91;
   _jumpMap[223][Attribute] = 90;
   _jumpMap[223][ExpressionList] = 359;
   _jumpMap[223][Function] = 89;
   _jumpMap[223][CasePrepare] = 88;
   _jumpMap[223][CaseClause] = 87;
   _jumpMap[223][Factor] = 86;
   _jumpMap[223][Term] = 85;
   _jumpMap[223][Expr] = 348;
   _actionMap[224][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[224][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[224][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[224][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[224][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[224][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[224][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[224][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[224][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[224][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[224][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[224][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[224][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[224][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[224][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[224][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[224][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[224][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[224][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[224][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[224][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[224][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[224][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[224][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[224][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[224][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[224][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[224][BITOR] = ActionEntry(SHIFT, 98);
}
void Cego::loadParser166()
{
   _actionMap[224][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[224][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[224][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[224][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[224][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[224][LB] = ActionEntry(SHIFT, 135);
   _actionMap[224][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[224][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[224][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[224][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[224][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[224][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[224][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[224][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[224][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[224][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[224][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[224][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[224][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[224][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[224][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[224][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[224][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[224][ObjSpec] = 94;
   _jumpMap[224][Constant] = 93;
   _jumpMap[224][SignedFloat] = 92;
   _jumpMap[224][SignedInt] = 91;
   _jumpMap[224][Attribute] = 90;
   _jumpMap[224][ExpressionList] = 360;
   _jumpMap[224][Function] = 89;
   _jumpMap[224][CasePrepare] = 88;
   _jumpMap[224][CaseClause] = 87;
   _jumpMap[224][Factor] = 86;
   _jumpMap[224][Term] = 85;
   _jumpMap[224][Expr] = 348;
   _actionMap[225][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[225][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[225][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[225][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[225][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[225][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[225][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[225][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[225][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[225][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[225][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[225][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[225][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[225][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[225][GETPOS] = ActionEntry(SHIFT, 108);
}
void Cego::loadParser167()
{
   _actionMap[225][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[225][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[225][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[225][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[225][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[225][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[225][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[225][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[225][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[225][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[225][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[225][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[225][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[225][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[225][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[225][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[225][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[225][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[225][LB] = ActionEntry(SHIFT, 135);
   _actionMap[225][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[225][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[225][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[225][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[225][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[225][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[225][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[225][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[225][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[225][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[225][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[225][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[225][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[225][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[225][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[225][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[225][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[225][ObjSpec] = 94;
   _jumpMap[225][Constant] = 93;
   _jumpMap[225][SignedFloat] = 92;
   _jumpMap[225][SignedInt] = 91;
   _jumpMap[225][Attribute] = 90;
   _jumpMap[225][ExpressionList] = 361;
   _jumpMap[225][Function] = 89;
   _jumpMap[225][CasePrepare] = 88;
   _jumpMap[225][CaseClause] = 87;
   _jumpMap[225][Factor] = 86;
   _jumpMap[225][Term] = 85;
   _jumpMap[225][Expr] = 348;
   _actionMap[226][INTO] = ActionEntry(SHIFT, 362);
   _actionMap[227][FLOATVAL] = ActionEntry(SHIFT, 139);
}
void Cego::loadParser168()
{
   _actionMap[227][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[227][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[227][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[227][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[227][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[227][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[227][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[227][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[227][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[227][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[227][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[227][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[227][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[227][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[227][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[227][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[227][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[227][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[227][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[227][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[227][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[227][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[227][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[227][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[227][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[227][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[227][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[227][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[227][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[227][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[227][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[227][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[227][LB] = ActionEntry(SHIFT, 135);
   _actionMap[227][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[227][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[227][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[227][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[227][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[227][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[227][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[227][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[227][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[227][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[227][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[227][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[227][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[227][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[227][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[227][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[227][MAX] = ActionEntry(SHIFT, 115);
}
void Cego::loadParser169()
{
   _jumpMap[227][ObjSpec] = 94;
   _jumpMap[227][Constant] = 93;
   _jumpMap[227][SignedFloat] = 92;
   _jumpMap[227][SignedInt] = 91;
   _jumpMap[227][Attribute] = 90;
   _jumpMap[227][ExpressionList] = 363;
   _jumpMap[227][Function] = 89;
   _jumpMap[227][CasePrepare] = 88;
   _jumpMap[227][CaseClause] = 87;
   _jumpMap[227][Factor] = 86;
   _jumpMap[227][Term] = 85;
   _jumpMap[227][Expr] = 348;
   _actionMap[228][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[228][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[228][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[228][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[228][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[228][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[228][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[228][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[228][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[228][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[228][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[228][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[228][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[228][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[228][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[228][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[228][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[228][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[228][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[228][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[228][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[228][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[228][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[228][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[228][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[228][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[228][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[228][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[228][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[228][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[228][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[228][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[228][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[228][LB] = ActionEntry(SHIFT, 135);
   _actionMap[228][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[228][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[228][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[228][NULLTOKEN] = ActionEntry(SHIFT, 118);
}
void Cego::loadParser170()
{
   _actionMap[228][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[228][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[228][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[228][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[228][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[228][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[228][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[228][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[228][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[228][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[228][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[228][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[228][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[228][ObjSpec] = 94;
   _jumpMap[228][Constant] = 93;
   _jumpMap[228][SignedFloat] = 92;
   _jumpMap[228][SignedInt] = 91;
   _jumpMap[228][Attribute] = 90;
   _jumpMap[228][ExpressionList] = 364;
   _jumpMap[228][Function] = 89;
   _jumpMap[228][CasePrepare] = 88;
   _jumpMap[228][CaseClause] = 87;
   _jumpMap[228][Factor] = 86;
   _jumpMap[228][Term] = 85;
   _jumpMap[228][Expr] = 348;
   _actionMap[229][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[229][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[229][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[229][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[229][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[229][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[229][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[229][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[229][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[229][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[229][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[229][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[229][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[229][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[229][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[229][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[229][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[229][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[229][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[229][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[229][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[229][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[229][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[229][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[229][DIV] = ActionEntry(SHIFT, 105);
}
void Cego::loadParser171()
{
   _actionMap[229][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[229][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[229][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[229][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[229][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[229][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[229][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[229][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[229][LB] = ActionEntry(SHIFT, 135);
   _actionMap[229][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[229][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[229][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[229][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[229][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[229][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[229][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[229][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[229][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[229][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[229][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[229][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[229][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[229][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[229][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[229][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[229][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[229][ObjSpec] = 94;
   _jumpMap[229][Constant] = 93;
   _jumpMap[229][SignedFloat] = 92;
   _jumpMap[229][SignedInt] = 91;
   _jumpMap[229][Attribute] = 90;
   _jumpMap[229][ExpressionList] = 365;
   _jumpMap[229][Function] = 89;
   _jumpMap[229][CasePrepare] = 88;
   _jumpMap[229][CaseClause] = 87;
   _jumpMap[229][Factor] = 86;
   _jumpMap[229][Term] = 85;
   _jumpMap[229][Expr] = 348;
   _actionMap[230][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[230][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[230][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[230][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[230][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[230][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[230][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[230][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[230][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[230][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[230][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[230][UPPER] = ActionEntry(SHIFT, 134);
}
void Cego::loadParser172()
{
   _actionMap[230][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[230][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[230][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[230][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[230][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[230][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[230][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[230][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[230][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[230][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[230][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[230][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[230][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[230][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[230][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[230][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[230][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[230][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[230][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[230][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[230][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[230][LB] = ActionEntry(SHIFT, 135);
   _actionMap[230][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[230][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[230][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[230][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[230][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[230][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[230][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[230][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[230][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[230][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[230][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[230][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[230][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[230][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[230][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[230][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[230][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[230][ObjSpec] = 94;
   _jumpMap[230][Constant] = 93;
   _jumpMap[230][SignedFloat] = 92;
   _jumpMap[230][SignedInt] = 91;
   _jumpMap[230][Attribute] = 90;
   _jumpMap[230][ExpressionList] = 366;
   _jumpMap[230][Function] = 89;
   _jumpMap[230][CasePrepare] = 88;
   _jumpMap[230][CaseClause] = 87;
   _jumpMap[230][Factor] = 86;
   _jumpMap[230][Term] = 85;
}
void Cego::loadParser173()
{
   _jumpMap[230][Expr] = 348;
   _actionMap[231][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[231][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[231][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[231][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[231][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[231][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[231][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[231][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[231][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[231][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[231][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[231][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[231][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[231][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[231][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[231][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[231][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[231][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[231][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[231][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[231][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[231][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[231][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[231][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[231][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[231][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[231][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[231][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[231][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[231][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[231][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[231][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[231][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[231][LB] = ActionEntry(SHIFT, 135);
   _actionMap[231][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[231][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[231][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[231][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[231][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[231][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[231][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[231][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[231][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[231][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[231][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[231][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[231][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[231][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[231][AVG] = ActionEntry(SHIFT, 96);
}
void Cego::loadParser174()
{
   _actionMap[231][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[231][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[231][ObjSpec] = 94;
   _jumpMap[231][Constant] = 93;
   _jumpMap[231][SignedFloat] = 92;
   _jumpMap[231][SignedInt] = 91;
   _jumpMap[231][Attribute] = 90;
   _jumpMap[231][ExpressionList] = 367;
   _jumpMap[231][Function] = 89;
   _jumpMap[231][CasePrepare] = 88;
   _jumpMap[231][CaseClause] = 87;
   _jumpMap[231][Factor] = 86;
   _jumpMap[231][Term] = 85;
   _jumpMap[231][Expr] = 348;
   _actionMap[232][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[232][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[232][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[232][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[232][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[232][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[232][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[232][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[232][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[232][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[232][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[232][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[232][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[232][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[232][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[232][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[232][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[232][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[232][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[232][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[232][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[232][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[232][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[232][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[232][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[232][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[232][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[232][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[232][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[232][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[232][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[232][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[232][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[232][LB] = ActionEntry(SHIFT, 135);
   _actionMap[232][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[232][DATE] = ActionEntry(SHIFT, 102);
}
void Cego::loadParser175()
{
   _actionMap[232][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[232][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[232][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[232][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[232][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[232][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[232][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[232][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[232][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[232][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[232][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[232][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[232][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[232][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[232][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[232][ObjSpec] = 94;
   _jumpMap[232][Constant] = 93;
   _jumpMap[232][SignedFloat] = 92;
   _jumpMap[232][SignedInt] = 91;
   _jumpMap[232][Attribute] = 90;
   _jumpMap[232][ExpressionList] = 368;
   _jumpMap[232][Function] = 89;
   _jumpMap[232][CasePrepare] = 88;
   _jumpMap[232][CaseClause] = 87;
   _jumpMap[232][Factor] = 86;
   _jumpMap[232][Term] = 85;
   _jumpMap[232][Expr] = 348;
   _actionMap[233][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[233][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[233][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[233][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[233][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[233][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[233][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[233][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[233][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[233][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[233][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[233][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[233][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[233][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[233][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[233][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[233][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[233][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[233][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[233][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[233][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[233][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[233][RANDINT] = ActionEntry(SHIFT, 121);
}
void Cego::loadParser176()
{
   _actionMap[233][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[233][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[233][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[233][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[233][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[233][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[233][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[233][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[233][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[233][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[233][LB] = ActionEntry(SHIFT, 135);
   _actionMap[233][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[233][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[233][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[233][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[233][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[233][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[233][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[233][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[233][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[233][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[233][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[233][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[233][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[233][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[233][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[233][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[233][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[233][ObjSpec] = 94;
   _jumpMap[233][Constant] = 93;
   _jumpMap[233][SignedFloat] = 92;
   _jumpMap[233][SignedInt] = 91;
   _jumpMap[233][Attribute] = 90;
   _jumpMap[233][Function] = 89;
   _jumpMap[233][CasePrepare] = 88;
   _jumpMap[233][CaseClause] = 87;
   _jumpMap[233][Factor] = 86;
   _jumpMap[233][Term] = 85;
   _jumpMap[233][Expr] = 369;
   _actionMap[234][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[234][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[234][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[234][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[234][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[234][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[234][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[234][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[234][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[234][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[234][LOWER] = ActionEntry(SHIFT, 112);
}
void Cego::loadParser177()
{
   _actionMap[234][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[234][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[234][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[234][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[234][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[234][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[234][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[234][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[234][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[234][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[234][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[234][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[234][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[234][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[234][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[234][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[234][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[234][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[234][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[234][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[234][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[234][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[234][LB] = ActionEntry(SHIFT, 135);
   _actionMap[234][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[234][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[234][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[234][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[234][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[234][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[234][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[234][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[234][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[234][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[234][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[234][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[234][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[234][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[234][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[234][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[234][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[234][ObjSpec] = 94;
   _jumpMap[234][Constant] = 93;
   _jumpMap[234][SignedFloat] = 92;
   _jumpMap[234][SignedInt] = 91;
   _jumpMap[234][Attribute] = 90;
   _jumpMap[234][Function] = 89;
   _jumpMap[234][CasePrepare] = 88;
   _jumpMap[234][CaseClause] = 87;
   _jumpMap[234][Factor] = 86;
   _jumpMap[234][Term] = 85;
}
void Cego::loadParser178()
{
   _jumpMap[234][Expr] = 370;
   _actionMap[235][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[235][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[235][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[235][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[235][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[235][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[235][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[235][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[235][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[235][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[235][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[235][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[235][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[235][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[235][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[235][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[235][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[235][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[235][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[235][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[235][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[235][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[235][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[235][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[235][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[235][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[235][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[235][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[235][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[235][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[235][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[235][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[235][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[235][LB] = ActionEntry(SHIFT, 135);
   _actionMap[235][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[235][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[235][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[235][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[235][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[235][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[235][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[235][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[235][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[235][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[235][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[235][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[235][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[235][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[235][AVG] = ActionEntry(SHIFT, 96);
}
void Cego::loadParser179()
{
   _actionMap[235][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[235][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[235][ObjSpec] = 94;
   _jumpMap[235][Constant] = 93;
   _jumpMap[235][SignedFloat] = 92;
   _jumpMap[235][SignedInt] = 91;
   _jumpMap[235][Attribute] = 90;
   _jumpMap[235][ExpressionList] = 371;
   _jumpMap[235][Function] = 89;
   _jumpMap[235][CasePrepare] = 88;
   _jumpMap[235][CaseClause] = 87;
   _jumpMap[235][Factor] = 86;
   _jumpMap[235][Term] = 85;
   _jumpMap[235][Expr] = 348;
   _actionMap[236][IDENTIFIER] = ActionEntry(SHIFT, 372);
   _actionMap[237][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[237][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[237][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[237][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[237][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[237][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[237][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[237][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[237][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[237][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[237][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[237][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[237][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[237][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[237][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[237][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[237][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[237][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[237][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[237][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[237][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[237][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[237][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[237][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[237][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[237][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[237][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[237][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[237][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[237][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[237][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[237][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[237][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[237][LB] = ActionEntry(SHIFT, 135);
   _actionMap[237][STRINGVAL] = ActionEntry(SHIFT, 95);
}
void Cego::loadParser180()
{
   _actionMap[237][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[237][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[237][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[237][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[237][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[237][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[237][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[237][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[237][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[237][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[237][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[237][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[237][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[237][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[237][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[237][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[237][ObjSpec] = 94;
   _jumpMap[237][Constant] = 93;
   _jumpMap[237][SignedFloat] = 92;
   _jumpMap[237][SignedInt] = 91;
   _jumpMap[237][Attribute] = 90;
   _jumpMap[237][ExpressionList] = 373;
   _jumpMap[237][Function] = 89;
   _jumpMap[237][CasePrepare] = 88;
   _jumpMap[237][CaseClause] = 87;
   _jumpMap[237][Factor] = 86;
   _jumpMap[237][Term] = 85;
   _jumpMap[237][Expr] = 348;
   _actionMap[238][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[238][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[238][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[238][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[238][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[238][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[238][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[238][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[238][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[238][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[238][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[238][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[238][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[238][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[238][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[238][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[238][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[238][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[238][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[238][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[238][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[238][RANDSTR] = ActionEntry(SHIFT, 120);
}
void Cego::loadParser181()
{
   _actionMap[238][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[238][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[238][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[238][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[238][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[238][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[238][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[238][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[238][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[238][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[238][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[238][LB] = ActionEntry(SHIFT, 135);
   _actionMap[238][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[238][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[238][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[238][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[238][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[238][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[238][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[238][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[238][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[238][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[238][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[238][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[238][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[238][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[238][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[238][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[238][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[238][ObjSpec] = 94;
   _jumpMap[238][Constant] = 93;
   _jumpMap[238][SignedFloat] = 92;
   _jumpMap[238][SignedInt] = 91;
   _jumpMap[238][Attribute] = 90;
   _jumpMap[238][ExpressionList] = 374;
   _jumpMap[238][Function] = 89;
   _jumpMap[238][CasePrepare] = 88;
   _jumpMap[238][CaseClause] = 87;
   _jumpMap[238][Factor] = 86;
   _jumpMap[238][Term] = 85;
   _jumpMap[238][Expr] = 348;
   _actionMap[239][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[239][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[239][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[239][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[239][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[239][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[239][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[239][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[239][DATE2INT] = ActionEntry(SHIFT, 104);
}
void Cego::loadParser182()
{
   _actionMap[239][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[239][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[239][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[239][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[239][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[239][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[239][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[239][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[239][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[239][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[239][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[239][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[239][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[239][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[239][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[239][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[239][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[239][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[239][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[239][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[239][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[239][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[239][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[239][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[239][LB] = ActionEntry(SHIFT, 135);
   _actionMap[239][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[239][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[239][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[239][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[239][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[239][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[239][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[239][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[239][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[239][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[239][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[239][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[239][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[239][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[239][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[239][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[239][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[239][ObjSpec] = 94;
   _jumpMap[239][Constant] = 93;
   _jumpMap[239][SignedFloat] = 92;
   _jumpMap[239][SignedInt] = 91;
   _jumpMap[239][Attribute] = 90;
   _jumpMap[239][ExpressionList] = 375;
   _jumpMap[239][Function] = 89;
   _jumpMap[239][CasePrepare] = 88;
}
void Cego::loadParser183()
{
   _jumpMap[239][CaseClause] = 87;
   _jumpMap[239][Factor] = 86;
   _jumpMap[239][Term] = 85;
   _jumpMap[239][Expr] = 348;
   _actionMap[240][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[240][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[240][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[240][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[240][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[240][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[240][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[240][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[240][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[240][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[240][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[240][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[240][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[240][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[240][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[240][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[240][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[240][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[240][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[240][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[240][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[240][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[240][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[240][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[240][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[240][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[240][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[240][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[240][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[240][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[240][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[240][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[240][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[240][LB] = ActionEntry(SHIFT, 135);
   _actionMap[240][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[240][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[240][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[240][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[240][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[240][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[240][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[240][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[240][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[240][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[240][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[240][FETCH] = ActionEntry(SHIFT, 107);
}
void Cego::loadParser184()
{
   _actionMap[240][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[240][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[240][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[240][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[240][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[240][ObjSpec] = 94;
   _jumpMap[240][Constant] = 93;
   _jumpMap[240][SignedFloat] = 92;
   _jumpMap[240][SignedInt] = 91;
   _jumpMap[240][Attribute] = 90;
   _jumpMap[240][ExpressionList] = 376;
   _jumpMap[240][Function] = 89;
   _jumpMap[240][CasePrepare] = 88;
   _jumpMap[240][CaseClause] = 87;
   _jumpMap[240][Factor] = 86;
   _jumpMap[240][Term] = 85;
   _jumpMap[240][Expr] = 348;
   _actionMap[241][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[241][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[241][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[241][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[241][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[241][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[241][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[241][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[241][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[241][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[241][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[241][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[241][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[241][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[241][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[241][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[241][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[241][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[241][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[241][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[241][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[241][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[241][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[241][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[241][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[241][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[241][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[241][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[241][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[241][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[241][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[241][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[241][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
}
void Cego::loadParser185()
{
   _actionMap[241][LB] = ActionEntry(SHIFT, 135);
   _actionMap[241][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[241][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[241][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[241][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[241][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[241][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[241][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[241][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[241][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[241][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[241][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[241][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[241][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[241][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[241][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[241][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[241][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[241][ObjSpec] = 94;
   _jumpMap[241][Constant] = 93;
   _jumpMap[241][SignedFloat] = 92;
   _jumpMap[241][SignedInt] = 91;
   _jumpMap[241][Attribute] = 90;
   _jumpMap[241][ExpressionList] = 377;
   _jumpMap[241][Function] = 89;
   _jumpMap[241][CasePrepare] = 88;
   _jumpMap[241][CaseClause] = 87;
   _jumpMap[241][Factor] = 86;
   _jumpMap[241][Term] = 85;
   _jumpMap[241][Expr] = 348;
   _actionMap[242][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[242][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[242][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[242][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[242][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[242][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[242][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[242][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[242][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[242][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[242][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[242][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[242][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[242][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[242][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[242][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[242][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[242][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[242][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[242][STR2INT] = ActionEntry(SHIFT, 129);
}
void Cego::loadParser186()
{
   _actionMap[242][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[242][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[242][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[242][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[242][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[242][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[242][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[242][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[242][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[242][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[242][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[242][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[242][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[242][LB] = ActionEntry(SHIFT, 135);
   _actionMap[242][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[242][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[242][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[242][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[242][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[242][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[242][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[242][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[242][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[242][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[242][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[242][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[242][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[242][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[242][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[242][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[242][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[242][ObjSpec] = 94;
   _jumpMap[242][Constant] = 93;
   _jumpMap[242][SignedFloat] = 92;
   _jumpMap[242][SignedInt] = 91;
   _jumpMap[242][Attribute] = 90;
   _jumpMap[242][ExpressionList] = 378;
   _jumpMap[242][Function] = 89;
   _jumpMap[242][CasePrepare] = 88;
   _jumpMap[242][CaseClause] = 87;
   _jumpMap[242][Factor] = 86;
   _jumpMap[242][Term] = 85;
   _jumpMap[242][Expr] = 348;
   _actionMap[243][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[243][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[243][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[243][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[243][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[243][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[243][ROUND] = ActionEntry(SHIFT, 124);
}
void Cego::loadParser187()
{
   _actionMap[243][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[243][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[243][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[243][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[243][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[243][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[243][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[243][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[243][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[243][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[243][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[243][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[243][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[243][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[243][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[243][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[243][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[243][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[243][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[243][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[243][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[243][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[243][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[243][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[243][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[243][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[243][LB] = ActionEntry(SHIFT, 135);
   _actionMap[243][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[243][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[243][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[243][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[243][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[243][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[243][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[243][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[243][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[243][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[243][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[243][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[243][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[243][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[243][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[243][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[243][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[243][ObjSpec] = 94;
   _jumpMap[243][Constant] = 93;
   _jumpMap[243][SignedFloat] = 92;
   _jumpMap[243][SignedInt] = 91;
   _jumpMap[243][Attribute] = 90;
   _jumpMap[243][ExpressionList] = 379;
}
void Cego::loadParser188()
{
   _jumpMap[243][Function] = 89;
   _jumpMap[243][CasePrepare] = 88;
   _jumpMap[243][CaseClause] = 87;
   _jumpMap[243][Factor] = 86;
   _jumpMap[243][Term] = 85;
   _jumpMap[243][Expr] = 348;
   _actionMap[244][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[244][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[244][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[244][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[244][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[244][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[244][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[244][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[244][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[244][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[244][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[244][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[244][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[244][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[244][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[244][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[244][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[244][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[244][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[244][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[244][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[244][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[244][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[244][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[244][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[244][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[244][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[244][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[244][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[244][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[244][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[244][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[244][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[244][LB] = ActionEntry(SHIFT, 135);
   _actionMap[244][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[244][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[244][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[244][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[244][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[244][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[244][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[244][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[244][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[244][CASE] = ActionEntry(SHIFT, 100);
}
void Cego::loadParser189()
{
   _actionMap[244][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[244][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[244][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[244][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[244][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[244][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[244][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[244][ObjSpec] = 94;
   _jumpMap[244][Constant] = 93;
   _jumpMap[244][SignedFloat] = 92;
   _jumpMap[244][SignedInt] = 91;
   _jumpMap[244][Attribute] = 90;
   _jumpMap[244][ExpressionList] = 380;
   _jumpMap[244][Function] = 89;
   _jumpMap[244][CasePrepare] = 88;
   _jumpMap[244][CaseClause] = 87;
   _jumpMap[244][Factor] = 86;
   _jumpMap[244][Term] = 85;
   _jumpMap[244][Expr] = 348;
   _actionMap[245][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[245][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[245][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[245][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[245][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[245][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[245][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[245][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[245][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[245][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[245][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[245][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[245][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[245][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[245][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[245][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[245][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[245][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[245][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[245][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[245][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[245][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[245][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[245][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[245][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[245][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[245][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[245][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[245][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[245][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[245][IDENTIFIER] = ActionEntry(SHIFT, 140);
}
void Cego::loadParser190()
{
   _actionMap[245][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[245][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[245][LB] = ActionEntry(SHIFT, 135);
   _actionMap[245][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[245][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[245][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[245][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[245][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[245][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[245][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[245][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[245][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[245][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[245][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[245][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[245][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[245][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[245][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[245][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[245][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[245][ObjSpec] = 94;
   _jumpMap[245][Constant] = 93;
   _jumpMap[245][SignedFloat] = 92;
   _jumpMap[245][SignedInt] = 91;
   _jumpMap[245][Attribute] = 90;
   _jumpMap[245][Function] = 89;
   _jumpMap[245][CasePrepare] = 88;
   _jumpMap[245][CaseClause] = 87;
   _jumpMap[245][Factor] = 86;
   _jumpMap[245][Term] = 85;
   _jumpMap[245][Expr] = 381;
   _actionMap[246][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[246][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[246][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[246][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[246][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[246][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[246][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[246][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[246][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[246][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[246][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[246][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[246][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[246][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[246][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[246][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[246][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[246][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[246][TRUNC] = ActionEntry(SHIFT, 133);
}
void Cego::loadParser191()
{
   _actionMap[246][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[246][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[246][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[246][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[246][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[246][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[246][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[246][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[246][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[246][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[246][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[246][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[246][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[246][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[246][LB] = ActionEntry(SHIFT, 135);
   _actionMap[246][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[246][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[246][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[246][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[246][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[246][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[246][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[246][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[246][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[246][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[246][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[246][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[246][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[246][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[246][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[246][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[246][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[246][ObjSpec] = 94;
   _jumpMap[246][Constant] = 93;
   _jumpMap[246][SignedFloat] = 92;
   _jumpMap[246][SignedInt] = 91;
   _jumpMap[246][Attribute] = 90;
   _jumpMap[246][ExpressionList] = 382;
   _jumpMap[246][Function] = 89;
   _jumpMap[246][CasePrepare] = 88;
   _jumpMap[246][CaseClause] = 87;
   _jumpMap[246][Factor] = 86;
   _jumpMap[246][Term] = 85;
   _jumpMap[246][Expr] = 348;
   _actionMap[247][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[247][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[247][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[247][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[247][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[247][LTRIM] = ActionEntry(SHIFT, 113);
}
void Cego::loadParser192()
{
   _actionMap[247][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[247][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[247][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[247][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[247][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[247][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[247][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[247][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[247][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[247][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[247][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[247][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[247][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[247][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[247][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[247][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[247][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[247][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[247][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[247][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[247][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[247][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[247][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[247][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[247][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[247][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[247][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[247][LB] = ActionEntry(SHIFT, 135);
   _actionMap[247][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[247][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[247][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[247][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[247][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[247][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[247][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[247][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[247][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[247][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[247][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[247][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[247][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[247][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[247][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[247][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[247][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[247][ObjSpec] = 94;
   _jumpMap[247][Constant] = 93;
   _jumpMap[247][SignedFloat] = 92;
   _jumpMap[247][SignedInt] = 91;
   _jumpMap[247][Attribute] = 90;
}
void Cego::loadParser193()
{
   _jumpMap[247][ExpressionList] = 383;
   _jumpMap[247][Function] = 89;
   _jumpMap[247][CasePrepare] = 88;
   _jumpMap[247][CaseClause] = 87;
   _jumpMap[247][Factor] = 86;
   _jumpMap[247][Term] = 85;
   _jumpMap[247][Expr] = 348;
   _actionMap[248][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[248][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[248][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[248][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[248][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[248][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[248][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[248][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[248][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[248][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[248][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[248][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[248][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[248][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[248][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[248][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[248][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[248][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[248][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[248][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[248][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[248][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[248][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[248][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[248][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[248][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[248][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[248][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[248][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[248][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[248][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[248][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[248][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[248][LB] = ActionEntry(SHIFT, 135);
   _actionMap[248][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[248][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[248][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[248][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[248][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[248][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[248][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[248][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[248][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
}
void Cego::loadParser194()
{
   _actionMap[248][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[248][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[248][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[248][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[248][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[248][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[248][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[248][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[248][ObjSpec] = 94;
   _jumpMap[248][Constant] = 93;
   _jumpMap[248][SignedFloat] = 92;
   _jumpMap[248][SignedInt] = 91;
   _jumpMap[248][Attribute] = 90;
   _jumpMap[248][ExpressionList] = 384;
   _jumpMap[248][Function] = 89;
   _jumpMap[248][CasePrepare] = 88;
   _jumpMap[248][CaseClause] = 87;
   _jumpMap[248][Factor] = 86;
   _jumpMap[248][Term] = 85;
   _jumpMap[248][Expr] = 348;
   _actionMap[249][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[249][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[249][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[249][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[249][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[249][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[249][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[249][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[249][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[249][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[249][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[249][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[249][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[249][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[249][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[249][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[249][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[249][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[249][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[249][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[249][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[249][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[249][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[249][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[249][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[249][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[249][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[249][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[249][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[249][NEXTCOUNT] = ActionEntry(SHIFT, 117);
}
void Cego::loadParser195()
{
   _actionMap[249][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[249][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[249][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[249][LB] = ActionEntry(SHIFT, 135);
   _actionMap[249][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[249][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[249][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[249][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[249][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[249][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[249][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[249][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[249][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[249][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[249][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[249][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[249][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[249][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[249][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[249][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[249][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[249][ObjSpec] = 94;
   _jumpMap[249][Constant] = 93;
   _jumpMap[249][SignedFloat] = 92;
   _jumpMap[249][SignedInt] = 91;
   _jumpMap[249][Attribute] = 90;
   _jumpMap[249][ExpressionList] = 385;
   _jumpMap[249][Function] = 89;
   _jumpMap[249][CasePrepare] = 88;
   _jumpMap[249][CaseClause] = 87;
   _jumpMap[249][Factor] = 86;
   _jumpMap[249][Term] = 85;
   _jumpMap[249][Expr] = 348;
   _actionMap[250][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[250][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[250][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[250][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[250][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[250][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[250][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[250][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[250][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[250][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[250][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[250][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[250][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[250][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[250][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[250][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[250][REPLACE] = ActionEntry(SHIFT, 122);
}
void Cego::loadParser196()
{
   _actionMap[250][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[250][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[250][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[250][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[250][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[250][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[250][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[250][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[250][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[250][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[250][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[250][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[250][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[250][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[250][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[250][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[250][LB] = ActionEntry(SHIFT, 135);
   _actionMap[250][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[250][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[250][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[250][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[250][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[250][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[250][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[250][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[250][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[250][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[250][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[250][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[250][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[250][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[250][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[250][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[250][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[250][ObjSpec] = 94;
   _jumpMap[250][Constant] = 93;
   _jumpMap[250][SignedFloat] = 92;
   _jumpMap[250][SignedInt] = 91;
   _jumpMap[250][Attribute] = 90;
   _jumpMap[250][ExpressionList] = 386;
   _jumpMap[250][Function] = 89;
   _jumpMap[250][CasePrepare] = 88;
   _jumpMap[250][CaseClause] = 87;
   _jumpMap[250][Factor] = 86;
   _jumpMap[250][Term] = 85;
   _jumpMap[250][Expr] = 348;
   _actionMap[251][RB] = ActionEntry(SHIFT, 387);
   _actionMap[251][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[251][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[251][CONCAT] = ActionEntry(SHIFT, 208);
}
void Cego::loadParser197()
{
   _actionMap[252][RB] = ActionEntry(SHIFT, 388);
   _actionMap[253][RB] = ActionEntry(SHIFT, 389);
   _actionMap[254][RB] = ActionEntry(SHIFT, 390);
   _actionMap[255][RB] = ActionEntry(SHIFT, 391);
   _actionMap[256][RB] = ActionEntry(SHIFT, 392);
   _actionMap[257][RB] = ActionEntry(SHIFT, 393);
   _actionMap[258][RB] = ActionEntry(SHIFT, 394);
   _actionMap[259][RB] = ActionEntry(SHIFT, 395);
   _actionMap[260][KSEP] = ActionEntry(SHIFT, 396);
   _actionMap[261][WHEN] = ActionEntry(REDUCE, 326);
   _actionMap[261][ELSE] = ActionEntry(REDUCE, 326);
   _actionMap[261][LEFT] = ActionEntry(REDUCE, 326);
   _actionMap[261][RIGHT] = ActionEntry(REDUCE, 326);
   _actionMap[261][INNER] = ActionEntry(REDUCE, 326);
   _actionMap[261][JOIN] = ActionEntry(REDUCE, 326);
   _actionMap[261][RETURNTOKEN] = ActionEntry(REDUCE, 326);
   _actionMap[261][ORDER] = ActionEntry(REDUCE, 326);
   _actionMap[261][GROUP] = ActionEntry(REDUCE, 326);
   _actionMap[261][WHERE] = ActionEntry(REDUCE, 326);
   _actionMap[261][AS] = ActionEntry(REDUCE, 326);
   _actionMap[261][FROM] = ActionEntry(REDUCE, 326);
   _actionMap[261][END_TOKEN] = ActionEntry(REDUCE, 326);
   _actionMap[261][BEGIN] = ActionEntry(REDUCE, 326);
   _actionMap[261][THEN] = ActionEntry(REDUCE, 326);
   _actionMap[261][OR] = ActionEntry(REDUCE, 326);
   _actionMap[261][AND] = ActionEntry(REDUCE, 326);
   _actionMap[261][NULLTOKEN] = ActionEntry(REDUCE, 326);
   _actionMap[261][LIKE] = ActionEntry(REDUCE, 326);
   _actionMap[261][IS] = ActionEntry(REDUCE, 326);
   _actionMap[261][BETWEEN] = ActionEntry(REDUCE, 326);
   _actionMap[261][NOT] = ActionEntry(REDUCE, 326);
   _actionMap[261][INTOK] = ActionEntry(REDUCE, 326);
   _actionMap[261][EQU] = ActionEntry(REDUCE, 326);
   _actionMap[261][NEGATION] = ActionEntry(REDUCE, 326);
   _actionMap[261][LT] = ActionEntry(REDUCE, 326);
   _actionMap[261][MT] = ActionEntry(REDUCE, 326);
   _actionMap[261][DESC] = ActionEntry(REDUCE, 326);
   _actionMap[261][ASC] = ActionEntry(REDUCE, 326);
   _actionMap[261][KSEP] = ActionEntry(REDUCE, 326);
   _actionMap[261][ROWLIMIT] = ActionEntry(REDUCE, 326);
   _actionMap[261][UNION] = ActionEntry(REDUCE, 326);
   _actionMap[261][ENDTOKEN] = ActionEntry(REDUCE, 326);
   _actionMap[261][RB] = ActionEntry(REDUCE, 326);
   _actionMap[261][SEMICOLON] = ActionEntry(REDUCE, 326);
   _actionMap[261][CONCAT] = ActionEntry(REDUCE, 326);
   _actionMap[261][STAR] = ActionEntry(REDUCE, 326);
   _actionMap[261][DIVISION] = ActionEntry(REDUCE, 326);
   _actionMap[261][MINUS] = ActionEntry(REDUCE, 326);
   _actionMap[261][PLUS] = ActionEntry(REDUCE, 326);
   _actionMap[262][WHEN] = ActionEntry(REDUCE, 328);
}
void Cego::loadParser198()
{
   _actionMap[262][ELSE] = ActionEntry(REDUCE, 328);
   _actionMap[262][LEFT] = ActionEntry(REDUCE, 328);
   _actionMap[262][RIGHT] = ActionEntry(REDUCE, 328);
   _actionMap[262][INNER] = ActionEntry(REDUCE, 328);
   _actionMap[262][JOIN] = ActionEntry(REDUCE, 328);
   _actionMap[262][RETURNTOKEN] = ActionEntry(REDUCE, 328);
   _actionMap[262][ORDER] = ActionEntry(REDUCE, 328);
   _actionMap[262][GROUP] = ActionEntry(REDUCE, 328);
   _actionMap[262][WHERE] = ActionEntry(REDUCE, 328);
   _actionMap[262][AS] = ActionEntry(REDUCE, 328);
   _actionMap[262][FROM] = ActionEntry(REDUCE, 328);
   _actionMap[262][END_TOKEN] = ActionEntry(REDUCE, 328);
   _actionMap[262][BEGIN] = ActionEntry(REDUCE, 328);
   _actionMap[262][THEN] = ActionEntry(REDUCE, 328);
   _actionMap[262][OR] = ActionEntry(REDUCE, 328);
   _actionMap[262][AND] = ActionEntry(REDUCE, 328);
   _actionMap[262][NULLTOKEN] = ActionEntry(REDUCE, 328);
   _actionMap[262][LIKE] = ActionEntry(REDUCE, 328);
   _actionMap[262][IS] = ActionEntry(REDUCE, 328);
   _actionMap[262][BETWEEN] = ActionEntry(REDUCE, 328);
   _actionMap[262][NOT] = ActionEntry(REDUCE, 328);
   _actionMap[262][INTOK] = ActionEntry(REDUCE, 328);
   _actionMap[262][EQU] = ActionEntry(REDUCE, 328);
   _actionMap[262][NEGATION] = ActionEntry(REDUCE, 328);
   _actionMap[262][LT] = ActionEntry(REDUCE, 328);
   _actionMap[262][MT] = ActionEntry(REDUCE, 328);
   _actionMap[262][DESC] = ActionEntry(REDUCE, 328);
   _actionMap[262][ASC] = ActionEntry(REDUCE, 328);
   _actionMap[262][KSEP] = ActionEntry(REDUCE, 328);
   _actionMap[262][ROWLIMIT] = ActionEntry(REDUCE, 328);
   _actionMap[262][UNION] = ActionEntry(REDUCE, 328);
   _actionMap[262][ENDTOKEN] = ActionEntry(REDUCE, 328);
   _actionMap[262][RB] = ActionEntry(REDUCE, 328);
   _actionMap[262][SEMICOLON] = ActionEntry(REDUCE, 328);
   _actionMap[262][CONCAT] = ActionEntry(REDUCE, 328);
   _actionMap[262][STAR] = ActionEntry(REDUCE, 328);
   _actionMap[262][DIVISION] = ActionEntry(REDUCE, 328);
   _actionMap[262][MINUS] = ActionEntry(REDUCE, 328);
   _actionMap[262][PLUS] = ActionEntry(REDUCE, 328);
   _actionMap[263][WHEN] = ActionEntry(REDUCE, 324);
   _actionMap[263][ELSE] = ActionEntry(REDUCE, 324);
   _actionMap[263][LEFT] = ActionEntry(REDUCE, 324);
   _actionMap[263][RIGHT] = ActionEntry(REDUCE, 324);
   _actionMap[263][INNER] = ActionEntry(REDUCE, 324);
   _actionMap[263][JOIN] = ActionEntry(REDUCE, 324);
   _actionMap[263][RETURNTOKEN] = ActionEntry(REDUCE, 324);
   _actionMap[263][GROUP] = ActionEntry(REDUCE, 324);
   _actionMap[263][WHERE] = ActionEntry(REDUCE, 324);
   _actionMap[263][FROM] = ActionEntry(REDUCE, 324);
   _actionMap[263][AS] = ActionEntry(REDUCE, 324);
}
void Cego::loadParser199()
{
   _actionMap[263][END_TOKEN] = ActionEntry(REDUCE, 324);
   _actionMap[263][BEGIN] = ActionEntry(REDUCE, 324);
   _actionMap[263][THEN] = ActionEntry(REDUCE, 324);
   _actionMap[263][OR] = ActionEntry(REDUCE, 324);
   _actionMap[263][AND] = ActionEntry(REDUCE, 324);
   _actionMap[263][INTOK] = ActionEntry(REDUCE, 324);
   _actionMap[263][NOT] = ActionEntry(REDUCE, 324);
   _actionMap[263][BETWEEN] = ActionEntry(REDUCE, 324);
   _actionMap[263][IS] = ActionEntry(REDUCE, 324);
   _actionMap[263][LIKE] = ActionEntry(REDUCE, 324);
   _actionMap[263][HAVING] = ActionEntry(REDUCE, 324);
   _actionMap[263][ORDER] = ActionEntry(REDUCE, 324);
   _actionMap[263][MT] = ActionEntry(REDUCE, 324);
   _actionMap[263][LT] = ActionEntry(REDUCE, 324);
   _actionMap[263][NEGATION] = ActionEntry(REDUCE, 324);
   _actionMap[263][EQU] = ActionEntry(REDUCE, 324);
   _actionMap[263][RB] = ActionEntry(REDUCE, 324);
   _actionMap[263][ENDTOKEN] = ActionEntry(REDUCE, 324);
   _actionMap[263][UNION] = ActionEntry(REDUCE, 324);
   _actionMap[263][ROWLIMIT] = ActionEntry(REDUCE, 324);
   _actionMap[263][KSEP] = ActionEntry(REDUCE, 324);
   _actionMap[263][ASC] = ActionEntry(REDUCE, 324);
   _actionMap[263][DESC] = ActionEntry(REDUCE, 324);
   _actionMap[263][SEMICOLON] = ActionEntry(REDUCE, 324);
   _actionMap[263][PLUS] = ActionEntry(REDUCE, 324);
   _actionMap[263][MINUS] = ActionEntry(REDUCE, 324);
   _actionMap[263][DIVISION] = ActionEntry(REDUCE, 324);
   _actionMap[263][STAR] = ActionEntry(REDUCE, 324);
   _actionMap[263][CONCAT] = ActionEntry(REDUCE, 324);
   _actionMap[264][TO] = ActionEntry(SHIFT, 397);
   _actionMap[265][TO] = ActionEntry(SHIFT, 398);
   _actionMap[266][TO] = ActionEntry(SHIFT, 399);
   _actionMap[267][TO] = ActionEntry(SHIFT, 400);
   _actionMap[268][TO] = ActionEntry(SHIFT, 401);
   _actionMap[269][TO] = ActionEntry(SHIFT, 402);
   _actionMap[270][SEMICOLON] = ActionEntry(REDUCE, 35);
   _actionMap[271][SEMICOLON] = ActionEntry(REDUCE, 34);
   _actionMap[272][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[272][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[272][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[272][ObjSpec] = 407;
   _jumpMap[272][Table] = 406;
   _jumpMap[272][TableList] = 405;
   _jumpMap[272][JoinSpecList] = 404;
   _jumpMap[272][TableSource] = 403;
   _actionMap[273][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[273][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[273][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[273][AS] = ActionEntry(SHIFT, 409);
   _actionMap[273][FROM] = ActionEntry(REDUCE, 209);
}
void Cego::loadParser200()
{
   _actionMap[273][KSEP] = ActionEntry(REDUCE, 209);
   _jumpMap[273][AliasOpt] = 408;
   _actionMap[274][KSEP] = ActionEntry(SHIFT, 410);
   _actionMap[274][FROM] = ActionEntry(REDUCE, 189);
   _actionMap[275][FROM] = ActionEntry(REDUCE, 192);
   _actionMap[275][KSEP] = ActionEntry(REDUCE, 192);
   _actionMap[276][SEMICOLON] = ActionEntry(REDUCE, 30);
   _actionMap[277][SEMICOLON] = ActionEntry(REDUCE, 29);
   _actionMap[278][SEMICOLON] = ActionEntry(REDUCE, 32);
   _actionMap[279][SEMICOLON] = ActionEntry(REDUCE, 31);
   _actionMap[280][SEMICOLON] = ActionEntry(REDUCE, 33);
   _actionMap[281][SEMICOLON] = ActionEntry(REDUCE, 24);
   _actionMap[282][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[282][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[282][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[282][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[282][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[282][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[282][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[282][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[282][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[282][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[282][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[282][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[282][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[282][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[282][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[282][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[282][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[282][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[282][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[282][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[282][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[282][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[282][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[282][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[282][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[282][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[282][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[282][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[282][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[282][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[282][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[282][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[282][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[282][LB] = ActionEntry(SHIFT, 135);
   _actionMap[282][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[282][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[282][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[282][NULLTOKEN] = ActionEntry(SHIFT, 118);
}
void Cego::loadParser201()
{
   _actionMap[282][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[282][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[282][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[282][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[282][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[282][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[282][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[282][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[282][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[282][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[282][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[282][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[282][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[282][ObjSpec] = 94;
   _jumpMap[282][Constant] = 93;
   _jumpMap[282][SignedFloat] = 92;
   _jumpMap[282][SignedInt] = 91;
   _jumpMap[282][Attribute] = 90;
   _jumpMap[282][Function] = 89;
   _jumpMap[282][CasePrepare] = 88;
   _jumpMap[282][CaseClause] = 87;
   _jumpMap[282][Factor] = 86;
   _jumpMap[282][Term] = 85;
   _jumpMap[282][Expr] = 411;
   _actionMap[283][SEMICOLON] = ActionEntry(REDUCE, 23);
   _actionMap[284][SEMICOLON] = ActionEntry(REDUCE, 21);
   _actionMap[285][SEMICOLON] = ActionEntry(REDUCE, 22);
   _actionMap[286][IDENTIFIER] = ActionEntry(SHIFT, 414);
   _jumpMap[286][Assignment] = 413;
   _jumpMap[286][UpdateList] = 412;
   _actionMap[287][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[287][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[287][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[287][ObjSpec] = 415;
   _actionMap[38][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[38][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[38][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[38][ObjSpec] = 171;
   _actionMap[39][KEY] = ActionEntry(SHIFT, 172);
   _actionMap[40][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[40][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[40][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[40][ObjSpec] = 173;
   _actionMap[41][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[41][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[41][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[41][ObjSpec] = 174;
   _actionMap[42][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[42][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[42][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
}
void Cego::loadParser202()
{
   _jumpMap[42][ObjSpec] = 175;
   _actionMap[43][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[43][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[43][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[43][ObjSpec] = 176;
   _actionMap[44][ENDTOKEN] = ActionEntry(ACCEPT, 0);
   _actionMap[45][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[45][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[45][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[45][ObjSpec] = 177;
   _actionMap[46][IDENTIFIED] = ActionEntry(SHIFT, 178);
   _actionMap[47][LB] = ActionEntry(SHIFT, 179);
   _actionMap[48][SET] = ActionEntry(REDUCE, 348);
   _actionMap[48][TO] = ActionEntry(REDUCE, 348);
   _actionMap[48][VALUES] = ActionEntry(REDUCE, 348);
   _actionMap[48][SELECT] = ActionEntry(REDUCE, 348);
   _actionMap[48][AS] = ActionEntry(REDUCE, 348);
   _actionMap[48][DROP] = ActionEntry(REDUCE, 348);
   _actionMap[48][MODIFY] = ActionEntry(REDUCE, 348);
   _actionMap[48][RENAME] = ActionEntry(REDUCE, 348);
   _actionMap[48][ADD] = ActionEntry(REDUCE, 348);
   _actionMap[48][JOIN] = ActionEntry(REDUCE, 348);
   _actionMap[48][INNER] = ActionEntry(REDUCE, 348);
   _actionMap[48][RIGHT] = ActionEntry(REDUCE, 348);
   _actionMap[48][LEFT] = ActionEntry(REDUCE, 348);
   _actionMap[48][KSEP] = ActionEntry(REDUCE, 348);
   _actionMap[48][RETURNTOKEN] = ActionEntry(REDUCE, 348);
   _actionMap[48][SEMICOLON] = ActionEntry(REDUCE, 348);
   _actionMap[48][RB] = ActionEntry(REDUCE, 348);
   _actionMap[48][ENDTOKEN] = ActionEntry(REDUCE, 348);
   _actionMap[48][UNION] = ActionEntry(REDUCE, 348);
   _actionMap[48][ROWLIMIT] = ActionEntry(REDUCE, 348);
   _actionMap[48][ORDER] = ActionEntry(REDUCE, 348);
   _actionMap[48][GROUP] = ActionEntry(REDUCE, 348);
   _actionMap[48][WHERE] = ActionEntry(REDUCE, 348);
   _actionMap[48][LB] = ActionEntry(REDUCE, 348);
   _actionMap[48][IDENTIFIER] = ActionEntry(REDUCE, 348);
   _actionMap[48][ON] = ActionEntry(REDUCE, 348);
   _actionMap[49][SET] = ActionEntry(REDUCE, 349);
   _actionMap[49][TO] = ActionEntry(REDUCE, 349);
   _actionMap[49][VALUES] = ActionEntry(REDUCE, 349);
   _actionMap[49][SELECT] = ActionEntry(REDUCE, 349);
   _actionMap[49][AS] = ActionEntry(REDUCE, 349);
   _actionMap[49][DROP] = ActionEntry(REDUCE, 349);
   _actionMap[49][MODIFY] = ActionEntry(REDUCE, 349);
   _actionMap[49][RENAME] = ActionEntry(REDUCE, 349);
   _actionMap[49][ADD] = ActionEntry(REDUCE, 349);
   _actionMap[49][JOIN] = ActionEntry(REDUCE, 349);
   _actionMap[49][INNER] = ActionEntry(REDUCE, 349);
   _actionMap[49][RIGHT] = ActionEntry(REDUCE, 349);
}
void Cego::loadParser203()
{
   _actionMap[49][LEFT] = ActionEntry(REDUCE, 349);
   _actionMap[49][KSEP] = ActionEntry(REDUCE, 349);
   _actionMap[49][RETURNTOKEN] = ActionEntry(REDUCE, 349);
   _actionMap[49][SEMICOLON] = ActionEntry(REDUCE, 349);
   _actionMap[49][RB] = ActionEntry(REDUCE, 349);
   _actionMap[49][ENDTOKEN] = ActionEntry(REDUCE, 349);
   _actionMap[49][UNION] = ActionEntry(REDUCE, 349);
   _actionMap[49][ROWLIMIT] = ActionEntry(REDUCE, 349);
   _actionMap[49][ORDER] = ActionEntry(REDUCE, 349);
   _actionMap[49][GROUP] = ActionEntry(REDUCE, 349);
   _actionMap[49][WHERE] = ActionEntry(REDUCE, 349);
   _actionMap[49][LB] = ActionEntry(REDUCE, 349);
   _actionMap[49][IDENTIFIER] = ActionEntry(REDUCE, 349);
   _actionMap[49][ON] = ActionEntry(REDUCE, 349);
   _actionMap[50][SET] = ActionEntry(REDUCE, 350);
   _actionMap[50][TO] = ActionEntry(REDUCE, 350);
   _actionMap[50][VALUES] = ActionEntry(REDUCE, 350);
   _actionMap[50][SELECT] = ActionEntry(REDUCE, 350);
   _actionMap[50][AS] = ActionEntry(REDUCE, 350);
   _actionMap[50][DROP] = ActionEntry(REDUCE, 350);
   _actionMap[50][MODIFY] = ActionEntry(REDUCE, 350);
   _actionMap[50][RENAME] = ActionEntry(REDUCE, 350);
   _actionMap[50][ADD] = ActionEntry(REDUCE, 350);
   _actionMap[50][JOIN] = ActionEntry(REDUCE, 350);
   _actionMap[50][INNER] = ActionEntry(REDUCE, 350);
   _actionMap[50][RIGHT] = ActionEntry(REDUCE, 350);
   _actionMap[50][LEFT] = ActionEntry(REDUCE, 350);
   _actionMap[50][KSEP] = ActionEntry(REDUCE, 350);
   _actionMap[50][RETURNTOKEN] = ActionEntry(REDUCE, 350);
   _actionMap[50][SEMICOLON] = ActionEntry(REDUCE, 350);
   _actionMap[50][RB] = ActionEntry(REDUCE, 350);
   _actionMap[50][ENDTOKEN] = ActionEntry(REDUCE, 350);
   _actionMap[50][UNION] = ActionEntry(REDUCE, 350);
   _actionMap[50][ROWLIMIT] = ActionEntry(REDUCE, 350);
   _actionMap[50][ORDER] = ActionEntry(REDUCE, 350);
   _actionMap[50][GROUP] = ActionEntry(REDUCE, 350);
   _actionMap[50][WHERE] = ActionEntry(REDUCE, 350);
   _actionMap[50][IDENTIFIER] = ActionEntry(REDUCE, 350);
   _actionMap[50][ON] = ActionEntry(REDUCE, 350);
   _actionMap[50][LB] = ActionEntry(REDUCE, 350);
   _actionMap[51][IDENTIFIER] = ActionEntry(SHIFT, 180);
   _actionMap[52][BEGIN] = ActionEntry(SHIFT, 181);
   _actionMap[53][SEMICOLON] = ActionEntry(REDUCE, 45);
   _actionMap[54][INDEX] = ActionEntry(SHIFT, 182);
   _actionMap[55][IDENTIFIER] = ActionEntry(SHIFT, 183);
   _actionMap[56][INDEX] = ActionEntry(SHIFT, 184);
   _actionMap[57][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[57][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[57][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[57][ObjSpec] = 185;
}
void Cego::loadParser204()
{
   _actionMap[58][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[58][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[58][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[58][ObjSpec] = 186;
   _actionMap[59][INDEX] = ActionEntry(REDUCE, 174);
   _actionMap[60][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[60][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[60][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[60][ObjSpec] = 187;
   _actionMap[61][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[61][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[61][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[61][ObjSpec] = 188;
   _actionMap[62][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[62][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[62][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[62][ObjSpec] = 189;
   _actionMap[63][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[63][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[63][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[63][ObjSpec] = 190;
   _actionMap[64][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[64][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[64][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[64][ObjSpec] = 191;
   _actionMap[65][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[65][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[65][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[65][ObjSpec] = 192;
   _actionMap[66][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[66][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[66][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[66][ObjSpec] = 193;
   _actionMap[67][IDENTIFIER] = ActionEntry(SHIFT, 194);
   _actionMap[68][EXISTS] = ActionEntry(SHIFT, 195);
   _actionMap[69][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[69][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[69][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[69][ObjSpec] = 196;
   _actionMap[70][IDENTIFIER] = ActionEntry(SHIFT, 197);
   _actionMap[70][SEMICOLON] = ActionEntry(REDUCE, 67);
   _actionMap[71][IDENTIFIER] = ActionEntry(REDUCE, 69);
   _actionMap[71][SEMICOLON] = ActionEntry(REDUCE, 69);
   _actionMap[72][FOR] = ActionEntry(SHIFT, 199);
   _actionMap[72][SEMICOLON] = ActionEntry(REDUCE, 12);
   _jumpMap[72][TableSetOpt] = 198;
   _actionMap[73][FOR] = ActionEntry(SHIFT, 199);
   _actionMap[73][SEMICOLON] = ActionEntry(REDUCE, 12);
   _jumpMap[73][TableSetOpt] = 200;
   _actionMap[74][FOR] = ActionEntry(SHIFT, 199);
}
void Cego::loadParser205()
{
   _actionMap[74][SEMICOLON] = ActionEntry(REDUCE, 12);
   _jumpMap[74][TableSetOpt] = 201;
   _actionMap[75][FOR] = ActionEntry(SHIFT, 199);
   _actionMap[75][SEMICOLON] = ActionEntry(REDUCE, 12);
   _jumpMap[75][TableSetOpt] = 202;
   _actionMap[76][FOR] = ActionEntry(SHIFT, 199);
   _actionMap[76][SEMICOLON] = ActionEntry(REDUCE, 12);
   _jumpMap[76][TableSetOpt] = 203;
   _actionMap[77][FOR] = ActionEntry(SHIFT, 199);
   _actionMap[77][SEMICOLON] = ActionEntry(REDUCE, 12);
   _jumpMap[77][TableSetOpt] = 204;
   _actionMap[78][SEMICOLON] = ActionEntry(REDUCE, 2);
   _actionMap[79][FOR] = ActionEntry(SHIFT, 199);
   _actionMap[79][SEMICOLON] = ActionEntry(REDUCE, 12);
   _jumpMap[79][TableSetOpt] = 205;
   _actionMap[80][FOR] = ActionEntry(SHIFT, 199);
   _actionMap[80][SEMICOLON] = ActionEntry(REDUCE, 12);
   _jumpMap[80][TableSetOpt] = 206;
   _actionMap[81][SEMICOLON] = ActionEntry(REDUCE, 46);
   _actionMap[82][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[82][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[82][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[82][ObjSpec] = 207;
   _actionMap[83][SEMICOLON] = ActionEntry(REDUCE, 37);
   _actionMap[84][PLUS] = ActionEntry(SHIFT, 210);
   _actionMap[84][MINUS] = ActionEntry(SHIFT, 209);
   _actionMap[84][CONCAT] = ActionEntry(SHIFT, 208);
   _actionMap[84][SEMICOLON] = ActionEntry(REDUCE, 63);
   _actionMap[85][STAR] = ActionEntry(SHIFT, 211);
   _actionMap[85][DIVISION] = ActionEntry(SHIFT, 212);
   _actionMap[85][WHEN] = ActionEntry(REDUCE, 133);
   _actionMap[85][ELSE] = ActionEntry(REDUCE, 133);
   _actionMap[85][LEFT] = ActionEntry(REDUCE, 133);
   _actionMap[85][RIGHT] = ActionEntry(REDUCE, 133);
   _actionMap[85][INNER] = ActionEntry(REDUCE, 133);
   _actionMap[85][JOIN] = ActionEntry(REDUCE, 133);
   _actionMap[85][RETURNTOKEN] = ActionEntry(REDUCE, 133);
   _actionMap[85][ORDER] = ActionEntry(REDUCE, 133);
   _actionMap[85][GROUP] = ActionEntry(REDUCE, 133);
   _actionMap[85][WHERE] = ActionEntry(REDUCE, 133);
   _actionMap[85][BEGIN] = ActionEntry(REDUCE, 133);
   _actionMap[85][THEN] = ActionEntry(REDUCE, 133);
   _actionMap[85][OR] = ActionEntry(REDUCE, 133);
   _actionMap[85][AS] = ActionEntry(REDUCE, 133);
   _actionMap[85][FROM] = ActionEntry(REDUCE, 133);
   _actionMap[85][END_TOKEN] = ActionEntry(REDUCE, 133);
   _actionMap[85][AND] = ActionEntry(REDUCE, 133);
   _actionMap[85][LIKE] = ActionEntry(REDUCE, 133);
   _actionMap[85][IS] = ActionEntry(REDUCE, 133);
   _actionMap[85][BETWEEN] = ActionEntry(REDUCE, 133);
}
void Cego::loadParser206()
{
   _actionMap[85][NOT] = ActionEntry(REDUCE, 133);
   _actionMap[85][INTOK] = ActionEntry(REDUCE, 133);
   _actionMap[85][EQU] = ActionEntry(REDUCE, 133);
   _actionMap[85][NEGATION] = ActionEntry(REDUCE, 133);
   _actionMap[85][LT] = ActionEntry(REDUCE, 133);
   _actionMap[85][MT] = ActionEntry(REDUCE, 133);
   _actionMap[85][DESC] = ActionEntry(REDUCE, 133);
   _actionMap[85][ASC] = ActionEntry(REDUCE, 133);
   _actionMap[85][KSEP] = ActionEntry(REDUCE, 133);
   _actionMap[85][ROWLIMIT] = ActionEntry(REDUCE, 133);
   _actionMap[85][UNION] = ActionEntry(REDUCE, 133);
   _actionMap[85][ENDTOKEN] = ActionEntry(REDUCE, 133);
   _actionMap[85][RB] = ActionEntry(REDUCE, 133);
   _actionMap[85][SEMICOLON] = ActionEntry(REDUCE, 133);
   _actionMap[85][CONCAT] = ActionEntry(REDUCE, 133);
   _actionMap[85][MINUS] = ActionEntry(REDUCE, 133);
   _actionMap[85][PLUS] = ActionEntry(REDUCE, 133);
   _actionMap[86][WHEN] = ActionEntry(REDUCE, 137);
   _actionMap[86][ELSE] = ActionEntry(REDUCE, 137);
   _actionMap[86][LEFT] = ActionEntry(REDUCE, 137);
   _actionMap[86][RIGHT] = ActionEntry(REDUCE, 137);
   _actionMap[86][INNER] = ActionEntry(REDUCE, 137);
   _actionMap[86][JOIN] = ActionEntry(REDUCE, 137);
   _actionMap[86][RETURNTOKEN] = ActionEntry(REDUCE, 137);
   _actionMap[86][ORDER] = ActionEntry(REDUCE, 137);
   _actionMap[86][GROUP] = ActionEntry(REDUCE, 137);
   _actionMap[86][WHERE] = ActionEntry(REDUCE, 137);
   _actionMap[86][BEGIN] = ActionEntry(REDUCE, 137);
   _actionMap[86][THEN] = ActionEntry(REDUCE, 137);
   _actionMap[86][OR] = ActionEntry(REDUCE, 137);
   _actionMap[86][FROM] = ActionEntry(REDUCE, 137);
   _actionMap[86][AS] = ActionEntry(REDUCE, 137);
   _actionMap[86][END_TOKEN] = ActionEntry(REDUCE, 137);
   _actionMap[86][AND] = ActionEntry(REDUCE, 137);
   _actionMap[86][INTOK] = ActionEntry(REDUCE, 137);
   _actionMap[86][NOT] = ActionEntry(REDUCE, 137);
   _actionMap[86][BETWEEN] = ActionEntry(REDUCE, 137);
   _actionMap[86][IS] = ActionEntry(REDUCE, 137);
   _actionMap[86][LIKE] = ActionEntry(REDUCE, 137);
   _actionMap[86][MT] = ActionEntry(REDUCE, 137);
   _actionMap[86][LT] = ActionEntry(REDUCE, 137);
   _actionMap[86][NEGATION] = ActionEntry(REDUCE, 137);
   _actionMap[86][EQU] = ActionEntry(REDUCE, 137);
   _actionMap[86][RB] = ActionEntry(REDUCE, 137);
   _actionMap[86][ENDTOKEN] = ActionEntry(REDUCE, 137);
   _actionMap[86][UNION] = ActionEntry(REDUCE, 137);
   _actionMap[86][ROWLIMIT] = ActionEntry(REDUCE, 137);
   _actionMap[86][KSEP] = ActionEntry(REDUCE, 137);
   _actionMap[86][ASC] = ActionEntry(REDUCE, 137);
   _actionMap[86][DESC] = ActionEntry(REDUCE, 137);
}
void Cego::loadParser207()
{
   _actionMap[86][SEMICOLON] = ActionEntry(REDUCE, 137);
   _actionMap[86][PLUS] = ActionEntry(REDUCE, 137);
   _actionMap[86][MINUS] = ActionEntry(REDUCE, 137);
   _actionMap[86][DIVISION] = ActionEntry(REDUCE, 137);
   _actionMap[86][STAR] = ActionEntry(REDUCE, 137);
   _actionMap[86][CONCAT] = ActionEntry(REDUCE, 137);
   _actionMap[87][WHEN] = ActionEntry(REDUCE, 145);
   _actionMap[87][ELSE] = ActionEntry(REDUCE, 145);
   _actionMap[87][LEFT] = ActionEntry(REDUCE, 145);
   _actionMap[87][RIGHT] = ActionEntry(REDUCE, 145);
   _actionMap[87][INNER] = ActionEntry(REDUCE, 145);
   _actionMap[87][JOIN] = ActionEntry(REDUCE, 145);
   _actionMap[87][RETURNTOKEN] = ActionEntry(REDUCE, 145);
   _actionMap[87][ORDER] = ActionEntry(REDUCE, 145);
   _actionMap[87][GROUP] = ActionEntry(REDUCE, 145);
   _actionMap[87][WHERE] = ActionEntry(REDUCE, 145);
   _actionMap[87][BEGIN] = ActionEntry(REDUCE, 145);
   _actionMap[87][THEN] = ActionEntry(REDUCE, 145);
   _actionMap[87][OR] = ActionEntry(REDUCE, 145);
   _actionMap[87][AS] = ActionEntry(REDUCE, 145);
   _actionMap[87][FROM] = ActionEntry(REDUCE, 145);
   _actionMap[87][END_TOKEN] = ActionEntry(REDUCE, 145);
   _actionMap[87][AND] = ActionEntry(REDUCE, 145);
   _actionMap[87][LIKE] = ActionEntry(REDUCE, 145);
   _actionMap[87][IS] = ActionEntry(REDUCE, 145);
   _actionMap[87][BETWEEN] = ActionEntry(REDUCE, 145);
   _actionMap[87][NOT] = ActionEntry(REDUCE, 145);
   _actionMap[87][INTOK] = ActionEntry(REDUCE, 145);
   _actionMap[87][EQU] = ActionEntry(REDUCE, 145);
   _actionMap[87][NEGATION] = ActionEntry(REDUCE, 145);
   _actionMap[87][LT] = ActionEntry(REDUCE, 145);
   _actionMap[87][MT] = ActionEntry(REDUCE, 145);
   _actionMap[87][DESC] = ActionEntry(REDUCE, 145);
   _actionMap[87][ASC] = ActionEntry(REDUCE, 145);
   _actionMap[87][KSEP] = ActionEntry(REDUCE, 145);
   _actionMap[87][ROWLIMIT] = ActionEntry(REDUCE, 145);
   _actionMap[87][UNION] = ActionEntry(REDUCE, 145);
   _actionMap[87][ENDTOKEN] = ActionEntry(REDUCE, 145);
   _actionMap[87][RB] = ActionEntry(REDUCE, 145);
   _actionMap[87][SEMICOLON] = ActionEntry(REDUCE, 145);
   _actionMap[87][CONCAT] = ActionEntry(REDUCE, 145);
   _actionMap[87][STAR] = ActionEntry(REDUCE, 145);
   _actionMap[87][DIVISION] = ActionEntry(REDUCE, 145);
   _actionMap[87][MINUS] = ActionEntry(REDUCE, 145);
   _actionMap[87][PLUS] = ActionEntry(REDUCE, 145);
   _actionMap[88][WHEN] = ActionEntry(SHIFT, 215);
   _jumpMap[88][CaseCondition] = 214;
   _jumpMap[88][CaseConditionList] = 213;
   _actionMap[89][WHEN] = ActionEntry(REDUCE, 142);
   _actionMap[89][ELSE] = ActionEntry(REDUCE, 142);
}
void Cego::loadParser208()
{
   _actionMap[89][LEFT] = ActionEntry(REDUCE, 142);
   _actionMap[89][RIGHT] = ActionEntry(REDUCE, 142);
   _actionMap[89][INNER] = ActionEntry(REDUCE, 142);
   _actionMap[89][JOIN] = ActionEntry(REDUCE, 142);
   _actionMap[89][RETURNTOKEN] = ActionEntry(REDUCE, 142);
   _actionMap[89][ORDER] = ActionEntry(REDUCE, 142);
   _actionMap[89][GROUP] = ActionEntry(REDUCE, 142);
   _actionMap[89][WHERE] = ActionEntry(REDUCE, 142);
   _actionMap[89][BEGIN] = ActionEntry(REDUCE, 142);
   _actionMap[89][THEN] = ActionEntry(REDUCE, 142);
   _actionMap[89][OR] = ActionEntry(REDUCE, 142);
   _actionMap[89][AS] = ActionEntry(REDUCE, 142);
   _actionMap[89][FROM] = ActionEntry(REDUCE, 142);
   _actionMap[89][END_TOKEN] = ActionEntry(REDUCE, 142);
   _actionMap[89][AND] = ActionEntry(REDUCE, 142);
   _actionMap[89][LIKE] = ActionEntry(REDUCE, 142);
   _actionMap[89][IS] = ActionEntry(REDUCE, 142);
   _actionMap[89][BETWEEN] = ActionEntry(REDUCE, 142);
   _actionMap[89][NOT] = ActionEntry(REDUCE, 142);
   _actionMap[89][INTOK] = ActionEntry(REDUCE, 142);
   _actionMap[89][EQU] = ActionEntry(REDUCE, 142);
   _actionMap[89][NEGATION] = ActionEntry(REDUCE, 142);
   _actionMap[89][LT] = ActionEntry(REDUCE, 142);
   _actionMap[89][MT] = ActionEntry(REDUCE, 142);
   _actionMap[89][DESC] = ActionEntry(REDUCE, 142);
   _actionMap[89][ASC] = ActionEntry(REDUCE, 142);
   _actionMap[89][KSEP] = ActionEntry(REDUCE, 142);
   _actionMap[89][ROWLIMIT] = ActionEntry(REDUCE, 142);
   _actionMap[89][UNION] = ActionEntry(REDUCE, 142);
   _actionMap[89][ENDTOKEN] = ActionEntry(REDUCE, 142);
   _actionMap[89][RB] = ActionEntry(REDUCE, 142);
   _actionMap[89][SEMICOLON] = ActionEntry(REDUCE, 142);
   _actionMap[89][CONCAT] = ActionEntry(REDUCE, 142);
   _actionMap[89][STAR] = ActionEntry(REDUCE, 142);
   _actionMap[89][DIVISION] = ActionEntry(REDUCE, 142);
   _actionMap[89][MINUS] = ActionEntry(REDUCE, 142);
   _actionMap[89][PLUS] = ActionEntry(REDUCE, 142);
   _actionMap[90][WHEN] = ActionEntry(REDUCE, 141);
   _actionMap[90][ELSE] = ActionEntry(REDUCE, 141);
   _actionMap[90][LEFT] = ActionEntry(REDUCE, 141);
   _actionMap[90][RIGHT] = ActionEntry(REDUCE, 141);
   _actionMap[90][INNER] = ActionEntry(REDUCE, 141);
   _actionMap[90][JOIN] = ActionEntry(REDUCE, 141);
   _actionMap[90][RETURNTOKEN] = ActionEntry(REDUCE, 141);
   _actionMap[90][ORDER] = ActionEntry(REDUCE, 141);
   _actionMap[90][GROUP] = ActionEntry(REDUCE, 141);
   _actionMap[90][WHERE] = ActionEntry(REDUCE, 141);
   _actionMap[90][AS] = ActionEntry(REDUCE, 141);
   _actionMap[90][FROM] = ActionEntry(REDUCE, 141);
   _actionMap[90][END_TOKEN] = ActionEntry(REDUCE, 141);
}
void Cego::loadParser209()
{
   _actionMap[90][BEGIN] = ActionEntry(REDUCE, 141);
   _actionMap[90][THEN] = ActionEntry(REDUCE, 141);
   _actionMap[90][OR] = ActionEntry(REDUCE, 141);
   _actionMap[90][AND] = ActionEntry(REDUCE, 141);
   _actionMap[90][LIKE] = ActionEntry(REDUCE, 141);
   _actionMap[90][IS] = ActionEntry(REDUCE, 141);
   _actionMap[90][BETWEEN] = ActionEntry(REDUCE, 141);
   _actionMap[90][NOT] = ActionEntry(REDUCE, 141);
   _actionMap[90][INTOK] = ActionEntry(REDUCE, 141);
   _actionMap[90][EQU] = ActionEntry(REDUCE, 141);
   _actionMap[90][NEGATION] = ActionEntry(REDUCE, 141);
   _actionMap[90][LT] = ActionEntry(REDUCE, 141);
   _actionMap[90][MT] = ActionEntry(REDUCE, 141);
   _actionMap[90][DESC] = ActionEntry(REDUCE, 141);
   _actionMap[90][ASC] = ActionEntry(REDUCE, 141);
   _actionMap[90][KSEP] = ActionEntry(REDUCE, 141);
   _actionMap[90][ROWLIMIT] = ActionEntry(REDUCE, 141);
   _actionMap[90][UNION] = ActionEntry(REDUCE, 141);
   _actionMap[90][ENDTOKEN] = ActionEntry(REDUCE, 141);
   _actionMap[90][RB] = ActionEntry(REDUCE, 141);
   _actionMap[90][SEMICOLON] = ActionEntry(REDUCE, 141);
   _actionMap[90][CONCAT] = ActionEntry(REDUCE, 141);
   _actionMap[90][STAR] = ActionEntry(REDUCE, 141);
   _actionMap[90][DIVISION] = ActionEntry(REDUCE, 141);
   _actionMap[90][MINUS] = ActionEntry(REDUCE, 141);
   _actionMap[90][PLUS] = ActionEntry(REDUCE, 141);
   _actionMap[91][WHEN] = ActionEntry(REDUCE, 329);
   _actionMap[91][ELSE] = ActionEntry(REDUCE, 329);
   _actionMap[91][LEFT] = ActionEntry(REDUCE, 329);
   _actionMap[91][RIGHT] = ActionEntry(REDUCE, 329);
   _actionMap[91][INNER] = ActionEntry(REDUCE, 329);
   _actionMap[91][JOIN] = ActionEntry(REDUCE, 329);
   _actionMap[91][RETURNTOKEN] = ActionEntry(REDUCE, 329);
   _actionMap[91][ORDER] = ActionEntry(REDUCE, 329);
   _actionMap[91][GROUP] = ActionEntry(REDUCE, 329);
   _actionMap[91][WHERE] = ActionEntry(REDUCE, 329);
   _actionMap[91][NULLTOKEN] = ActionEntry(REDUCE, 329);
   _actionMap[91][FROM] = ActionEntry(REDUCE, 329);
   _actionMap[91][AS] = ActionEntry(REDUCE, 329);
   _actionMap[91][END_TOKEN] = ActionEntry(REDUCE, 329);
   _actionMap[91][BEGIN] = ActionEntry(REDUCE, 329);
   _actionMap[91][THEN] = ActionEntry(REDUCE, 329);
   _actionMap[91][OR] = ActionEntry(REDUCE, 329);
   _actionMap[91][AND] = ActionEntry(REDUCE, 329);
   _actionMap[91][INTOK] = ActionEntry(REDUCE, 329);
   _actionMap[91][NOT] = ActionEntry(REDUCE, 329);
   _actionMap[91][BETWEEN] = ActionEntry(REDUCE, 329);
   _actionMap[91][IS] = ActionEntry(REDUCE, 329);
   _actionMap[91][LIKE] = ActionEntry(REDUCE, 329);
   _actionMap[91][MT] = ActionEntry(REDUCE, 329);
}
void Cego::loadParser210()
{
   _actionMap[91][LT] = ActionEntry(REDUCE, 329);
   _actionMap[91][NEGATION] = ActionEntry(REDUCE, 329);
   _actionMap[91][EQU] = ActionEntry(REDUCE, 329);
   _actionMap[91][RB] = ActionEntry(REDUCE, 329);
   _actionMap[91][ENDTOKEN] = ActionEntry(REDUCE, 329);
   _actionMap[91][UNION] = ActionEntry(REDUCE, 329);
   _actionMap[91][ROWLIMIT] = ActionEntry(REDUCE, 329);
   _actionMap[91][KSEP] = ActionEntry(REDUCE, 329);
   _actionMap[91][ASC] = ActionEntry(REDUCE, 329);
   _actionMap[91][DESC] = ActionEntry(REDUCE, 329);
   _actionMap[91][SEMICOLON] = ActionEntry(REDUCE, 329);
   _actionMap[91][PLUS] = ActionEntry(REDUCE, 329);
   _actionMap[91][MINUS] = ActionEntry(REDUCE, 329);
   _actionMap[91][DIVISION] = ActionEntry(REDUCE, 329);
   _actionMap[91][STAR] = ActionEntry(REDUCE, 329);
   _actionMap[91][CONCAT] = ActionEntry(REDUCE, 329);
   _actionMap[92][WHEN] = ActionEntry(REDUCE, 335);
   _actionMap[92][ELSE] = ActionEntry(REDUCE, 335);
   _actionMap[92][LEFT] = ActionEntry(REDUCE, 335);
   _actionMap[92][RIGHT] = ActionEntry(REDUCE, 335);
   _actionMap[92][INNER] = ActionEntry(REDUCE, 335);
   _actionMap[92][JOIN] = ActionEntry(REDUCE, 335);
   _actionMap[92][RETURNTOKEN] = ActionEntry(REDUCE, 335);
   _actionMap[92][ORDER] = ActionEntry(REDUCE, 335);
   _actionMap[92][GROUP] = ActionEntry(REDUCE, 335);
   _actionMap[92][WHERE] = ActionEntry(REDUCE, 335);
   _actionMap[92][NULLTOKEN] = ActionEntry(REDUCE, 335);
   _actionMap[92][FROM] = ActionEntry(REDUCE, 335);
   _actionMap[92][AS] = ActionEntry(REDUCE, 335);
   _actionMap[92][END_TOKEN] = ActionEntry(REDUCE, 335);
   _actionMap[92][BEGIN] = ActionEntry(REDUCE, 335);
   _actionMap[92][THEN] = ActionEntry(REDUCE, 335);
   _actionMap[92][OR] = ActionEntry(REDUCE, 335);
   _actionMap[92][AND] = ActionEntry(REDUCE, 335);
   _actionMap[92][INTOK] = ActionEntry(REDUCE, 335);
   _actionMap[92][NOT] = ActionEntry(REDUCE, 335);
   _actionMap[92][BETWEEN] = ActionEntry(REDUCE, 335);
   _actionMap[92][IS] = ActionEntry(REDUCE, 335);
   _actionMap[92][LIKE] = ActionEntry(REDUCE, 335);
   _actionMap[92][MT] = ActionEntry(REDUCE, 335);
   _actionMap[92][LT] = ActionEntry(REDUCE, 335);
   _actionMap[92][NEGATION] = ActionEntry(REDUCE, 335);
   _actionMap[92][EQU] = ActionEntry(REDUCE, 335);
   _actionMap[92][RB] = ActionEntry(REDUCE, 335);
   _actionMap[92][ENDTOKEN] = ActionEntry(REDUCE, 335);
   _actionMap[92][UNION] = ActionEntry(REDUCE, 335);
   _actionMap[92][ROWLIMIT] = ActionEntry(REDUCE, 335);
   _actionMap[92][KSEP] = ActionEntry(REDUCE, 335);
   _actionMap[92][ASC] = ActionEntry(REDUCE, 335);
   _actionMap[92][DESC] = ActionEntry(REDUCE, 335);
}
void Cego::loadParser211()
{
   _actionMap[92][SEMICOLON] = ActionEntry(REDUCE, 335);
   _actionMap[92][PLUS] = ActionEntry(REDUCE, 335);
   _actionMap[92][MINUS] = ActionEntry(REDUCE, 335);
   _actionMap[92][DIVISION] = ActionEntry(REDUCE, 335);
   _actionMap[92][STAR] = ActionEntry(REDUCE, 335);
   _actionMap[92][CONCAT] = ActionEntry(REDUCE, 335);
   _actionMap[93][WHEN] = ActionEntry(REDUCE, 139);
   _actionMap[93][ELSE] = ActionEntry(REDUCE, 139);
   _actionMap[93][LEFT] = ActionEntry(REDUCE, 139);
   _actionMap[93][RIGHT] = ActionEntry(REDUCE, 139);
   _actionMap[93][INNER] = ActionEntry(REDUCE, 139);
   _actionMap[93][JOIN] = ActionEntry(REDUCE, 139);
   _actionMap[93][RETURNTOKEN] = ActionEntry(REDUCE, 139);
   _actionMap[93][ORDER] = ActionEntry(REDUCE, 139);
   _actionMap[93][GROUP] = ActionEntry(REDUCE, 139);
   _actionMap[93][WHERE] = ActionEntry(REDUCE, 139);
   _actionMap[93][AS] = ActionEntry(REDUCE, 139);
   _actionMap[93][FROM] = ActionEntry(REDUCE, 139);
   _actionMap[93][END_TOKEN] = ActionEntry(REDUCE, 139);
   _actionMap[93][BEGIN] = ActionEntry(REDUCE, 139);
   _actionMap[93][THEN] = ActionEntry(REDUCE, 139);
   _actionMap[93][OR] = ActionEntry(REDUCE, 139);
   _actionMap[93][AND] = ActionEntry(REDUCE, 139);
   _actionMap[93][LIKE] = ActionEntry(REDUCE, 139);
   _actionMap[93][IS] = ActionEntry(REDUCE, 139);
   _actionMap[93][BETWEEN] = ActionEntry(REDUCE, 139);
   _actionMap[93][NOT] = ActionEntry(REDUCE, 139);
   _actionMap[93][INTOK] = ActionEntry(REDUCE, 139);
   _actionMap[93][EQU] = ActionEntry(REDUCE, 139);
   _actionMap[93][NEGATION] = ActionEntry(REDUCE, 139);
   _actionMap[93][LT] = ActionEntry(REDUCE, 139);
   _actionMap[93][MT] = ActionEntry(REDUCE, 139);
   _actionMap[93][DESC] = ActionEntry(REDUCE, 139);
   _actionMap[93][ASC] = ActionEntry(REDUCE, 139);
   _actionMap[93][KSEP] = ActionEntry(REDUCE, 139);
   _actionMap[93][ROWLIMIT] = ActionEntry(REDUCE, 139);
   _actionMap[93][UNION] = ActionEntry(REDUCE, 139);
   _actionMap[93][ENDTOKEN] = ActionEntry(REDUCE, 139);
   _actionMap[93][RB] = ActionEntry(REDUCE, 139);
   _actionMap[93][SEMICOLON] = ActionEntry(REDUCE, 139);
   _actionMap[93][CONCAT] = ActionEntry(REDUCE, 139);
   _actionMap[93][STAR] = ActionEntry(REDUCE, 139);
   _actionMap[93][DIVISION] = ActionEntry(REDUCE, 139);
   _actionMap[93][MINUS] = ActionEntry(REDUCE, 139);
   _actionMap[93][PLUS] = ActionEntry(REDUCE, 139);
   _actionMap[94][LB] = ActionEntry(SHIFT, 216);
   _actionMap[95][WHEN] = ActionEntry(REDUCE, 334);
   _actionMap[95][ELSE] = ActionEntry(REDUCE, 334);
   _actionMap[95][LEFT] = ActionEntry(REDUCE, 334);
   _actionMap[95][RIGHT] = ActionEntry(REDUCE, 334);
}
void Cego::loadParser212()
{
   _actionMap[95][INNER] = ActionEntry(REDUCE, 334);
   _actionMap[95][JOIN] = ActionEntry(REDUCE, 334);
   _actionMap[95][RETURNTOKEN] = ActionEntry(REDUCE, 334);
   _actionMap[95][ORDER] = ActionEntry(REDUCE, 334);
   _actionMap[95][GROUP] = ActionEntry(REDUCE, 334);
   _actionMap[95][WHERE] = ActionEntry(REDUCE, 334);
   _actionMap[95][NULLTOKEN] = ActionEntry(REDUCE, 334);
   _actionMap[95][FROM] = ActionEntry(REDUCE, 334);
   _actionMap[95][AS] = ActionEntry(REDUCE, 334);
   _actionMap[95][END_TOKEN] = ActionEntry(REDUCE, 334);
   _actionMap[95][BEGIN] = ActionEntry(REDUCE, 334);
   _actionMap[95][THEN] = ActionEntry(REDUCE, 334);
   _actionMap[95][OR] = ActionEntry(REDUCE, 334);
   _actionMap[95][AND] = ActionEntry(REDUCE, 334);
   _actionMap[95][INTOK] = ActionEntry(REDUCE, 334);
   _actionMap[95][NOT] = ActionEntry(REDUCE, 334);
   _actionMap[95][BETWEEN] = ActionEntry(REDUCE, 334);
   _actionMap[95][IS] = ActionEntry(REDUCE, 334);
   _actionMap[95][LIKE] = ActionEntry(REDUCE, 334);
   _actionMap[95][MT] = ActionEntry(REDUCE, 334);
   _actionMap[95][LT] = ActionEntry(REDUCE, 334);
   _actionMap[95][NEGATION] = ActionEntry(REDUCE, 334);
   _actionMap[95][EQU] = ActionEntry(REDUCE, 334);
   _actionMap[95][RB] = ActionEntry(REDUCE, 334);
   _actionMap[95][ENDTOKEN] = ActionEntry(REDUCE, 334);
   _actionMap[95][UNION] = ActionEntry(REDUCE, 334);
   _actionMap[95][ROWLIMIT] = ActionEntry(REDUCE, 334);
   _actionMap[95][KSEP] = ActionEntry(REDUCE, 334);
   _actionMap[95][ASC] = ActionEntry(REDUCE, 334);
   _actionMap[95][DESC] = ActionEntry(REDUCE, 334);
   _actionMap[95][SEMICOLON] = ActionEntry(REDUCE, 334);
   _actionMap[95][PLUS] = ActionEntry(REDUCE, 334);
   _actionMap[95][MINUS] = ActionEntry(REDUCE, 334);
   _actionMap[95][DIVISION] = ActionEntry(REDUCE, 334);
   _actionMap[95][STAR] = ActionEntry(REDUCE, 334);
   _actionMap[95][CONCAT] = ActionEntry(REDUCE, 334);
   _actionMap[96][LB] = ActionEntry(SHIFT, 217);
   _actionMap[97][LB] = ActionEntry(SHIFT, 218);
   _actionMap[98][LB] = ActionEntry(SHIFT, 219);
   _actionMap[99][LB] = ActionEntry(SHIFT, 220);
   _actionMap[100][WHEN] = ActionEntry(REDUCE, 156);
   _actionMap[101][LB] = ActionEntry(SHIFT, 221);
   _actionMap[102][LB] = ActionEntry(SHIFT, 222);
   _actionMap[103][LB] = ActionEntry(SHIFT, 223);
   _actionMap[104][LB] = ActionEntry(SHIFT, 224);
   _actionMap[105][LB] = ActionEntry(SHIFT, 225);
   _actionMap[106][WHEN] = ActionEntry(REDUCE, 343);
   _actionMap[106][ELSE] = ActionEntry(REDUCE, 343);
   _actionMap[106][LEFT] = ActionEntry(REDUCE, 343);
   _actionMap[106][RIGHT] = ActionEntry(REDUCE, 343);
}
void Cego::loadParser213()
{
   _actionMap[106][INNER] = ActionEntry(REDUCE, 343);
   _actionMap[106][JOIN] = ActionEntry(REDUCE, 343);
   _actionMap[106][RETURNTOKEN] = ActionEntry(REDUCE, 343);
   _actionMap[106][ORDER] = ActionEntry(REDUCE, 343);
   _actionMap[106][GROUP] = ActionEntry(REDUCE, 343);
   _actionMap[106][WHERE] = ActionEntry(REDUCE, 343);
   _actionMap[106][FROM] = ActionEntry(REDUCE, 343);
   _actionMap[106][AS] = ActionEntry(REDUCE, 343);
   _actionMap[106][END_TOKEN] = ActionEntry(REDUCE, 343);
   _actionMap[106][BEGIN] = ActionEntry(REDUCE, 343);
   _actionMap[106][THEN] = ActionEntry(REDUCE, 343);
   _actionMap[106][OR] = ActionEntry(REDUCE, 343);
   _actionMap[106][AND] = ActionEntry(REDUCE, 343);
   _actionMap[106][NULLTOKEN] = ActionEntry(REDUCE, 343);
   _actionMap[106][INTOK] = ActionEntry(REDUCE, 343);
   _actionMap[106][NOT] = ActionEntry(REDUCE, 343);
   _actionMap[106][BETWEEN] = ActionEntry(REDUCE, 343);
   _actionMap[106][IS] = ActionEntry(REDUCE, 343);
   _actionMap[106][LIKE] = ActionEntry(REDUCE, 343);
   _actionMap[106][MT] = ActionEntry(REDUCE, 343);
   _actionMap[106][LT] = ActionEntry(REDUCE, 343);
   _actionMap[106][NEGATION] = ActionEntry(REDUCE, 343);
   _actionMap[106][EQU] = ActionEntry(REDUCE, 343);
   _actionMap[106][RB] = ActionEntry(REDUCE, 343);
   _actionMap[106][ENDTOKEN] = ActionEntry(REDUCE, 343);
   _actionMap[106][UNION] = ActionEntry(REDUCE, 343);
   _actionMap[106][ROWLIMIT] = ActionEntry(REDUCE, 343);
   _actionMap[106][KSEP] = ActionEntry(REDUCE, 343);
   _actionMap[106][ASC] = ActionEntry(REDUCE, 343);
   _actionMap[106][DESC] = ActionEntry(REDUCE, 343);
   _actionMap[106][SEMICOLON] = ActionEntry(REDUCE, 343);
   _actionMap[106][PLUS] = ActionEntry(REDUCE, 343);
   _actionMap[106][MINUS] = ActionEntry(REDUCE, 343);
   _actionMap[106][DIVISION] = ActionEntry(REDUCE, 343);
   _actionMap[106][STAR] = ActionEntry(REDUCE, 343);
   _actionMap[106][CONCAT] = ActionEntry(REDUCE, 343);
   _actionMap[107][IDENTIFIER] = ActionEntry(SHIFT, 226);
   _actionMap[108][LB] = ActionEntry(SHIFT, 227);
   _actionMap[109][LB] = ActionEntry(SHIFT, 228);
   _actionMap[110][LB] = ActionEntry(SHIFT, 229);
   _actionMap[111][LB] = ActionEntry(SHIFT, 230);
   _actionMap[112][LB] = ActionEntry(SHIFT, 231);
   _actionMap[113][LB] = ActionEntry(SHIFT, 232);
   _actionMap[114][LB] = ActionEntry(SHIFT, 233);
   _actionMap[115][LB] = ActionEntry(SHIFT, 234);
   _actionMap[116][LB] = ActionEntry(SHIFT, 235);
   _actionMap[117][LB] = ActionEntry(SHIFT, 236);
   _actionMap[118][WHEN] = ActionEntry(REDUCE, 341);
   _actionMap[118][ELSE] = ActionEntry(REDUCE, 341);
   _actionMap[118][LEFT] = ActionEntry(REDUCE, 341);
}
void Cego::loadParser214()
{
   _actionMap[118][RIGHT] = ActionEntry(REDUCE, 341);
   _actionMap[118][INNER] = ActionEntry(REDUCE, 341);
   _actionMap[118][JOIN] = ActionEntry(REDUCE, 341);
   _actionMap[118][RETURNTOKEN] = ActionEntry(REDUCE, 341);
   _actionMap[118][ORDER] = ActionEntry(REDUCE, 341);
   _actionMap[118][GROUP] = ActionEntry(REDUCE, 341);
   _actionMap[118][WHERE] = ActionEntry(REDUCE, 341);
   _actionMap[118][FROM] = ActionEntry(REDUCE, 341);
   _actionMap[118][AS] = ActionEntry(REDUCE, 341);
   _actionMap[118][END_TOKEN] = ActionEntry(REDUCE, 341);
   _actionMap[118][BEGIN] = ActionEntry(REDUCE, 341);
   _actionMap[118][THEN] = ActionEntry(REDUCE, 341);
   _actionMap[118][OR] = ActionEntry(REDUCE, 341);
   _actionMap[118][AND] = ActionEntry(REDUCE, 341);
   _actionMap[118][NULLTOKEN] = ActionEntry(REDUCE, 341);
   _actionMap[118][INTOK] = ActionEntry(REDUCE, 341);
   _actionMap[118][NOT] = ActionEntry(REDUCE, 341);
   _actionMap[118][BETWEEN] = ActionEntry(REDUCE, 341);
   _actionMap[118][IS] = ActionEntry(REDUCE, 341);
   _actionMap[118][LIKE] = ActionEntry(REDUCE, 341);
   _actionMap[118][MT] = ActionEntry(REDUCE, 341);
   _actionMap[118][LT] = ActionEntry(REDUCE, 341);
   _actionMap[118][NEGATION] = ActionEntry(REDUCE, 341);
   _actionMap[118][EQU] = ActionEntry(REDUCE, 341);
   _actionMap[118][RB] = ActionEntry(REDUCE, 341);
   _actionMap[118][ENDTOKEN] = ActionEntry(REDUCE, 341);
   _actionMap[118][UNION] = ActionEntry(REDUCE, 341);
   _actionMap[118][ROWLIMIT] = ActionEntry(REDUCE, 341);
   _actionMap[118][KSEP] = ActionEntry(REDUCE, 341);
   _actionMap[118][ASC] = ActionEntry(REDUCE, 341);
   _actionMap[118][DESC] = ActionEntry(REDUCE, 341);
   _actionMap[118][SEMICOLON] = ActionEntry(REDUCE, 341);
   _actionMap[118][PLUS] = ActionEntry(REDUCE, 341);
   _actionMap[118][MINUS] = ActionEntry(REDUCE, 341);
   _actionMap[118][DIVISION] = ActionEntry(REDUCE, 341);
   _actionMap[118][STAR] = ActionEntry(REDUCE, 341);
   _actionMap[118][CONCAT] = ActionEntry(REDUCE, 341);
   _actionMap[119][LB] = ActionEntry(SHIFT, 237);
   _actionMap[120][LB] = ActionEntry(SHIFT, 238);
   _actionMap[121][LB] = ActionEntry(SHIFT, 239);
   _actionMap[122][LB] = ActionEntry(SHIFT, 240);
   _actionMap[123][LB] = ActionEntry(SHIFT, 241);
   _actionMap[124][LB] = ActionEntry(SHIFT, 242);
   _actionMap[125][LB] = ActionEntry(SHIFT, 243);
   _actionMap[126][LB] = ActionEntry(SHIFT, 244);
   _actionMap[127][LB] = ActionEntry(SHIFT, 245);
   _actionMap[128][WHEN] = ActionEntry(REDUCE, 340);
   _actionMap[128][ELSE] = ActionEntry(REDUCE, 340);
   _actionMap[128][LEFT] = ActionEntry(REDUCE, 340);
   _actionMap[128][RIGHT] = ActionEntry(REDUCE, 340);
}
void Cego::loadParser215()
{
   _actionMap[128][INNER] = ActionEntry(REDUCE, 340);
   _actionMap[128][JOIN] = ActionEntry(REDUCE, 340);
   _actionMap[128][RETURNTOKEN] = ActionEntry(REDUCE, 340);
   _actionMap[128][ORDER] = ActionEntry(REDUCE, 340);
   _actionMap[128][GROUP] = ActionEntry(REDUCE, 340);
   _actionMap[128][WHERE] = ActionEntry(REDUCE, 340);
   _actionMap[128][FROM] = ActionEntry(REDUCE, 340);
   _actionMap[128][AS] = ActionEntry(REDUCE, 340);
   _actionMap[128][END_TOKEN] = ActionEntry(REDUCE, 340);
   _actionMap[128][BEGIN] = ActionEntry(REDUCE, 340);
   _actionMap[128][THEN] = ActionEntry(REDUCE, 340);
   _actionMap[128][OR] = ActionEntry(REDUCE, 340);
   _actionMap[128][AND] = ActionEntry(REDUCE, 340);
   _actionMap[128][NULLTOKEN] = ActionEntry(REDUCE, 340);
   _actionMap[128][INTOK] = ActionEntry(REDUCE, 340);
   _actionMap[128][NOT] = ActionEntry(REDUCE, 340);
   _actionMap[128][BETWEEN] = ActionEntry(REDUCE, 340);
   _actionMap[128][IS] = ActionEntry(REDUCE, 340);
   _actionMap[128][LIKE] = ActionEntry(REDUCE, 340);
   _actionMap[128][MT] = ActionEntry(REDUCE, 340);
   _actionMap[128][LT] = ActionEntry(REDUCE, 340);
   _actionMap[128][NEGATION] = ActionEntry(REDUCE, 340);
   _actionMap[128][EQU] = ActionEntry(REDUCE, 340);
   _actionMap[128][RB] = ActionEntry(REDUCE, 340);
   _actionMap[128][ENDTOKEN] = ActionEntry(REDUCE, 340);
   _actionMap[128][UNION] = ActionEntry(REDUCE, 340);
   _actionMap[128][ROWLIMIT] = ActionEntry(REDUCE, 340);
   _actionMap[128][KSEP] = ActionEntry(REDUCE, 340);
   _actionMap[128][ASC] = ActionEntry(REDUCE, 340);
   _actionMap[128][DESC] = ActionEntry(REDUCE, 340);
   _actionMap[128][SEMICOLON] = ActionEntry(REDUCE, 340);
   _actionMap[128][PLUS] = ActionEntry(REDUCE, 340);
   _actionMap[128][MINUS] = ActionEntry(REDUCE, 340);
   _actionMap[128][DIVISION] = ActionEntry(REDUCE, 340);
   _actionMap[128][STAR] = ActionEntry(REDUCE, 340);
   _actionMap[128][CONCAT] = ActionEntry(REDUCE, 340);
   _actionMap[129][LB] = ActionEntry(SHIFT, 246);
   _actionMap[130][LB] = ActionEntry(SHIFT, 247);
   _actionMap[131][LB] = ActionEntry(SHIFT, 248);
   _actionMap[132][WHEN] = ActionEntry(REDUCE, 342);
   _actionMap[132][ELSE] = ActionEntry(REDUCE, 342);
   _actionMap[132][LEFT] = ActionEntry(REDUCE, 342);
   _actionMap[132][RIGHT] = ActionEntry(REDUCE, 342);
   _actionMap[132][INNER] = ActionEntry(REDUCE, 342);
   _actionMap[132][JOIN] = ActionEntry(REDUCE, 342);
   _actionMap[132][RETURNTOKEN] = ActionEntry(REDUCE, 342);
   _actionMap[132][ORDER] = ActionEntry(REDUCE, 342);
   _actionMap[132][GROUP] = ActionEntry(REDUCE, 342);
   _actionMap[132][WHERE] = ActionEntry(REDUCE, 342);
   _actionMap[132][FROM] = ActionEntry(REDUCE, 342);
}
void Cego::loadParser216()
{
   _actionMap[132][AS] = ActionEntry(REDUCE, 342);
   _actionMap[132][END_TOKEN] = ActionEntry(REDUCE, 342);
   _actionMap[132][BEGIN] = ActionEntry(REDUCE, 342);
   _actionMap[132][THEN] = ActionEntry(REDUCE, 342);
   _actionMap[132][OR] = ActionEntry(REDUCE, 342);
   _actionMap[132][AND] = ActionEntry(REDUCE, 342);
   _actionMap[132][NULLTOKEN] = ActionEntry(REDUCE, 342);
   _actionMap[132][INTOK] = ActionEntry(REDUCE, 342);
   _actionMap[132][NOT] = ActionEntry(REDUCE, 342);
   _actionMap[132][BETWEEN] = ActionEntry(REDUCE, 342);
   _actionMap[132][IS] = ActionEntry(REDUCE, 342);
   _actionMap[132][LIKE] = ActionEntry(REDUCE, 342);
   _actionMap[132][MT] = ActionEntry(REDUCE, 342);
   _actionMap[132][LT] = ActionEntry(REDUCE, 342);
   _actionMap[132][NEGATION] = ActionEntry(REDUCE, 342);
   _actionMap[132][EQU] = ActionEntry(REDUCE, 342);
   _actionMap[132][RB] = ActionEntry(REDUCE, 342);
   _actionMap[132][ENDTOKEN] = ActionEntry(REDUCE, 342);
   _actionMap[132][UNION] = ActionEntry(REDUCE, 342);
   _actionMap[132][ROWLIMIT] = ActionEntry(REDUCE, 342);
   _actionMap[132][KSEP] = ActionEntry(REDUCE, 342);
   _actionMap[132][ASC] = ActionEntry(REDUCE, 342);
   _actionMap[132][DESC] = ActionEntry(REDUCE, 342);
   _actionMap[132][SEMICOLON] = ActionEntry(REDUCE, 342);
   _actionMap[132][PLUS] = ActionEntry(REDUCE, 342);
   _actionMap[132][MINUS] = ActionEntry(REDUCE, 342);
   _actionMap[132][DIVISION] = ActionEntry(REDUCE, 342);
   _actionMap[132][STAR] = ActionEntry(REDUCE, 342);
   _actionMap[132][CONCAT] = ActionEntry(REDUCE, 342);
   _actionMap[133][LB] = ActionEntry(SHIFT, 249);
   _actionMap[134][LB] = ActionEntry(SHIFT, 250);
   _actionMap[135][LONG] = ActionEntry(SHIFT, 257);
   _actionMap[135][BIGINT] = ActionEntry(SHIFT, 253);
   _actionMap[135][SMALLINT] = ActionEntry(SHIFT, 258);
   _actionMap[135][TINYINT] = ActionEntry(SHIFT, 259);
   _actionMap[135][DOUBLE] = ActionEntry(SHIFT, 255);
   _actionMap[135][DECIMAL] = ActionEntry(SHIFT, 254);
   _actionMap[135][FIXED] = ActionEntry(SHIFT, 256);
   _actionMap[135][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[135][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[135][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[135][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[135][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[135][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[135][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[135][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[135][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[135][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[135][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[135][UPPER] = ActionEntry(SHIFT, 134);
}
void Cego::loadParser217()
{
   _actionMap[135][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[135][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[135][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[135][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[135][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[135][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[135][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[135][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[135][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[135][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[135][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[135][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[135][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[135][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[135][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[135][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[135][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[135][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[135][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[135][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[135][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[135][LB] = ActionEntry(SHIFT, 135);
   _actionMap[135][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[135][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[135][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[135][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[135][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[135][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[135][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[135][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[135][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[135][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[135][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[135][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[135][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[135][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[135][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[135][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[135][MAX] = ActionEntry(SHIFT, 115);
   _actionMap[135][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[135][ObjSpec] = 94;
   _jumpMap[135][Constant] = 93;
   _jumpMap[135][SignedFloat] = 92;
   _jumpMap[135][SignedInt] = 91;
   _jumpMap[135][Attribute] = 90;
   _jumpMap[135][Function] = 89;
   _jumpMap[135][SelectStatement] = 252;
   _jumpMap[135][CasePrepare] = 88;
   _jumpMap[135][CaseClause] = 87;
   _jumpMap[135][Factor] = 86;
}
void Cego::loadParser218()
{
   _jumpMap[135][Term] = 85;
   _jumpMap[135][Expr] = 251;
   _actionMap[136][INTVAL] = ActionEntry(SHIFT, 260);
   _actionMap[137][FLOATVAL] = ActionEntry(SHIFT, 262);
   _actionMap[137][INTVAL] = ActionEntry(SHIFT, 261);
   _actionMap[138][WHEN] = ActionEntry(REDUCE, 325);
   _actionMap[138][ELSE] = ActionEntry(REDUCE, 325);
   _actionMap[138][LEFT] = ActionEntry(REDUCE, 325);
   _actionMap[138][RIGHT] = ActionEntry(REDUCE, 325);
   _actionMap[138][INNER] = ActionEntry(REDUCE, 325);
   _actionMap[138][JOIN] = ActionEntry(REDUCE, 325);
   _actionMap[138][RETURNTOKEN] = ActionEntry(REDUCE, 325);
   _actionMap[138][ORDER] = ActionEntry(REDUCE, 325);
   _actionMap[138][GROUP] = ActionEntry(REDUCE, 325);
   _actionMap[138][WHERE] = ActionEntry(REDUCE, 325);
   _actionMap[138][AS] = ActionEntry(REDUCE, 325);
   _actionMap[138][FROM] = ActionEntry(REDUCE, 325);
   _actionMap[138][END_TOKEN] = ActionEntry(REDUCE, 325);
   _actionMap[138][BEGIN] = ActionEntry(REDUCE, 325);
   _actionMap[138][THEN] = ActionEntry(REDUCE, 325);
   _actionMap[138][OR] = ActionEntry(REDUCE, 325);
   _actionMap[138][AND] = ActionEntry(REDUCE, 325);
   _actionMap[138][NULLTOKEN] = ActionEntry(REDUCE, 325);
   _actionMap[138][LIKE] = ActionEntry(REDUCE, 325);
   _actionMap[138][IS] = ActionEntry(REDUCE, 325);
   _actionMap[138][BETWEEN] = ActionEntry(REDUCE, 325);
   _actionMap[138][NOT] = ActionEntry(REDUCE, 325);
   _actionMap[138][INTOK] = ActionEntry(REDUCE, 325);
   _actionMap[138][EQU] = ActionEntry(REDUCE, 325);
   _actionMap[138][NEGATION] = ActionEntry(REDUCE, 325);
   _actionMap[138][LT] = ActionEntry(REDUCE, 325);
   _actionMap[138][MT] = ActionEntry(REDUCE, 325);
   _actionMap[138][DESC] = ActionEntry(REDUCE, 325);
   _actionMap[138][ASC] = ActionEntry(REDUCE, 325);
   _actionMap[138][KSEP] = ActionEntry(REDUCE, 325);
   _actionMap[138][ROWLIMIT] = ActionEntry(REDUCE, 325);
   _actionMap[138][UNION] = ActionEntry(REDUCE, 325);
   _actionMap[138][ENDTOKEN] = ActionEntry(REDUCE, 325);
   _actionMap[138][RB] = ActionEntry(REDUCE, 325);
   _actionMap[138][SEMICOLON] = ActionEntry(REDUCE, 325);
   _actionMap[138][CONCAT] = ActionEntry(REDUCE, 325);
   _actionMap[138][STAR] = ActionEntry(REDUCE, 325);
   _actionMap[138][DIVISION] = ActionEntry(REDUCE, 325);
   _actionMap[138][MINUS] = ActionEntry(REDUCE, 325);
   _actionMap[138][PLUS] = ActionEntry(REDUCE, 325);
   _actionMap[139][WHEN] = ActionEntry(REDUCE, 327);
   _actionMap[139][ELSE] = ActionEntry(REDUCE, 327);
   _actionMap[139][LEFT] = ActionEntry(REDUCE, 327);
   _actionMap[139][RIGHT] = ActionEntry(REDUCE, 327);
   _actionMap[139][INNER] = ActionEntry(REDUCE, 327);
}
void Cego::loadParser219()
{
   _actionMap[139][JOIN] = ActionEntry(REDUCE, 327);
   _actionMap[139][RETURNTOKEN] = ActionEntry(REDUCE, 327);
   _actionMap[139][ORDER] = ActionEntry(REDUCE, 327);
   _actionMap[139][GROUP] = ActionEntry(REDUCE, 327);
   _actionMap[139][WHERE] = ActionEntry(REDUCE, 327);
   _actionMap[139][AS] = ActionEntry(REDUCE, 327);
   _actionMap[139][FROM] = ActionEntry(REDUCE, 327);
   _actionMap[139][END_TOKEN] = ActionEntry(REDUCE, 327);
   _actionMap[139][BEGIN] = ActionEntry(REDUCE, 327);
   _actionMap[139][THEN] = ActionEntry(REDUCE, 327);
   _actionMap[139][OR] = ActionEntry(REDUCE, 327);
   _actionMap[139][AND] = ActionEntry(REDUCE, 327);
   _actionMap[139][NULLTOKEN] = ActionEntry(REDUCE, 327);
   _actionMap[139][LIKE] = ActionEntry(REDUCE, 327);
   _actionMap[139][IS] = ActionEntry(REDUCE, 327);
   _actionMap[139][BETWEEN] = ActionEntry(REDUCE, 327);
   _actionMap[139][NOT] = ActionEntry(REDUCE, 327);
   _actionMap[139][INTOK] = ActionEntry(REDUCE, 327);
   _actionMap[139][EQU] = ActionEntry(REDUCE, 327);
   _actionMap[139][NEGATION] = ActionEntry(REDUCE, 327);
   _actionMap[139][LT] = ActionEntry(REDUCE, 327);
   _actionMap[139][MT] = ActionEntry(REDUCE, 327);
   _actionMap[139][DESC] = ActionEntry(REDUCE, 327);
   _actionMap[139][ASC] = ActionEntry(REDUCE, 327);
   _actionMap[139][KSEP] = ActionEntry(REDUCE, 327);
   _actionMap[139][ROWLIMIT] = ActionEntry(REDUCE, 327);
   _actionMap[139][UNION] = ActionEntry(REDUCE, 327);
   _actionMap[139][ENDTOKEN] = ActionEntry(REDUCE, 327);
   _actionMap[139][RB] = ActionEntry(REDUCE, 327);
   _actionMap[139][SEMICOLON] = ActionEntry(REDUCE, 327);
   _actionMap[139][CONCAT] = ActionEntry(REDUCE, 327);
   _actionMap[139][STAR] = ActionEntry(REDUCE, 327);
   _actionMap[139][DIVISION] = ActionEntry(REDUCE, 327);
   _actionMap[139][MINUS] = ActionEntry(REDUCE, 327);
   _actionMap[139][PLUS] = ActionEntry(REDUCE, 327);
   _actionMap[140][WHEN] = ActionEntry(REDUCE, 322);
   _actionMap[140][ELSE] = ActionEntry(REDUCE, 322);
   _actionMap[140][LEFT] = ActionEntry(REDUCE, 322);
   _actionMap[140][RIGHT] = ActionEntry(REDUCE, 322);
   _actionMap[140][INNER] = ActionEntry(REDUCE, 322);
   _actionMap[140][JOIN] = ActionEntry(REDUCE, 322);
   _actionMap[140][RETURNTOKEN] = ActionEntry(REDUCE, 322);
   _actionMap[140][ORDER] = ActionEntry(REDUCE, 322);
   _actionMap[140][GROUP] = ActionEntry(REDUCE, 322);
   _actionMap[140][WHERE] = ActionEntry(REDUCE, 322);
   _actionMap[140][FROM] = ActionEntry(REDUCE, 322);
   _actionMap[140][AS] = ActionEntry(REDUCE, 322);
   _actionMap[140][END_TOKEN] = ActionEntry(REDUCE, 322);
   _actionMap[140][BEGIN] = ActionEntry(REDUCE, 322);
   _actionMap[140][THEN] = ActionEntry(REDUCE, 322);
}
void Cego::loadParser220()
{
   _actionMap[140][OR] = ActionEntry(REDUCE, 322);
   _actionMap[140][AND] = ActionEntry(REDUCE, 322);
   _actionMap[140][INTOK] = ActionEntry(REDUCE, 322);
   _actionMap[140][NOT] = ActionEntry(REDUCE, 322);
   _actionMap[140][BETWEEN] = ActionEntry(REDUCE, 322);
   _actionMap[140][IS] = ActionEntry(REDUCE, 322);
   _actionMap[140][LIKE] = ActionEntry(REDUCE, 322);
   _actionMap[140][MT] = ActionEntry(REDUCE, 322);
   _actionMap[140][LT] = ActionEntry(REDUCE, 322);
   _actionMap[140][NEGATION] = ActionEntry(REDUCE, 322);
   _actionMap[140][EQU] = ActionEntry(REDUCE, 322);
   _actionMap[140][RB] = ActionEntry(REDUCE, 322);
   _actionMap[140][ENDTOKEN] = ActionEntry(REDUCE, 322);
   _actionMap[140][UNION] = ActionEntry(REDUCE, 322);
   _actionMap[140][ROWLIMIT] = ActionEntry(REDUCE, 322);
   _actionMap[140][KSEP] = ActionEntry(REDUCE, 322);
   _actionMap[140][ASC] = ActionEntry(REDUCE, 322);
   _actionMap[140][DESC] = ActionEntry(REDUCE, 322);
   _actionMap[140][SEMICOLON] = ActionEntry(REDUCE, 322);
   _actionMap[140][PLUS] = ActionEntry(REDUCE, 322);
   _actionMap[140][MINUS] = ActionEntry(REDUCE, 322);
   _actionMap[140][LB] = ActionEntry(REDUCE, 348);
   _actionMap[140][DIVISION] = ActionEntry(REDUCE, 322);
   _actionMap[140][STAR] = ActionEntry(REDUCE, 322);
   _actionMap[140][CONCAT] = ActionEntry(REDUCE, 322);
   _actionMap[141][WHEN] = ActionEntry(REDUCE, 138);
   _actionMap[141][ELSE] = ActionEntry(REDUCE, 138);
   _actionMap[141][LEFT] = ActionEntry(REDUCE, 138);
   _actionMap[141][RIGHT] = ActionEntry(REDUCE, 138);
   _actionMap[141][INNER] = ActionEntry(REDUCE, 138);
   _actionMap[141][JOIN] = ActionEntry(REDUCE, 138);
   _actionMap[141][RETURNTOKEN] = ActionEntry(REDUCE, 138);
   _actionMap[141][ORDER] = ActionEntry(REDUCE, 138);
   _actionMap[141][GROUP] = ActionEntry(REDUCE, 138);
   _actionMap[141][WHERE] = ActionEntry(REDUCE, 138);
   _actionMap[141][AS] = ActionEntry(REDUCE, 138);
   _actionMap[141][FROM] = ActionEntry(REDUCE, 138);
   _actionMap[141][END_TOKEN] = ActionEntry(REDUCE, 138);
   _actionMap[141][BEGIN] = ActionEntry(REDUCE, 138);
   _actionMap[141][THEN] = ActionEntry(REDUCE, 138);
   _actionMap[141][OR] = ActionEntry(REDUCE, 138);
   _actionMap[141][AND] = ActionEntry(REDUCE, 138);
   _actionMap[141][LIKE] = ActionEntry(REDUCE, 138);
   _actionMap[141][IS] = ActionEntry(REDUCE, 138);
   _actionMap[141][BETWEEN] = ActionEntry(REDUCE, 138);
   _actionMap[141][NOT] = ActionEntry(REDUCE, 138);
   _actionMap[141][INTOK] = ActionEntry(REDUCE, 138);
   _actionMap[141][EQU] = ActionEntry(REDUCE, 138);
   _actionMap[141][NEGATION] = ActionEntry(REDUCE, 138);
   _actionMap[141][LT] = ActionEntry(REDUCE, 138);
}
void Cego::loadParser221()
{
   _actionMap[141][MT] = ActionEntry(REDUCE, 138);
   _actionMap[141][DESC] = ActionEntry(REDUCE, 138);
   _actionMap[141][ASC] = ActionEntry(REDUCE, 138);
   _actionMap[141][KSEP] = ActionEntry(REDUCE, 138);
   _actionMap[141][ROWLIMIT] = ActionEntry(REDUCE, 138);
   _actionMap[141][UNION] = ActionEntry(REDUCE, 138);
   _actionMap[141][ENDTOKEN] = ActionEntry(REDUCE, 138);
   _actionMap[141][RB] = ActionEntry(REDUCE, 138);
   _actionMap[141][SEMICOLON] = ActionEntry(REDUCE, 138);
   _actionMap[141][CONCAT] = ActionEntry(REDUCE, 138);
   _actionMap[141][STAR] = ActionEntry(REDUCE, 138);
   _actionMap[141][DIVISION] = ActionEntry(REDUCE, 138);
   _actionMap[141][MINUS] = ActionEntry(REDUCE, 138);
   _actionMap[141][PLUS] = ActionEntry(REDUCE, 138);
   _actionMap[142][WHEN] = ActionEntry(REDUCE, 323);
   _actionMap[142][ELSE] = ActionEntry(REDUCE, 323);
   _actionMap[142][LEFT] = ActionEntry(REDUCE, 323);
   _actionMap[142][RIGHT] = ActionEntry(REDUCE, 323);
   _actionMap[142][INNER] = ActionEntry(REDUCE, 323);
   _actionMap[142][JOIN] = ActionEntry(REDUCE, 323);
   _actionMap[142][RETURNTOKEN] = ActionEntry(REDUCE, 323);
   _actionMap[142][ORDER] = ActionEntry(REDUCE, 323);
   _actionMap[142][GROUP] = ActionEntry(REDUCE, 323);
   _actionMap[142][WHERE] = ActionEntry(REDUCE, 323);
   _actionMap[142][FROM] = ActionEntry(REDUCE, 323);
   _actionMap[142][AS] = ActionEntry(REDUCE, 323);
   _actionMap[142][END_TOKEN] = ActionEntry(REDUCE, 323);
   _actionMap[142][BEGIN] = ActionEntry(REDUCE, 323);
   _actionMap[142][THEN] = ActionEntry(REDUCE, 323);
   _actionMap[142][OR] = ActionEntry(REDUCE, 323);
   _actionMap[142][AND] = ActionEntry(REDUCE, 323);
   _actionMap[142][INTOK] = ActionEntry(REDUCE, 323);
   _actionMap[142][NOT] = ActionEntry(REDUCE, 323);
   _actionMap[142][BETWEEN] = ActionEntry(REDUCE, 323);
   _actionMap[142][IS] = ActionEntry(REDUCE, 323);
   _actionMap[142][LIKE] = ActionEntry(REDUCE, 323);
   _actionMap[142][MT] = ActionEntry(REDUCE, 323);
   _actionMap[142][LT] = ActionEntry(REDUCE, 323);
   _actionMap[142][NEGATION] = ActionEntry(REDUCE, 323);
   _actionMap[142][EQU] = ActionEntry(REDUCE, 323);
   _actionMap[142][RB] = ActionEntry(REDUCE, 323);
   _actionMap[142][ENDTOKEN] = ActionEntry(REDUCE, 323);
   _actionMap[142][UNION] = ActionEntry(REDUCE, 323);
   _actionMap[142][ROWLIMIT] = ActionEntry(REDUCE, 323);
   _actionMap[142][KSEP] = ActionEntry(REDUCE, 323);
   _actionMap[142][ASC] = ActionEntry(REDUCE, 323);
   _actionMap[142][DESC] = ActionEntry(REDUCE, 323);
   _actionMap[142][SEMICOLON] = ActionEntry(REDUCE, 323);
   _actionMap[142][PLUS] = ActionEntry(REDUCE, 323);
   _actionMap[142][MINUS] = ActionEntry(REDUCE, 323);
}
void Cego::loadParser222()
{
   _actionMap[142][LB] = ActionEntry(REDUCE, 349);
   _actionMap[142][DIVISION] = ActionEntry(REDUCE, 323);
   _actionMap[142][STAR] = ActionEntry(REDUCE, 323);
   _actionMap[142][CONCAT] = ActionEntry(REDUCE, 323);
   _actionMap[143][STAR] = ActionEntry(SHIFT, 263);
   _actionMap[144][WHEN] = ActionEntry(REDUCE, 345);
   _actionMap[144][ELSE] = ActionEntry(REDUCE, 345);
   _actionMap[144][LEFT] = ActionEntry(REDUCE, 345);
   _actionMap[144][RIGHT] = ActionEntry(REDUCE, 345);
   _actionMap[144][INNER] = ActionEntry(REDUCE, 345);
   _actionMap[144][JOIN] = ActionEntry(REDUCE, 345);
   _actionMap[144][RETURNTOKEN] = ActionEntry(REDUCE, 345);
   _actionMap[144][ORDER] = ActionEntry(REDUCE, 345);
   _actionMap[144][GROUP] = ActionEntry(REDUCE, 345);
   _actionMap[144][WHERE] = ActionEntry(REDUCE, 345);
   _actionMap[144][FROM] = ActionEntry(REDUCE, 345);
   _actionMap[144][AS] = ActionEntry(REDUCE, 345);
   _actionMap[144][END_TOKEN] = ActionEntry(REDUCE, 345);
   _actionMap[144][BEGIN] = ActionEntry(REDUCE, 345);
   _actionMap[144][THEN] = ActionEntry(REDUCE, 345);
   _actionMap[144][OR] = ActionEntry(REDUCE, 345);
   _actionMap[144][AND] = ActionEntry(REDUCE, 345);
   _actionMap[144][NULLTOKEN] = ActionEntry(REDUCE, 345);
   _actionMap[144][INTOK] = ActionEntry(REDUCE, 345);
   _actionMap[144][NOT] = ActionEntry(REDUCE, 345);
   _actionMap[144][BETWEEN] = ActionEntry(REDUCE, 345);
   _actionMap[144][IS] = ActionEntry(REDUCE, 345);
   _actionMap[144][LIKE] = ActionEntry(REDUCE, 345);
   _actionMap[144][MT] = ActionEntry(REDUCE, 345);
   _actionMap[144][LT] = ActionEntry(REDUCE, 345);
   _actionMap[144][NEGATION] = ActionEntry(REDUCE, 345);
   _actionMap[144][EQU] = ActionEntry(REDUCE, 345);
   _actionMap[144][RB] = ActionEntry(REDUCE, 345);
   _actionMap[144][ENDTOKEN] = ActionEntry(REDUCE, 345);
   _actionMap[144][UNION] = ActionEntry(REDUCE, 345);
   _actionMap[144][ROWLIMIT] = ActionEntry(REDUCE, 345);
   _actionMap[144][KSEP] = ActionEntry(REDUCE, 345);
   _actionMap[144][ASC] = ActionEntry(REDUCE, 345);
   _actionMap[144][DESC] = ActionEntry(REDUCE, 345);
   _actionMap[144][SEMICOLON] = ActionEntry(REDUCE, 345);
   _actionMap[144][PLUS] = ActionEntry(REDUCE, 345);
   _actionMap[144][MINUS] = ActionEntry(REDUCE, 345);
   _actionMap[144][DIVISION] = ActionEntry(REDUCE, 345);
   _actionMap[144][STAR] = ActionEntry(REDUCE, 345);
   _actionMap[144][CONCAT] = ActionEntry(REDUCE, 345);
   _actionMap[145][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[145][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[145][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[145][ObjSpec] = 264;
   _actionMap[146][IDENTIFIER] = ActionEntry(SHIFT, 48);
}
void Cego::loadParser223()
{
   _actionMap[146][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[146][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[146][ObjSpec] = 265;
   _actionMap[147][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[147][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[147][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[147][ObjSpec] = 266;
   _actionMap[148][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[148][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[148][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[148][ObjSpec] = 267;
   _actionMap[149][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[149][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[149][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[149][ObjSpec] = 268;
   _actionMap[150][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[150][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[150][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[150][ObjSpec] = 269;
   _actionMap[151][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[151][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[151][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[151][ObjSpec] = 270;
   _actionMap[152][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[152][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[152][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[152][ObjSpec] = 271;
   _actionMap[153][FROM] = ActionEntry(SHIFT, 272);
   _actionMap[154][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[154][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[154][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[154][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[154][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[154][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[154][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[154][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[154][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[154][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[154][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[154][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[154][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[154][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[154][GETPOS] = ActionEntry(SHIFT, 108);
   _actionMap[154][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[154][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[154][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[154][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[154][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[154][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[154][RANDSTR] = ActionEntry(SHIFT, 120);
}
void Cego::loadParser224()
{
   _actionMap[154][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[154][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[154][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[154][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[154][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[154][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[154][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[154][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[154][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[154][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[154][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[154][LB] = ActionEntry(SHIFT, 135);
   _actionMap[154][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[154][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[154][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[154][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[154][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[154][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[154][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[154][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[154][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[154][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[154][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[154][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[154][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[154][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[154][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[154][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[154][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[154][ObjSpec] = 94;
   _jumpMap[154][Constant] = 93;
   _jumpMap[154][SignedFloat] = 92;
   _jumpMap[154][SignedInt] = 91;
   _jumpMap[154][Attribute] = 90;
   _jumpMap[154][Function] = 89;
   _jumpMap[154][SelectItem] = 275;
   _jumpMap[154][SelectionList] = 274;
   _jumpMap[154][CasePrepare] = 88;
   _jumpMap[154][CaseClause] = 87;
   _jumpMap[154][Factor] = 86;
   _jumpMap[154][Term] = 85;
   _jumpMap[154][Expr] = 273;
   _actionMap[155][VARREF] = ActionEntry(REDUCE, 227);
   _actionMap[155][FETCH] = ActionEntry(REDUCE, 227);
   _actionMap[155][LB] = ActionEntry(REDUCE, 227);
   _actionMap[155][COUNT] = ActionEntry(REDUCE, 227);
   _actionMap[155][SUM] = ActionEntry(REDUCE, 227);
   _actionMap[155][AVG] = ActionEntry(REDUCE, 227);
   _actionMap[155][MIN] = ActionEntry(REDUCE, 227);
   _actionMap[155][MAX] = ActionEntry(REDUCE, 227);
}
void Cego::loadParser225()
{
   _actionMap[155][CASE] = ActionEntry(REDUCE, 227);
   _actionMap[155][TRIM] = ActionEntry(REDUCE, 227);
   _actionMap[155][RTRIM] = ActionEntry(REDUCE, 227);
   _actionMap[155][LTRIM] = ActionEntry(REDUCE, 227);
   _actionMap[155][ROUND] = ActionEntry(REDUCE, 227);
   _actionMap[155][DATE2STR] = ActionEntry(REDUCE, 227);
   _actionMap[155][DATE2INT] = ActionEntry(REDUCE, 227);
   _actionMap[155][INT2DATE] = ActionEntry(REDUCE, 227);
   _actionMap[155][LOWER] = ActionEntry(REDUCE, 227);
   _actionMap[155][UPPER] = ActionEntry(REDUCE, 227);
   _actionMap[155][LEFT] = ActionEntry(REDUCE, 227);
   _actionMap[155][RIGHT] = ActionEntry(REDUCE, 227);
   _actionMap[155][GETPOS] = ActionEntry(REDUCE, 227);
   _actionMap[155][SUBSTR] = ActionEntry(REDUCE, 227);
   _actionMap[155][REPLACE] = ActionEntry(REDUCE, 227);
   _actionMap[155][LENGTH] = ActionEntry(REDUCE, 227);
   _actionMap[155][TRUNC] = ActionEntry(REDUCE, 227);
   _actionMap[155][STR2INT] = ActionEntry(REDUCE, 227);
   _actionMap[155][STR2LONG] = ActionEntry(REDUCE, 227);
   _actionMap[155][RANDSTR] = ActionEntry(REDUCE, 227);
   _actionMap[155][RANDINT] = ActionEntry(REDUCE, 227);
   _actionMap[155][MOD] = ActionEntry(REDUCE, 227);
   _actionMap[155][DIV] = ActionEntry(REDUCE, 227);
   _actionMap[155][POWER] = ActionEntry(REDUCE, 227);
   _actionMap[155][BITAND] = ActionEntry(REDUCE, 227);
   _actionMap[155][BITOR] = ActionEntry(REDUCE, 227);
   _actionMap[155][BITXOR] = ActionEntry(REDUCE, 227);
   _actionMap[155][NEXTCOUNT] = ActionEntry(REDUCE, 227);
   _actionMap[155][IDENTIFIER] = ActionEntry(REDUCE, 227);
   _actionMap[155][QUALIFIEDOBJ] = ActionEntry(REDUCE, 227);
   _actionMap[155][QUALIFIEDTS] = ActionEntry(REDUCE, 227);
   _actionMap[155][QUALIFIEDPRE] = ActionEntry(REDUCE, 227);
   _actionMap[155][STRINGVAL] = ActionEntry(REDUCE, 227);
   _actionMap[155][DATE] = ActionEntry(REDUCE, 227);
   _actionMap[155][SYSDATE] = ActionEntry(REDUCE, 227);
   _actionMap[155][NULLTOKEN] = ActionEntry(REDUCE, 227);
   _actionMap[155][TRUEVAL] = ActionEntry(REDUCE, 227);
   _actionMap[155][FALSEVAL] = ActionEntry(REDUCE, 227);
   _actionMap[155][LAB] = ActionEntry(REDUCE, 227);
   _actionMap[155][COUNTERID] = ActionEntry(REDUCE, 227);
   _actionMap[155][FLOATVAL] = ActionEntry(REDUCE, 227);
   _actionMap[155][MINUS] = ActionEntry(REDUCE, 227);
   _actionMap[155][INTVAL] = ActionEntry(REDUCE, 227);
   _actionMap[156][FROM] = ActionEntry(REDUCE, 190);
   _actionMap[157][OFF] = ActionEntry(SHIFT, 276);
   _actionMap[157][ON] = ActionEntry(SHIFT, 277);
   _actionMap[158][OFF] = ActionEntry(SHIFT, 278);
   _actionMap[158][ON] = ActionEntry(SHIFT, 279);
   _actionMap[159][IDENTIFIER] = ActionEntry(SHIFT, 280);
   _actionMap[160][IDENTIFIER] = ActionEntry(SHIFT, 281);
}
void Cego::loadParser226()
{
   _actionMap[161][EQU] = ActionEntry(SHIFT, 282);
   _actionMap[162][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[162][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[162][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[162][ObjSpec] = 283;
   _actionMap[163][SEMICOLON] = ActionEntry(REDUCE, 14);
   _actionMap[164][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[164][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[164][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[164][ObjSpec] = 284;
   _actionMap[165][SEMICOLON] = ActionEntry(REDUCE, 15);
   _actionMap[166][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[166][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[166][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[166][ObjSpec] = 285;
   _actionMap[167][SEMICOLON] = ActionEntry(REDUCE, 176);
   _actionMap[168][SEMICOLON] = ActionEntry(REDUCE, 13);
   _actionMap[169][SET] = ActionEntry(SHIFT, 286);
   _actionMap[170][CALL] = ActionEntry(SHIFT, 287);
   _actionMap[1][TABLE] = ActionEntry(SHIFT, 42);
   _actionMap[1][INDEX] = ActionEntry(SHIFT, 40);
   _actionMap[1][VIEW] = ActionEntry(SHIFT, 43);
   _actionMap[1][PROCEDURE] = ActionEntry(SHIFT, 41);
   _actionMap[1][FOREIGN] = ActionEntry(SHIFT, 39);
   _actionMap[1][CHECK] = ActionEntry(SHIFT, 38);
   _actionMap[2][SEMICOLON] = ActionEntry(SHIFT, 44);
   _actionMap[3][SEMICOLON] = ActionEntry(REDUCE, 26);
   _actionMap[4][SEMICOLON] = ActionEntry(REDUCE, 27);
   _actionMap[5][SEMICOLON] = ActionEntry(REDUCE, 28);
   _actionMap[6][SEMICOLON] = ActionEntry(REDUCE, 38);
   _actionMap[7][SEMICOLON] = ActionEntry(REDUCE, 36);
   _actionMap[8][SEMICOLON] = ActionEntry(REDUCE, 40);
   _actionMap[9][SEMICOLON] = ActionEntry(REDUCE, 39);
   _actionMap[10][SEMICOLON] = ActionEntry(REDUCE, 41);
   _actionMap[11][SEMICOLON] = ActionEntry(REDUCE, 42);
   _actionMap[12][TABLE] = ActionEntry(SHIFT, 45);
   _actionMap[13][IDENTIFIER] = ActionEntry(SHIFT, 46);
   _actionMap[14][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[14][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[14][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[14][ObjSpec] = 47;
   _actionMap[15][INDEX] = ActionEntry(SHIFT, 51);
   _actionMap[16][SEMICOLON] = ActionEntry(REDUCE, 177);
   _actionMap[17][VIEW] = ActionEntry(SHIFT, 60);
   _actionMap[17][TABLE] = ActionEntry(SHIFT, 58);
   _actionMap[17][PRIMARY] = ActionEntry(SHIFT, 56);
   _actionMap[17][COUNTER] = ActionEntry(SHIFT, 55);
   _actionMap[17][PROCEDURE] = ActionEntry(SHIFT, 57);
   _actionMap[17][UNIQUE] = ActionEntry(SHIFT, 59);
   _actionMap[17][INDEX] = ActionEntry(REDUCE, 175);
}
void Cego::loadParser227()
{
   _jumpMap[17][IndexOption] = 54;
   _jumpMap[17][ProcDef] = 53;
   _jumpMap[17][ProcHead] = 52;
   _actionMap[18][FROM] = ActionEntry(SHIFT, 61);
   _actionMap[19][TABLE] = ActionEntry(SHIFT, 65);
   _actionMap[19][INDEX] = ActionEntry(SHIFT, 62);
   _actionMap[19][VIEW] = ActionEntry(SHIFT, 66);
   _actionMap[19][KEY] = ActionEntry(SHIFT, 63);
   _actionMap[19][PROCEDURE] = ActionEntry(SHIFT, 64);
   _actionMap[20][CHECK] = ActionEntry(REDUCE, 58);
   _actionMap[20][IF] = ActionEntry(SHIFT, 68);
   _actionMap[20][FOREIGN] = ActionEntry(REDUCE, 58);
   _actionMap[20][PROCEDURE] = ActionEntry(REDUCE, 58);
   _actionMap[20][VIEW] = ActionEntry(REDUCE, 58);
   _actionMap[20][INDEX] = ActionEntry(REDUCE, 58);
   _actionMap[20][TABLE] = ActionEntry(REDUCE, 58);
   _actionMap[20][COUNTER] = ActionEntry(SHIFT, 67);
   _actionMap[21][INTO] = ActionEntry(SHIFT, 69);
   _actionMap[22][IDENTIFIER] = ActionEntry(SHIFT, 71);
   _jumpMap[22][JdbcArgList] = 70;
   _actionMap[23][TABLESET] = ActionEntry(SHIFT, 78);
   _actionMap[23][TABLE] = ActionEntry(SHIFT, 77);
   _actionMap[23][PROCEDURE] = ActionEntry(SHIFT, 75);
   _actionMap[23][VIEW] = ActionEntry(SHIFT, 80);
   _actionMap[23][INDEX] = ActionEntry(SHIFT, 73);
   _actionMap[23][KEY] = ActionEntry(SHIFT, 74);
   _actionMap[23][COUNTER] = ActionEntry(SHIFT, 72);
   _actionMap[23][SYSOBJ] = ActionEntry(SHIFT, 76);
   _actionMap[23][TMPOBJ] = ActionEntry(SHIFT, 79);
   _actionMap[24][VIEW] = ActionEntry(SHIFT, 82);
   _actionMap[24][PROCEDURE] = ActionEntry(SHIFT, 57);
   _jumpMap[24][ProcDef] = 81;
   _jumpMap[24][ProcHead] = 52;
   _actionMap[25][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[25][SelectStatement] = 83;
   _actionMap[26][FLOATVAL] = ActionEntry(SHIFT, 139);
   _actionMap[26][MINUS] = ActionEntry(SHIFT, 137);
   _actionMap[26][INTVAL] = ActionEntry(SHIFT, 138);
   _actionMap[26][TRIM] = ActionEntry(SHIFT, 131);
   _actionMap[26][RTRIM] = ActionEntry(SHIFT, 125);
   _actionMap[26][LTRIM] = ActionEntry(SHIFT, 113);
   _actionMap[26][ROUND] = ActionEntry(SHIFT, 124);
   _actionMap[26][DATE2STR] = ActionEntry(SHIFT, 103);
   _actionMap[26][DATE2INT] = ActionEntry(SHIFT, 104);
   _actionMap[26][INT2DATE] = ActionEntry(SHIFT, 109);
   _actionMap[26][LOWER] = ActionEntry(SHIFT, 112);
   _actionMap[26][UPPER] = ActionEntry(SHIFT, 134);
   _actionMap[26][LEFT] = ActionEntry(SHIFT, 110);
   _actionMap[26][RIGHT] = ActionEntry(SHIFT, 123);
   _actionMap[26][GETPOS] = ActionEntry(SHIFT, 108);
}
void Cego::loadParser228()
{
   _actionMap[26][SUBSTR] = ActionEntry(SHIFT, 126);
   _actionMap[26][REPLACE] = ActionEntry(SHIFT, 122);
   _actionMap[26][LENGTH] = ActionEntry(SHIFT, 111);
   _actionMap[26][TRUNC] = ActionEntry(SHIFT, 133);
   _actionMap[26][STR2INT] = ActionEntry(SHIFT, 129);
   _actionMap[26][STR2LONG] = ActionEntry(SHIFT, 130);
   _actionMap[26][RANDSTR] = ActionEntry(SHIFT, 120);
   _actionMap[26][RANDINT] = ActionEntry(SHIFT, 121);
   _actionMap[26][MOD] = ActionEntry(SHIFT, 116);
   _actionMap[26][DIV] = ActionEntry(SHIFT, 105);
   _actionMap[26][POWER] = ActionEntry(SHIFT, 119);
   _actionMap[26][BITAND] = ActionEntry(SHIFT, 97);
   _actionMap[26][BITOR] = ActionEntry(SHIFT, 98);
   _actionMap[26][BITXOR] = ActionEntry(SHIFT, 99);
   _actionMap[26][NEXTCOUNT] = ActionEntry(SHIFT, 117);
   _actionMap[26][IDENTIFIER] = ActionEntry(SHIFT, 140);
   _actionMap[26][QUALIFIEDOBJ] = ActionEntry(SHIFT, 142);
   _actionMap[26][QUALIFIEDPRE] = ActionEntry(SHIFT, 143);
   _actionMap[26][LB] = ActionEntry(SHIFT, 135);
   _actionMap[26][STRINGVAL] = ActionEntry(SHIFT, 95);
   _actionMap[26][DATE] = ActionEntry(SHIFT, 102);
   _actionMap[26][SYSDATE] = ActionEntry(SHIFT, 128);
   _actionMap[26][NULLTOKEN] = ActionEntry(SHIFT, 118);
   _actionMap[26][TRUEVAL] = ActionEntry(SHIFT, 132);
   _actionMap[26][FALSEVAL] = ActionEntry(SHIFT, 106);
   _actionMap[26][LAB] = ActionEntry(SHIFT, 136);
   _actionMap[26][COUNTERID] = ActionEntry(SHIFT, 144);
   _actionMap[26][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _actionMap[26][CASE] = ActionEntry(SHIFT, 100);
   _actionMap[26][VARREF] = ActionEntry(SHIFT, 141);
   _actionMap[26][FETCH] = ActionEntry(SHIFT, 107);
   _actionMap[26][COUNT] = ActionEntry(SHIFT, 101);
   _actionMap[26][SUM] = ActionEntry(SHIFT, 127);
   _actionMap[26][AVG] = ActionEntry(SHIFT, 96);
   _actionMap[26][MIN] = ActionEntry(SHIFT, 114);
   _actionMap[26][MAX] = ActionEntry(SHIFT, 115);
   _jumpMap[26][ObjSpec] = 94;
   _jumpMap[26][Constant] = 93;
   _jumpMap[26][SignedFloat] = 92;
   _jumpMap[26][SignedInt] = 91;
   _jumpMap[26][Attribute] = 90;
   _jumpMap[26][Function] = 89;
   _jumpMap[26][CasePrepare] = 88;
   _jumpMap[26][CaseClause] = 87;
   _jumpMap[26][Factor] = 86;
   _jumpMap[26][Term] = 85;
   _jumpMap[26][Expr] = 84;
   _actionMap[27][TABLE] = ActionEntry(SHIFT, 149);
   _actionMap[27][INDEX] = ActionEntry(SHIFT, 146);
   _actionMap[27][KEY] = ActionEntry(SHIFT, 147);
}
void Cego::loadParser229()
{
   _actionMap[27][PROCEDURE] = ActionEntry(SHIFT, 148);
   _actionMap[27][VIEW] = ActionEntry(SHIFT, 150);
   _actionMap[27][CHECK] = ActionEntry(SHIFT, 145);
   _actionMap[28][TABLE] = ActionEntry(SHIFT, 152);
   _actionMap[28][INDEX] = ActionEntry(SHIFT, 151);
   _actionMap[29][SEMICOLON] = ActionEntry(REDUCE, 178);
   _actionMap[30][DISTINCT] = ActionEntry(SHIFT, 155);
   _actionMap[30][VARREF] = ActionEntry(REDUCE, 228);
   _actionMap[30][FETCH] = ActionEntry(REDUCE, 228);
   _actionMap[30][LB] = ActionEntry(REDUCE, 228);
   _actionMap[30][COUNT] = ActionEntry(REDUCE, 228);
   _actionMap[30][SUM] = ActionEntry(REDUCE, 228);
   _actionMap[30][AVG] = ActionEntry(REDUCE, 228);
   _actionMap[30][MIN] = ActionEntry(REDUCE, 228);
   _actionMap[30][MAX] = ActionEntry(REDUCE, 228);
   _actionMap[30][CASE] = ActionEntry(REDUCE, 228);
   _actionMap[30][TRIM] = ActionEntry(REDUCE, 228);
   _actionMap[30][RTRIM] = ActionEntry(REDUCE, 228);
   _actionMap[30][LTRIM] = ActionEntry(REDUCE, 228);
   _actionMap[30][ROUND] = ActionEntry(REDUCE, 228);
   _actionMap[30][DATE2STR] = ActionEntry(REDUCE, 228);
   _actionMap[30][DATE2INT] = ActionEntry(REDUCE, 228);
   _actionMap[30][INT2DATE] = ActionEntry(REDUCE, 228);
   _actionMap[30][LOWER] = ActionEntry(REDUCE, 228);
   _actionMap[30][UPPER] = ActionEntry(REDUCE, 228);
   _actionMap[30][LEFT] = ActionEntry(REDUCE, 228);
   _actionMap[30][RIGHT] = ActionEntry(REDUCE, 228);
   _actionMap[30][GETPOS] = ActionEntry(REDUCE, 228);
   _actionMap[30][SUBSTR] = ActionEntry(REDUCE, 228);
   _actionMap[30][REPLACE] = ActionEntry(REDUCE, 228);
   _actionMap[30][LENGTH] = ActionEntry(REDUCE, 228);
   _actionMap[30][TRUNC] = ActionEntry(REDUCE, 228);
   _actionMap[30][STR2INT] = ActionEntry(REDUCE, 228);
   _actionMap[30][STR2LONG] = ActionEntry(REDUCE, 228);
   _actionMap[30][RANDSTR] = ActionEntry(REDUCE, 228);
   _actionMap[30][RANDINT] = ActionEntry(REDUCE, 228);
   _actionMap[30][MOD] = ActionEntry(REDUCE, 228);
   _actionMap[30][DIV] = ActionEntry(REDUCE, 228);
   _actionMap[30][POWER] = ActionEntry(REDUCE, 228);
   _actionMap[30][BITAND] = ActionEntry(REDUCE, 228);
   _actionMap[30][BITOR] = ActionEntry(REDUCE, 228);
   _actionMap[30][BITXOR] = ActionEntry(REDUCE, 228);
   _actionMap[30][NEXTCOUNT] = ActionEntry(REDUCE, 228);
   _actionMap[30][IDENTIFIER] = ActionEntry(REDUCE, 228);
   _actionMap[30][QUALIFIEDOBJ] = ActionEntry(REDUCE, 228);
   _actionMap[30][QUALIFIEDTS] = ActionEntry(REDUCE, 228);
   _actionMap[30][QUALIFIEDPRE] = ActionEntry(REDUCE, 228);
   _actionMap[30][STRINGVAL] = ActionEntry(REDUCE, 228);
   _actionMap[30][DATE] = ActionEntry(REDUCE, 228);
   _actionMap[30][SYSDATE] = ActionEntry(REDUCE, 228);
}
void Cego::loadParser230()
{
   _actionMap[30][NULLTOKEN] = ActionEntry(REDUCE, 228);
   _actionMap[30][TRUEVAL] = ActionEntry(REDUCE, 228);
   _actionMap[30][FALSEVAL] = ActionEntry(REDUCE, 228);
   _actionMap[30][LAB] = ActionEntry(REDUCE, 228);
   _actionMap[30][COUNTERID] = ActionEntry(REDUCE, 228);
   _actionMap[30][FLOATVAL] = ActionEntry(REDUCE, 228);
   _actionMap[30][MINUS] = ActionEntry(REDUCE, 228);
   _actionMap[30][INTVAL] = ActionEntry(REDUCE, 228);
   _actionMap[30][STAR] = ActionEntry(SHIFT, 156);
   _jumpMap[30][DistinctOpt] = 154;
   _jumpMap[30][Selection] = 153;
   _actionMap[31][TABLESET] = ActionEntry(SHIFT, 160);
   _actionMap[31][APPEND] = ActionEntry(SHIFT, 157);
   _actionMap[31][AUTOCOMMIT] = ActionEntry(SHIFT, 158);
   _actionMap[31][ISOLATION] = ActionEntry(SHIFT, 159);
   _actionMap[31][IDENTIFIER] = ActionEntry(SHIFT, 161);
   _actionMap[32][POOL] = ActionEntry(SHIFT, 163);
   _actionMap[32][SYSTEMSPACE] = ActionEntry(SHIFT, 165);
   _actionMap[32][PROCEDURE] = ActionEntry(SHIFT, 164);
   _actionMap[32][VIEW] = ActionEntry(SHIFT, 166);
   _actionMap[32][CHECK] = ActionEntry(SHIFT, 162);
   _actionMap[33][TRANSACTION] = ActionEntry(SHIFT, 167);
   _actionMap[34][SEMICOLON] = ActionEntry(REDUCE, 1);
   _actionMap[35][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[35][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[35][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[35][ObjSpec] = 168;
   _actionMap[36][IDENTIFIER] = ActionEntry(SHIFT, 48);
   _actionMap[36][QUALIFIEDOBJ] = ActionEntry(SHIFT, 49);
   _actionMap[36][QUALIFIEDTS] = ActionEntry(SHIFT, 50);
   _jumpMap[36][ObjSpec] = 169;
   _actionMap[37][EQU] = ActionEntry(SHIFT, 170);
   _actionMap[0][DROP] = ActionEntry(SHIFT, 20);
   _actionMap[0][RENAME] = ActionEntry(SHIFT, 27);
   _actionMap[0][ALTER] = ActionEntry(SHIFT, 12);
   _actionMap[0][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[0][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[0][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[0][SELECT] = ActionEntry(SHIFT, 30);
   _actionMap[0][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[0][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[0][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[0][SYNC] = ActionEntry(SHIFT, 34);
   _actionMap[0][LIST] = ActionEntry(SHIFT, 23);
   _actionMap[0][TABLEINFO] = ActionEntry(SHIFT, 35);
   _actionMap[0][SHOW] = ActionEntry(SHIFT, 32);
   _actionMap[0][DESC] = ActionEntry(SHIFT, 19);
   _actionMap[0][SET] = ActionEntry(SHIFT, 31);
   _actionMap[0][AUTHORIZE] = ActionEntry(SHIFT, 13);
   _actionMap[0][REORGANIZE] = ActionEntry(SHIFT, 28);
}
void Cego::loadParser231()
{
   _actionMap[0][PLAN] = ActionEntry(SHIFT, 25);
   _actionMap[0][CREATE] = ActionEntry(SHIFT, 17);
   _actionMap[0][LOAD] = ActionEntry(SHIFT, 24);
   _actionMap[0][CALL] = ActionEntry(SHIFT, 14);
   _actionMap[0][VARREF] = ActionEntry(SHIFT, 37);
   _actionMap[0][PRINT] = ActionEntry(SHIFT, 26);
   _actionMap[0][CHECK] = ActionEntry(SHIFT, 15);
   _actionMap[0][JDBC] = ActionEntry(SHIFT, 22);
   _jumpMap[0][RenameStatement] = 11;
   _jumpMap[0][AlterStatement] = 10;
   _jumpMap[0][DeleteStatement] = 9;
   _jumpMap[0][UpdateStatement] = 8;
   _jumpMap[0][SelectStatement] = 7;
   _jumpMap[0][InsertStatement] = 6;
   _jumpMap[0][RollbackStatement] = 5;
   _jumpMap[0][CommitStatement] = 4;
   _jumpMap[0][StartStatement] = 3;
   _jumpMap[0][Statement] = 2;
   _jumpMap[0][DropOpt] = 1;
}
void Cego::loadParser232()
{
   _prodInfo.Insert(ProdEntry(350, ObjSpec, 1));
   _prodInfo.Insert(ProdEntry(349, ObjSpec, 1));
   _prodInfo.Insert(ProdEntry(348, ObjSpec, 1));
   _prodInfo.Insert(ProdEntry(347, DateValue, 1));
   _prodInfo.Insert(ProdEntry(346, DateFormat, 1));
   _prodInfo.Insert(ProdEntry(345, Constant, 1));
   _prodInfo.Insert(ProdEntry(344, Constant, 5));
   _prodInfo.Insert(ProdEntry(343, Constant, 1));
   _prodInfo.Insert(ProdEntry(342, Constant, 1));
   _prodInfo.Insert(ProdEntry(341, Constant, 1));
   _prodInfo.Insert(ProdEntry(340, Constant, 1));
   _prodInfo.Insert(ProdEntry(339, Constant, 6));
   _prodInfo.Insert(ProdEntry(338, Constant, 4));
   _prodInfo.Insert(ProdEntry(337, Constant, 4));
   _prodInfo.Insert(ProdEntry(336, Constant, 4));
   _prodInfo.Insert(ProdEntry(335, Constant, 1));
   _prodInfo.Insert(ProdEntry(334, Constant, 1));
   _prodInfo.Insert(ProdEntry(333, Constant, 4));
   _prodInfo.Insert(ProdEntry(332, Constant, 4));
   _prodInfo.Insert(ProdEntry(331, Constant, 4));
   _prodInfo.Insert(ProdEntry(330, Constant, 4));
   _prodInfo.Insert(ProdEntry(329, Constant, 1));
   _prodInfo.Insert(ProdEntry(328, SignedFloat, 2));
   _prodInfo.Insert(ProdEntry(327, SignedFloat, 1));
   _prodInfo.Insert(ProdEntry(326, SignedInt, 2));
   _prodInfo.Insert(ProdEntry(325, SignedInt, 1));
   _prodInfo.Insert(ProdEntry(324, Attribute, 2));
   _prodInfo.Insert(ProdEntry(323, Attribute, 1));
   _prodInfo.Insert(ProdEntry(322, Attribute, 1));
   _prodInfo.Insert(ProdEntry(321, Comparison, 2));
   _prodInfo.Insert(ProdEntry(320, Comparison, 2));
   _prodInfo.Insert(ProdEntry(319, Comparison, 1));
   _prodInfo.Insert(ProdEntry(318, Comparison, 1));
   _prodInfo.Insert(ProdEntry(317, Comparison, 2));
   _prodInfo.Insert(ProdEntry(316, Comparison, 1));
   _prodInfo.Insert(ProdEntry(315, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(314, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(313, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(312, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(311, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(310, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(309, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(308, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(307, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(306, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(305, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(304, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(303, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(302, QueryPredicate, 2));
   _prodInfo.Insert(ProdEntry(301, QueryPredicate, 3));
   _prodInfo.Insert(ProdEntry(300, QueryPredicate, 4));
   _prodInfo.Insert(ProdEntry(299, QueryPredicate, 3));
   _prodInfo.Insert(ProdEntry(298, QueryPredicate, 4));
   _prodInfo.Insert(ProdEntry(297, QueryPredicate, 3));
   _prodInfo.Insert(ProdEntry(296, QueryPredicate, 5));
   _prodInfo.Insert(ProdEntry(295, QueryPredicate, 3));
   _prodInfo.Insert(ProdEntry(294, QueryPredicate, 6));
   _prodInfo.Insert(ProdEntry(293, QueryPredicate, 5));
   _prodInfo.Insert(ProdEntry(292, QueryPredicate, 4));
   _prodInfo.Insert(ProdEntry(291, QueryCondition, 1));
   _prodInfo.Insert(ProdEntry(290, QueryCondition, 3));
   _prodInfo.Insert(ProdEntry(289, QueryCondition, 3));
   _prodInfo.Insert(ProdEntry(288, NoWhere, 0));
   _prodInfo.Insert(ProdEntry(287, WhereClause, 1));
   _prodInfo.Insert(ProdEntry(286, WhereClause, 2));
   _prodInfo.Insert(ProdEntry(285, ExpressionList, 1));
   _prodInfo.Insert(ProdEntry(284, ExpressionList, 3));
   _prodInfo.Insert(ProdEntry(283, Function, 3));
   _prodInfo.Insert(ProdEntry(282, Function, 4));
   _prodInfo.Insert(ProdEntry(281, Function, 4));
   _prodInfo.Insert(ProdEntry(280, Function, 4));
   _prodInfo.Insert(ProdEntry(279, Function, 4));
   _prodInfo.Insert(ProdEntry(278, Function, 4));
   _prodInfo.Insert(ProdEntry(277, Function, 4));
   _prodInfo.Insert(ProdEntry(276, Function, 4));
   _prodInfo.Insert(ProdEntry(275, Function, 4));
   _prodInfo.Insert(ProdEntry(274, Function, 4));
   _prodInfo.Insert(ProdEntry(273, Function, 4));
   _prodInfo.Insert(ProdEntry(272, Function, 4));
   _prodInfo.Insert(ProdEntry(271, Function, 4));
   _prodInfo.Insert(ProdEntry(270, Function, 4));
   _prodInfo.Insert(ProdEntry(269, Function, 4));
   _prodInfo.Insert(ProdEntry(268, Function, 4));
   _prodInfo.Insert(ProdEntry(267, Function, 4));
   _prodInfo.Insert(ProdEntry(266, Function, 4));
   _prodInfo.Insert(ProdEntry(265, Function, 4));
   _prodInfo.Insert(ProdEntry(264, Function, 4));
   _prodInfo.Insert(ProdEntry(263, Function, 4));
   _prodInfo.Insert(ProdEntry(262, Function, 4));
   _prodInfo.Insert(ProdEntry(261, Function, 4));
   _prodInfo.Insert(ProdEntry(260, Function, 4));
   _prodInfo.Insert(ProdEntry(259, Function, 4));
   _prodInfo.Insert(ProdEntry(258, Function, 4));
   _prodInfo.Insert(ProdEntry(257, Function, 4));
   _prodInfo.Insert(ProdEntry(256, Function, 4));
   _prodInfo.Insert(ProdEntry(255, Function, 4));
   _prodInfo.Insert(ProdEntry(254, RenameStatement, 5));
   _prodInfo.Insert(ProdEntry(253, RenameStatement, 5));
   _prodInfo.Insert(ProdEntry(252, RenameStatement, 5));
   _prodInfo.Insert(ProdEntry(251, RenameStatement, 5));
   _prodInfo.Insert(ProdEntry(250, RenameStatement, 5));
   _prodInfo.Insert(ProdEntry(249, RenameStatement, 5));
   _prodInfo.Insert(ProdEntry(248, AlterOption, 5));
   _prodInfo.Insert(ProdEntry(247, AlterOption, 3));
   _prodInfo.Insert(ProdEntry(246, AlterOption, 3));
   _prodInfo.Insert(ProdEntry(245, AlterOption, 3));
   _prodInfo.Insert(ProdEntry(244, AlterList, 1));
   _prodInfo.Insert(ProdEntry(243, AlterList, 3));
   _prodInfo.Insert(ProdEntry(242, AlterStatement, 4));
   _prodInfo.Insert(ProdEntry(241, DeleteStatement, 4));
   _prodInfo.Insert(ProdEntry(240, ReturnVar, 3));
   _prodInfo.Insert(ProdEntry(239, ReturnVarList, 1));
   _prodInfo.Insert(ProdEntry(238, ReturnVarList, 3));
   _prodInfo.Insert(ProdEntry(237, UpdReturnOpt, 0));
   _prodInfo.Insert(ProdEntry(236, UpdReturnOpt, 2));
   _prodInfo.Insert(ProdEntry(235, Assignment, 3));
   _prodInfo.Insert(ProdEntry(234, UpdateList, 1));
   _prodInfo.Insert(ProdEntry(233, UpdateList, 3));
   _prodInfo.Insert(ProdEntry(232, UpdateStatement, 6));
   _prodInfo.Insert(ProdEntry(231, NoLimit, 0));
   _prodInfo.Insert(ProdEntry(230, LimitOpt, 1));
   _prodInfo.Insert(ProdEntry(229, LimitOpt, 2));
   _prodInfo.Insert(ProdEntry(228, DistinctOpt, 0));
   _prodInfo.Insert(ProdEntry(227, DistinctOpt, 1));
   _prodInfo.Insert(ProdEntry(226, DefaultOrderOpt, 0));
   _prodInfo.Insert(ProdEntry(225, DefaultOrderOpt, 1));
   _prodInfo.Insert(ProdEntry(224, OrderingOpt, 1));
   _prodInfo.Insert(ProdEntry(223, OrderingOpt, 1));
   _prodInfo.Insert(ProdEntry(222, OrderingList, 2));
   _prodInfo.Insert(ProdEntry(221, OrderingList, 4));
   _prodInfo.Insert(ProdEntry(220, NoOrdering, 0));
   _prodInfo.Insert(ProdEntry(219, OrderingClause, 1));
   _prodInfo.Insert(ProdEntry(218, OrderingClause, 3));
   _prodInfo.Insert(ProdEntry(217, NoHaving, 0));
   _prodInfo.Insert(ProdEntry(216, HavingClause, 1));
   _prodInfo.Insert(ProdEntry(215, HavingClause, 4));
   _prodInfo.Insert(ProdEntry(214, GroupList, 1));
   _prodInfo.Insert(ProdEntry(213, GroupList, 3));
   _prodInfo.Insert(ProdEntry(212, NoGroup, 0));
   _prodInfo.Insert(ProdEntry(211, GroupClause, 1));
   _prodInfo.Insert(ProdEntry(210, GroupClause, 4));
   _prodInfo.Insert(ProdEntry(209, AliasOpt, 0));
   _prodInfo.Insert(ProdEntry(208, AliasOpt, 2));
   _prodInfo.Insert(ProdEntry(207, JoinTableOn, 1));
   _prodInfo.Insert(ProdEntry(206, Table, 2));
   _prodInfo.Insert(ProdEntry(205, Table, 1));
   _prodInfo.Insert(ProdEntry(204, TableList, 1));
   _prodInfo.Insert(ProdEntry(203, TableList, 3));
   _prodInfo.Insert(ProdEntry(202, InnerJoin, 1));
   _prodInfo.Insert(ProdEntry(201, InnerJoin, 2));
   _prodInfo.Insert(ProdEntry(200, JoinSpec, 6));
   _prodInfo.Insert(ProdEntry(199, JoinSpec, 6));
   _prodInfo.Insert(ProdEntry(198, JoinSpec, 4));
   _prodInfo.Insert(ProdEntry(197, JoinSpecList, 2));
   _prodInfo.Insert(ProdEntry(196, JoinSpecList, 2));
   _prodInfo.Insert(ProdEntry(195, TableSource, 1));
   _prodInfo.Insert(ProdEntry(194, TableSource, 1));
   _prodInfo.Insert(ProdEntry(193, SelectItem, 2));
   _prodInfo.Insert(ProdEntry(192, SelectionList, 1));
   _prodInfo.Insert(ProdEntry(191, SelectionList, 3));
   _prodInfo.Insert(ProdEntry(190, Selection, 1));
   _prodInfo.Insert(ProdEntry(189, Selection, 2));
   _prodInfo.Insert(ProdEntry(188, SelectStatement, 9));
   _prodInfo.Insert(ProdEntry(187, InsertValueList, 1));
   _prodInfo.Insert(ProdEntry(186, InsertValueList, 3));
   _prodInfo.Insert(ProdEntry(185, InsertArgList, 1));
   _prodInfo.Insert(ProdEntry(184, InsertArgList, 3));
   _prodInfo.Insert(ProdEntry(183, InsertValueSpec, 3));
   _prodInfo.Insert(ProdEntry(182, InsertArgSpec, 0));
   _prodInfo.Insert(ProdEntry(181, InsertArgSpec, 3));
   _prodInfo.Insert(ProdEntry(180, InsertStatement, 5));
   _prodInfo.Insert(ProdEntry(179, InsertStatement, 6));
   _prodInfo.Insert(ProdEntry(178, RollbackStatement, 1));
   _prodInfo.Insert(ProdEntry(177, CommitStatement, 1));
   _prodInfo.Insert(ProdEntry(176, StartStatement, 2));
   _prodInfo.Insert(ProdEntry(175, IndexOption, 0));
   _prodInfo.Insert(ProdEntry(174, IndexOption, 1));
   _prodInfo.Insert(ProdEntry(173, SimpleAttr, 1));
   _prodInfo.Insert(ProdEntry(172, SimpleAttrList, 1));
   _prodInfo.Insert(ProdEntry(171, SimpleAttrList, 3));
   _prodInfo.Insert(ProdEntry(170, DefaultDefOpt, 0));
   _prodInfo.Insert(ProdEntry(169, DefaultOpt, 1));
   _prodInfo.Insert(ProdEntry(168, DefaultOpt, 2));
   _prodInfo.Insert(ProdEntry(167, DefaultNullOpt, 0));
   _prodInfo.Insert(ProdEntry(166, NullOpt, 1));
   _prodInfo.Insert(ProdEntry(165, NullOpt, 2));
   _prodInfo.Insert(ProdEntry(164, NullOpt, 1));
   _prodInfo.Insert(ProdEntry(163, ColumnDesc, 4));
   _prodInfo.Insert(ProdEntry(162, KeyColumn, 1));
   _prodInfo.Insert(ProdEntry(161, KeyColumn, 2));
   _prodInfo.Insert(ProdEntry(160, ColumnList, 1));
   _prodInfo.Insert(ProdEntry(159, ColumnList, 3));
   _prodInfo.Insert(ProdEntry(158, FetchArgList, 1));
   _prodInfo.Insert(ProdEntry(157, FetchArgList, 3));
   _prodInfo.Insert(ProdEntry(156, CasePrepare, 1));
   _prodInfo.Insert(ProdEntry(155, CaseCondition, 4));
   _prodInfo.Insert(ProdEntry(154, CaseConditionList, 1));
   _prodInfo.Insert(ProdEntry(153, CaseConditionList, 2));
   _prodInfo.Insert(ProdEntry(152, CaseClause, 5));
   _prodInfo.Insert(ProdEntry(151, Factor, 4));
   _prodInfo.Insert(ProdEntry(150, Factor, 4));
   _prodInfo.Insert(ProdEntry(149, Factor, 4));
   _prodInfo.Insert(ProdEntry(148, Factor, 4));
   _prodInfo.Insert(ProdEntry(147, Factor, 4));
   _prodInfo.Insert(ProdEntry(146, Factor, 4));
   _prodInfo.Insert(ProdEntry(145, Factor, 1));
   _prodInfo.Insert(ProdEntry(144, Factor, 3));
   _prodInfo.Insert(ProdEntry(143, Factor, 3));
   _prodInfo.Insert(ProdEntry(142, Factor, 1));
   _prodInfo.Insert(ProdEntry(141, Factor, 1));
   _prodInfo.Insert(ProdEntry(140, Factor, 6));
   _prodInfo.Insert(ProdEntry(139, Factor, 1));
   _prodInfo.Insert(ProdEntry(138, Factor, 1));
   _prodInfo.Insert(ProdEntry(137, Term, 1));
   _prodInfo.Insert(ProdEntry(136, Term, 3));
   _prodInfo.Insert(ProdEntry(135, Term, 3));
   _prodInfo.Insert(ProdEntry(134, Expr, 3));
   _prodInfo.Insert(ProdEntry(133, Expr, 1));
   _prodInfo.Insert(ProdEntry(132, Expr, 3));
   _prodInfo.Insert(ProdEntry(131, Expr, 3));
   _prodInfo.Insert(ProdEntry(130, ProcPredicate, 4));
   _prodInfo.Insert(ProdEntry(129, ProcPredicate, 3));
   _prodInfo.Insert(ProdEntry(128, ProcPredicate, 3));
   _prodInfo.Insert(ProdEntry(127, ProcPredicate, 3));
   _prodInfo.Insert(ProdEntry(126, ProcCondition, 1));
   _prodInfo.Insert(ProdEntry(125, ProcCondition, 3));
   _prodInfo.Insert(ProdEntry(124, ProcCondition, 3));
   _prodInfo.Insert(ProdEntry(123, ProcWhileCondition, 1));
   _prodInfo.Insert(ProdEntry(122, ProcStatement, 5));
   _prodInfo.Insert(ProdEntry(121, ProcElsIfCondition, 1));
   _prodInfo.Insert(ProdEntry(120, ProcIfCondition, 1));
   _prodInfo.Insert(ProdEntry(119, ProcElsePart, 1));
   _prodInfo.Insert(ProdEntry(118, ProcElseOpt, 0));
   _prodInfo.Insert(ProdEntry(117, ProcElseOpt, 2));
   _prodInfo.Insert(ProdEntry(116, ProcElsIfOpt, 4));
   _prodInfo.Insert(ProdEntry(115, ProcElsIfList, 0));
   _prodInfo.Insert(ProdEntry(114, ProcElsIfList, 2));
   _prodInfo.Insert(ProdEntry(113, ProcIfPart, 4));
   _prodInfo.Insert(ProdEntry(112, ProcStatement, 4));
   _prodInfo.Insert(ProdEntry(111, ProcExceptionType, 1));
   _prodInfo.Insert(ProdEntry(110, ProcValueList, 1));
   _prodInfo.Insert(ProdEntry(109, ProcValueList, 3));
   _prodInfo.Insert(ProdEntry(108, ProcValueListOpt, 0));
   _prodInfo.Insert(ProdEntry(107, ProcValueListOpt, 1));
   _prodInfo.Insert(ProdEntry(106, ProcExceptionStmt, 5));
   _prodInfo.Insert(ProdEntry(105, ProcExceptionList, 0));
   _prodInfo.Insert(ProdEntry(104, ProcExceptionList, 2));
   _prodInfo.Insert(ProdEntry(103, ProcBlockStart, 1));
   _prodInfo.Insert(ProdEntry(102, ProcStatement, 3));
   _prodInfo.Insert(ProdEntry(101, ProcStatement, 2));
   _prodInfo.Insert(ProdEntry(100, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(99, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(98, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(97, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(96, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(95, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(94, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(93, ProcNoAssignment, 0));
   _prodInfo.Insert(ProdEntry(92, ProcInitialAssignment, 1));
   _prodInfo.Insert(ProdEntry(91, ProcInitialAssignment, 2));
   _prodInfo.Insert(ProdEntry(90, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(89, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(88, ProcStatement, 3));
   _prodInfo.Insert(ProdEntry(87, ProcStatement, 2));
   _prodInfo.Insert(ProdEntry(86, ProcStatement, 4));
   _prodInfo.Insert(ProdEntry(85, ProcStatement, 4));
   _prodInfo.Insert(ProdEntry(84, ProcStatementList, 2));
   _prodInfo.Insert(ProdEntry(83, ProcStatementList, 3));
   _prodInfo.Insert(ProdEntry(82, ProcStmtBlock, 2));
   _prodInfo.Insert(ProdEntry(81, ProcArg, 3));
   _prodInfo.Insert(ProdEntry(80, ProcArg, 3));
   _prodInfo.Insert(ProdEntry(79, ProcArgList, 1));
   _prodInfo.Insert(ProdEntry(78, ProcArgList, 3));
   _prodInfo.Insert(ProdEntry(77, ProcArgOpt, 0));
   _prodInfo.Insert(ProdEntry(76, ProcArgOpt, 1));
   _prodInfo.Insert(ProdEntry(75, ReturnOpt, 0));
   _prodInfo.Insert(ProdEntry(74, ReturnOpt, 2));
   _prodInfo.Insert(ProdEntry(73, ProcDef, 4));
   _prodInfo.Insert(ProdEntry(72, ProcHead, 6));
   _prodInfo.Insert(ProdEntry(71, UnionAllOpt, 0));
   _prodInfo.Insert(ProdEntry(70, UnionAllOpt, 3));
   _prodInfo.Insert(ProdEntry(69, JdbcArgList, 1));
   _prodInfo.Insert(ProdEntry(68, JdbcArgList, 2));
   _prodInfo.Insert(ProdEntry(67, Statement, 2));
   _prodInfo.Insert(ProdEntry(66, Statement, 3));
   _prodInfo.Insert(ProdEntry(65, Statement, 3));
   _prodInfo.Insert(ProdEntry(64, Statement, 3));
   _prodInfo.Insert(ProdEntry(63, Statement, 2));
   _prodInfo.Insert(ProdEntry(62, Statement, 4));
   _prodInfo.Insert(ProdEntry(61, Statement, 8));
   _prodInfo.Insert(ProdEntry(60, Statement, 15));
   _prodInfo.Insert(ProdEntry(59, DropOpt, 3));
   _prodInfo.Insert(ProdEntry(58, DropOpt, 1));
   _prodInfo.Insert(ProdEntry(57, Statement, 3));
   _prodInfo.Insert(ProdEntry(56, Statement, 4));
   _prodInfo.Insert(ProdEntry(55, Statement, 3));
   _prodInfo.Insert(ProdEntry(54, Statement, 3));
   _prodInfo.Insert(ProdEntry(53, Statement, 3));
   _prodInfo.Insert(ProdEntry(52, Statement, 3));
   _prodInfo.Insert(ProdEntry(51, Statement, 9));
   _prodInfo.Insert(ProdEntry(50, Statement, 8));
   _prodInfo.Insert(ProdEntry(49, Statement, 6));
   _prodInfo.Insert(ProdEntry(48, Statement, 7));
   _prodInfo.Insert(ProdEntry(47, Statement, 5));
   _prodInfo.Insert(ProdEntry(46, Statement, 2));
   _prodInfo.Insert(ProdEntry(45, Statement, 2));
   _prodInfo.Insert(ProdEntry(44, Statement, 5));
   _prodInfo.Insert(ProdEntry(43, Statement, 5));
   _prodInfo.Insert(ProdEntry(42, Statement, 1));
   _prodInfo.Insert(ProdEntry(41, Statement, 1));
   _prodInfo.Insert(ProdEntry(40, Statement, 1));
   _prodInfo.Insert(ProdEntry(39, Statement, 1));
   _prodInfo.Insert(ProdEntry(38, Statement, 1));
   _prodInfo.Insert(ProdEntry(37, Statement, 2));
   _prodInfo.Insert(ProdEntry(36, Statement, 1));
   _prodInfo.Insert(ProdEntry(35, Statement, 3));
   _prodInfo.Insert(ProdEntry(34, Statement, 3));
   _prodInfo.Insert(ProdEntry(33, Statement, 3));
   _prodInfo.Insert(ProdEntry(32, Statement, 3));
   _prodInfo.Insert(ProdEntry(31, Statement, 3));
   _prodInfo.Insert(ProdEntry(30, Statement, 3));
   _prodInfo.Insert(ProdEntry(29, Statement, 3));
   _prodInfo.Insert(ProdEntry(28, Statement, 1));
   _prodInfo.Insert(ProdEntry(27, Statement, 1));
   _prodInfo.Insert(ProdEntry(26, Statement, 1));
   _prodInfo.Insert(ProdEntry(25, Statement, 7));
   _prodInfo.Insert(ProdEntry(24, Statement, 3));
   _prodInfo.Insert(ProdEntry(23, Statement, 3));
   _prodInfo.Insert(ProdEntry(22, Statement, 3));
   _prodInfo.Insert(ProdEntry(21, Statement, 3));
   _prodInfo.Insert(ProdEntry(20, Statement, 3));
   _prodInfo.Insert(ProdEntry(19, Statement, 3));
   _prodInfo.Insert(ProdEntry(18, Statement, 3));
   _prodInfo.Insert(ProdEntry(17, Statement, 3));
   _prodInfo.Insert(ProdEntry(16, Statement, 3));
   _prodInfo.Insert(ProdEntry(15, Statement, 2));
   _prodInfo.Insert(ProdEntry(14, Statement, 2));
   _prodInfo.Insert(ProdEntry(13, Statement, 2));
   _prodInfo.Insert(ProdEntry(12, TableSetOpt, 0));
   _prodInfo.Insert(ProdEntry(11, TableSetOpt, 2));
   _prodInfo.Insert(ProdEntry(10, Statement, 3));
   _prodInfo.Insert(ProdEntry(9, Statement, 3));
   _prodInfo.Insert(ProdEntry(8, Statement, 3));
   _prodInfo.Insert(ProdEntry(7, Statement, 3));
   _prodInfo.Insert(ProdEntry(6, Statement, 3));
   _prodInfo.Insert(ProdEntry(5, Statement, 3));
   _prodInfo.Insert(ProdEntry(4, Statement, 3));
   _prodInfo.Insert(ProdEntry(3, Statement, 3));
   _prodInfo.Insert(ProdEntry(2, Statement, 2));
   _prodInfo.Insert(ProdEntry(1, Statement, 1));
   _prodInfo.Insert(ProdEntry(0, Start, 2));
}

Cego::Cego()
{
   loadScanner();
   for ( int i=0; i < 792; i++)
   {
      int j;
      for ( j = 0; j < 176; j++)
         _actionMap[i][j] = ActionEntry();
      for ( j = 0; j < 111; j++)
         _jumpMap[i][j] = -1;
   }
   loadParser0();
   loadParser1();
   loadParser2();
   loadParser3();
   loadParser4();
   loadParser5();
   loadParser6();
   loadParser7();
   loadParser8();
   loadParser9();
   loadParser10();
   loadParser11();
   loadParser12();
   loadParser13();
   loadParser14();
   loadParser15();
   loadParser16();
   loadParser17();
   loadParser18();
   loadParser19();
   loadParser20();
   loadParser21();
   loadParser22();
   loadParser23();
   loadParser24();
   loadParser25();
   loadParser26();
   loadParser27();
   loadParser28();
   loadParser29();
   loadParser30();
   loadParser31();
   loadParser32();
   loadParser33();
   loadParser34();
   loadParser35();
   loadParser36();
   loadParser37();
   loadParser38();
   loadParser39();
   loadParser40();
   loadParser41();
   loadParser42();
   loadParser43();
   loadParser44();
   loadParser45();
   loadParser46();
   loadParser47();
   loadParser48();
   loadParser49();
   loadParser50();
   loadParser51();
   loadParser52();
   loadParser53();
   loadParser54();
   loadParser55();
   loadParser56();
   loadParser57();
   loadParser58();
   loadParser59();
   loadParser60();
   loadParser61();
   loadParser62();
   loadParser63();
   loadParser64();
   loadParser65();
   loadParser66();
   loadParser67();
   loadParser68();
   loadParser69();
   loadParser70();
   loadParser71();
   loadParser72();
   loadParser73();
   loadParser74();
   loadParser75();
   loadParser76();
   loadParser77();
   loadParser78();
   loadParser79();
   loadParser80();
   loadParser81();
   loadParser82();
   loadParser83();
   loadParser84();
   loadParser85();
   loadParser86();
   loadParser87();
   loadParser88();
   loadParser89();
   loadParser90();
   loadParser91();
   loadParser92();
   loadParser93();
   loadParser94();
   loadParser95();
   loadParser96();
   loadParser97();
   loadParser98();
   loadParser99();
   loadParser100();
   loadParser101();
   loadParser102();
   loadParser103();
   loadParser104();
   loadParser105();
   loadParser106();
   loadParser107();
   loadParser108();
   loadParser109();
   loadParser110();
   loadParser111();
   loadParser112();
   loadParser113();
   loadParser114();
   loadParser115();
   loadParser116();
   loadParser117();
   loadParser118();
   loadParser119();
   loadParser120();
   loadParser121();
   loadParser122();
   loadParser123();
   loadParser124();
   loadParser125();
   loadParser126();
   loadParser127();
   loadParser128();
   loadParser129();
   loadParser130();
   loadParser131();
   loadParser132();
   loadParser133();
   loadParser134();
   loadParser135();
   loadParser136();
   loadParser137();
   loadParser138();
   loadParser139();
   loadParser140();
   loadParser141();
   loadParser142();
   loadParser143();
   loadParser144();
   loadParser145();
   loadParser146();
   loadParser147();
   loadParser148();
   loadParser149();
   loadParser150();
   loadParser151();
   loadParser152();
   loadParser153();
   loadParser154();
   loadParser155();
   loadParser156();
   loadParser157();
   loadParser158();
   loadParser159();
   loadParser160();
   loadParser161();
   loadParser162();
   loadParser163();
   loadParser164();
   loadParser165();
   loadParser166();
   loadParser167();
   loadParser168();
   loadParser169();
   loadParser170();
   loadParser171();
   loadParser172();
   loadParser173();
   loadParser174();
   loadParser175();
   loadParser176();
   loadParser177();
   loadParser178();
   loadParser179();
   loadParser180();
   loadParser181();
   loadParser182();
   loadParser183();
   loadParser184();
   loadParser185();
   loadParser186();
   loadParser187();
   loadParser188();
   loadParser189();
   loadParser190();
   loadParser191();
   loadParser192();
   loadParser193();
   loadParser194();
   loadParser195();
   loadParser196();
   loadParser197();
   loadParser198();
   loadParser199();
   loadParser200();
   loadParser201();
   loadParser202();
   loadParser203();
   loadParser204();
   loadParser205();
   loadParser206();
   loadParser207();
   loadParser208();
   loadParser209();
   loadParser210();
   loadParser211();
   loadParser212();
   loadParser213();
   loadParser214();
   loadParser215();
   loadParser216();
   loadParser217();
   loadParser218();
   loadParser219();
   loadParser220();
   loadParser221();
   loadParser222();
   loadParser223();
   loadParser224();
   loadParser225();
   loadParser226();
   loadParser227();
   loadParser228();
   loadParser229();
   loadParser230();
   loadParser231();
   loadParser232();
   _isReserved = false;
}

Cego::~Cego()
{
}

void Cego::parse()
{
   StackT<StackEntry> s;
   StackEntry se(NONE, 0, 0);
   s.Push(se);
   _isReserved = false;
   if ( shiftToken() == false )
   {
      Chain msg = "invalid token <" + Chain(_tokenVal) + ">.";
      throw Exception(EXLOC, msg);
   }
   while ( true )
   {
      Action a;
      int num;
      if ( getAction(s.getTop()->getState(), _token, a, num) )
      {
         switch (a)
         {
            case SHIFT:
            {
               StackEntry se(TOKEN, _token, num, _tokenVal);
               s.Push(se);
               if ( shiftToken() == false )
               {
                  Chain msg = "Invalid token <" + Chain(_tokenVal) + ">.";
                  throw Exception(EXLOC, msg);
               }
               break;
            }
            case REDUCE:
            {
               _tokenList.Empty();
               ProdEntry* pPE = _prodInfo.Find(num);
               for (int i=0; i<pPE->getNumSymbol();i++)
               {
                  StackEntry se;
                  s.Pop(se);
                  if (se.getSymbol() == TOKEN)
                     _tokenList.Insert(se.getTval());
               }
               int fstate;
               if (getJump(s.getTop()->getState(), pPE->getProd(), fstate))
               {
                  StackEntry se(PROD, pPE->getId(), fstate, _tokenVal);
                  s.Push(se);
               }
               else
               {
                  Chain msg = "Cannot reduce after token <" + Chain(_tokenVal) + ">.";
                  throw Exception(EXLOC, msg);
               }
               switch (num)
               {
                  case 350:
                     setObject3();
                     break;
                  case 349:
                     setObject2();
                     break;
                  case 348:
                     setObject1();
                     break;
                  case 347:
                     miscDateValue();
                     break;
                  case 346:
                     miscDateFormat();
                     break;
                  case 345:
                     miscCounter();
                     break;
                  case 344:
                     miscBlobRef();
                     break;
                  case 343:
                     miscFalseValue();
                     break;
                  case 342:
                     miscTrueValue();
                     break;
                  case 341:
                     miscNull();
                     break;
                  case 340:
                     miscSysDate();
                     break;
                  case 339:
                     miscFormatDate();
                     break;
                  case 338:
                     miscFixedValue();
                     break;
                  case 337:
                     miscDecimalValue();
                     break;
                  case 336:
                     miscDoubleValue();
                     break;
                  case 335:
                     miscFloatValue();
                     break;
                  case 334:
                     miscStringValue();
                     break;
                  case 333:
                     miscTinyIntValue();
                     break;
                  case 332:
                     miscSmallIntValue();
                     break;
                  case 331:
                     miscBigIntValue();
                     break;
                  case 330:
                     miscLongValue();
                     break;
                  case 329:
                     miscIntValue();
                     break;
                  case 328:
                     miscNegatedFloatString();
                     break;
                  case 327:
                     miscFloatString();
                     break;
                  case 326:
                     miscNegatedIntString();
                     break;
                  case 325:
                     miscIntString();
                     break;
                  case 324:
                     miscAttribute3();
                     break;
                  case 323:
                     miscAttribute2();
                     break;
                  case 322:
                     miscAttribute1();
                     break;
                  case 321:
                     miscMoreEqualComp();
                     break;
                  case 320:
                     miscLessEqualComp();
                     break;
                  case 319:
                     miscMoreComp();
                     break;
                  case 318:
                     miscLessComp();
                     break;
                  case 317:
                     miscNotEqualComp();
                     break;
                  case 316:
                     miscEqualComp();
                     break;
                  case 315:
                     miscBlobType();
                     break;
                  case 314:
                     miscFixedType();
                     break;
                  case 313:
                     miscDecimalType();
                     break;
                  case 312:
                     miscTinyIntType();
                     break;
                  case 311:
                     miscSmallIntType();
                     break;
                  case 310:
                     miscDoubleType();
                     break;
                  case 309:
                     miscFloatType();
                     break;
                  case 308:
                     miscBigIntType();
                     break;
                  case 307:
                     miscBoolType();
                     break;
                  case 306:
                     miscDateTimeType();
                     break;
                  case 305:
                     miscStringType();
                     break;
                  case 304:
                     miscLongType();
                     break;
                  case 303:
                     miscIntType();
                     break;
                  case 302:
                     wcPredicateNotPredicate();
                     break;
                  case 301:
                     wcPredicateCondition();
                     break;
                  case 300:
                     wcPredicateNotLikeComp();
                     break;
                  case 299:
                     wcPredicateLikeComp();
                     break;
                  case 298:
                     wcPredicateNotNullComp();
                     break;
                  case 297:
                     wcPredicateNullComp();
                     break;
                  case 296:
                     wcPredicateBetween();
                     break;
                  case 295:
                     wcPredicateExprComp();
                     break;
                  case 294:
                     wcPredicateQueryNotIn();
                     break;
                  case 293:
                     wcPredicateQueryIn();
                     break;
                  case 292:
                     wcPredicateQueryExists();
                     break;
                  case 291:
                     wcConditionPredicate();
                     break;
                  case 290:
                     wcConditionOr();
                     break;
                  case 289:
                     wcConditionAnd();
                     break;
                  case 287:
                     wcEmptyClause();
                     break;
                  case 286:
                     wcWhereClause();
                     break;
                  case 285:
                     functionExprList2();
                     break;
                  case 284:
                     functionExprList1();
                     break;
                  case 283:
                     functionUserDef2();
                     break;
                  case 282:
                     functionUserDef1();
                     break;
                  case 281:
                     functionNextCount();
                     break;
                  case 280:
                     functionNative();
                     break;
                  case 279:
                     functionNative();
                     break;
                  case 278:
                     functionNative();
                     break;
                  case 277:
                     functionNative();
                     break;
                  case 276:
                     functionNative();
                     break;
                  case 275:
                     functionNative();
                     break;
                  case 274:
                     functionNative();
                     break;
                  case 273:
                     functionNative();
                     break;
                  case 272:
                     functionNative();
                     break;
                  case 271:
                     functionNative();
                     break;
                  case 270:
                     functionNative();
                     break;
                  case 269:
                     functionNative();
                     break;
                  case 268:
                     functionNative();
                     break;
                  case 267:
                     functionNative();
                     break;
                  case 266:
                     functionNative();
                     break;
                  case 265:
                     functionNative();
                     break;
                  case 264:
                     functionNative();
                     break;
                  case 263:
                     functionNative();
                     break;
                  case 262:
                     functionNative();
                     break;
                  case 261:
                     functionNative();
                     break;
                  case 260:
                     functionNative();
                     break;
                  case 259:
                     functionNative();
                     break;
                  case 258:
                     functionNative();
                     break;
                  case 257:
                     functionNative();
                     break;
                  case 256:
                     functionNative();
                     break;
                  case 255:
                     functionNative();
                     break;
                  case 254:
                     renameCheck();
                     break;
                  case 253:
                     renameView();
                     break;
                  case 252:
                     renameProcedure();
                     break;
                  case 251:
                     renameKey();
                     break;
                  case 250:
                     renameIndex();
                     break;
                  case 249:
                     renameTable();
                     break;
                  case 248:
                     alterRenameCol();
                     break;
                  case 247:
                     alterModCol();
                     break;
                  case 246:
                     alterAddCol();
                     break;
                  case 245:
                     alterDropCol();
                     break;
                  case 242:
                     alterStore();
                     break;
                  case 241:
                     deleteStore();
                     break;
                  case 240:
                     returnVarAssignment();
                     break;
                  case 235:
                     updateAssignment();
                     break;
                  case 232:
                     updateStore();
                     break;
                  case 230:
                     selectLimitOpt2();
                     break;
                  case 229:
                     selectLimitOpt1();
                     break;
                  case 227:
                     selectDistinctOpt();
                     break;
                  case 224:
                     selectOrderingDesc();
                     break;
                  case 223:
                     selectOrderingAsc();
                     break;
                  case 222:
                     selectOrderingList2();
                     break;
                  case 221:
                     selectOrderingList1();
                     break;
                  case 219:
                     selectEmptyOrderingClause();
                     break;
                  case 218:
                     selectOrderingClause();
                     break;
                  case 216:
                     selectEmptyHavingClause();
                     break;
                  case 215:
                     selectHavingClause();
                     break;
                  case 214:
                     selectGroupList2();
                     break;
                  case 213:
                     selectGroupList1();
                     break;
                  case 211:
                     selectEmptyGroupClause();
                     break;
                  case 210:
                     selectGroupClause();
                     break;
                  case 208:
                     aliasOpt();
                     break;
                  case 207:
                     selectStackJoinTable();
                     break;
                  case 206:
                     selectTable2();
                     break;
                  case 205:
                     selectTable1();
                     break;
                  case 200:
                     selectRightOuterJoinStore();
                     break;
                  case 199:
                     selectLeftOuterJoinStore();
                     break;
                  case 198:
                     selectInnerJoinStore();
                     break;
                  case 195:
                     selectJoinSpecStore();
                     break;
                  case 194:
                     selectTableListStore();
                     break;
                  case 193:
                     selectItem();
                     break;
                  case 192:
                     selectionList2();
                     break;
                  case 191:
                     selectionList1();
                     break;
                  case 190:
                     selectSelectionStore2();
                     break;
                  case 189:
                     selectSelectionStore1();
                     break;
                  case 188:
                     selectStore();
                     break;
                  case 187:
                     insertExprValue();
                     break;
                  case 186:
                     insertExprValue();
                     break;
                  case 185:
                     insertArg();
                     break;
                  case 184:
                     insertArg();
                     break;
                  case 183:
                     insertValueSpec();
                     break;
                  case 180:
                     insertBySelectStore();
                     break;
                  case 179:
                     insertStore();
                     break;
                  case 178:
                     rollbackStore();
                     break;
                  case 177:
                     commitStore();
                     break;
                  case 176:
                     startStore();
                     break;
                  case 174:
                     createUniqueIndex();
                     break;
                  case 173:
                     createSimpleAttr();
                     break;
                  case 172:
                     createSimpleAttrList();
                     break;
                  case 169:
                     defaultNullOpt();
                     break;
                  case 168:
                     defaultOpt();
                     break;
                  case 166:
                     createNullOpt();
                     break;
                  case 165:
                     createNotNullOpt();
                     break;
                  case 164:
                     createNullOpt();
                     break;
                  case 163:
                     createFieldName();
                     break;
                  case 162:
                     createSetOrdinary();
                     break;
                  case 161:
                     createSetPrimary();
                     break;
                  case 158:
                     procStoreFetchArg2();
                     break;
                  case 157:
                     procStoreFetchArg1();
                     break;
                  case 156:
                     casePrepare();
                     break;
                  case 155:
                     caseCondition();
                     break;
                  case 154:
                     caseConditionList2();
                     break;
                  case 153:
                     caseConditionList1();
                     break;
                  case 152:
                     caseClause();
                     break;
                  case 151:
                     procFactor14();
                     break;
                  case 150:
                     procFactor13();
                     break;
                  case 149:
                     procFactor12();
                     break;
                  case 148:
                     procFactor11();
                     break;
                  case 147:
                     procFactor10();
                     break;
                  case 146:
                     procFactor9();
                     break;
                  case 145:
                     procFactor8();
                     break;
                  case 144:
                     procFactor7();
                     break;
                  case 143:
                     procFactor6();
                     break;
                  case 142:
                     procFactor5();
                     break;
                  case 141:
                     procFactor4();
                     break;
                  case 140:
                     procFactor3();
                     break;
                  case 139:
                     procFactor2();
                     break;
                  case 138:
                     procFactor1();
                     break;
                  case 137:
                     procTerm3();
                     break;
                  case 136:
                     procTerm2();
                     break;
                  case 135:
                     procTerm1();
                     break;
                  case 134:
                     procExpr4();
                     break;
                  case 133:
                     procExpr3();
                     break;
                  case 132:
                     procExpr2();
                     break;
                  case 131:
                     procExpr1();
                     break;
                  case 130:
                     procPredicate4();
                     break;
                  case 129:
                     procPredicate3();
                     break;
                  case 128:
                     procPredicate2();
                     break;
                  case 127:
                     procPredicate1();
                     break;
                  case 126:
                     procCondition3();
                     break;
                  case 125:
                     procCondition2();
                     break;
                  case 124:
                     procCondition1();
                     break;
                  case 123:
                     procWhileCondition();
                     break;
                  case 122:
                     procWhileStatement();
                     break;
                  case 121:
                     procElsIfCondition();
                     break;
                  case 120:
                     procIfCondition();
                     break;
                  case 119:
                     procElsePart();
                     break;
                  case 117:
                     procStoreElseBlock();
                     break;
                  case 116:
                     procStoreIfBlock();
                     break;
                  case 113:
                     procStoreIfBlock();
                     break;
                  case 112:
                     procIfStatement();
                     break;
                  case 111:
                     procExceptionCondition();
                     break;
                  case 110:
                     procExprValue();
                     break;
                  case 109:
                     procExprValue();
                     break;
                  case 107:
                     procValueSpec();
                     break;
                  case 106:
                     procExceptionStatement();
                     break;
                  case 103:
                     procBlockStart();
                     break;
                  case 102:
                     procBlockStatement();
                     break;
                  case 101:
                     procReturnStatement2();
                     break;
                  case 100:
                     procReturnStatement1();
                     break;
                  case 99:
                     procQueryStatement();
                     break;
                  case 98:
                     procQueryStatement();
                     break;
                  case 97:
                     procQueryStatement();
                     break;
                  case 96:
                     procQueryStatement();
                     break;
                  case 95:
                     procQueryStatement();
                     break;
                  case 94:
                     procQueryStatement();
                     break;
                  case 92:
                     procInitialAssignment2();
                     break;
                  case 91:
                     procInitialAssignment1();
                     break;
                  case 90:
                     procNoopStatement();
                     break;
                  case 89:
                     procAssign2NullStatement();
                     break;
                  case 88:
                     procAssignStatement();
                     break;
                  case 87:
                     procCursorCloseStatement();
                     break;
                  case 86:
                     procCursorCreateStatement();
                     break;
                  case 85:
                     procVarStatement();
                     break;
                  case 84:
                     procStoreBlock();
                     break;
                  case 81:
                     procArg2();
                     break;
                  case 80:
                     procArg1();
                     break;
                  case 74:
                     procReturnOpt();
                     break;
                  case 73:
                     procStore();
                     break;
                  case 72:
                     procHead();
                     break;
                  case 70:
                     unionAllStore();
                     break;
                  case 69:
                     jdbcArg2();
                     break;
                  case 68:
                     jdbcArg1();
                     break;
                  case 67:
                     jdbcInfo();
                     break;
                  case 66:
                     execDropCounter();
                     break;
                  case 65:
                     execCreateCounter();
                     break;
                  case 64:
                     execIndexCheck();
                     break;
                  case 63:
                     execPrint();
                     break;
                  case 62:
                     execAssignStatement();
                     break;
                  case 61:
                     execCheckCreate();
                     break;
                  case 60:
                     execForeignKeyCreate();
                     break;
                  case 59:
                     dropOpt2();
                     break;
                  case 58:
                     dropOpt1();
                     break;
                  case 57:
                     execCheckDrop();
                     break;
                  case 56:
                     execFKeyDrop();
                     break;
                  case 55:
                     execProcDrop();
                     break;
                  case 54:
                     execViewDrop();
                     break;
                  case 53:
                     execIndexDrop();
                     break;
                  case 52:
                     execTableDrop();
                     break;
                  case 51:
                     execIndexCreate();
                     break;
                  case 50:
                     execPrimaryIndexCreate();
                     break;
                  case 49:
                     execUserTableCreate();
                     break;
                  case 48:
                     execFuncCall();
                     break;
                  case 47:
                     execProcCall();
                     break;
                  case 46:
                     execProcLoad();
                     break;
                  case 45:
                     execProcCreate();
                     break;
                  case 44:
                     execViewLoad();
                     break;
                  case 43:
                     execViewCreate();
                     break;
                  case 42:
                     execQuery();
                     break;
                  case 41:
                     execQuery();
                     break;
                  case 40:
                     execQuery();
                     break;
                  case 39:
                     execQuery();
                     break;
                  case 38:
                     execQuery();
                     break;
                  case 37:
                     execSelectPlan();
                     break;
                  case 36:
                     execSelect();
                     break;
                  case 35:
                     execIndexReorganize();
                     break;
                  case 34:
                     execTableReorganize();
                     break;
                  case 33:
                     execSetIsolation();
                     break;
                  case 32:
                     execDisableAutoCommit();
                     break;
                  case 31:
                     execEnableAutoCommit();
                     break;
                  case 30:
                     execDisableAppendMode();
                     break;
                  case 29:
                     execEnableAppendMode();
                     break;
                  case 28:
                     execQuery();
                     break;
                  case 27:
                     execQuery();
                     break;
                  case 26:
                     execQuery();
                     break;
                  case 25:
                     execAuthUser();
                     break;
                  case 24:
                     execSetTableSet();
                     break;
                  case 23:
                     execCheckShow();
                     break;
                  case 22:
                     execViewShow();
                     break;
                  case 21:
                     execProcShow();
                     break;
                  case 20:
                     execProcDesc();
                     break;
                  case 19:
                     execKeyDesc();
                     break;
                  case 18:
                     execViewDesc();
                     break;
                  case 17:
                     execIndexDesc();
                     break;
                  case 16:
                     execTableDesc();
                     break;
                  case 15:
                     execShowSystemSpace();
                     break;
                  case 14:
                     execShowPool();
                     break;
                  case 13:
                     execTableInfo();
                     break;
                  case 11:
                     setTableSetOpt();
                     break;
                  case 10:
                     execListTmpObj();
                     break;
                  case 9:
                     execListSysObj();
                     break;
                  case 8:
                     execListCounter();
                     break;
                  case 7:
                     execListKey();
                     break;
                  case 6:
                     execListIndex();
                     break;
                  case 5:
                     execListView();
                     break;
                  case 4:
                     execListProc();
                     break;
                  case 3:
                     execListTable();
                     break;
                  case 2:
                     execListTableSet();
                     break;
                  case 1:
                     execSync();
                     break;
               }
               break;
            }
            case ACCEPT:
            {
               return;
            }
            default:
               break;
         }
      }
      else
      {
         Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
         throw Exception(EXLOC, msg);
      }
   }
}


bool Cego::getAction(int state, Cego::Token token, Cego::Action& a, int& num)
{
    if (_actionMap[state][token].getAction() != NULLACTION )
    {
	a = _actionMap[state][token].getAction();
	num = _actionMap[state][token].getNum();
	return true;
    }
    else
    {
	return false;
    }
}

bool Cego::getJump(int state, Production prod, int& fstate)
{
    if ( _jumpMap[state][prod] > 0 )
    {
       fstate = _jumpMap[state][prod];
	    return true;
    }
    else
    {
	    return false;
    }
}

bool Cego::isSepSign(char c)
{
   if (c == ';') return true;
   if (c == ',') return true;
   if (c == '=') return true;
   if (c == '<') return true;
   if (c == '>') return true;
   if (c == ')') return true;
   if (c == '(') return true;
   if (c == '[') return true;
   if (c == ']') return true;
   if (c == '/') return true;
   if (c == '+') return true;
   if (c == '-') return true;
   if (c == '|') return true;
   if (c == '*') return true;
   return false;
}
bool Cego::isSepIgnore(char c)
{
   if (c == '\t') return true;
   if (c == ' ') return true;
   if (c == '\n') return true;
   return false;
}
bool Cego::shiftToken()
{
   unsigned long i=0;
   char c;
   while ( isSepIgnore(c = nextChar()) && ! _isReserved );
   if ( _isReserved )
   {
      _token = _reservedToken;
      _isReserved = false;
      return true;
   }
   if (c == 0)
   {
      _token = ENDTOKEN;
      return true;
   }
   if (isSepSign(c))
   {
      _tokenVal[i]=c;
       i++;
   }
   else
   {
      while (c && ! isSepIgnore(c) && ! ( isSepSign(c) && i>0 ) )
      {
         _tokenVal[i]=c;
         i++;
         c = nextChar();
      }
      if (isSepSign(c)) backChar();
   }
   _tokenVal[i]=0;
   Scanner* pS = _scannerList.First();
   while (pS)
   {
      if (pS->checkPattern(_tokenVal))
      {
         _token = pS->getToken();
         return true;
      }
      pS=_scannerList.Next();
   }
   return false;
}
void Cego::setReserved(Token t)
{
   _reservedToken = t;
   _isReserved = true;
}
